/* A Bison parser, made by GNU Bison 3.0.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2013 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         cf_parse
#define yylex           cf_lex
#define yyerror         cf_error
#define yydebug         cf_debug
#define yynerrs         cf_nerrs

#define yylval          cf_lval
#define yychar          cf_char

/* Copy the first part of user declarations.  */
#line 1 "cf-parse.y" /* yacc.c:339  */

/* Headers from ../../conf/confbase.Y */

#define PARSER 1

#include "nest/bird.h"
#include "conf/conf.h"
#include "lib/resource.h"
#include "lib/socket.h"
#include "lib/timer.h"
#include "lib/string.h"
#include "nest/protocol.h"
#include "nest/iface.h"
#include "nest/route.h"
#include "nest/cli.h"
#include "filter/filter.h"

/* FIXME: Turn on YYERROR_VERBOSE and work around lots of bison bugs? */

/* Defines from ../../conf/confbase.Y */

static void
check_u16(unsigned val)
{
  if (val > 0xFFFF)
    cf_error("Value %d out of range (0-65535)", val);
}

/* Headers from ../../sysdep/unix/config.Y */

#include "lib/unix.h"
#include <stdio.h>

/* Headers from ../../sysdep/unix/krt.Y */

#include "lib/krt.h"

/* Defines from ../../sysdep/unix/krt.Y */

#define THIS_KRT ((struct krt_config *) this_proto)
#define THIS_KIF ((struct kif_config *) this_proto)

/* Headers from ../../sysdep/linux/netlink.Y */

/* Headers from ../../nest/config.Y */

#include "nest/rt-dev.h"
#include "nest/password.h"
#include "nest/cmds.h"
#include "lib/lists.h"

/* Defines from ../../nest/config.Y */

static struct proto_config *this_proto;
static struct iface_patt *this_ipatt;
static struct iface_patt_node *this_ipn;
static struct roa_table_config *this_roa_table;
static list *this_p_list;
static struct password_item *this_p_item;
static int password_id;

static void
iface_patt_check(void)
{
  struct iface_patt_node *pn;

  WALK_LIST(pn, this_ipatt->ipn_list)
    if (!pn->pattern || pn->pxlen)
      cf_error("Interface name/mask expected, not IP prefix");
}


static inline void
reset_passwords(void)
{
  this_p_list = NULL;
}

static inline list *
get_passwords(void)
{
  list *rv = this_p_list;
  this_p_list = NULL;
  return rv;
}

#define DIRECT_CFG ((struct rt_dev_config *) this_proto)

/* Headers from ../../filter/config.Y */

/* Defines from ../../filter/config.Y */

#define P(a,b) ((a << 8) | b)

static inline u32 pair(u32 a, u32 b) { return (a << 16) | b; }
static inline u32 pair_a(u32 p) { return p >> 16; }
static inline u32 pair_b(u32 p) { return p & 0xFFFF; }


/*
 * Sets and their items are during parsing handled as lists, linked
 * through left ptr. The first item in a list also contains a pointer
 * to the last item in a list (right ptr). For convenience, even items
 * are handled as one-item lists. Lists are merged by f_merge_items().
 */

static inline struct f_tree *
f_new_item(struct f_val from, struct f_val to)
{
  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from = from;
  t->to = to;
  return t;
}

static inline struct f_tree *
f_merge_items(struct f_tree *a, struct f_tree *b)
{
  if (!a) return b;
  a->right->left = b;
  a->right = b->right;
  b->right = NULL;
  return a;
}

static inline struct f_tree *
f_new_pair_item(int fa, int ta, int fb, int tb)
{
  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_PAIR;
  t->from.val.i = pair(fa, fb);
  t->to.val.i = pair(ta, tb);
  return t;
}

static inline struct f_tree *
f_new_pair_set(int fa, int ta, int fb, int tb)
{
  struct f_tree *lst = NULL;
  int i;

  if ((fa == ta) || ((fb == 0) && (tb == 0xFFFF)))
    return f_new_pair_item(fa, ta, fb, tb);
  
  if ((ta < fa) || (tb < fb))
    cf_error( "From value cannot be higher that To value in pair sets");

  for (i = fa; i <= ta; i++)
    lst = f_merge_items(lst, f_new_pair_item(i, i, fb, tb));

  return lst;
}

#define EC_ALL 0xFFFFFFFF

static struct f_tree *
f_new_ec_item(u32 kind, u32 ipv4_used, u32 key, u32 vf, u32 vt)
{
  u64 fm, to;

  if (ipv4_used || (key >= 0x10000)) {
    check_u16(vf);
    if (vt == EC_ALL)
      vt = 0xFFFF;
    else
      check_u16(vt);
  }

  if (kind == EC_GENERIC) {
    fm = ec_generic(key, vf);
    to = ec_generic(key, vt);
  }
  else if (ipv4_used) {
    fm = ec_ip4(kind, key, vf);
    to = ec_ip4(kind, key, vt);
  }
  else if (key < 0x10000) {
    fm = ec_as2(kind, key, vf);
    to = ec_as2(kind, key, vt);
  }
  else {
    fm = ec_as4(kind, key, vf);
    to = ec_as4(kind, key, vt);
  }

  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_EC;
  t->from.val.ec = fm;
  t->to.val.ec = to;
  return t;
}

static inline struct f_inst *
f_generate_empty(struct f_inst *dyn)
{ 
  struct f_inst *e = f_new_inst();
  e->code = 'E';

  switch (dyn->aux & EAF_TYPE_MASK) {
    case EAF_TYPE_AS_PATH:
      e->aux = T_PATH;
      break;
    case EAF_TYPE_INT_SET:
      e->aux = T_CLIST;
      break;
    case EAF_TYPE_EC_SET:
      e->aux = T_ECLIST;
      break;
    default:
      cf_error("Can't empty that attribute");
  }

  dyn->code = P('e','S');
  dyn->a1.p = e;
  return dyn;
}


static inline struct f_inst *
f_generate_dpair(struct f_inst *t1, struct f_inst *t2)
{
  struct f_inst *rv;

  if ((t1->code == 'c') && (t2->code == 'c')) {
    if ((t1->aux != T_INT) || (t2->aux != T_INT))
      cf_error( "Can't operate with value of non-integer type in pair constructor");

    check_u16(t1->a2.i);
    check_u16(t2->a2.i);

    rv = f_new_inst();
    rv->code = 'c';
    rv->aux = T_PAIR;
    rv->a2.i = pair(t1->a2.i, t2->a2.i);
  }
  else {
    rv = f_new_inst();
    rv->code = P('m', 'p');
    rv->a1.p = t1;
    rv->a2.p = t2;
  }

  return rv;
}

static inline struct f_inst *
f_generate_ec(u16 kind, struct f_inst *tk, struct f_inst *tv)
{
  struct f_inst *rv;
  int c1 = 0, c2 = 0, ipv4_used = 0;
  u32 key = 0, val2 = 0;

  if (tk->code == 'c') {
    c1 = 1;

    if (tk->aux == T_INT) {
      ipv4_used = 0; key = tk->a2.i;
    }
    else if (tk->aux == T_QUAD) {
      ipv4_used = 1; key = tk->a2.i;
    }
    else
      cf_error("Can't operate with key of non-integer/IPv4 type in EC constructor");
  }

#ifndef IPV6
  /* IP->Quad implicit conversion */
  else if (tk->code == 'C') {
    c1 = 1;
    struct f_val *val = tk->a1.p;

    if (val->type == T_INT) {
      ipv4_used = 0; key = val->val.i;
    }
    else if (val->type == T_QUAD) {
      ipv4_used = 1; key = val->val.i;
    }
    else if (val->type == T_IP) {
      ipv4_used = 1; key = ipa_to_u32(val->val.px.ip);
    }
    else
      cf_error("Can't operate with key of non-integer/IPv4 type in EC constructor");
  }
#endif

  if (tv->code == 'c') {
    if (tv->aux != T_INT)
      cf_error("Can't operate with value of non-integer type in EC constructor");
    c2 = 1;
    val2 = tv->a2.i;
  }

  if (c1 && c2) {
    u64 ec;
  
    if (kind == EC_GENERIC) {
      ec = ec_generic(key, val2);
    }
    else if (ipv4_used) {
      check_u16(val2);
      ec = ec_ip4(kind, key, val2);
    }
    else if (key < 0x10000) {
      ec = ec_as2(kind, key, val2);
    }
    else {
      check_u16(val2);
      ec = ec_as4(kind, key, val2);
    }

    NEW_F_VAL;
    rv = f_new_inst();
    rv->code = 'C';
    rv->a1.p = val;    
    val->type = T_EC;
    val->val.ec = ec;
  }
  else {
    rv = f_new_inst();
    rv->code = P('m','c');
    rv->aux = kind;
    rv->a1.p = tk;
    rv->a2.p = tv;
  }

  return rv;
}



/* Headers from ../../proto/bfd/config.Y */

#include "proto/bfd/bfd.h"

/* Defines from ../../proto/bfd/config.Y */

#define BFD_CFG ((struct bfd_config *) this_proto)
#define BFD_IFACE ((struct bfd_iface_config *) this_ipatt)
#define BFD_NEIGHBOR this_bfd_neighbor

static struct bfd_neighbor *this_bfd_neighbor;

extern struct bfd_config *bfd_cf;

/* Headers from ../../proto/bgp/config.Y */

#include "proto/bgp/bgp.h"

/* Defines from ../../proto/bgp/config.Y */

#define BGP_CFG ((struct bgp_config *) this_proto)

/* Headers from ../../proto/ospf/config.Y */

#include "proto/ospf/ospf.h"

/* Defines from ../../proto/ospf/config.Y */

#define OSPF_CFG ((struct ospf_config *) this_proto)
#define OSPF_PATT ((struct ospf_iface_patt *) this_ipatt)

static struct ospf_area_config *this_area;
static struct nbma_node *this_nbma;
static list *this_nets;
static struct area_net_config *this_pref;
static struct ospf_stubnet_config *this_stubnet; 

#ifdef OSPFv2
static void
ospf_iface_finish(void)
{
  struct ospf_iface_patt *ip = OSPF_PATT;

  if (ip->deadint == 0)
    ip->deadint = ip->deadc * ip->helloint;

  ip->passwords = get_passwords();

  if ((ip->autype == OSPF_AUTH_CRYPT) && (ip->helloint < 5))
    log(L_WARN "Hello or poll interval less that 5 makes cryptographic authenication prone to replay attacks");

  if ((ip->autype == OSPF_AUTH_NONE) && (ip->passwords != NULL))
    log(L_WARN "Password option without authentication option does not make sense");
}
#endif

#ifdef OSPFv3
static void
ospf_iface_finish(void)
{
  struct ospf_iface_patt *ip = OSPF_PATT;

  if (ip->deadint == 0)
    ip->deadint = ip->deadc * ip->helloint;

  if ((ip->autype != OSPF_AUTH_NONE) || (get_passwords() != NULL))
    cf_error("Authentication not supported in OSPFv3");
}
#endif

static void
ospf_area_finish(void)
{
  if ((this_area->areaid == 0) && (this_area->type != OPT_E))
    cf_error("Backbone area cannot be stub/NSSA");

  if (this_area->summary && (this_area->type == OPT_E))
    cf_error("Only Stub/NSSA areas can use summary propagation");

  if (this_area->default_nssa && ((this_area->type != OPT_N) || ! this_area->summary))
    cf_error("Only NSSA areas with summary propagation can use NSSA default route");

  if ((this_area->default_cost & LSA_EXT_EBIT) && ! this_area->default_nssa)
    cf_error("Only NSSA default route can use type 2 metric");
}

static void
ospf_proto_finish(void)
{
  struct ospf_config *cf = OSPF_CFG;

  if (EMPTY_LIST(cf->area_list))
    cf_error( "No configured areas in OSPF");

  int areano = 0;
  int backbone = 0;
  struct ospf_area_config *ac;
  WALK_LIST(ac, cf->area_list)
  {
    areano++;
    if (ac->areaid == 0)
     backbone = 1;
  }
  cf->abr = areano > 1;

  if (cf->abr && !backbone)
  {
    struct ospf_area_config *ac = cfg_allocz(sizeof(struct ospf_area_config));
    ac->type = OPT_E; /* Backbone is non-stub */
    add_head(&cf->area_list, NODE ac);
    init_list(&ac->patt_list);
    init_list(&ac->net_list);
    init_list(&ac->enet_list);
    init_list(&ac->stubnet_list);
  }

  if (!cf->abr && !EMPTY_LIST(cf->vlink_list))
    cf_error( "Vlinks cannot be used on single area router");
}

static inline void
check_defcost(int cost)
{
  if ((cost <= 0) || (cost >= LSINFINITY))
   cf_error("Default cost must be in range 1-%d", LSINFINITY-1);
}

static inline void
set_instance_id(unsigned id)
{
#ifdef OSPFv3
  OSPF_PATT->instance_id = id;
#else
  cf_error("Instance ID requires OSPFv3");
#endif
}

/* Headers from ../../proto/pipe/config.Y */

#include "proto/pipe/pipe.h"

/* Defines from ../../proto/pipe/config.Y */

#define PIPE_CFG ((struct pipe_config *) this_proto)

/* Headers from ../../proto/radv/config.Y */

#include "proto/radv/radv.h"

/* Defines from ../../proto/radv/config.Y */

#define RADV_CFG ((struct radv_config *) this_proto)
#define RADV_IFACE ((struct radv_iface_config *) this_ipatt)
#define RADV_PREFIX this_radv_prefix
#define RADV_RDNSS (&this_radv_rdnss)
#define RADV_DNSSL (&this_radv_dnssl)

static struct radv_prefix_config *this_radv_prefix;
static struct radv_rdnss_config this_radv_rdnss;
static struct radv_dnssl_config this_radv_dnssl;
static list radv_dns_list;	/* Used by radv_rdnss and radv_dnssl */
static u8 radv_mult_val;	/* Used by radv_mult for second return value */


/* Headers from ../../proto/rip/config.Y */

#include "proto/rip/rip.h"
#include "nest/iface.h"

/* Defines from ../../proto/rip/config.Y */

#define RIP_CFG ((struct rip_proto_config *) this_proto)
#define RIP_IPATT ((struct rip_patt *) this_ipatt)

#ifdef IPV6
#define RIP_DEFAULT_TTL_SECURITY 2
#else
#define RIP_DEFAULT_TTL_SECURITY 0
#endif

/* Headers from ../../proto/static/config.Y */

#include "proto/static/static.h"

/* Defines from ../../proto/static/config.Y */

#define STATIC_CFG ((struct static_config *) this_proto)
static struct static_route *this_srt, *this_srt_nh, *last_srt_nh;


#line 598 "cf-parse.tab.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "cf-parse.tab.h".  */
#ifndef YY_CF_CF_PARSE_TAB_H_INCLUDED
# define YY_CF_CF_PARSE_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int cf_debug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    END = 258,
    CLI_MARKER = 259,
    INVALID_TOKEN = 260,
    ELSECOL = 261,
    DDOT = 262,
    GEQ = 263,
    LEQ = 264,
    NEQ = 265,
    AND = 266,
    OR = 267,
    PO = 268,
    PC = 269,
    NUM = 270,
    ENUM = 271,
    RTRID = 272,
    IPA = 273,
    SYM = 274,
    TEXT = 275,
    PREFIX_DUMMY = 276,
    DEFINE = 277,
    ON = 278,
    OFF = 279,
    YES = 280,
    NO = 281,
    S = 282,
    MS = 283,
    US = 284,
    LOG = 285,
    SYSLOG = 286,
    ALL = 287,
    DEBUG = 288,
    TRACE = 289,
    INFO = 290,
    REMOTE = 291,
    WARNING = 292,
    ERROR = 293,
    AUTH = 294,
    FATAL = 295,
    BUG = 296,
    STDERR = 297,
    SOFT = 298,
    TIMEFORMAT = 299,
    ISO = 300,
    OLD = 301,
    SHORT = 302,
    LONG = 303,
    BASE = 304,
    NAME = 305,
    CONFIRM = 306,
    UNDO = 307,
    CHECK = 308,
    TIMEOUT = 309,
    CONFIGURE = 310,
    DOWN = 311,
    KERNEL = 312,
    PERSIST = 313,
    SCAN = 314,
    TIME = 315,
    LEARN = 316,
    DEVICE = 317,
    ROUTES = 318,
    GRACEFUL = 319,
    RESTART = 320,
    KRT_SOURCE = 321,
    KRT_METRIC = 322,
    TABLE = 323,
    KRT_PREFSRC = 324,
    KRT_REALM = 325,
    ROUTER = 326,
    ID = 327,
    PROTOCOL = 328,
    TEMPLATE = 329,
    PREFERENCE = 330,
    DISABLED = 331,
    DIRECT = 332,
    INTERFACE = 333,
    IMPORT = 334,
    EXPORT = 335,
    FILTER = 336,
    NONE = 337,
    STATES = 338,
    FILTERS = 339,
    RECEIVE = 340,
    LIMIT = 341,
    ACTION = 342,
    WARN = 343,
    BLOCK = 344,
    DISABLE = 345,
    KEEP = 346,
    FILTERED = 347,
    PASSWORD = 348,
    FROM = 349,
    PASSIVE = 350,
    TO = 351,
    EVENTS = 352,
    PACKETS = 353,
    PROTOCOLS = 354,
    INTERFACES = 355,
    PRIMARY = 356,
    STATS = 357,
    COUNT = 358,
    FOR = 359,
    COMMANDS = 360,
    PREEXPORT = 361,
    GENERATE = 362,
    ROA = 363,
    MAX = 364,
    FLUSH = 365,
    AS = 366,
    LISTEN = 367,
    BGP = 368,
    V6ONLY = 369,
    DUAL = 370,
    ADDRESS = 371,
    PORT = 372,
    PASSWORDS = 373,
    DESCRIPTION = 374,
    SORTED = 375,
    RELOAD = 376,
    IN = 377,
    OUT = 378,
    MRTDUMP = 379,
    MESSAGES = 380,
    RESTRICT = 381,
    MEMORY = 382,
    IGP_METRIC = 383,
    CLASS = 384,
    DSCP = 385,
    WAIT = 386,
    SHOW = 387,
    STATUS = 388,
    SUMMARY = 389,
    ROUTE = 390,
    SYMBOLS = 391,
    ADD = 392,
    DELETE = 393,
    DUMP = 394,
    RESOURCES = 395,
    SOCKETS = 396,
    NEIGHBORS = 397,
    ATTRIBUTES = 398,
    EVAL = 399,
    ECHO = 400,
    ENABLE = 401,
    FUNCTION = 402,
    PRINT = 403,
    PRINTN = 404,
    UNSET = 405,
    RETURN = 406,
    ACCEPT = 407,
    REJECT = 408,
    QUITBIRD = 409,
    INT = 410,
    BOOL = 411,
    IP = 412,
    PREFIX = 413,
    PAIR = 414,
    QUAD = 415,
    EC = 416,
    SET = 417,
    STRING = 418,
    BGPMASK = 419,
    BGPPATH = 420,
    CLIST = 421,
    ECLIST = 422,
    IF = 423,
    THEN = 424,
    ELSE = 425,
    CASE = 426,
    TRUE = 427,
    FALSE = 428,
    RT = 429,
    RO = 430,
    UNKNOWN = 431,
    GENERIC = 432,
    GW = 433,
    NET = 434,
    MASK = 435,
    PROTO = 436,
    SOURCE = 437,
    SCOPE = 438,
    CAST = 439,
    DEST = 440,
    IFNAME = 441,
    IFINDEX = 442,
    LEN = 443,
    DEFINED = 444,
    CONTAINS = 445,
    RESET = 446,
    PREPEND = 447,
    FIRST = 448,
    LAST = 449,
    MATCH = 450,
    ROA_CHECK = 451,
    EMPTY = 452,
    WHERE = 453,
    BFD = 454,
    MIN = 455,
    IDLE = 456,
    RX = 457,
    TX = 458,
    INTERVAL = 459,
    MULTIPLIER = 460,
    MULTIHOP = 461,
    NEIGHBOR = 462,
    DEV = 463,
    LOCAL = 464,
    SESSIONS = 465,
    HOLD = 466,
    CONNECT = 467,
    RETRY = 468,
    KEEPALIVE = 469,
    STARTUP = 470,
    VIA = 471,
    NEXT = 472,
    HOP = 473,
    SELF = 474,
    DEFAULT = 475,
    PATH = 476,
    METRIC = 477,
    START = 478,
    DELAY = 479,
    FORGET = 480,
    AFTER = 481,
    BGP_PATH = 482,
    BGP_LOCAL_PREF = 483,
    BGP_MED = 484,
    BGP_ORIGIN = 485,
    BGP_NEXT_HOP = 486,
    BGP_ATOMIC_AGGR = 487,
    BGP_AGGREGATOR = 488,
    BGP_COMMUNITY = 489,
    BGP_EXT_COMMUNITY = 490,
    RR = 491,
    RS = 492,
    CLIENT = 493,
    CLUSTER = 494,
    AS4 = 495,
    ADVERTISE = 496,
    IPV4 = 497,
    CAPABILITIES = 498,
    PREFER = 499,
    OLDER = 500,
    MISSING = 501,
    LLADDR = 502,
    DROP = 503,
    IGNORE = 504,
    REFRESH = 505,
    INTERPRET = 506,
    COMMUNITIES = 507,
    BGP_ORIGINATOR_ID = 508,
    BGP_CLUSTER_LIST = 509,
    IGP = 510,
    GATEWAY = 511,
    RECURSIVE = 512,
    MED = 513,
    TTL = 514,
    SECURITY = 515,
    DETERMINISTIC = 516,
    SECONDARY = 517,
    ALLOW = 518,
    PATHS = 519,
    AWARE = 520,
    OSPF = 521,
    AREA = 522,
    OSPF_METRIC1 = 523,
    OSPF_METRIC2 = 524,
    OSPF_TAG = 525,
    OSPF_ROUTER_ID = 526,
    RFC1583COMPAT = 527,
    STUB = 528,
    TICK = 529,
    COST = 530,
    COST2 = 531,
    RETRANSMIT = 532,
    HELLO = 533,
    TRANSMIT = 534,
    PRIORITY = 535,
    DEAD = 536,
    TYPE = 537,
    BROADCAST = 538,
    BCAST = 539,
    NONBROADCAST = 540,
    NBMA = 541,
    POINTOPOINT = 542,
    PTP = 543,
    POINTOMULTIPOINT = 544,
    PTMP = 545,
    SIMPLE = 546,
    AUTHENTICATION = 547,
    STRICT = 548,
    CRYPTOGRAPHIC = 549,
    ELIGIBLE = 550,
    POLL = 551,
    NETWORKS = 552,
    HIDDEN = 553,
    VIRTUAL = 554,
    LINK = 555,
    ONLY = 556,
    BUFFER = 557,
    LARGE = 558,
    NORMAL = 559,
    STUBNET = 560,
    TAG = 561,
    EXTERNAL = 562,
    LSADB = 563,
    ECMP = 564,
    WEIGHT = 565,
    NSSA = 566,
    TRANSLATOR = 567,
    STABILITY = 568,
    GLOBAL = 569,
    LSID = 570,
    INSTANCE = 571,
    REAL = 572,
    NETMASK = 573,
    LENGTH = 574,
    MERGE = 575,
    TOPOLOGY = 576,
    STATE = 577,
    PIPE = 578,
    PEER = 579,
    MODE = 580,
    OPAQUE = 581,
    TRANSPARENT = 582,
    RADV = 583,
    RA = 584,
    MANAGED = 585,
    OTHER = 586,
    CONFIG = 587,
    MTU = 588,
    REACHABLE = 589,
    RETRANS = 590,
    TIMER = 591,
    CURRENT = 592,
    VALID = 593,
    PREFERRED = 594,
    MULT = 595,
    LIFETIME = 596,
    SKIP = 597,
    ONLINK = 598,
    AUTONOMOUS = 599,
    RDNSS = 600,
    DNSSL = 601,
    NS = 602,
    DOMAIN = 603,
    TRIGGER = 604,
    SENSITIVE = 605,
    LOW = 606,
    MEDIUM = 607,
    HIGH = 608,
    RIP = 609,
    INFINITY = 610,
    PERIOD = 611,
    GARBAGE = 612,
    MULTICAST = 613,
    QUIET = 614,
    NOLISTEN = 615,
    VERSION1 = 616,
    PLAINTEXT = 617,
    MD5 = 618,
    HONOR = 619,
    NEVER = 620,
    ALWAYS = 621,
    RIP_METRIC = 622,
    RIP_TAG = 623,
    STATIC = 624,
    PROHIBIT = 625,
    MULTIPATH = 626,
    BLACKHOLE = 627,
    UNREACHABLE = 628
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE YYSTYPE;
union YYSTYPE
{
#line 527 "cf-parse.y" /* yacc.c:355  */

  int i;
  u32 i32;
  ip_addr a;
  struct symbol *s;
  char *t;
  struct rtable_config *r;
  struct f_inst *x;
  struct filter *f;
  struct f_tree *e;
  struct f_trie *trie;
  struct f_val v;
  struct f_path_mask *h;
  struct password_item *p;
  struct rt_show_data *ra;
  struct roa_show_data *ro;
  struct sym_show_data *sd;
  struct lsadb_show_data *ld;
  struct iface *iface;
  struct roa_table *rot;
  void *g;
  bird_clock_t time;
  struct prefix px;
  struct proto_spec ps;
  struct timeformat *tf;

#line 1039 "cf-parse.tab.c" /* yacc.c:355  */
};
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE cf_lval;

int cf_parse (void);

#endif /* !YY_CF_CF_PARSE_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 1054 "cf-parse.tab.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  67
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   2859

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  395
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  291
/* YYNRULES -- Number of rules.  */
#define YYNRULES  910
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  1708

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   628

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    31,     2,     2,     2,    30,     2,     2,
     386,   387,    28,    26,   391,    27,    32,    29,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   388,   385,
      23,    22,    24,   392,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   393,     2,   394,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   389,     2,   390,    25,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   722,   722,   723,   726,   728,   736,   745,   746,   747,
     754,   755,   756,   764,   765,   766,   767,   768,   769,   775,
     776,   783,   784,   788,   795,   796,   800,   804,   811,   819,
     820,   827,   828,   834,   843,   844,   848,   853,   854,   858,
     859,   863,   864,   868,   869,   870,   871,   872,   873,   874,
     875,   876,   882,   883,   892,   893,   894,   895,   898,   899,
     900,   901,   902,   903,   907,   914,   917,   924,   927,   930,
     933,   937,   938,   942,   943,   944,   952,   957,   958,   962,
     969,   970,   976,   981,   985,   999,  1013,  1014,  1018,  1019,
    1020,  1031,  1033,  1035,  1039,  1040,  1041,  1042,  1047,  1053,
    1054,  1058,  1066,  1070,  1072,  1078,  1079,  1086,  1087,  1091,
    1097,  1101,  1111,  1113,  1117,  1118,  1119,  1120,  1121,  1122,
    1123,  1124,  1125,  1126,  1127,  1128,  1132,  1133,  1134,  1135,
    1139,  1140,  1141,  1142,  1143,  1147,  1153,  1157,  1165,  1166,
    1174,  1182,  1183,  1184,  1188,  1189,  1193,  1198,  1199,  1203,
    1205,  1213,  1217,  1218,  1224,  1231,  1232,  1233,  1237,  1245,
    1251,  1252,  1253,  1257,  1258,  1262,  1263,  1264,  1265,  1266,
    1267,  1273,  1274,  1275,  1279,  1280,  1284,  1285,  1291,  1292,
    1295,  1297,  1301,  1302,  1306,  1324,  1325,  1326,  1327,  1328,
    1329,  1337,  1340,  1343,  1346,  1350,  1351,  1354,  1357,  1361,
    1365,  1370,  1376,  1383,  1388,  1393,  1398,  1402,  1406,  1410,
    1419,  1427,  1431,  1438,  1439,  1444,  1448,  1455,  1462,  1466,
    1474,  1475,  1476,  1481,  1485,  1488,  1489,  1490,  1491,  1492,
    1493,  1494,  1499,  1504,  1512,  1519,  1526,  1534,  1536,  1538,
    1540,  1542,  1544,  1546,  1549,  1553,  1559,  1560,  1561,  1565,
    1566,  1572,  1574,  1576,  1578,  1580,  1582,  1586,  1590,  1593,
    1597,  1598,  1599,  1603,  1604,  1605,  1613,  1613,  1623,  1627,
    1628,  1629,  1630,  1631,  1632,  1633,  1634,  1635,  1636,  1637,
    1638,  1639,  1660,  1671,  1672,  1679,  1680,  1687,  1696,  1700,
    1704,  1728,  1729,  1733,  1746,  1746,  1762,  1763,  1766,  1767,
    1771,  1774,  1783,  1796,  1797,  1798,  1799,  1803,  1804,  1805,
    1806,  1807,  1811,  1814,  1815,  1816,  1820,  1823,  1832,  1835,
    1836,  1837,  1838,  1842,  1843,  1844,  1848,  1849,  1850,  1851,
    1855,  1856,  1857,  1858,  1862,  1863,  1867,  1868,  1872,  1879,
    1880,  1881,  1882,  1889,  1890,  1893,  1894,  1901,  1913,  1914,
    1918,  1919,  1923,  1924,  1925,  1926,  1927,  1931,  1932,  1933,
    1937,  1938,  1939,  1940,  1941,  1942,  1943,  1944,  1945,  1946,
    1947,  1951,  1952,  1962,  1966,  1989,  2003,  2004,  2005,  2006,
    2007,  2008,  2009,  2010,  2011,  2012,  2016,  2017,  2018,  2019,
    2020,  2021,  2022,  2023,  2024,  2025,  2026,  2027,  2028,  2029,
    2030,  2031,  2033,  2034,  2035,  2037,  2039,  2041,  2043,  2044,
    2045,  2046,  2047,  2057,  2058,  2059,  2060,  2061,  2062,  2063,
    2065,  2066,  2071,  2094,  2095,  2096,  2097,  2098,  2099,  2103,
    2106,  2107,  2108,  2116,  2123,  2132,  2133,  2137,  2143,  2153,
    2162,  2168,  2173,  2180,  2185,  2191,  2192,  2193,  2201,  2202,
    2203,  2204,  2205,  2211,  2223,  2224,  2225,  2226,  2229,  2231,
    2235,  2239,  2250,  2251,  2252,  2253,  2254,  2255,  2258,  2260,
    2263,  2265,  2268,  2271,  2276,  2277,  2278,  2282,  2283,  2287,
    2288,  2291,  2310,  2316,  2340,  2341,  2342,  2343,  2344,  2354,
    2355,  2356,  2357,  2358,  2359,  2360,  2361,  2362,  2363,  2364,
    2365,  2366,  2367,  2368,  2369,  2370,  2371,  2372,  2373,  2374,
    2375,  2376,  2377,  2378,  2379,  2380,  2381,  2382,  2383,  2384,
    2385,  2386,  2387,  2388,  2393,  2394,  2395,  2396,  2397,  2398,
    2399,  2400,  2401,  2402,  2403,  2404,  2405,  2406,  2417,  2427,
    2428,  2432,  2433,  2434,  2435,  2436,  2437,  2438,  2439,  2442,
    2457,  2460,  2462,  2466,  2467,  2468,  2469,  2470,  2471,  2472,
    2473,  2474,  2475,  2475,  2476,  2476,  2477,  2478,  2479,  2483,
    2484,  2488,  2496,  2498,  2502,  2503,  2504,  2508,  2509,  2512,
    2514,  2517,  2518,  2519,  2520,  2521,  2522,  2523,  2524,  2525,
    2526,  2527,  2530,  2552,  2553,  2554,  2555,  2556,  2557,  2558,
    2559,  2560,  2561,  2562,  2563,  2564,  2565,  2566,  2567,  2568,
    2569,  2570,  2571,  2572,  2573,  2574,  2575,  2576,  2577,  2578,
    2579,  2580,  2581,  2582,  2583,  2584,  2585,  2586,  2587,  2588,
    2589,  2592,  2594,  2597,  2599,  2608,  2610,  2611,  2614,  2616,
    2620,  2621,  2624,  2634,  2657,  2659,  2663,  2663,  2666,  2668,
    2671,  2673,  2677,  2681,  2682,  2687,  2690,  2693,  2698,  2701,
    2706,  2709,  2713,  2717,  2720,  2721,  2722,  2723,  2724,  2725,
    2726,  2727,  2733,  2740,  2741,  2742,  2747,  2748,  2754,  2764,
    2765,  2766,  2767,  2767,  2768,  2768,  2769,  2776,  2778,  2782,
    2786,  2804,  2805,  2806,  2807,  2808,  2809,  2810,  2811,  2812,
    2813,  2818,  2819,  2820,  2820,  2821,  2821,  2822,  2823,  2827,
    2828,  2829,  2832,  2850,  2852,  2855,  2857,  2861,  2864,  2877,
    2878,  2879,  2880,  2885,  2893,  2901,  2903,  2906,  2908,  2912,
    2916,  2926,  2931,  2932,  2933,  2937,  2949,  2951,  2955,  2956,
    2960,  2973,  2978,  2979,  2980,  2984,  2996,  2998,  3002,  3003,
    3008,  3009,  3013,  3014,  3020,  3027,  3028,  3029,  3030,  3031,
    3032,  3033,  3034,  3035,  3036,  3037,  3038,  3039,  3043,  3044,
    3045,  3050,  3051,  3052,  3053,  3054,  3057,  3058,  3059,  3060,
    3061,  3062,  3063,  3066,  3068,  3071,  3073,  3077,  3089,  3096,
    3103,  3104,  3105,  3106,  3107,  3110,  3119,  3127,  3134,  3135,
    3139,  3144,  3150,  3153,  3158,  3159,  3160,  3161,  3162,  3165,
    3172,  3172,  3172,  3172,  3172,  3172,  3172,  3172,  3172,  3172,
    3172,  3172,  3172,  3172,  3172,  3173,  3173,  3173,  3173,  3173,
    3173,  3173,  3173,  3173,  3173,  3173,  3173,  3173,  3173,  3173,
    3173,  3173,  3173,  3173,  3173,  3173,  3173,  3173,  3173,  3173,
    3173,  3173,  3173,  3173,  3173,  3173,  3173,  3173,  3173,  3173,
    3173,  3173,  3173,  3173,  3173,  3173,  3173,  3173,  3173,  3173,
    3173,  3174,  3174,  3174,  3174,  3174,  3174,  3174,  3174,  3174,
    3174,  3175,  3175,  3175,  3175,  3176,  3176,  3176,  3177,  3177,
    3177,  3177,  3177,  3178,  3178,  3179,  3180,  3181,  3182,  3183,
    3184,  3185,  3186,  3187,  3188,  3189,  3189,  3189,  3189,  3189,
    3189
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "END", "CLI_MARKER", "INVALID_TOKEN",
  "ELSECOL", "DDOT", "GEQ", "LEQ", "NEQ", "AND", "OR", "PO", "PC", "NUM",
  "ENUM", "RTRID", "IPA", "SYM", "TEXT", "PREFIX_DUMMY", "'='", "'<'",
  "'>'", "'~'", "'+'", "'-'", "'*'", "'/'", "'%'", "'!'", "'.'", "DEFINE",
  "ON", "OFF", "YES", "NO", "S", "MS", "US", "LOG", "SYSLOG", "ALL",
  "DEBUG", "TRACE", "INFO", "REMOTE", "WARNING", "ERROR", "AUTH", "FATAL",
  "BUG", "STDERR", "SOFT", "TIMEFORMAT", "ISO", "OLD", "SHORT", "LONG",
  "BASE", "NAME", "CONFIRM", "UNDO", "CHECK", "TIMEOUT", "CONFIGURE",
  "DOWN", "KERNEL", "PERSIST", "SCAN", "TIME", "LEARN", "DEVICE", "ROUTES",
  "GRACEFUL", "RESTART", "KRT_SOURCE", "KRT_METRIC", "TABLE",
  "KRT_PREFSRC", "KRT_REALM", "ROUTER", "ID", "PROTOCOL", "TEMPLATE",
  "PREFERENCE", "DISABLED", "DIRECT", "INTERFACE", "IMPORT", "EXPORT",
  "FILTER", "NONE", "STATES", "FILTERS", "RECEIVE", "LIMIT", "ACTION",
  "WARN", "BLOCK", "DISABLE", "KEEP", "FILTERED", "PASSWORD", "FROM",
  "PASSIVE", "TO", "EVENTS", "PACKETS", "PROTOCOLS", "INTERFACES",
  "PRIMARY", "STATS", "COUNT", "FOR", "COMMANDS", "PREEXPORT", "GENERATE",
  "ROA", "MAX", "FLUSH", "AS", "LISTEN", "BGP", "V6ONLY", "DUAL",
  "ADDRESS", "PORT", "PASSWORDS", "DESCRIPTION", "SORTED", "RELOAD", "IN",
  "OUT", "MRTDUMP", "MESSAGES", "RESTRICT", "MEMORY", "IGP_METRIC",
  "CLASS", "DSCP", "WAIT", "SHOW", "STATUS", "SUMMARY", "ROUTE", "SYMBOLS",
  "ADD", "DELETE", "DUMP", "RESOURCES", "SOCKETS", "NEIGHBORS",
  "ATTRIBUTES", "EVAL", "ECHO", "ENABLE", "FUNCTION", "PRINT", "PRINTN",
  "UNSET", "RETURN", "ACCEPT", "REJECT", "QUITBIRD", "INT", "BOOL", "IP",
  "PREFIX", "PAIR", "QUAD", "EC", "SET", "STRING", "BGPMASK", "BGPPATH",
  "CLIST", "ECLIST", "IF", "THEN", "ELSE", "CASE", "TRUE", "FALSE", "RT",
  "RO", "UNKNOWN", "GENERIC", "GW", "NET", "MASK", "PROTO", "SOURCE",
  "SCOPE", "CAST", "DEST", "IFNAME", "IFINDEX", "LEN", "DEFINED",
  "CONTAINS", "RESET", "PREPEND", "FIRST", "LAST", "MATCH", "ROA_CHECK",
  "EMPTY", "WHERE", "BFD", "MIN", "IDLE", "RX", "TX", "INTERVAL",
  "MULTIPLIER", "MULTIHOP", "NEIGHBOR", "DEV", "LOCAL", "SESSIONS", "HOLD",
  "CONNECT", "RETRY", "KEEPALIVE", "STARTUP", "VIA", "NEXT", "HOP", "SELF",
  "DEFAULT", "PATH", "METRIC", "START", "DELAY", "FORGET", "AFTER",
  "BGP_PATH", "BGP_LOCAL_PREF", "BGP_MED", "BGP_ORIGIN", "BGP_NEXT_HOP",
  "BGP_ATOMIC_AGGR", "BGP_AGGREGATOR", "BGP_COMMUNITY",
  "BGP_EXT_COMMUNITY", "RR", "RS", "CLIENT", "CLUSTER", "AS4", "ADVERTISE",
  "IPV4", "CAPABILITIES", "PREFER", "OLDER", "MISSING", "LLADDR", "DROP",
  "IGNORE", "REFRESH", "INTERPRET", "COMMUNITIES", "BGP_ORIGINATOR_ID",
  "BGP_CLUSTER_LIST", "IGP", "GATEWAY", "RECURSIVE", "MED", "TTL",
  "SECURITY", "DETERMINISTIC", "SECONDARY", "ALLOW", "PATHS", "AWARE",
  "OSPF", "AREA", "OSPF_METRIC1", "OSPF_METRIC2", "OSPF_TAG",
  "OSPF_ROUTER_ID", "RFC1583COMPAT", "STUB", "TICK", "COST", "COST2",
  "RETRANSMIT", "HELLO", "TRANSMIT", "PRIORITY", "DEAD", "TYPE",
  "BROADCAST", "BCAST", "NONBROADCAST", "NBMA", "POINTOPOINT", "PTP",
  "POINTOMULTIPOINT", "PTMP", "SIMPLE", "AUTHENTICATION", "STRICT",
  "CRYPTOGRAPHIC", "ELIGIBLE", "POLL", "NETWORKS", "HIDDEN", "VIRTUAL",
  "LINK", "ONLY", "BUFFER", "LARGE", "NORMAL", "STUBNET", "TAG",
  "EXTERNAL", "LSADB", "ECMP", "WEIGHT", "NSSA", "TRANSLATOR", "STABILITY",
  "GLOBAL", "LSID", "INSTANCE", "REAL", "NETMASK", "LENGTH", "MERGE",
  "TOPOLOGY", "STATE", "PIPE", "PEER", "MODE", "OPAQUE", "TRANSPARENT",
  "RADV", "RA", "MANAGED", "OTHER", "CONFIG", "MTU", "REACHABLE",
  "RETRANS", "TIMER", "CURRENT", "VALID", "PREFERRED", "MULT", "LIFETIME",
  "SKIP", "ONLINK", "AUTONOMOUS", "RDNSS", "DNSSL", "NS", "DOMAIN",
  "TRIGGER", "SENSITIVE", "LOW", "MEDIUM", "HIGH", "RIP", "INFINITY",
  "PERIOD", "GARBAGE", "MULTICAST", "QUIET", "NOLISTEN", "VERSION1",
  "PLAINTEXT", "MD5", "HONOR", "NEVER", "ALWAYS", "RIP_METRIC", "RIP_TAG",
  "STATIC", "PROHIBIT", "MULTIPATH", "BLACKHOLE", "UNREACHABLE", "';'",
  "'('", "')'", "':'", "'{'", "'}'", "','", "'?'", "'['", "']'", "$accept",
  "config", "conf_entries", "definition", "expr", "expr_us", "bool", "ipa",
  "ipa_scope", "prefix", "prefix_or_ipa", "pxlen", "datetime", "text",
  "text_or_none", "log_config", "syslog_name", "log_file", "log_mask",
  "log_mask_list", "log_cat", "mrtdump_base", "timeformat_which",
  "timeformat_spec", "timeformat_base", "cmd_CONFIGURE",
  "cmd_CONFIGURE_SOFT", "cmd_CONFIGURE_CONFIRM", "cmd_CONFIGURE_UNDO",
  "cmd_CONFIGURE_CHECK", "cmd_DOWN", "cfg_name", "cfg_timeout",
  "kern_proto_start", "kern_item", "kif_proto_start", "kif_item",
  "kern_sys_item", "rtrid", "idval", "listen", "listen_opts", "listen_opt",
  "gr_opts", "tab_sorted", "newtab", "roa_table_start", "roa_table_opts",
  "roa_table", "proto_start", "proto_name", "proto_item", "imexport",
  "limit_action", "limit_spec", "rtable", "debug_default",
  "iface_patt_node_init", "iface_patt_node_body", "iface_negate",
  "iface_patt_node", "iface_patt_list", "iface_patt_list_nopx",
  "iface_patt_init", "iface_patt", "tos", "dev_proto_start", "dev_proto",
  "dev_iface_init", "dev_iface_patt", "debug_mask", "debug_list",
  "debug_flag", "mrtdump_mask", "mrtdump_list", "mrtdump_flag",
  "password_list", "password_items", "password_item",
  "password_item_begin", "password_item_params", "cmd_SHOW_STATUS",
  "cmd_SHOW_MEMORY", "cmd_SHOW_PROTOCOLS", "cmd_SHOW_PROTOCOLS_ALL",
  "optsym", "cmd_SHOW_INTERFACES", "cmd_SHOW_INTERFACES_SUMMARY",
  "cmd_SHOW_ROUTE", "r_args", "export_or_preexport", "cmd_SHOW_ROA",
  "roa_args", "roa_mode", "cmd_SHOW_SYMBOLS", "sym_args", "roa_table_arg",
  "cmd_ADD_ROA", "cmd_DELETE_ROA", "cmd_FLUSH_ROA", "cmd_DUMP_RESOURCES",
  "cmd_DUMP_SOCKETS", "cmd_DUMP_INTERFACES", "cmd_DUMP_NEIGHBORS",
  "cmd_DUMP_ATTRIBUTES", "cmd_DUMP_ROUTES", "cmd_DUMP_PROTOCOLS",
  "cmd_EVAL", "cmd_ECHO", "echo_mask", "echo_size", "cmd_DISABLE",
  "cmd_ENABLE", "cmd_RESTART", "cmd_RELOAD", "cmd_RELOAD_IN",
  "cmd_RELOAD_OUT", "cmd_DEBUG", "cmd_MRTDUMP", "cmd_RESTRICT",
  "proto_patt", "proto_patt2", "filter_def", "$@1", "filter_eval", "type",
  "one_decl", "decls", "declsn", "filter_body", "filter", "where_filter",
  "function_params", "function_body", "function_def", "$@2", "cmds",
  "cmds_int", "block", "fipa", "set_atom", "switch_atom", "pair_expr",
  "pair_atom", "pair_item", "ec_expr", "ec_kind", "ec_item", "set_item",
  "switch_item", "set_items", "switch_items", "fprefix_s", "fprefix",
  "fprefix_set", "switch_body", "bgp_path_expr", "bgp_path",
  "bgp_path_tail1", "bgp_path_tail2", "constant", "constructor", "rtadot",
  "function_call", "symbol", "static_attr", "term", "break_command",
  "print_one", "print_list", "var_listn", "var_list", "cmd",
  "bfd_proto_start", "bfd_proto_item", "bfd_proto_opts", "bfd_proto",
  "bfd_iface_start", "bfd_iface_item", "bfd_iface_opts",
  "bfd_iface_opt_list", "bfd_iface", "bfd_multihop", "bfd_neigh_iface",
  "bfd_neigh_local", "bfd_neigh_multihop", "bfd_neighbor",
  "cmd_SHOW_BFD_SESSIONS", "bgp_proto_start", "bgp_proto",
  "ospf_proto_start", "ospf_proto", "ospf_proto_item", "ospf_area_start",
  "ospf_area", "ospf_area_opts", "ospf_area_item", "$@3", "$@4",
  "ospf_stubnet", "ospf_stubnet_start", "ospf_stubnet_opts",
  "ospf_stubnet_item", "ospf_vlink", "ospf_vlink_opts", "ospf_vlink_item",
  "ospf_vlink_start", "ospf_iface_item", "pref_list", "pref_item",
  "pref_base", "pref_opt", "nbma_list", "nbma_eligible", "nbma_item",
  "ospf_iface_start", "ospf_instance_id", "ospf_iface_patt_list", "$@5",
  "ospf_iface_opts", "ospf_iface_opt_list", "ospf_iface", "opttext",
  "cmd_SHOW_OSPF", "cmd_SHOW_OSPF_NEIGHBORS", "cmd_SHOW_OSPF_INTERFACE",
  "cmd_SHOW_OSPF_TOPOLOGY", "cmd_SHOW_OSPF_TOPOLOGY_ALL",
  "cmd_SHOW_OSPF_STATE", "cmd_SHOW_OSPF_STATE_ALL", "cmd_SHOW_OSPF_LSADB",
  "lsadb_args", "pipe_proto_start", "pipe_proto", "radv_proto_start",
  "radv_proto_item", "$@6", "$@7", "radv_proto_opts", "radv_proto",
  "radv_iface_start", "radv_iface_item", "$@8", "$@9", "radv_preference",
  "radv_iface_finish", "radv_iface_opts", "radv_iface_opt_list",
  "radv_iface", "radv_prefix_start", "radv_prefix_item",
  "radv_prefix_finish", "radv_prefix_opts", "radv_prefix_opt_list",
  "radv_prefix", "radv_rdnss_node", "radv_rdnss_start", "radv_rdnss_item",
  "radv_rdnss_finish", "radv_rdnss_opts", "radv_rdnss", "radv_dnssl_node",
  "radv_dnssl_start", "radv_dnssl_item", "radv_dnssl_finish",
  "radv_dnssl_opts", "radv_dnssl", "radv_mult", "radv_sensitive",
  "rip_cfg_start", "rip_cfg", "rip_auth", "rip_mode", "rip_iface_item",
  "rip_iface_opts", "rip_iface_opt_list", "rip_iface_init", "rip_iface",
  "static_proto_start", "static_proto", "stat_route0", "stat_multipath1",
  "stat_multipath", "stat_route", "cmd_SHOW_STATIC", "conf", "cli_cmd",
  "proto", "kern_proto", "kif_proto", "dynamic_attr", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,    61,    60,    62,   126,    43,    45,    42,    47,
      37,    33,    46,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,    59,    40,    41,    58,   123,
     125,    44,    63,    91,    93
};
# endif

#define YYPACT_NINF -1391

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-1391)))

#define YYTABLE_NINF -436

#define yytable_value_is_error(Yytable_value) \
  (!!((Yytable_value) == (-436)))

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
      98,  2529,   247,   690,   689,   432,   133,   689,   689,   140,
     655,   689,   392,  1619,   289,   293,   896,  1561,    39,   689,
   -1391, -1391, -1391, -1391, -1391, -1391, -1391, -1391, -1391, -1391,
   -1391, -1391, -1391, -1391, -1391, -1391, -1391, -1391, -1391, -1391,
   -1391, -1391, -1391, -1391, -1391, -1391, -1391, -1391, -1391, -1391,
   -1391, -1391, -1391, -1391, -1391, -1391, -1391, -1391, -1391, -1391,
   -1391, -1391, -1391, -1391, -1391, -1391, -1391, -1391, -1391,   438,
     605,   415,   665,   385,   459,   433, -1391, -1391,   479,   472,
     414,   592,  1561,   542, -1391, -1391, -1391, -1391, -1391,   554,
     554, -1391, -1391, -1391, -1391,   204, -1391,   447, -1391,   554,
    2469, -1391, -1391, -1391,   554, -1391,   554,  2199,   554,  2074,
     554,  2404,   554, -1391,   554,  2009,   554,  1136, -1391, -1391,
    2406,  2419, -1391, -1391, -1391,    94, -1391,   588,   618,   648,
     588,   573, -1391,   661,   675,   617,   689,   689,   683,   305,
   -1391,   709,   208, -1391,   697,   702, -1391, -1391,   489,   435,
     693,   740,   740,   758,   760,   763,   770,   780,   782,   784,
      35, -1391, -1391, -1391,   769,   428, -1391,   608,   167,    13,
    1561, -1391,   448,   450,   452, -1391, -1391,   475,   477,   495,
     918,    40, -1391, -1391, -1391, -1391, -1391,  1982, -1391,  2679,
   -1391, -1391,  1643,   805,   821,   873, -1391, -1391,   836, -1391,
   -1391,   -16,    94,   258, -1391, -1391, -1391, -1391,   462,   521,
     766,   795,   631, -1391,   894, -1391,   305,   547,  2725, -1391,
     838,   564,   582, -1391, -1391, -1391, -1391, -1391, -1391, -1391,
   -1391, -1391, -1391, -1391,   586,    94,   927,   905,   258,   188,
   -1391,   548,   794,   882,   751,   305, -1391,   596,   624,   613,
     638,   -43,   975,   688,   809,   751,   188,   963,   793,    21,
     947,   188,    33,   740,   359,  1006,   862,  1016,   867,   861,
     615,   858,   857,   629,   844,   841,   188,   851,   850,   854,
      32,   -47,   889,   852,   859,   188,   906, -1391,   742,   748,
     666,   188,  1056,   258,   188,   822, -1391, -1391,   756,   755,
   -1391,   759,  1070,   585, -1391,   773,   765,   772,  1081, -1391,
     751,   258,   779,     7,   258,   258,  1098,   134, -1391,   785,
     797, -1391,   799,   800,   875,   740,  1104, -1391,   808,   671,
     810,  1105,   188,  1119,   188,  1122,  1131, -1391,   824,   828,
     831,  1127,  1197, -1391,   834,   835, -1391, -1391,   970,  1218,
     573, -1391, -1391,  1221,   258,  1222, -1391, -1391,  1209,  1226,
    1227,  1228, -1391, -1391, -1391,   138,  1233, -1391, -1391,   921,
    1235, -1391,  1240,   893, -1391, -1391,  2509,  1178,   693, -1391,
     693,   693, -1391,   322,   412,  1243,  1246, -1391, -1391,     1,
    1130,  1132, -1391, -1391, -1391, -1391, -1391, -1391, -1391,    35,
   -1391,    35,  1561,    35,    35,  1239, -1391,  1236,  1116,  1232,
    1052,  1234,    13,    13,  1249,  1248,  1561,  1561,  1561,  1561,
    1561,  1250, -1391, -1391,  1257, -1391,   895,    69, -1391, -1391,
   -1391, -1391,   813, -1391, -1391,  1277, -1391, -1391, -1391,   164,
     100, -1391,   213, -1391, -1391, -1391, -1391, -1391, -1391, -1391,
   -1391, -1391, -1391, -1391, -1391, -1391, -1391, -1391, -1391, -1391,
   -1391, -1391, -1391, -1391, -1391, -1391, -1391, -1391, -1391, -1391,
   -1391, -1391, -1391, -1391, -1391, -1391, -1391, -1391, -1391,  1561,
    1561,  1561,  1561,  1561,  1561,  1561,  1561,  1561,  1561,  1561,
    1561,  1561,   512, -1391, -1391, -1391, -1391, -1391, -1391, -1391,
   -1391, -1391,   560, -1391, -1391,  1285, -1391,  1561,   751, -1391,
   -1391,  1643,   907, -1391,  1561, -1391,   258,   898,   901, -1391,
     258, -1391, -1391, -1391, -1391, -1391, -1391,   909,  2147, -1391,
     103,   913, -1391,   904,  1282, -1391, -1391,   -87, -1391, -1391,
   -1391, -1391,   666, -1391, -1391, -1391, -1391, -1391, -1391, -1391,
   -1391, -1391,  1385, -1391,   120,  1199,  1561, -1391, -1391,   120,
   -1391,   120, -1391, -1391, -1391, -1391, -1391, -1391,  1238,  1241,
     256, -1391,  1254,   920,   922,   258,    49,  1045,   188,   740,
     923, -1391,   925,  1283,   258,  1192,   258,  1244,   258,  1251,
      75,   258,   258,   188,  1253,   940,  1245,   941,   188,   942,
     188,   216,   188,   927,   188,   944,   949,   188,   188,   188,
     950,  1210, -1391, -1391, -1391, -1391,   188, -1391,  1242,   188,
   -1391, -1391, -1391,  1318,   953,   955, -1391, -1391, -1391,   258,
   -1391,   959, -1391,   964,  1252, -1391, -1391, -1391,   967,   968,
     972,   258,   976,   977,   978, -1391, -1391,   341, -1391,   188,
   -1391,   927, -1391, -1391,   971, -1391,   740, -1391,  1121, -1391,
   -1391, -1391,   258, -1391,   258, -1391,   188,   188, -1391, -1391,
   -1391,   258, -1391,   740, -1391, -1391, -1391, -1391, -1391, -1391,
   -1391, -1391,   594, -1391, -1391,  1352, -1391, -1391, -1391, -1391,
   -1391, -1391, -1391, -1391, -1391,   602, -1391, -1391,  1357, -1391,
   -1391, -1391,  1345, -1391,  1351, -1391,   740, -1391, -1391,  1350,
    1353, -1391,  1385, -1391, -1391, -1391, -1391,   740, -1391, -1391,
    1356, -1391, -1391, -1391, -1391, -1391, -1391, -1391, -1391, -1391,
    1367,  1358,  1358,   846,   693,  1358,   693,  1358, -1391, -1391,
     258,   740, -1391,  1362,  1364, -1391, -1391,   607, -1391, -1391,
   -1391, -1391,    96, -1391,   984, -1391,  1354, -1391, -1391, -1391,
   -1391,   122,   272,   310,   644,   335,   -62, -1391,  1561, -1391,
    1561, -1391,  1373,   991,   995,   768,   291,   296, -1391, -1391,
   -1391,  1372,  1374, -1391,  2159,  2159,  2159,  2752,  2752,  2159,
    2159,  2159,  2159,   818,   818,  1248,  1248, -1391,  1004, -1391,
   -1391, -1391, -1391,  1643, -1391,  1891, -1391,   621, -1391,   768,
    1371, -1391, -1391, -1391, -1391,  1008, -1391,  1011, -1391, -1391,
   -1391, -1391, -1391, -1391, -1391, -1391, -1391, -1391, -1391, -1391,
   -1391,   143,  1012,  1010, -1391, -1391, -1391, -1391,   740,   258,
   -1391, -1391, -1391,  1956,  2147, -1391,   740, -1391, -1391,  1378,
   -1391,  1015, -1391, -1391, -1391, -1391,  1309, -1391,   188,  2725,
   -1391, -1391,  2163,   258,   258,   258,  1023,  1025,   188, -1391,
   -1391,  1027,  1029,  1030,  1031,   188,  1035,  1036, -1391, -1391,
    1404,  1302,  1040,   258,  1041,   258,  1048,   258,  1049,  1050,
    1051,  1053,  1062,   258, -1391,   666, -1391,  1063, -1391,  1064,
    1069,  1080,  1084,  1085,  1088,  1090, -1391, -1391,  1091,  1092,
    1093, -1391,   151, -1391,   258, -1391,   869,  1095, -1391, -1391,
    2283,  1097,  -181, -1391, -1391,  1096,  1100, -1391, -1391, -1391,
    1102, -1391, -1391, -1391,   258,   182,   635,  1099,  1103,  1106,
   -1391,  1283, -1391,   740,  1120,  1121, -1391, -1391, -1391, -1391,
   -1391,     1, -1391, -1391, -1391,   970, -1391, -1391,   138, -1391,
   -1391, -1391, -1391, -1391, -1391, -1391, -1391, -1391, -1391, -1391,
    1487,  1490, -1391, -1391,   666, -1391,   666,  1485, -1391, -1391,
     666,  1358,  1498,  1358,  1501, -1391, -1391,  1398,  1400, -1391,
    1561, -1391,  1480,  1561,  1561,  1561, -1391,  1561, -1391,  1561,
     518,   848,  1561,  1147,  1561, -1391, -1391, -1391, -1391,  1133,
     769, -1391,  1561, -1391, -1391, -1391, -1391, -1391,  1015, -1391,
   -1391, -1391,  2147,   804, -1391, -1391, -1391,  1140,  1141, -1391,
    1407, -1391,   999, -1391,   767, -1391, -1391, -1391, -1391,   740,
   -1391, -1391,  1144,  1139,  1156,  1157, -1391, -1391,  1158, -1391,
   -1391, -1391, -1391,  1159, -1391, -1391, -1391,   258, -1391,  1164,
   -1391,  1173, -1391,  1179, -1391, -1391, -1391, -1391, -1391,  1181,
    1188, -1391, -1391, -1391, -1391, -1391, -1391, -1391, -1391, -1391,
   -1391, -1391, -1391,  1200, -1391, -1391,   188,   434,   137, -1391,
    1271,   740, -1391, -1391,   123, -1391,  1201, -1391,  1262, -1391,
   -1391,   740, -1391, -1391,   740, -1391, -1391,  1206, -1391, -1391,
   -1391, -1391,  1252, -1391,  1211,  1564,  1564,  1564,  1564, -1391,
   -1391, -1391, -1391,  1283,   258,  1120, -1391, -1391, -1391, -1391,
   -1391, -1391, -1391, -1391,  1591, -1391,  1592, -1391,  1583,  1584,
   -1391, -1391,   892,  1013,  1087,  1434,   557,  1561, -1391, -1391,
    2725,  1214,  1212,  2725,  1587,  1613, -1391,    53, -1391,  1582,
   -1391, -1391,  1220,  1561, -1391, -1391, -1391,  1561,  1561,  1219,
      27,  1982,  1223,  1479, -1391,  2147, -1391,  1595,   740, -1391,
   -1391, -1391, -1391, -1391, -1391, -1391, -1391, -1391,  1224, -1391,
      59, -1391, -1391,   258, -1391, -1391, -1391, -1391,  1230, -1391,
   -1391, -1391, -1391, -1391, -1391, -1391, -1391, -1391,   258,   258,
     188,   258, -1391,  1255,   666, -1391, -1391,  1259,  1260,   258,
   -1391, -1391,   258,  1261, -1391, -1391, -1391,  1263, -1391,    48,
       9, -1391, -1391,   474, -1391,   341, -1391,  1231,  1247,  1258,
    1266, -1391, -1391, -1391, -1391,   617,   617, -1391, -1391, -1391,
   -1391,  1561,  1649,  1600,  1519,  1229, -1391,  1561,  1116,  1561,
   -1391,  1916,  2057,   173, -1391, -1391,  1590,   426, -1391,  2725,
    1264,  1269, -1391,  1495, -1391,  1015,  1224, -1391, -1391,  1610,
     751,  1410,  1279, -1391,  1015,  1267, -1391, -1391, -1391, -1391,
   -1391, -1391, -1391, -1391, -1391, -1391, -1391,  1276, -1391, -1391,
   -1391, -1391, -1391, -1391, -1391, -1391, -1391, -1391,   -31,   258,
    1360,   513, -1391,  1281, -1391,   341,   341,   341,   341,  1630,
    1631,  1689, -1391,  1297,  1298,    10, -1391,  1941,  1317,  1966,
    1954, -1391,  1688, -1391,  1561,  1561,   598,  1479, -1391,  1654,
   -1391,   337, -1391, -1391,   740,  1429, -1391,  1262, -1391, -1391,
       4,   409,     6,  1280, -1391, -1391,   539, -1391, -1391, -1391,
     258,   258,   258, -1391, -1391,   465, -1391, -1391, -1391, -1391,
   -1391, -1391, -1391, -1391, -1391, -1391, -1391, -1391, -1391, -1391,
    1561, -1391,  1561, -1391, -1391, -1391, -1391,  1319,   804,  1503,
   -1391,    20,  1993,  2018,  1310,  1322,  1334,  1337,  1320, -1391,
    1339,   188,   843,  1511,   258,   258, -1391,  1342, -1391,   188,
   -1391, -1391,  2439, -1391, -1391, -1391,   136,   188,   258,   188,
   -1391,  1343, -1391,   258,   258,   258,  1496,   237,   -59, -1391,
   -1391,  1355,  2229, -1391,  1387,  1389,   188,   188,   188, -1391,
    1369,    30,   340, -1391, -1391, -1391,  1430, -1391,  1368,  1375,
    1370,  1377,  1688,    54, -1391, -1391, -1391,   813, -1391, -1391,
    1736, -1391, -1391, -1391,   271, -1391, -1391,  1561,  1561,  1561,
    1561, -1391, -1391, -1391,  1543,  1545,  1560,   872, -1391, -1391,
   -1391, -1391,  1465,   258,  1388,   188,  1466,   -79,  1507,   188,
     188,   258,   258,   258,  1546,   258,   242,  1217,  1451,    82,
    1486,   258,  1470,  1505, -1391, -1391,  1415, -1391,   258,  1416,
   -1391, -1391, -1391, -1391, -1391, -1391, -1391,   258,   258, -1391,
   -1391, -1391, -1391, -1391,  1452,   740,    89,   -35,  1458,   188,
    1460,  1733,  1459,  1576,  1596,  1597, -1391,  1422,   258,   258,
   -1391, -1391, -1391, -1391,   353,   740, -1391,  1435,   353,  1799,
   -1391,  1442, -1391,  1561, -1391, -1391, -1391, -1391, -1391,  1724,
      99,    54,   251,  1761,  1786,  1814,  1851,   258,   258,   258,
   -1391, -1391, -1391,   188, -1391, -1391, -1391,   219,   258,   258,
   -1391,   541, -1391, -1391, -1391, -1391, -1391,   258, -1391,   258,
   -1391, -1391, -1391, -1391, -1391, -1391, -1391, -1391, -1391,   188,
   -1391, -1391, -1391,   188, -1391,   258,   188, -1391, -1391, -1391,
   -1391, -1391,  1615, -1391,   258,  1616,   670,   258,   258, -1391,
     188,   258,   258,  1731,   188,    48,   188,     9, -1391,  1471,
    1471,   258, -1391, -1391, -1391, -1391, -1391, -1391, -1391, -1391,
   -1391,  1446, -1391,  1561, -1391, -1391, -1391,  1449,  1450,  1469,
    1472, -1391, -1391, -1391, -1391,     2, -1391, -1391, -1391, -1391,
   -1391,  1532, -1391, -1391, -1391, -1391, -1391, -1391, -1391,   258,
   -1391,   258, -1391, -1391, -1391, -1391,  1471, -1391, -1391, -1391,
   -1391,   258, -1391, -1391, -1391, -1391,   188, -1391, -1391, -1391,
   -1391,  1724, -1391, -1391, -1391, -1391,  1539, -1391, -1391, -1391,
   -1391, -1391, -1391, -1391, -1391, -1391,  1473, -1391
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       4,     0,     0,     0,     0,    71,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   373,     0,     0,
     825,   826,   827,   828,   829,   830,   831,   832,   833,   834,
     835,   836,   837,   838,   839,   840,   841,   842,   843,   844,
     845,   846,   847,   848,   849,   850,   851,   852,   853,   854,
     855,   856,   857,   858,   859,   860,   861,   862,   863,   864,
     865,   866,   867,   868,   869,   870,     3,     1,     2,     0,
       0,     0,     0,     0,     0,     0,   107,   108,     0,     0,
       0,     0,   373,     0,   810,   811,   812,   813,   814,   109,
     109,   815,   816,   817,   818,   105,   819,     0,   821,   109,
     112,   822,   823,   824,   109,   874,   109,   112,   109,   112,
     109,   112,   109,   878,   109,   112,   109,   112,     5,   820,
     112,   112,   260,   262,   261,     0,    72,    71,     0,     0,
      71,    73,    70,     0,     0,   232,     0,     0,     0,     0,
     259,   264,     0,   216,     0,     0,   200,   224,     0,   196,
     196,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     356,   360,   369,   366,   302,   375,   363,     0,     0,   359,
     373,   405,     0,     0,     0,   361,   362,     0,     0,     0,
     373,     0,   364,   365,   370,   403,   404,     0,   402,     0,
     247,   246,     0,   249,     0,     0,    30,    29,    35,    38,
      36,     0,     0,     0,    57,    56,    55,    54,     0,     0,
       0,    99,     0,   266,     0,    92,     0,     0,   268,   294,
     110,     0,     0,   103,    76,    82,   154,   483,   453,   538,
     672,   678,   754,   789,     0,     0,     0,     0,     0,    18,
     158,     0,     0,     0,     0,     0,   873,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    18,     0,     0,     0,
       0,    18,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    18,     0,     0,     0,
       0,     0,     0,     0,     0,    18,     0,   875,     0,     0,
       0,    18,     0,     0,    18,     0,   876,   541,     0,     0,
     548,     0,     0,     0,   877,     0,     0,     0,     0,   787,
       0,     0,     0,     0,     0,     0,     0,     0,   879,     0,
       0,   179,   183,     0,     0,     0,     0,   880,     0,     0,
       0,     0,    18,     0,    18,     0,     0,   871,     0,     0,
       0,     0,    32,   872,     0,     0,   161,   160,     0,     0,
      73,    67,    68,     0,    74,     0,   253,   251,     0,     0,
       0,     0,   254,   172,   171,     0,     0,   263,   265,   264,
       0,   197,     0,   220,   192,   191,     0,     0,   196,   195,
     196,   196,   663,   196,   196,     0,     0,    19,    20,     0,
       0,     0,   242,   243,   239,   237,   238,   240,   241,   356,
     375,   356,   373,   356,   356,     0,   348,     0,   373,     0,
       0,     0,   359,   359,     0,   400,   373,   373,   373,   373,
     373,     0,   319,   320,     0,   322,     0,     0,     7,   306,
     304,     9,   373,   303,   305,   328,   326,   327,   334,     0,
     339,   343,     0,   893,   888,   889,   890,   891,   376,   892,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   895,
     898,   897,   894,   896,   899,   900,   901,   904,   902,   903,
     905,   906,   907,   908,   909,   910,   406,   407,   244,   373,
     373,   373,   373,   373,   373,   373,   373,   373,   373,   373,
     373,   373,     0,    43,    44,    45,    46,    47,    48,    49,
      50,    51,     0,    41,   250,     0,   252,   373,     0,    37,
      39,     0,     0,   138,   373,   139,    58,     0,     0,    64,
       0,   100,   101,    88,    89,    90,   150,     0,   283,   102,
       0,     0,    53,     0,     0,   881,   885,     0,   155,   115,
     137,   123,     0,   113,    14,    16,    15,    17,    13,   114,
     140,   128,   283,   129,     0,     0,   373,   117,   127,     0,
     118,     0,   125,   116,   156,   157,   458,   484,     0,     0,
      18,   496,     0,     0,     0,     0,    18,     0,    18,     0,
       0,   497,     0,    21,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    18,     0,     0,     0,     0,    18,     0,
      18,     0,    18,     0,    18,     0,     0,    18,    18,    18,
       0,     0,   485,   539,   549,   542,    18,   547,   544,    18,
     540,   551,   673,     0,     0,     0,   674,   687,   755,     0,
     140,     0,   184,     0,   180,   770,   768,   769,     0,     0,
       0,     0,     0,     0,     0,   756,   763,   185,   790,    18,
     795,     0,   791,   805,     0,   804,     0,   808,     0,   806,
     807,   794,     0,    77,     0,    79,    18,    18,   883,   884,
     882,     0,    31,     0,   887,   886,   166,   165,   167,   169,
     170,   168,     0,   163,   257,     0,    69,    75,    65,   233,
     236,   255,   256,   176,   177,     0,   174,   258,     0,   193,
     198,   215,     0,   222,     0,   221,     0,   199,   206,     0,
       0,   214,   283,   208,   207,   211,   212,     0,   213,   201,
       0,   205,   223,   231,   225,   228,   229,   227,   230,   226,
       0,   654,   654,     0,   196,   654,   196,   654,   655,   809,
       0,     0,    23,     0,     0,   352,   353,     0,   354,   355,
     350,   338,   433,   436,     0,   413,     0,   414,   357,   358,
     351,     0,     0,     0,     0,     0,     0,   321,   373,   386,
     373,   315,   313,     0,     0,   312,     0,     0,   367,   340,
     341,     0,     0,   368,   398,   396,   394,   391,   392,   393,
     395,   397,   399,   387,   388,   389,   390,   408,     0,   409,
     411,   412,   248,     0,   245,     0,    34,     0,    33,     0,
       0,    60,    61,    62,    63,     0,   140,     0,    86,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,     0,     0,     0,   267,   287,    96,    97,     0,     0,
      91,    93,    52,     0,   283,   111,     0,   106,   124,   144,
     147,   159,   288,   289,   126,   136,   130,   120,    18,   290,
     121,   119,   112,     0,     0,     0,     0,     0,    18,   522,
     524,     0,     0,     0,     0,    18,     0,     0,   537,   498,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   490,     0,   491,     0,   520,     0,
       0,     0,     0,     0,     0,     0,   504,   505,     0,     0,
       0,   526,     0,   543,     0,   546,     0,     0,   676,   677,
     112,     0,   785,   767,   758,     0,     0,   762,   757,   759,
       0,   765,   766,   764,     0,     0,     0,     0,     0,     0,
     801,    21,   803,     0,   798,   802,    85,    78,    80,    81,
      83,    25,    24,    84,   162,     0,    66,   173,     0,   194,
     219,   218,   217,   203,   210,   204,   202,   209,   482,   653,
       0,     0,   662,   671,     0,   669,     0,     0,   666,   664,
       0,   654,     0,   654,     0,    26,    27,     0,     0,   349,
     373,   422,     0,   373,   373,   373,   401,   373,   420,   373,
       0,     0,   373,   373,   373,     8,   302,   329,   335,     0,
       0,   344,   373,    42,     6,    40,    59,    98,   151,    87,
     282,   281,   283,   373,    94,    95,   292,   285,     0,   295,
       0,   145,     0,   140,     0,   135,   122,   461,   461,     0,
     460,   454,     0,     0,     0,     0,   533,   532,     0,   523,
     527,   528,   529,     0,   519,   513,    22,     0,   486,     0,
     492,     0,   495,     0,   500,   499,   512,   511,   506,     0,
       0,   521,   509,   501,   502,   503,   525,   535,   508,   507,
     536,   510,   530,     0,   545,   643,    18,     0,    18,   562,
       0,     0,   564,   554,    18,   550,     0,   568,   644,   675,
     690,     0,   682,   684,     0,   689,   679,     0,   761,   783,
     788,   178,   180,   760,     0,     0,     0,     0,     0,   182,
     792,   793,   800,    21,     0,   799,   164,   175,   657,   656,
     670,   665,   667,   668,     0,   658,     0,   660,     0,     0,
     434,   415,     0,     0,     0,     0,     0,   373,   371,   314,
     312,     0,     0,   318,     0,     0,   284,     0,   426,     0,
     427,   428,     0,   373,   424,   425,   423,   373,   373,     0,
     373,     0,     0,   373,   298,     0,   291,     0,   141,   142,
     146,   148,   133,   131,   132,   134,   140,   455,   470,   456,
     474,   457,   459,     0,   515,   534,   517,   518,     0,   487,
     494,   493,   514,   489,   531,   140,   567,   555,     0,     0,
      18,     0,   553,     0,     0,   571,   566,   570,     0,     0,
     560,   552,     0,   578,   140,   680,   718,   727,   681,     0,
       0,   686,   688,   776,   181,   185,    28,     0,     0,     0,
       0,   796,   797,   659,   661,   232,   232,   419,   417,   418,
     416,   373,     0,   316,   373,     0,   410,   373,   373,   373,
     373,     0,     0,     0,   293,   299,     0,     0,   446,   429,
     431,     0,   286,     0,   143,   149,   470,   468,   473,     0,
       0,   477,     0,   488,   646,   650,   557,   558,   556,   559,
     631,   592,   572,   631,   561,   645,   579,   715,   725,   724,
     731,   730,   738,   683,   740,   741,   748,   685,     0,     0,
       0,     0,   786,     0,   190,   185,   185,   185,   185,     0,
       0,     0,   372,     0,     0,     0,   342,     0,     0,     0,
       0,   440,   373,   345,   373,   373,     0,   373,   445,     0,
     472,     0,   475,   476,     0,   479,   516,   644,   648,   652,
       0,     0,     0,   581,   713,   712,     0,   729,   736,   746,
       0,     0,     0,   779,   777,    18,   771,   772,   773,   774,
     775,   778,   784,   186,   187,   188,   189,   234,   235,   421,
     373,   325,   373,   323,   439,   374,   443,     0,   373,   437,
     300,     0,     0,     0,     0,     0,     0,     0,     0,   432,
       0,    18,     0,     0,     0,     0,   471,     0,   478,    18,
     481,   647,     0,   563,   634,   632,   635,    18,     0,    18,
     569,     0,   565,     0,     0,     0,     0,     0,     0,   577,
     591,     0,     0,   717,     0,     0,    18,    18,    18,   728,
       0,   732,   742,   152,   153,   780,     0,   781,     0,     0,
       0,     0,   373,   373,   307,   311,   309,   373,   447,   310,
     332,   330,   331,   336,     0,   442,   441,   373,   373,   373,
     373,   448,   104,   467,     0,     0,     0,     0,   462,   466,
     469,   480,     0,     0,     0,    18,     0,     0,     0,    18,
      18,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   651,   630,     0,   636,     0,     0,
     575,   576,   574,   573,   585,   583,   582,     0,     0,   586,
     588,   589,   590,   580,     0,     0,     0,     0,     0,    18,
       0,     0,     0,     0,   703,   705,   716,     0,     0,     0,
     719,   720,   721,   726,     0,     0,   735,     0,     0,     0,
     745,     0,   782,   373,   324,   444,   301,   438,   347,   312,
       0,   373,     0,     0,     0,     0,     0,     0,     0,     0,
      10,    11,    12,    18,   597,   638,   628,     0,     0,     0,
     623,    18,   629,   613,   593,   596,   594,     0,   611,     0,
     598,   600,   601,   602,   603,   604,   605,   606,   607,    18,
     617,   618,   619,    18,   595,     0,    18,   649,   637,   633,
     584,   587,     0,   702,     0,     0,     0,     0,     0,   694,
      18,     0,     0,     0,    18,     0,    18,     0,   714,   752,
     752,     0,   750,   734,   733,   739,   737,   744,   743,   749,
     747,     0,   308,   373,   333,   346,   337,     0,     0,     0,
       0,   463,   464,   465,   614,     0,   621,   620,   622,   624,
     625,     0,   626,   610,   599,   609,   612,   615,   608,     0,
     693,     0,   709,   710,   711,   701,   752,   696,   695,   697,
     698,     0,   707,   704,   708,   706,    18,   722,   723,   751,
     317,     0,   452,   450,   451,   449,   640,   616,   639,   627,
     692,   691,   700,   699,   753,   641,     0,   642
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1391, -1391, -1391, -1391,  -150,  -539,    -6,  -224,  -800,  -149,
    -701, -1391,   -33,   -75, -1391, -1391, -1391, -1391, -1391,  1344,
    1065, -1391, -1391, -1391, -1391, -1391, -1391, -1391, -1391, -1391,
   -1391,   611,  1506, -1391, -1391, -1391, -1391, -1391, -1391,  -289,
   -1391, -1391, -1391, -1391, -1391, -1391, -1391, -1391, -1391, -1391,
    1177,  -102,  1624, -1391,   189,  -349, -1391, -1391, -1391, -1391,
     849,  -540,   645, -1391, -1391,   384, -1391, -1391, -1391, -1391,
     181, -1391,   926,   177, -1391,   928, -1175,   775,  -620, -1391,
    -513, -1391, -1391, -1391, -1391,  -139, -1391, -1391, -1391, -1391,
   -1391, -1391, -1391, -1391, -1391, -1391,  -183, -1391, -1391, -1391,
   -1391, -1391, -1391, -1391, -1391, -1391, -1391, -1391, -1391, -1391,
   -1391, -1391, -1391, -1391, -1391, -1391, -1391, -1391, -1391, -1391,
    1237,  1515, -1391, -1391, -1391, -1391,  -796,   863,   713,  1361,
    1180,  1514, -1391,  1047, -1391, -1391, -1039, -1391,   441,  -177,
    1118,   338,  -990,   903, -1342, -1028,  1715, -1212,  1134,   342,
   -1391, -1391,  -173,  1115, -1391, -1391, -1391, -1391,   418,   658,
   -1391, -1391, -1002, -1391,   104,   736,   -17, -1391, -1391,   571,
     919,   652, -1083, -1391, -1391, -1391, -1391,   883, -1391, -1391,
     646, -1391, -1391, -1391, -1391, -1391, -1391, -1391, -1391, -1391,
   -1391, -1391, -1391, -1391, -1391, -1391, -1391, -1391, -1391, -1391,
   -1391, -1391, -1391, -1391, -1391, -1391, -1391, -1391,   636, -1391,
   -1391, -1391, -1391, -1391, -1391, -1391,   583, -1391, -1391, -1391,
   -1391, -1391,  -361, -1391, -1391, -1391, -1391, -1391, -1391, -1391,
   -1391, -1391, -1391, -1391, -1391, -1391, -1391, -1391, -1391, -1391,
   -1391, -1391, -1391, -1391, -1391, -1391, -1391, -1391, -1391, -1391,
   -1391, -1391, -1391, -1391,   406,   387, -1391, -1391, -1391, -1391,
     308,   386, -1391, -1391, -1391, -1391,   307,   388, -1390, -1391,
   -1391, -1391, -1391, -1391, -1391, -1391, -1391, -1391, -1391, -1391,
   -1391,   992, -1391, -1391, -1391, -1391, -1391, -1391, -1391, -1391,
    -923
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,     3,    85,   548,  1478,   549,   389,   881,   952,
     953,   742,  1237,   200,   673,    86,   509,   201,   512,   502,
     503,    87,   208,   209,    88,    20,    21,    22,    23,    24,
      25,   131,   355,    89,   338,    90,   344,   339,    91,   527,
      92,   530,   841,    93,   522,    94,    95,   537,    96,    97,
     221,   247,   557,  1035,   857,   541,    98,   849,  1180,  1032,
     850,  1275,  1276,   816,   817,  1363,    99,   100,   550,   248,
     349,   682,   683,   366,   695,   696,   320,   925,   321,   322,
     937,    26,    27,    28,    29,   385,    30,    31,    32,   376,
     720,    33,   373,   706,    34,   377,   359,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,   193,
     505,    47,    48,    49,    50,    51,    52,    53,    54,    55,
     125,   370,   101,   528,   102,   831,   832,   833,  1028,   853,
     854,   558,   844,   835,   103,   533,  1169,  1170,  1389,   182,
     435,  1460,   772,   773,   436,  1152,   774,   437,   438,  1463,
     439,  1464,   183,   441,   442,  1391,   404,   184,   405,   414,
     185,   186,   187,  1172,   188,   476,  1150,  1173,  1270,  1271,
     753,   754,  1174,   104,  1042,   862,   105,  1186,  1407,  1341,
    1278,  1187,  1189,  1281,  1345,  1410,  1191,    56,   106,   107,
     108,   109,   298,   299,   300,   916,  1096,  1213,  1218,  1216,
    1217,  1351,  1421,  1097,  1353,  1431,  1098,  1506,  1350,  1415,
    1416,  1509,  1655,  1706,  1698,  1205,  1223,  1285,  1347,  1412,
    1349,  1206,   970,    57,    58,    59,    60,    61,    62,    63,
      64,   733,   110,   111,   112,  1107,  1229,  1230,   920,   113,
    1224,  1537,  1625,  1627,  1675,  1433,  1432,  1355,  1225,  1227,
    1440,  1357,  1356,  1299,  1228,  1302,  1358,  1547,  1635,  1441,
    1303,  1306,  1359,  1551,  1639,  1442,  1307,  1633,  1687,   114,
     115,   638,  1371,  1313,  1233,  1110,   630,   631,   116,   117,
     329,   944,   945,   330,    65,   118,    66,   119,   120,   121,
     477
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     189,   614,   390,   391,   434,   288,   217,   297,   440,   305,
     851,   386,  1149,   319,   926,   328,   966,  1382,   340,   345,
    1696,  1171,   387,   388,   387,   388,  1453,   510,   412,  1304,
     740,   433,   846,  -297,  1520,  1454,  1455,  1456,  1006,   583,
     585,   605,  -297,  -297,  -297,  -297,  1157,  1027,   428,  1461,
     399,  1616,   431,   515,   400,   428,   429,   430,   164,   431,
    -296,  1360,  1361,   401,   428,   218,   387,   388,   431,  -296,
    -296,  -296,  -296,  1157,   190,  1257,  1158,   479,   480,   481,
     482,   483,   191,   544,   545,   546,   547,  1265,   543,  1279,
     922,   484,   485,   486,   487,   488,   489,   490,   491,   568,
     635,   492,     1,  1158,   479,   480,   481,   482,   483,  1360,
    1361,   603,   582,  1159,  1454,  1455,  1456,  1006,   484,   485,
     486,   487,   488,   489,   490,   491,   779,   780,   492,   346,
     479,   480,   481,   482,   483,   428,   132,   347,   428,   431,
    1159,  1122,   431,   617,   484,   485,   486,   487,   488,   489,
     490,   491,   428,   415,   492,   855,   431,   544,   545,   546,
     547,   633,  1020,   427,   639,   640,   428,   577,  1171,   562,
     431,   544,   545,   546,   547,  1600,   650,   888,  1430,  1462,
     573,   479,   480,   481,   482,   483,  1160,  1161,  1162,  1163,
    1164,  1165,  1166,   569,   410,   484,   485,   486,   487,   488,
     489,   490,   491,   428,   687,   492,  1167,   431,  1109,  1168,
    1033,   371,  1578,  1160,  1161,  1162,  1163,  1164,  1165,  1166,
    1461,   606,   544,   545,   546,   547,  1325,   719,   836,   837,
     838,   839,   693,  1167,   428,   632,  1168,  1505,   431,   730,
    1688,   731,   732,  1521,   735,   737,  1522,    67,  1267,  1390,
     574,  1579,   428,   848,   904,   580,   431,   428,  1330,   135,
    1362,   431,   872,   873,   406,   604,  1454,  1455,  1456,  1006,
     599,   428,   578,   428,   694,   431,  1018,   431,  1280,   610,
     479,   480,   481,   482,   483,   615,  1702,  1115,   618,  1116,
     544,   545,   546,   547,   484,   485,   486,   487,   488,   489,
     490,   491,   939,   847,   492,   889,   428,   429,   430,  1006,
     431,   428,   429,   430,  1006,   431,  1021,  1617,   479,   480,
     481,   482,   483,  1241,  1614,   998,   663,   865,   665,   999,
    1171,  1179,   484,   485,   486,   487,   488,   489,   490,   491,
     363,   379,   492,   479,   480,   481,   482,   483,   364,  1451,
    1462,  1518,   642,   372,  1449,   877,  1589,   484,   485,   486,
     487,   488,   489,   490,   491,   734,   810,   492,   428,  1390,
     815,   971,   431,   511,   982,   411,   984,   387,   388,  1027,
     636,   637,  1544,   513,  1601,   747,  1171,  1602,  1545,   741,
    1448,   752,  1697,   531,  1413,   140,  1422,  1383,  1305,   761,
     762,   763,   764,   765,   856,   413,  1457,  1387,   151,   856,
    1458,   856,   152,  -297,  1558,   775,   539,  -297,   581,   514,
    1546,   402,   563,  1211,   934,   871,   432,   403,   192,  1615,
     941,   379,   942,   806,   882,   514,   884,  1300,   886,  1258,
    -296,   890,   891,  1401,  -296,  1507,   900,  1219,  1335,   951,
    1171,  1171,   126,  1508,   379,   736,   769,   195,  1336,   935,
     770,   210,   784,   785,   786,   787,   788,   789,   790,   791,
     792,   793,   794,   795,   796,   901,   902,  1274,   211,   921,
     428,   584,   516,   348,   431,  1643,   127,   990,   840,   781,
     805,   930,   926,   951,   128,   129,   130,   809,   213,   544,
     545,   546,   547,   406,   936,   406,   514,   406,   406,   514,
     643,   644,   946,   993,   947,   224,   212,   986,   517,   518,
     225,   950,  1645,   514,   380,   202,   479,   480,   481,   482,
     483,   203,   866,  1656,  1657,   226,  1082,   514,   215,   859,
     484,   485,   486,   487,   488,   489,   490,   491,  1402,  1403,
     492,   214,  1404,  1405,  1417,   777,   428,   962,   778,  1171,
     431,   219,  1333,  1641,   867,   479,   480,   481,   482,   483,
     874,   227,   876,   220,   514,   544,   545,   546,   547,   484,
     485,   486,   487,   488,   489,   490,   491,   892,   381,   492,
     985,   551,   897,   223,   899,   981,   903,   983,   905,   434,
     434,   908,   909,   910,   782,   514,  1070,   783,   126,   440,
     913,   196,   197,   915,  1024,   479,   480,   481,   482,   483,
    1134,   351,  1136,   514,   196,   197,   433,   433,   514,   484,
     485,   486,   487,   488,   489,   490,   491,  1457,   354,   492,
     552,   553,   514,   938,   514,   554,   523,   198,   524,   525,
     555,   352,   479,   480,   481,   482,   483,   228,   199,  1561,
     948,   949,  1562,   994,   356,  1284,   484,   485,   486,   487,
     488,   489,   490,   491,   122,   123,   492,   514,   357,  1446,
     797,   523,   432,   524,   525,  1130,   362,  1131,  1308,  1025,
    1394,  1133,  1548,    68,   365,  1418,   358,  1030,   124,  1549,
     374,   995,   216,   798,  1631,   375,   204,  1309,   122,   123,
     378,   799,   379,  1043,  1044,  1045,   800,   801,  1419,  1123,
    1208,  1209,  1314,    69,   229,   205,   997,  1406,   367,   368,
    1550,    70,   124,  1059,    71,  1061,   526,  1063,   350,   514,
    1117,   353,  1118,  1069,  1310,    72,  1395,  1396,   860,   206,
     861,  1000,   369,  1001,   382,  1661,  1210,   556,   387,   388,
    1041,   392,  1083,   393,  1084,    73,   394,   383,   384,    74,
     196,   197,    75,   395,    76,    77,   479,   480,   481,   482,
     483,   230,    78,   396,  1114,   397,   231,   398,   136,   137,
     484,   485,   486,   487,   488,   489,   490,   491,   407,  1420,
     492,  1397,  1373,  1374,  1375,  1376,  1398,  1366,   951,    79,
    1311,   207,   232,    80,   408,  1190,   409,   745,  1106,   746,
     504,   748,   749,  1157,   506,    81,   160,   233,   161,   162,
     163,   164,   165,   166,   416,   653,   417,   551,   418,   167,
     168,   771,   169,  1182,   170,    82,   490,   491,    83,   972,
     492,   514,  1036,  1158,   591,   592,   479,   480,   481,   482,
     483,   419,  1048,   420,  1312,   973,  1183,  1184,  1185,  1053,
     484,   485,   486,   487,   488,   489,   490,   491,   595,   596,
     492,   421,  1367,  1368,  1369,  1370,   552,   553,  1434,  1435,
    1159,   559,  1436,  1437,  1438,   507,   701,   508,   654,   171,
     479,   480,   481,   482,   483,   172,   519,  1198,   520,  1147,
    1570,  1571,  1572,   529,   484,   485,   486,   487,   488,   489,
     490,   491,   624,   625,   492,  1291,   521,   514,   974,  1439,
     655,   160,   532,   161,   162,   163,   164,   165,   166,   656,
     367,   368,  1215,   534,   167,   168,   540,   169,  1251,   170,
     802,   803,  1226,   535,   951,  1231,   811,   812,  1085,   813,
     814,   173,   174,  1160,  1161,  1162,  1163,  1164,  1165,  1166,
     153,   536,   702,   752,  1242,   538,  1142,  1143,  1144,   561,
    1145,   564,  1146,  1167,   954,   955,  1168,  1153,   542,   387,
     388,   940,   957,   958,   989,  1155,   175,   176,   422,   423,
     424,   425,   566,   556,   171,  1301,   154,   155,   703,   565,
     172,  1015,   803,   177,  1086,   704,   178,   387,   388,  1178,
     179,   479,   480,   481,   482,   483,   705,   567,  1651,  1652,
    1653,   996,  1672,  1673,  1674,   484,   485,   486,   487,   488,
     489,   490,   491,  1282,   676,   492,   572,   156,   157,   158,
     159,   570,   657,   658,   659,   660,  1474,  1475,  1286,  1287,
     575,  1289,  1319,  1320,   677,   678,   173,   174,   576,  1294,
     758,   759,  1295,   571,   579,    84,   975,   586,   679,   680,
    1207,   681,  1212,  1238,  1239,  1240,   587,   588,  1220,   589,
     590,   593,   594,   597,   598,   479,   480,   481,   482,   483,
    1087,   175,   176,   422,   423,   424,   425,   600,   601,   484,
     485,   486,   487,   488,   489,   490,   491,   602,   177,   492,
    1408,   178,   607,   608,   976,   179,   611,   612,   609,   160,
    1252,   161,   162,   163,   164,   165,   166,   613,   616,   977,
     619,   620,   167,   168,   621,   169,  1261,   170,   622,   623,
    1262,  1263,   629,  1088,   627,  1005,  1269,   978,   626,  1364,
     160,   628,   161,   162,   163,   164,   165,   166,   634,   641,
     645,   979,   980,   167,   168,   771,   169,  1089,   170,  1090,
     235,   722,   646,   651,   662,  1091,   649,  1092,   647,   648,
     664,  1093,  1094,   652,  -296,   661,   666,   723,   671,   180,
     324,  1414,   171,  1414,  1288,  1343,   181,   667,   172,   668,
    1443,  1444,  1445,   669,  1459,   236,   670,   672,   237,   674,
     675,   684,   238,   239,   686,   688,   241,   242,   689,   690,
     691,   692,   243,   171,  1321,  1148,   697,  1153,   699,   172,
    1327,   752,  1329,   700,   133,   134,   738,   138,   139,   739,
     743,   751,   744,   750,  1477,  1479,   194,   724,   755,  1095,
     756,   757,   725,   726,   173,   174,   244,   222,  1511,   766,
     727,   245,   767,  1514,  1515,  1516,   234,  1519,   760,  1247,
     492,   249,   325,   250,   776,   289,   768,   301,   804,   306,
     843,   307,   808,   323,   818,   173,   174,   728,   842,   175,
     176,   845,   858,   868,   180,   869,   875,   870,   878,   863,
     879,   181,   864,   880,   883,   885,   177,  1392,  1393,   178,
    1269,  1301,   887,   179,   893,   894,   896,   898,   895,   906,
     175,   176,   912,  1574,   907,   911,   729,   917,   918,   914,
     919,  1584,  1585,  1586,   923,  1588,  1590,   177,   943,   924,
     178,  1604,   927,   928,   179,   956,   310,   929,  1608,  1447,
     959,   931,   932,   933,   960,  1153,   961,  1610,  1611,   963,
     968,   991,   964,   360,   361,   967,  1226,   987,   969,   988,
    1002,   992,  1003,  1459,   310,  1459,  1004,  1009,  1629,  1630,
    1012,  1016,  1010,  1017,  1632,  1473,  1019,  1022,  1632,  1023,
    1248,  1301,   326,  1481,   852,  1031,  1033,  1034,  1046,   312,
    1047,  1510,  1049,  1512,  1050,  1051,  1052,  1477,  1477,  1477,
    1054,  1055,  1423,  1056,  1057,  1058,  1060,  1658,  1659,  1660,
    1540,  1541,  1542,  1062,  1064,  1065,  1066,  1663,  1067,  1664,
    1559,  1124,   479,   480,   481,   482,   483,  1068,  1071,  1072,
    1563,  1564,  1565,  1566,  1073,  1667,   484,   485,   486,   487,
     488,   489,   490,   491,  1670,  1074,   492,  1676,  1677,  1075,
    1076,  1679,  1680,  1077,  1249,  1078,  1079,  1080,  1081,  1576,
    1099,  1689,  1108,  1582,  1583,  1112,  1111,  1113,  1120,  1119,
    1128,  1121,   160,  1129,   161,   162,   163,   164,   165,   166,
    1132,  1135,   180,  -435,  1137,   167,   168,  1141,   169,   181,
     170,  1591,  1592,  1593,  1594,  1595,  1596,  1597,  1598,  1700,
    1138,  1701,  1139,  1619,  1154,  1175,   327,  1177,  1176,  1192,
    1193,  1703,   160,   180,   161,   162,   163,   164,   165,   166,
     181,  1194,  1195,  1196,  1197,   167,   168,  1324,   169,  1199,
     170,   819,   820,   821,   822,   823,   824,   825,  1200,   826,
     827,   828,   829,   830,  1201,   171,  1202,  1654,  1424,  1425,
    1426,   172,  1427,  1203,   160,  1662,   161,   162,   163,   164,
     165,   166,  1214,  1428,  1236,  1204,  1221,   167,   168,  1222,
     169,  1232,   170,  1665,  1243,  1244,  1235,  1666,  1245,  1246,
    1668,  1253,  1255,  1254,  1259,   171,  1260,  1323,  1268,  1264,
    1273,   172,  1334,  1277,  1678,  1283,  1315,  1339,  1682,  1326,
    1684,   479,   480,   481,   482,   483,  1691,   173,   174,  1342,
    1344,  1365,  1316,  1377,  1378,   484,   485,   486,   487,   488,
     489,   490,   491,  1317,  1290,   492,  1409,   171,  1292,  1293,
    1296,  1318,  1298,   172,  1338,  1337,  1348,   479,   480,   481,
     482,   483,   175,   176,  1346,  1354,  1372,   173,   174,  1400,
    1429,   484,   485,   486,   487,   488,   489,   490,   491,   177,
    1704,   492,   178,  1380,  1452,  1381,   179,   493,   494,   495,
     496,   497,   498,   499,   500,   501,  1467,   479,   480,   481,
     482,   483,   175,   176,  1385,  1471,  1450,  1157,  1468,   173,
     174,   484,   485,   486,   487,   488,   489,   490,   491,   177,
    1469,   492,   178,  1470,  1472,  1476,   179,  1480,  1513,   141,
     142,  1517,   479,   480,   481,   482,   483,  1158,   143,  1538,
    1523,  1539,  1552,  1560,   175,   176,   484,   485,   486,   487,
     488,   489,   490,   491,  1543,  1555,   492,   144,  1567,  1553,
    1568,   177,  1554,   145,   178,   146,   147,  1556,   179,   479,
     480,   481,   482,   483,  1159,  1569,  1573,  1575,  1581,  1577,
    1599,  1587,  1603,   484,   485,   486,   487,   488,   489,   490,
     491,  1605,  1612,   492,   479,   480,   481,   482,   483,  1606,
    1607,  1609,  1618,  1620,  1621,  1623,  1622,  1628,   484,   485,
     486,   487,   488,   489,   490,   491,  1624,  1626,   492,  1304,
    1636,  1250,   479,   480,   481,   482,   483,  1640,  1681,   148,
    1669,  1671,  1686,  1690,  1692,  1693,   484,   485,   486,   487,
     488,   489,   490,   491,  1699,  1705,   492,  1160,  1161,  1162,
    1163,  1164,  1165,  1166,  1694,   807,   685,  1695,  1707,   479,
     480,   481,   482,   483,  -430,   180,   560,  1167,  1013,  1297,
    1168,  1580,   181,   484,   485,   486,   487,   488,   489,   490,
     491,  1126,  1181,   492,   698,  1156,  1127,  1234,  1272,   834,
     721,  1029,   965,  1557,  1007,   426,   149,  1011,  1644,   479,
     480,   481,   482,   483,  1646,   180,  1151,  1266,  1399,  1140,
    1328,  1008,   181,   484,   485,   486,   487,   488,   489,   490,
     491,  1188,  1340,   492,   479,   480,   481,   482,   483,  1352,
    1411,  1613,  1634,  1683,  1685,  1638,  1637,  1125,   484,   485,
     486,   487,   488,   489,   490,   491,     0,   180,   492,   479,
     480,   481,   482,   483,   181,     0,     0,     0,     0,   443,
       0,     0,     0,   484,   485,   486,   487,   488,   489,   490,
     491,     0,     0,   492,   479,   480,   481,   482,   483,     0,
       0,     0,     0,     0,     0,     0,     0,   443,   484,   485,
     486,   487,   488,   489,   490,   491,     0,     0,   492,   150,
    1256,   479,   480,   481,   482,   483,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   484,   485,   486,   487,   488,
     489,   490,   491,     0,     0,   492,   479,   480,   481,   482,
     483,   444,   445,     0,   446,   447,  1322,     0,     0,     0,
     484,   485,   486,   487,   488,   489,   490,   491,     0,     0,
     492,     0,     0,   235,     0,     0,     0,     0,     0,   444,
     445,     0,   446,   447,     0,   479,   480,   481,   482,   483,
       0,     0,     0,     0,   308,     0,  1379,  1388,     0,   484,
     485,   486,   487,   488,   489,   490,   491,   448,   236,   492,
       0,   237,     0,   449,     0,   238,   239,     0,   309,   241,
     242,     0,     0,     0,     0,   243,     0,     0,     0,     0,
       0,  1642,     0,   310,     0,     0,     0,     0,   235,     0,
       0,   449,   819,   820,   821,   822,   823,   824,   825,     0,
     826,   827,   828,   829,   830,     0,     0,   311,   312,   244,
       0,     0,     0,     0,   245,     0,     0,     0,  1647,     0,
       0,     0,     0,   236,     0,     0,   237,     0,     0,     0,
     238,   239,     0,     0,   241,   242,     0,  -436,  -436,  -436,
     243,   450,   451,  1648,   452,   453,   454,   455,   456,   457,
     458,  -436,  -436,  -436,  -436,   488,   489,   490,   491,     0,
       0,   492,   459,   460,   461,   462,   463,   464,   465,   466,
     467,  1649,     0,     0,   244,     0,     0,   235,     0,   245,
       0,     0,     0,     0,     0,     0,     0,     0,   468,   469,
     459,   460,   461,   462,   463,   464,   465,   466,   467,     0,
       0,     0,     0,   470,   471,   472,   473,  1332,  1650,     0,
       0,     0,   236,   235,     0,   237,   468,   469,   251,   238,
     239,     0,  1037,   241,   242,     0,     0,     0,     0,   243,
       0,   470,   471,   472,   473,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   252,     0,  1014,     0,   236,     0,
       0,   237,     0,     0,     0,   238,   239,   253,     0,   241,
     242,     0,     0,   244,     0,   243,     0,     0,   245,     0,
     254,  1331,     0,   255,     0,   256,     0,     0,     0,     0,
       0,     0,   313,   819,   820,   821,   822,   823,   824,   825,
       0,   826,   827,   828,   829,   830,  1384,   235,     0,   244,
       0,     0,   474,   475,   245,     0,     0,     0,     0,     0,
       0,     0,     0,  1026,     0,   257,     0,   258,     0,  1524,
       0,  1386,   290,     0,     0,     0,   259,   291,   292,   293,
     474,   475,   236,     0,     0,   237,     0,     0,     0,   238,
     239,     0,  1100,   241,   242,   314,   315,   316,  1465,   243,
    1038,  1039,     0,     0,   317,     0,     0,     0,     0,     0,
       0,     0,   260,     0,   294,     0,     0,     0,  1525,   318,
       0,     0,     0,  1466,     0,   295,     0,     0,     0,   261,
       0,     0,     0,   244,     0,     0,   262,   263,   245,   264,
       0,   265,   266,     0,   267,   268,     0,   269,     0,     0,
     270,   271,     0,   272,     0,     0,     0,     0,     0,     0,
    1526,     0,     0,     0,     0,     0,   273,   274,   235,     0,
     235,   275,  1101,   276,   277,     0,   278,     0,     0,     0,
    1527,   279,     0,   235,   296,   280,   281,     0,   282,   283,
       0,   284,   285,   286,   331,   332,   333,     0,   334,   335,
       0,   336,     0,   236,     0,   236,   237,     0,   237,   341,
     238,   239,   238,   239,   241,   242,   241,   242,   236,     0,
     243,   237,   243,  1482,     0,   238,   239,     0,     0,   241,
     242,     0,   707,   235,     0,   243,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   387,   388,     0,
       0,   342,     0,     0,   244,     0,   244,     0,     0,   245,
    1528,   245,     0,   310,     0,     0,     0,     0,   236,   244,
       0,   237,   708,  1040,   245,   238,   239,     0,   240,   241,
     242,     0,     0,     0,     0,   243,     0,     0,   312,     0,
    1529,  1530,     0,     4,  1531,  1532,     0,  1533,     0,     0,
       0,  1483,     0,     0,     0,  1534,  1535,     0,   709,   287,
       0,     0,  1484,   710,     0,     5,     6,     0,     0,   244,
     711,   712,     0,     0,   245,     7,     0,     0,     0,     0,
       0,     0,   713,     0,     0,     0,     0,     0,     0,  1536,
       0,   714,   715,   716,   717,     0,   718,     0,     0,     0,
       8,     0,     0,     0,     0,     0,     0,     0,     0,  1102,
    1103,     0,     0,  1104,     0,     0,     0,     0,     0,  1485,
       9,     0,  1486,  1487,     0,     0,     0,     0,     0,     0,
       0,    10,     0,     0,    11,     0,    12,     0,     0,     0,
       0,     0,    13,  1105,     0,     0,     0,    14,    15,    16,
       0,     0,   478,     0,    17,    18,    19,   479,   480,   481,
     482,   483,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   484,   485,   486,   487,   488,   489,   490,   491,  1488,
       0,   492,  1489,     0,     0,     0,     0,     0,   556,     0,
       0,     0,     0,  1490,     0,  1491,     0,  1492,  1493,  1494,
    1495,  1496,  1497,   479,   480,   481,   482,   483,  1498,   302,
     303,     0,  1499,  1500,     0,     0,  1501,   484,   485,   486,
     487,   488,   489,   490,   491,     0,     0,   492,     0,  1502,
     479,   480,   481,     0,     0,     0,     0,  1503,     0,     0,
       0,     0,     0,     0,   484,   485,   486,   487,   488,   489,
     490,   491,     0,     0,   492,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   304,     0,   337,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   343,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1504,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   246
};

static const yytype_int16 yycheck[] =
{
      17,   290,   151,   152,   181,   107,    81,   109,   181,   111,
     550,   150,  1002,   115,   634,   117,   717,     7,   120,   121,
      18,  1023,    18,    19,    18,    19,     6,    43,    15,    20,
      29,   181,   119,     6,    93,    15,    16,    17,    18,   263,
     264,    88,    15,    16,    17,    18,    19,   843,    15,  1391,
      15,    86,    19,   203,    19,    15,    16,    17,    18,    19,
       6,   140,   141,    28,    15,    82,    18,    19,    19,    15,
      16,    17,    18,    19,    35,    22,    49,     8,     9,    10,
      11,    12,    43,    34,    35,    36,    37,  1170,   238,    30,
     630,    22,    23,    24,    25,    26,    27,    28,    29,   142,
      93,    32,     4,    49,     8,     9,    10,    11,    12,   140,
     141,    79,   262,    86,    15,    16,    17,    18,    22,    23,
      24,    25,    26,    27,    28,    29,    26,    27,    32,    35,
       8,     9,    10,    11,    12,    15,     3,    43,    15,    19,
      86,   941,    19,   293,    22,    23,    24,    25,    26,    27,
      28,    29,    15,   170,    32,    35,    19,    34,    35,    36,
      37,   311,    19,   180,   314,   315,    15,   146,  1170,   244,
      19,    34,    35,    36,    37,    93,   325,   102,  1353,  1391,
     255,     8,     9,    10,    11,    12,   159,   160,   161,   162,
     163,   164,   165,   236,    27,    22,    23,    24,    25,    26,
      27,    28,    29,    15,   354,    32,   179,    19,   389,   182,
     391,     3,   291,   159,   160,   161,   162,   163,   164,   165,
    1562,   268,    34,    35,    36,    37,  1254,   376,   125,   126,
     127,   128,    94,   179,    15,   310,   182,  1412,    19,   378,
    1630,   380,   381,   302,   383,   384,   305,     0,  1171,  1332,
     256,   330,    15,   542,   603,   261,    19,    15,  1260,   119,
     291,    19,   213,   214,   160,   233,    15,    16,    17,    18,
     276,    15,   251,    15,   136,    19,   816,    19,   219,   285,
       8,     9,    10,    11,    12,   291,  1676,   105,   294,   107,
      34,    35,    36,    37,    22,    23,    24,    25,    26,    27,
      28,    29,   651,   390,    32,   230,    15,    16,    17,    18,
      19,    15,    16,    17,    18,    19,   173,   352,     8,     9,
      10,    11,    12,  1123,   235,   387,   332,    71,   334,   391,
    1332,  1032,    22,    23,    24,    25,    26,    27,    28,    29,
      35,    19,    32,     8,     9,    10,    11,    12,    43,  1388,
    1562,   114,   218,   145,  1382,   579,   114,    22,    23,    24,
      25,    26,    27,    28,    29,    43,   516,    32,    15,  1452,
     520,   732,    19,   389,   735,   208,   737,    18,    19,  1175,
     373,   374,   352,   202,   302,   402,  1388,   305,   358,   388,
    1380,   408,   390,   216,   390,     3,   390,   387,   389,   416,
     417,   418,   419,   420,   554,   392,   386,  1330,   119,   559,
     390,   561,   119,   386,  1453,   432,   235,   390,   385,   386,
     390,   386,   245,   286,    83,   575,   386,   392,   389,   340,
     654,    19,   656,   508,   584,   386,   586,   389,   588,   386,
     386,   591,   592,   106,   390,   309,   230,   324,    22,   673,
    1452,  1453,    20,   317,    19,    43,   387,    19,    32,   118,
     391,    76,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   259,   260,  1178,    19,   629,
      15,   122,    20,   389,    19,   386,    54,   391,   385,   389,
     507,   641,  1112,   717,    62,    63,    64,   514,    19,    34,
      35,    36,    37,   399,   163,   401,   386,   403,   404,   386,
     376,   377,   662,   391,   664,    68,    83,   741,    56,    57,
      73,   671,  1561,   386,    89,   110,     8,     9,    10,    11,
      12,   116,   276,   314,   315,    88,   385,   386,   124,   556,
      22,    23,    24,    25,    26,    27,    28,    29,   211,   212,
      32,    79,   215,   216,   145,   391,    15,   706,   394,  1561,
      19,    19,   389,  1553,   570,     8,     9,    10,    11,    12,
     576,   124,   578,    19,   386,    34,    35,    36,    37,    22,
      23,    24,    25,    26,    27,    28,    29,   593,   153,    32,
     740,    43,   598,   389,   600,   734,   602,   736,   604,   776,
     777,   607,   608,   609,   391,   386,   895,   394,    20,   782,
     616,    19,    20,   619,   838,     8,     9,    10,    11,    12,
     981,     3,   983,   386,    19,    20,   776,   777,   386,    22,
      23,    24,    25,    26,    27,    28,    29,   386,    65,    32,
      92,    93,   386,   649,   386,    97,    15,    42,    17,    18,
     102,     3,     8,     9,    10,    11,    12,   210,    53,   388,
     666,   667,   391,   391,     3,  1205,    22,    23,    24,    25,
      26,    27,    28,    29,    19,    20,    32,   386,     3,   214,
     168,    15,   386,    17,    18,   974,     3,   976,   214,   839,
      92,   980,   352,     3,   389,   286,    79,   846,    43,   359,
       3,   391,   110,   191,   351,     3,    41,   233,    19,    20,
     221,   199,    19,   863,   864,   865,   204,   205,   309,   943,
     286,   287,  1235,    33,   277,    60,   391,   390,    19,    20,
     390,    41,    43,   883,    44,   885,   105,   887,   127,   386,
     105,   130,   107,   893,   270,    55,   148,   149,   559,    84,
     561,   768,    43,   770,   319,   214,   322,   209,    18,    19,
     862,     3,   912,     3,   914,    75,     3,   332,   333,    79,
      19,    20,    82,     3,    84,    85,     8,     9,    10,    11,
      12,   334,    92,     3,   934,     3,   339,     3,   133,   134,
      22,    23,    24,    25,    26,    27,    28,    29,    29,   390,
      32,   203,  1315,  1316,  1317,  1318,   208,   294,  1032,   119,
     336,   146,   365,   123,   386,  1039,   208,   399,   920,   401,
      15,   403,   404,    19,     3,   135,    13,   380,    15,    16,
      17,    18,    19,    20,   386,   164,   386,    43,   386,    26,
      27,    28,    29,    76,    31,   155,    28,    29,   158,     3,
      32,   386,   858,    49,   239,   240,     8,     9,    10,    11,
      12,   386,   868,   386,   390,    19,    99,   100,   101,   875,
      22,    23,    24,    25,    26,    27,    28,    29,   249,   250,
      32,   386,   369,   370,   371,   372,    92,    93,   349,   350,
      86,    97,   353,   354,   355,    22,     3,    61,   227,    86,
       8,     9,    10,    11,    12,    92,   385,  1057,   142,   391,
      38,    39,    40,    19,    22,    23,    24,    25,    26,    27,
      28,    29,   337,   338,    32,  1214,   131,   386,    82,   390,
     259,    13,   385,    15,    16,    17,    18,    19,    20,   268,
      19,    20,  1091,   105,    26,    27,    19,    29,   391,    31,
     390,   391,  1101,   389,  1178,  1104,    58,    59,    89,    58,
      59,   148,   149,   159,   160,   161,   162,   163,   164,   165,
      74,   389,    79,   990,  1124,   389,   993,   994,   995,    97,
     997,   385,   999,   179,   390,   391,   182,  1004,    83,    18,
      19,    20,   390,   391,   387,  1012,   183,   184,   185,   186,
     187,   188,   389,   209,    86,  1229,   110,   111,   115,   385,
      92,   390,   391,   200,   145,   122,   203,    18,    19,    20,
     207,     8,     9,    10,    11,    12,   133,   389,  1567,  1568,
    1569,   387,   362,   363,   364,    22,    23,    24,    25,    26,
      27,    28,    29,  1193,    74,    32,   237,   151,   152,   153,
     154,    76,   381,   382,   383,   384,   213,   214,  1208,  1209,
      97,  1211,  1245,  1246,    94,    95,   148,   149,   275,  1219,
     412,   413,  1222,   385,   127,   385,   230,    71,   108,   109,
    1086,   111,  1088,  1116,  1117,  1118,   224,    71,  1094,   222,
     229,   233,   235,   249,   253,     8,     9,    10,    11,    12,
     231,   183,   184,   185,   186,   187,   188,   256,   258,    22,
      23,    24,    25,    26,    27,    28,    29,   263,   200,    32,
    1344,   203,   233,   271,   278,   207,   220,   385,   269,    13,
    1147,    15,    16,    17,    18,    19,    20,   389,    82,   293,
     318,   385,    26,    27,   389,    29,  1163,    31,   389,    79,
    1167,  1168,    71,   284,   389,   387,  1173,   311,   385,  1309,
      13,   389,    15,    16,    17,    18,    19,    20,   389,    71,
     385,   325,   326,    26,    27,    28,    29,   308,    31,   310,
      44,     3,   385,    79,    79,   316,   311,   318,   389,   389,
      71,   322,   323,   385,   390,   385,    74,    19,    71,   386,
      64,  1350,    86,  1352,  1210,  1280,   393,    76,    92,   385,
    1360,  1361,  1362,   385,  1391,    79,   385,    20,    82,   385,
     385,     3,    86,    87,     3,     3,    90,    91,    19,     3,
       3,     3,    96,    86,  1251,   387,     3,  1254,     3,    92,
    1257,  1258,  1259,     3,     7,     8,     3,    10,    11,     3,
     120,    15,   120,    14,  1404,  1405,    19,    79,    26,   390,
     208,    27,    84,    85,   148,   149,   130,    90,  1418,    19,
      92,   135,    15,  1423,  1424,  1425,    99,  1427,    29,   387,
      32,   104,   146,   106,     7,   108,   391,   110,     3,   112,
     386,   114,   385,   116,   385,   148,   149,   119,   385,   183,
     184,    19,   103,    49,   386,   385,   261,   385,   385,    71,
     385,   393,    71,    30,   122,    71,   200,  1334,  1335,   203,
    1337,  1545,    71,   207,    71,   385,   385,   385,    83,   385,
     183,   184,   122,  1483,   385,   385,   158,    19,   385,    97,
     385,  1491,  1492,  1493,   385,  1495,  1496,   200,   227,   385,
     203,  1501,   385,   385,   207,     3,   104,   385,  1508,  1365,
       3,   385,   385,   385,    19,  1382,    15,  1517,  1518,    19,
       3,   387,    19,   136,   137,    19,  1525,    15,    20,    15,
       7,    27,   391,  1560,   104,  1562,   391,    15,  1538,  1539,
     386,    20,    18,   385,  1544,  1401,   385,   385,  1548,   389,
     387,  1625,   266,  1409,    19,    27,   391,    98,   385,   129,
     385,  1417,   385,  1419,   385,   385,   385,  1567,  1568,  1569,
     385,   385,   142,    19,   122,   385,   385,  1577,  1578,  1579,
    1436,  1437,  1438,   385,   385,   385,   385,  1587,   385,  1589,
    1457,   321,     8,     9,    10,    11,    12,   385,   385,   385,
    1467,  1468,  1469,  1470,   385,  1605,    22,    23,    24,    25,
      26,    27,    28,    29,  1614,   385,    32,  1617,  1618,   385,
     385,  1621,  1622,   385,   387,   385,   385,   385,   385,  1485,
     385,  1631,   385,  1489,  1490,   385,   390,   385,   385,   390,
       3,   385,    13,     3,    15,    16,    17,    18,    19,    20,
      15,     3,   386,   387,     3,    26,    27,    27,    29,   393,
      31,   294,   295,   296,   297,   298,   299,   300,   301,  1669,
     122,  1671,   122,  1529,   391,   385,   390,   120,   387,   385,
     391,  1681,    13,   386,    15,    16,    17,    18,    19,    20,
     393,   385,   385,   385,   385,    26,    27,    28,    29,   385,
      31,   166,   167,   168,   169,   170,   171,   172,   385,   174,
     175,   176,   177,   178,   385,    86,   385,  1573,   288,   289,
     290,    92,   292,   385,    13,  1581,    15,    16,    17,    18,
      19,    20,   311,   303,    20,   385,   385,    26,    27,   327,
      29,   385,    31,  1599,     3,     3,   385,  1603,    15,    15,
    1606,   387,    15,   391,    22,    86,   386,     7,   385,   390,
      15,    92,    22,   389,  1620,   385,   385,   122,  1624,   390,
    1626,     8,     9,    10,    11,    12,  1643,   148,   149,    19,
     220,   271,   385,     3,     3,    22,    23,    24,    25,    26,
      27,    28,    29,   385,   389,    32,   217,    86,   389,   389,
     389,   385,   389,    92,   385,   391,   389,     8,     9,    10,
      11,    12,   183,   184,   385,   389,   385,   148,   149,    15,
     390,    22,    23,    24,    25,    26,    27,    28,    29,   200,
    1686,    32,   203,   386,   181,   387,   207,    44,    45,    46,
      47,    48,    49,    50,    51,    52,   386,     8,     9,    10,
      11,    12,   183,   184,   387,   385,   387,    19,   386,   148,
     149,    22,    23,    24,    25,    26,    27,    28,    29,   200,
     386,    32,   203,   386,   385,   214,   207,   385,   385,   110,
     111,   235,     8,     9,    10,    11,    12,    49,   119,   352,
     385,   352,   312,     7,   183,   184,    22,    23,    24,    25,
      26,    27,    28,    29,   385,   385,    32,   138,   215,   391,
     215,   200,   387,   144,   203,   146,   147,   390,   207,     8,
       9,    10,    11,    12,    86,   215,   311,   389,   271,   313,
     329,   235,   296,    22,    23,    24,    25,    26,    27,    28,
      29,   321,   340,    32,     8,     9,    10,    11,    12,   294,
     385,   385,   344,   343,    71,   229,   347,   385,    22,    23,
      24,    25,    26,    27,    28,    29,   220,   220,    32,    20,
     385,   387,     8,     9,    10,    11,    12,   385,    97,   210,
     215,   215,   361,   387,   385,   385,    22,    23,    24,    25,
      26,    27,    28,    29,   312,   306,    32,   159,   160,   161,
     162,   163,   164,   165,   385,   511,   350,   385,   385,     8,
       9,    10,    11,    12,   385,   386,   242,   179,   803,  1224,
     182,  1487,   393,    22,    23,    24,    25,    26,    27,    28,
      29,   955,  1033,    32,   369,  1022,   958,  1112,  1175,   528,
     376,   844,   712,  1452,   776,   180,   277,   782,  1560,     8,
       9,    10,    11,    12,  1562,   386,  1003,  1171,  1337,   990,
    1258,   777,   393,    22,    23,    24,    25,    26,    27,    28,
      29,  1038,  1276,    32,     8,     9,    10,    11,    12,  1293,
    1347,  1525,  1545,  1625,  1627,  1549,  1548,   945,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,   386,    32,     8,
       9,    10,    11,    12,   393,    -1,    -1,    -1,    -1,     5,
      -1,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    -1,    32,     8,     9,    10,    11,    12,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     5,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    -1,    32,   380,
     387,     8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    -1,    32,     8,     9,    10,    11,
      12,    77,    78,    -1,    80,    81,   387,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    -1,
      32,    -1,    -1,    44,    -1,    -1,    -1,    -1,    -1,    77,
      78,    -1,    80,    81,    -1,     8,     9,    10,    11,    12,
      -1,    -1,    -1,    -1,    65,    -1,   387,   389,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,   105,    79,    32,
      -1,    82,    -1,   139,    -1,    86,    87,    -1,    89,    90,
      91,    -1,    -1,    -1,    -1,    96,    -1,    -1,    -1,    -1,
      -1,   387,    -1,   104,    -1,    -1,    -1,    -1,    44,    -1,
      -1,   139,   166,   167,   168,   169,   170,   171,   172,    -1,
     174,   175,   176,   177,   178,    -1,    -1,   128,   129,   130,
      -1,    -1,    -1,    -1,   135,    -1,    -1,    -1,   387,    -1,
      -1,    -1,    -1,    79,    -1,    -1,    82,    -1,    -1,    -1,
      86,    87,    -1,    -1,    90,    91,    -1,     8,     9,    10,
      96,   189,   190,   387,   192,   193,   194,   195,   196,   197,
     198,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      -1,    32,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   387,    -1,    -1,   130,    -1,    -1,    44,    -1,   135,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   264,   265,
     238,   239,   240,   241,   242,   243,   244,   245,   246,    -1,
      -1,    -1,    -1,   279,   280,   281,   282,   180,   387,    -1,
      -1,    -1,    79,    44,    -1,    82,   264,   265,    49,    86,
      87,    -1,    89,    90,    91,    -1,    -1,    -1,    -1,    96,
      -1,   279,   280,   281,   282,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    75,    -1,   385,    -1,    79,    -1,
      -1,    82,    -1,    -1,    -1,    86,    87,    88,    -1,    90,
      91,    -1,    -1,   130,    -1,    96,    -1,    -1,   135,    -1,
     101,   385,    -1,   104,    -1,   106,    -1,    -1,    -1,    -1,
      -1,    -1,   303,   166,   167,   168,   169,   170,   171,   172,
      -1,   174,   175,   176,   177,   178,   385,    44,    -1,   130,
      -1,    -1,   378,   379,   135,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   387,    -1,   146,    -1,   148,    -1,   120,
      -1,   385,   278,    -1,    -1,    -1,   157,   283,   284,   285,
     378,   379,    79,    -1,    -1,    82,    -1,    -1,    -1,    86,
      87,    -1,    89,    90,    91,   366,   367,   368,   385,    96,
     217,   218,    -1,    -1,   375,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   193,    -1,   320,    -1,    -1,    -1,   169,   390,
      -1,    -1,    -1,   385,    -1,   331,    -1,    -1,    -1,   210,
      -1,    -1,    -1,   130,    -1,    -1,   217,   218,   135,   220,
      -1,   222,   223,    -1,   225,   226,    -1,   228,    -1,    -1,
     231,   232,    -1,   234,    -1,    -1,    -1,    -1,    -1,    -1,
     211,    -1,    -1,    -1,    -1,    -1,   247,   248,    44,    -1,
      44,   252,   169,   254,   255,    -1,   257,    -1,    -1,    -1,
     231,   262,    -1,    44,   390,   266,   267,    -1,   269,   270,
      -1,   272,   273,   274,    68,    69,    70,    -1,    72,    73,
      -1,    75,    -1,    79,    -1,    79,    82,    -1,    82,    70,
      86,    87,    86,    87,    90,    91,    90,    91,    79,    -1,
      96,    82,    96,    64,    -1,    86,    87,    -1,    -1,    90,
      91,    -1,     3,    44,    -1,    96,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    -1,
      -1,   112,    -1,    -1,   130,    -1,   130,    -1,    -1,   135,
     311,   135,    -1,   104,    -1,    -1,    -1,    -1,    79,   130,
      -1,    82,    43,   390,   135,    86,    87,    -1,    89,    90,
      91,    -1,    -1,    -1,    -1,    96,    -1,    -1,   129,    -1,
     341,   342,    -1,    44,   345,   346,    -1,   348,    -1,    -1,
      -1,   142,    -1,    -1,    -1,   356,   357,    -1,    79,   390,
      -1,    -1,   153,    84,    -1,    66,    67,    -1,    -1,   130,
      91,    92,    -1,    -1,   135,    76,    -1,    -1,    -1,    -1,
      -1,    -1,   103,    -1,    -1,    -1,    -1,    -1,    -1,   390,
      -1,   112,   113,   114,   115,    -1,   117,    -1,    -1,    -1,
     101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   356,
     357,    -1,    -1,   360,    -1,    -1,    -1,    -1,    -1,   210,
     121,    -1,   213,   214,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   132,    -1,    -1,   135,    -1,   137,    -1,    -1,    -1,
      -1,    -1,   143,   390,    -1,    -1,    -1,   148,   149,   150,
      -1,    -1,     3,    -1,   155,   156,   157,     8,     9,    10,
      11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,   270,
      -1,    32,   273,    -1,    -1,    -1,    -1,    -1,   209,    -1,
      -1,    -1,    -1,   284,    -1,   286,    -1,   288,   289,   290,
     291,   292,   293,     8,     9,    10,    11,    12,   299,   335,
     336,    -1,   303,   304,    -1,    -1,   307,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    -1,    32,    -1,   320,
       8,     9,    10,    -1,    -1,    -1,    -1,   328,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    -1,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   390,    -1,   390,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   390,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   390,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   390
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,     4,   396,   397,    44,    66,    67,    76,   101,   121,
     132,   135,   137,   143,   148,   149,   150,   155,   156,   157,
     420,   421,   422,   423,   424,   425,   476,   477,   478,   479,
     481,   482,   483,   486,   489,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   582,   618,   619,   620,
     621,   622,   623,   624,   625,   679,   681,     0,     3,    33,
      41,    44,    55,    75,    79,    82,    84,    85,    92,   119,
     123,   135,   155,   158,   385,   398,   410,   416,   419,   428,
     430,   433,   435,   438,   440,   441,   443,   444,   451,   461,
     462,   517,   519,   529,   568,   571,   583,   584,   585,   586,
     627,   628,   629,   634,   664,   665,   673,   674,   680,   682,
     683,   684,    19,    20,    43,   515,    20,    54,    62,    63,
      64,   426,     3,   515,   515,   119,   133,   134,   515,   515,
       3,   110,   111,   119,   138,   144,   146,   147,   210,   277,
     380,   119,   119,    74,   110,   111,   151,   152,   153,   154,
      13,    15,    16,    17,    18,    19,    20,    26,    27,    29,
      31,    86,    92,   148,   149,   183,   184,   200,   203,   207,
     386,   393,   534,   547,   552,   555,   556,   557,   559,   561,
      35,    43,   389,   504,   515,    19,    19,    20,    42,    53,
     408,   412,   110,   116,    41,    60,    84,   146,   417,   418,
      76,    19,    83,    19,    79,   124,   110,   408,   561,    19,
      19,   445,   445,   389,    68,    73,    88,   124,   210,   277,
     334,   339,   365,   380,   445,    44,    79,    82,    86,    87,
      89,    90,    91,    96,   130,   135,   390,   446,   464,   445,
     445,    49,    75,    88,   101,   104,   106,   146,   148,   157,
     193,   210,   217,   218,   220,   222,   223,   225,   226,   228,
     231,   232,   234,   247,   248,   252,   254,   255,   257,   262,
     266,   267,   269,   270,   272,   273,   274,   390,   446,   445,
     278,   283,   284,   285,   320,   331,   390,   446,   587,   588,
     589,   445,   335,   336,   390,   446,   445,   445,    65,    89,
     104,   128,   129,   303,   366,   367,   368,   375,   390,   446,
     471,   473,   474,   445,    64,   146,   266,   390,   446,   675,
     678,    68,    69,    70,    72,    73,    75,   390,   429,   432,
     446,    70,   112,   390,   431,   446,    35,    43,   389,   465,
     426,     3,     3,   426,    65,   427,     3,     3,    79,   491,
     515,   515,     3,    35,    43,   389,   468,    19,    20,    43,
     516,     3,   145,   487,     3,     3,   484,   490,   221,    19,
      89,   153,   319,   332,   333,   480,   480,    18,    19,   402,
     404,   404,     3,     3,     3,     3,     3,     3,     3,    15,
      19,    28,   386,   392,   551,   553,   559,    29,   386,   208,
      27,   208,    15,   392,   554,   561,   386,   386,   386,   386,
     386,   386,   185,   186,   187,   188,   541,   561,    15,    16,
      17,    19,   386,   399,   534,   535,   539,   542,   543,   545,
     547,   548,   549,     5,    77,    78,    80,    81,   105,   139,
     189,   190,   192,   193,   194,   195,   196,   197,   198,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   264,   265,
     279,   280,   281,   282,   378,   379,   560,   685,     3,     8,
       9,    10,    11,    12,    22,    23,    24,    25,    26,    27,
      28,    29,    32,    44,    45,    46,    47,    48,    49,    50,
      51,    52,   414,   415,    15,   505,     3,    22,    61,   411,
      43,   389,   413,   465,   386,   399,    20,    56,    57,   385,
     142,   131,   439,    15,    17,    18,   105,   434,   518,    19,
     436,   468,   385,   530,   105,   389,   389,   442,   389,   465,
      19,   450,    83,   399,    34,    35,    36,    37,   399,   401,
     463,    43,    92,    93,    97,   102,   209,   447,   526,    97,
     447,    97,   408,   468,   385,   385,   389,   389,   142,   236,
      76,   385,   237,   408,   401,    97,   275,   146,   251,   127,
     401,   385,   399,   402,   122,   402,    71,   224,    71,   222,
     229,   239,   240,   233,   235,   249,   250,   249,   253,   401,
     256,   258,   263,    79,   233,    88,   268,   233,   271,   269,
     401,   220,   385,   389,   434,   401,    82,   399,   401,   318,
     385,   389,   389,    79,   337,   338,   385,   389,   389,    71,
     671,   672,   408,   399,   389,    93,   373,   374,   666,   399,
     399,    71,   218,   376,   377,   385,   385,   389,   389,   311,
     404,    79,   385,   164,   227,   259,   268,   381,   382,   383,
     384,   385,    79,   401,    71,   401,    74,    76,   385,   385,
     385,    71,    20,   409,   385,   385,    74,    94,    95,   108,
     109,   111,   466,   467,     3,   427,     3,   399,     3,    19,
       3,     3,     3,    94,   136,   469,   470,     3,   516,     3,
       3,     3,    79,   115,   122,   133,   488,     3,    43,    79,
      84,    91,    92,   103,   112,   113,   114,   115,   117,   404,
     485,   526,     3,    19,    79,    84,    85,    92,   119,   158,
     480,   480,   480,   626,    43,   480,    43,   480,     3,     3,
      29,   388,   406,   120,   120,   553,   553,   561,   553,   553,
      14,    15,   561,   565,   566,    26,   208,    27,   554,   554,
      29,   561,   561,   561,   561,   561,    19,    15,   391,   387,
     391,    28,   537,   538,   541,   561,     7,   391,   394,    26,
      27,   389,   391,   394,   561,   561,   561,   561,   561,   561,
     561,   561,   561,   561,   561,   561,   561,   168,   191,   199,
     204,   205,   390,   391,     3,   561,   408,   414,   385,   561,
     399,    58,    59,    58,    59,   399,   458,   459,   385,   166,
     167,   168,   169,   170,   171,   172,   174,   175,   176,   177,
     178,   520,   521,   522,   524,   528,   125,   126,   127,   128,
     385,   437,   385,   386,   527,    19,   119,   390,   434,   452,
     455,   456,    19,   524,   525,    35,   399,   449,   103,   561,
     449,   449,   570,    71,    71,    71,   276,   401,    49,   385,
     385,   399,   213,   214,   401,   261,   401,   402,   385,   385,
      30,   403,   399,   122,   399,    71,   399,    71,   102,   230,
     399,   399,   401,    71,   385,    83,   385,   401,   385,   401,
     230,   259,   260,   401,   450,   401,   385,   385,   401,   401,
     401,   385,   122,   401,    97,   401,   590,    19,   385,   385,
     633,   399,   456,   385,   385,   472,   473,   385,   385,   385,
     399,   385,   385,   385,    83,   118,   163,   475,   401,   450,
      20,   402,   402,   227,   676,   677,   399,   399,   401,   401,
     399,   402,   404,   405,   390,   391,     3,   390,   391,     3,
      19,    15,   404,    19,    19,   525,   405,    19,     3,    20,
     617,   617,     3,    19,    82,   230,   278,   293,   311,   325,
     326,   480,   617,   480,   617,   399,   402,    15,    15,   387,
     391,   387,    27,   391,   391,   391,   387,   391,   387,   391,
     561,   561,     7,   391,   391,   387,    18,   535,   543,    15,
      18,   548,   386,   415,   385,   390,    20,   385,   456,   385,
      19,   173,   385,   389,   402,   399,   387,   521,   523,   528,
     404,    27,   454,   391,    98,   448,   401,    89,   217,   218,
     390,   446,   569,   399,   399,   399,   385,   385,   401,   385,
     385,   385,   385,   401,   385,   385,    19,   122,   385,   399,
     385,   399,   385,   399,   385,   385,   385,   385,   385,   399,
     434,   385,   385,   385,   385,   385,   385,   385,   385,   385,
     385,   385,   385,   399,   399,    89,   145,   231,   284,   308,
     310,   316,   318,   322,   323,   390,   591,   598,   601,   385,
      89,   169,   356,   357,   360,   390,   446,   630,   385,   389,
     670,   390,   385,   385,   399,   105,   107,   105,   107,   390,
     385,   385,   403,   402,   321,   676,   467,   470,     3,     3,
     434,   434,    15,   434,   617,     3,   617,     3,   122,   122,
     565,    27,   561,   561,   561,   561,   561,   391,   387,   537,
     561,   538,   540,   561,   391,   561,   522,    19,    49,    86,
     159,   160,   161,   162,   163,   164,   165,   179,   182,   531,
     532,   557,   558,   562,   567,   385,   387,   120,    20,   405,
     453,   455,    76,    99,   100,   101,   572,   576,   572,   577,
     402,   581,   385,   391,   385,   385,   385,   385,   399,   385,
     385,   385,   385,   385,   385,   610,   616,   401,   286,   287,
     322,   286,   401,   592,   311,   404,   594,   595,   593,   324,
     401,   385,   327,   611,   635,   643,   404,   644,   649,   631,
     632,   404,   385,   669,   472,   385,    20,   407,   407,   407,
     407,   403,   399,     3,     3,    15,    15,   387,   387,   387,
     387,   391,   561,   387,   391,    15,   387,    22,   386,    22,
     386,   561,   561,   561,   390,   567,   560,   685,   385,   561,
     563,   564,   523,    15,   405,   456,   457,   389,   575,    30,
     219,   578,   399,   385,   456,   612,   399,   399,   401,   399,
     389,   434,   389,   389,   399,   399,   389,   457,   389,   648,
     389,   402,   650,   655,    20,   389,   656,   661,   214,   233,
     270,   336,   390,   668,   475,   385,   385,   385,   385,   491,
     491,   561,   387,     7,    28,   540,   390,   561,   566,   561,
     557,   385,   180,   389,    22,    22,    32,   391,   385,   122,
     575,   574,    19,   408,   220,   579,   385,   613,   389,   615,
     603,   596,   603,   599,   389,   642,   647,   646,   651,   657,
     140,   141,   291,   460,   399,   271,   294,   369,   370,   371,
     372,   667,   385,   475,   475,   475,   475,     3,     3,   387,
     386,   387,     7,   387,   385,   387,   385,   685,   389,   533,
     567,   550,   561,   561,    92,   148,   149,   203,   208,   564,
      15,   106,   211,   212,   215,   216,   390,   573,   402,   217,
     580,   611,   614,   390,   404,   604,   605,   145,   286,   309,
     390,   597,   390,   142,   288,   289,   290,   292,   303,   390,
     471,   600,   641,   640,   349,   350,   353,   354,   355,   390,
     645,   654,   660,   399,   399,   399,   214,   401,   537,   540,
     387,   531,   181,     6,    15,    16,    17,   386,   390,   534,
     536,   539,   542,   544,   546,   385,   385,   386,   386,   386,
     386,   385,   385,   401,   213,   214,   214,   399,   400,   399,
     385,   401,    64,   142,   153,   210,   213,   214,   270,   273,
     284,   286,   288,   289,   290,   291,   292,   293,   299,   303,
     304,   307,   320,   328,   390,   471,   602,   309,   317,   606,
     401,   399,   401,   385,   399,   399,   399,   235,   114,   399,
      93,   302,   305,   385,   120,   169,   211,   231,   311,   341,
     342,   345,   346,   348,   356,   357,   390,   636,   352,   352,
     401,   401,   401,   385,   352,   358,   390,   652,   352,   359,
     390,   658,   312,   391,   387,   385,   390,   533,   531,   561,
       7,   388,   391,   561,   561,   561,   561,   215,   215,   215,
      38,    39,    40,   311,   399,   389,   401,   313,   291,   330,
     460,   271,   401,   401,   399,   399,   399,   235,   399,   114,
     399,   294,   295,   296,   297,   298,   299,   300,   301,   329,
      93,   302,   305,   296,   399,   321,   294,   385,   399,   385,
     399,   399,   340,   649,   235,   340,    86,   352,   344,   401,
     343,    71,   347,   229,   220,   637,   220,   638,   385,   399,
     399,   351,   399,   662,   650,   653,   385,   662,   656,   659,
     385,   537,   387,   386,   536,   531,   544,   387,   387,   387,
     387,   400,   400,   400,   401,   607,   314,   315,   399,   399,
     399,   214,   401,   399,   399,   401,   401,   399,   401,   215,
     399,   215,   362,   363,   364,   639,   399,   399,   401,   399,
     399,    97,   401,   655,   401,   661,   361,   663,   663,   399,
     387,   561,   385,   385,   385,   385,    18,   390,   609,   312,
     399,   399,   663,   399,   401,   306,   608,   385
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   395,   396,   396,   397,   397,   398,   399,   399,   399,
     400,   400,   400,   401,   401,   401,   401,   401,   401,   402,
     402,   403,   403,   404,   405,   405,   406,   406,   407,   408,
     408,   409,   409,   410,   411,   411,   412,   412,   412,   413,
     413,   414,   414,   415,   415,   415,   415,   415,   415,   415,
     415,   415,   416,   416,   417,   417,   417,   417,   418,   418,
     418,   418,   418,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   426,   427,   427,   427,   428,   429,   429,   429,
     429,   429,   430,   431,   431,   432,   433,   433,   434,   434,
     434,   435,   436,   436,   437,   437,   437,   437,   438,   439,
     439,   440,   441,   442,   442,   443,   443,   444,   444,   445,
     445,   445,   446,   446,   446,   446,   446,   446,   446,   446,
     446,   446,   446,   446,   446,   446,   447,   447,   447,   447,
     448,   448,   448,   448,   448,   449,   449,   450,   451,   451,
     452,   453,   453,   453,   454,   454,   455,   456,   456,   457,
     458,   459,   460,   460,   461,   462,   462,   462,   463,   464,
     465,   465,   465,   466,   466,   467,   467,   467,   467,   467,
     467,   468,   468,   468,   469,   469,   470,   470,   471,   471,
     472,   472,   473,   473,   474,   475,   475,   475,   475,   475,
     475,   476,   477,   478,   479,   480,   480,   481,   482,   483,
     484,   484,   484,   484,   484,   484,   484,   484,   484,   484,
     484,   484,   484,   485,   485,   486,   487,   487,   487,   487,
     488,   488,   488,   489,   490,   490,   490,   490,   490,   490,
     490,   490,   491,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   504,   504,   505,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   515,   515,   516,   516,   516,   518,   517,   519,   520,
     520,   520,   520,   520,   520,   520,   520,   520,   520,   520,
     520,   520,   521,   522,   522,   523,   523,   524,   525,   525,
     526,   527,   527,   528,   530,   529,   531,   531,   532,   532,
     533,   533,   534,   535,   535,   535,   535,   536,   536,   536,
     536,   536,   537,   538,   538,   538,   539,   539,   540,   541,
     541,   541,   541,   542,   542,   542,   543,   543,   543,   543,
     544,   544,   544,   544,   545,   545,   546,   546,   547,   548,
     548,   548,   548,   549,   549,   550,   550,   550,   551,   551,
     552,   552,   553,   553,   553,   553,   553,   554,   554,   554,
     555,   555,   555,   555,   555,   555,   555,   555,   555,   555,
     555,   556,   556,   557,   558,   559,   560,   560,   560,   560,
     560,   560,   560,   560,   560,   560,   561,   561,   561,   561,
     561,   561,   561,   561,   561,   561,   561,   561,   561,   561,
     561,   561,   561,   561,   561,   561,   561,   561,   561,   561,
     561,   561,   561,   561,   561,   561,   561,   561,   561,   561,
     561,   561,   561,   562,   562,   562,   562,   562,   562,   563,
     564,   564,   564,   565,   565,   566,   566,   567,   567,   567,
     567,   567,   567,   567,   567,   567,   567,   567,   567,   567,
     567,   567,   567,   568,   569,   569,   569,   569,   570,   570,
     571,   572,   573,   573,   573,   573,   573,   573,   574,   574,
     575,   575,   576,   577,   578,   578,   578,   579,   579,   580,
     580,   581,   582,   583,   584,   584,   584,   584,   584,   584,
     584,   584,   584,   584,   584,   584,   584,   584,   584,   584,
     584,   584,   584,   584,   584,   584,   584,   584,   584,   584,
     584,   584,   584,   584,   584,   584,   584,   584,   584,   584,
     584,   584,   584,   584,   584,   584,   584,   584,   584,   584,
     584,   584,   584,   584,   584,   584,   584,   584,   585,   586,
     586,   587,   587,   587,   587,   587,   587,   587,   587,   588,
     589,   590,   590,   591,   591,   591,   591,   591,   591,   591,
     591,   591,   592,   591,   593,   591,   591,   591,   591,   594,
     594,   595,   596,   596,   597,   597,   597,   598,   598,   599,
     599,   600,   600,   600,   600,   600,   600,   600,   600,   600,
     600,   600,   601,   602,   602,   602,   602,   602,   602,   602,
     602,   602,   602,   602,   602,   602,   602,   602,   602,   602,
     602,   602,   602,   602,   602,   602,   602,   602,   602,   602,
     602,   602,   602,   602,   602,   602,   602,   602,   602,   602,
     602,   603,   603,   604,   605,   606,   606,   606,   607,   607,
     608,   608,   609,   610,   611,   611,   613,   612,   614,   614,
     615,   615,   616,   617,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   626,   626,   626,   626,   626,   626,
     626,   626,   627,   628,   628,   628,   628,   628,   629,   630,
     630,   630,   631,   630,   632,   630,   630,   633,   633,   634,
     635,   636,   636,   636,   636,   636,   636,   636,   636,   636,
     636,   636,   636,   637,   636,   638,   636,   636,   636,   639,
     639,   639,   640,   641,   641,   642,   642,   643,   644,   645,
     645,   645,   645,   645,   646,   647,   647,   648,   648,   649,
     650,   651,   652,   652,   652,   653,   654,   654,   655,   655,
     656,   657,   658,   658,   658,   659,   660,   660,   661,   661,
     662,   662,   663,   663,   664,   665,   665,   665,   665,   665,
     665,   665,   665,   665,   665,   665,   665,   665,   666,   666,
     666,   667,   667,   667,   667,   667,   668,   668,   668,   668,
     668,   668,   668,   669,   669,   670,   670,   671,   672,   673,
     674,   674,   674,   674,   674,   675,   676,   676,   677,   677,
     678,   678,   678,   678,   678,   678,   678,   678,   678,   679,
     680,   680,   680,   680,   680,   680,   680,   680,   680,   680,
     680,   680,   680,   680,   680,   681,   681,   681,   681,   681,
     681,   681,   681,   681,   681,   681,   681,   681,   681,   681,
     681,   681,   681,   681,   681,   681,   681,   681,   681,   681,
     681,   681,   681,   681,   681,   681,   681,   681,   681,   681,
     681,   681,   681,   681,   681,   681,   681,   681,   681,   681,
     681,   682,   682,   682,   682,   682,   682,   682,   682,   682,
     682,   683,   683,   683,   683,   684,   684,   684,   685,   685,
     685,   685,   685,   685,   685,   685,   685,   685,   685,   685,
     685,   685,   685,   685,   685,   685,   685,   685,   685,   685,
     685
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     2,     2,     0,     2,     5,     1,     3,     1,
       2,     2,     2,     1,     1,     1,     1,     1,     0,     1,
       1,     0,     2,     2,     1,     1,     2,     2,     1,     1,
       1,     1,     0,     4,     2,     0,     1,     2,     1,     1,
       3,     1,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     4,     3,     1,     1,     1,     1,     2,     4,
       3,     3,     3,     3,     3,     4,     5,     3,     3,     4,
       2,     0,     1,     0,     1,     2,     2,     2,     3,     2,
       3,     3,     2,     3,     3,     3,     4,     5,     1,     1,
       1,     4,     0,     2,     2,     2,     1,     1,     5,     0,
       1,     3,     3,     0,     8,     1,     4,     1,     1,     0,
       1,     3,     0,     2,     2,     2,     2,     2,     2,     3,
       3,     3,     4,     2,     3,     2,     2,     1,     1,     1,
       0,     2,     2,     2,     2,     2,     1,     1,     3,     3,
       0,     1,     1,     2,     0,     1,     3,     1,     3,     1,
       0,     2,     2,     2,     2,     3,     3,     3,     0,     3,
       1,     1,     3,     1,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     3,     1,     3,     1,     1,     4,     1,
       0,     3,     4,     1,     2,     0,     5,     5,     5,     5,
       4,     3,     3,     4,     5,     1,     0,     3,     4,     4,
       0,     2,     3,     3,     3,     2,     2,     2,     2,     3,
       3,     2,     2,     1,     1,     4,     0,     3,     3,     3,
       0,     1,     1,     4,     0,     2,     2,     2,     2,     2,
       2,     2,     0,     2,     9,     9,     4,     3,     3,     3,
       3,     3,     3,     3,     3,     4,     1,     1,     3,     0,
       1,     3,     3,     3,     3,     4,     4,     4,     4,     2,
       1,     1,     1,     1,     0,     1,     0,     4,     2,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     2,     0,     3,     1,     3,     1,     1,     1,
       2,     3,     2,     4,     0,     5,     0,     1,     1,     2,
       1,     3,     1,     1,     1,     1,     1,     1,     3,     1,
       1,     1,     1,     1,     3,     1,     5,    11,     1,     1,
       1,     2,     1,     7,     9,     7,     1,     1,     1,     3,
       1,     1,     1,     3,     1,     3,     1,     3,     3,     1,
       2,     2,     6,     1,     3,     0,     4,     3,     1,     3,
       3,     3,     2,     2,     2,     2,     0,     2,     2,     0,
       1,     1,     1,     1,     1,     1,     1,     3,     3,     1,
       1,     5,     7,     0,     4,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       2,     4,     1,     1,     1,     1,     2,     2,     3,     3,
       6,     3,     3,     3,     3,     5,     6,     6,     6,     6,
       4,     8,     4,     1,     1,     1,     1,     1,     1,     1,
       0,     1,     3,     1,     3,     0,     1,     4,     6,     4,
       3,     5,     5,     4,     6,     3,     2,     5,     5,     8,
       8,     8,     8,     2,     1,     2,     2,     2,     0,     3,
       5,     0,     2,     4,     4,     4,     2,     2,     0,     3,
       0,     3,     3,     2,     0,     2,     2,     0,     2,     0,
       2,     4,     5,     2,     3,     3,     5,     6,     7,     6,
       4,     4,     5,     6,     6,     5,     3,     3,     4,     5,
       5,     5,     5,     5,     4,     4,     5,     5,     5,     5,
       5,     5,     5,     5,     6,     6,     8,     6,     6,     5,
       4,     5,     4,     5,     4,     5,     4,     5,     5,     5,
       5,     6,     5,     5,     6,     5,     5,     4,     2,     3,
       3,     1,     2,     3,     2,     4,     3,     2,     1,     2,
       4,     0,     3,     2,     1,     2,     3,     3,     3,     3,
       2,     3,     0,     5,     0,     5,     2,     2,     1,     4,
       1,     1,     0,     3,     2,     2,     2,     5,     2,     0,
       3,     0,     2,     2,     3,     2,     2,     3,     2,     2,
       2,     1,     3,     2,     2,     2,     2,     2,     2,     3,
       2,     2,     2,     2,     2,     2,     2,     2,     3,     3,
       3,     2,     3,     2,     3,     3,     4,     2,     2,     2,
       3,     3,     3,     2,     3,     3,     3,     4,     2,     2,
       1,     0,     2,     3,     1,     0,     1,     2,     0,     2,
       0,     1,     3,     0,     0,     2,     0,     3,     0,     3,
       0,     3,     3,     1,     0,     4,     6,     6,     6,     7,
       6,     7,     5,     0,     2,     3,     2,     3,     3,     2,
       3,     2,     2,     3,     3,     5,     4,     4,     2,     1,
       2,     2,     0,     3,     0,     3,     2,     0,     3,     5,
       0,     4,     4,     3,     2,     3,     3,     3,     3,     4,
       4,     3,     2,     0,     3,     0,     3,     3,     3,     1,
       1,     1,     0,     0,     3,     0,     3,     4,     1,     2,
       2,     2,     4,     4,     0,     0,     3,     0,     3,     3,
       1,     0,     0,     2,     2,     0,     0,     3,     1,     5,
       1,     0,     0,     2,     2,     0,     0,     3,     1,     5,
       1,     2,     0,     2,     2,     3,     3,     4,     4,     4,
       5,     5,     4,     3,     4,     4,     4,     4,     1,     1,
       1,     1,     1,     1,     1,     1,     0,     2,     2,     2,
       3,     3,     4,     0,     3,     0,     3,     0,     3,     2,
       3,     3,     5,     5,     3,     2,     3,     3,     1,     2,
       4,     3,     3,     3,     2,     2,     2,     2,     2,     4,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     2,     2,     1,     2,     2,     2,     1,     2,
       2,     3,     3,     3,     3,     3,     3,     3,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 722 "cf-parse.y" /* yacc.c:1646  */
    { return 0; }
#line 3731 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 3:
#line 723 "cf-parse.y" /* yacc.c:1646  */
    { return 0; }
#line 3737 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 6:
#line 736 "cf-parse.y" /* yacc.c:1646  */
    {
     struct f_val *val = cfg_alloc(sizeof(struct f_val));
     *val = f_eval((yyvsp[-1].x), cfg_mem);
     if (val->type == T_RETURN) cf_error("Runtime error");
     cf_define_symbol((yyvsp[-3].s), SYM_CONSTANT | val->type, val);
   }
#line 3748 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 8:
#line 746 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = f_eval_int((yyvsp[-1].x)); }
#line 3754 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 9:
#line 747 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != (SYM_CONSTANT | T_INT)) cf_error("Number expected");
     (yyval.i) = SYM_VAL((yyvsp[0].s)).i; }
#line 3762 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 10:
#line 754 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = (u32) (yyvsp[-1].i) * 1000000; }
#line 3768 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 11:
#line 755 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = (u32) (yyvsp[-1].i) * 1000; }
#line 3774 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 12:
#line 756 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = (u32) (yyvsp[-1].i) * 1; }
#line 3780 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 13:
#line 764 "cf-parse.y" /* yacc.c:1646  */
    {(yyval.i) = !!(yyvsp[0].i); }
#line 3786 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 14:
#line 765 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 3792 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 15:
#line 766 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 3798 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 16:
#line 767 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 3804 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 17:
#line 768 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 3810 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 18:
#line 769 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 3816 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 20:
#line 776 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != (SYM_CONSTANT | T_IP)) cf_error("IP address expected");
     (yyval.a) = SYM_VAL((yyvsp[0].s)).px.ip;
   }
#line 3825 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 21:
#line 783 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.iface) = NULL; }
#line 3831 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 22:
#line 784 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.iface) = if_get_by_name((yyvsp[0].s)->name); }
#line 3837 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 23:
#line 788 "cf-parse.y" /* yacc.c:1646  */
    {
     if (!ip_is_prefix((yyvsp[-1].a), (yyvsp[0].i))) cf_error("Invalid prefix");
     (yyval.px).addr = (yyvsp[-1].a); (yyval.px).len = (yyvsp[0].i);
   }
#line 3846 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 25:
#line 796 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.px).addr = (yyvsp[0].a); (yyval.px).len = BITS_PER_IP_ADDRESS; }
#line 3852 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 26:
#line 800 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].i) < 0 || (yyvsp[0].i) > BITS_PER_IP_ADDRESS) cf_error("Invalid prefix length %d", (yyvsp[0].i));
     (yyval.i) = (yyvsp[0].i);
   }
#line 3861 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 27:
#line 804 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.i) = ipa_mklen((yyvsp[0].a));
     if ((yyval.i) < 0) cf_error("Invalid netmask %I", (yyvsp[0].a));
   }
#line 3870 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 28:
#line 811 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.time) = tm_parse_datetime((yyvsp[0].t));
     if (!(yyval.time))
       cf_error("Invalid date and time");
   }
#line 3880 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 30:
#line 820 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != (SYM_CONSTANT | T_STRING)) cf_error("String expected");
     (yyval.t) = SYM_VAL((yyvsp[0].s)).s;
   }
#line 3889 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 31:
#line 827 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = (yyvsp[0].t); }
#line 3895 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 32:
#line 828 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = NULL; }
#line 3901 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 33:
#line 834 "cf-parse.y" /* yacc.c:1646  */
    {
    struct log_config *c = cfg_allocz(sizeof(struct log_config));
    c->fh = (yyvsp[-2].g);
    c->mask = (yyvsp[-1].i);
    add_tail(&new_config->logfiles, &c->n);
  }
#line 3912 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 34:
#line 843 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = (yyvsp[0].t); }
#line 3918 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 35:
#line 844 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = bird_name; }
#line 3924 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 36:
#line 848 "cf-parse.y" /* yacc.c:1646  */
    {
     FILE *f = tracked_fopen(new_config->pool, (yyvsp[0].t), "a");
     if (!f) cf_error("Unable to open log file `%s': %m", (yyvsp[0].t));
     (yyval.g) = f;
   }
#line 3934 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 37:
#line 853 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.g) = NULL; new_config->syslog_name = (yyvsp[0].t); }
#line 3940 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 38:
#line 854 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.g) = stderr; }
#line 3946 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 39:
#line 858 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ~0; }
#line 3952 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 40:
#line 859 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-1].i); }
#line 3958 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 41:
#line 863 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1 << (yyvsp[0].i); }
#line 3964 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 42:
#line 864 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-2].i) | (1 << (yyvsp[0].i)); }
#line 3970 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 43:
#line 868 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_DEBUG[0]; }
#line 3976 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 44:
#line 869 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_TRACE[0]; }
#line 3982 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 45:
#line 870 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_INFO[0]; }
#line 3988 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 46:
#line 871 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_REMOTE[0]; }
#line 3994 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 47:
#line 872 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_WARN[0]; }
#line 4000 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 48:
#line 873 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_ERR[0]; }
#line 4006 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 49:
#line 874 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_AUTH[0]; }
#line 4012 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 50:
#line 875 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_FATAL[0]; }
#line 4018 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 51:
#line 876 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_BUG[0]; }
#line 4024 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 52:
#line 882 "cf-parse.y" /* yacc.c:1646  */
    { new_config->proto_default_mrtdump = (yyvsp[-1].i); }
#line 4030 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 53:
#line 883 "cf-parse.y" /* yacc.c:1646  */
    {
     FILE *f = tracked_fopen(new_config->pool, (yyvsp[-1].t), "a");
     if (!f) cf_error("Unable to open MRTDump file '%s': %m", (yyvsp[-1].t));
     new_config->mrtdump_file = fileno(f);
   }
#line 4040 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 54:
#line 892 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.tf) = &new_config->tf_route; }
#line 4046 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 55:
#line 893 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.tf) = &new_config->tf_proto; }
#line 4052 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 56:
#line 894 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.tf) = &new_config->tf_base; }
#line 4058 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 57:
#line 895 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.tf) = &new_config->tf_log; }
#line 4064 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 58:
#line 898 "cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-1].tf) = (struct timeformat){(yyvsp[0].t), NULL, 0}; }
#line 4070 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 59:
#line 899 "cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-3].tf) = (struct timeformat){(yyvsp[-2].t), (yyvsp[0].t), (yyvsp[-1].i)}; }
#line 4076 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 60:
#line 900 "cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-2].tf) = (struct timeformat){"%T", "%F", 20*3600}; }
#line 4082 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 61:
#line 901 "cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-2].tf) = (struct timeformat){"%F %T", NULL, 0}; }
#line 4088 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 62:
#line 902 "cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-2].tf) = (struct timeformat){NULL, NULL, 0}; }
#line 4094 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 63:
#line 903 "cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-2].tf) = (struct timeformat){"%d-%m-%Y %T", NULL, 0}; }
#line 4100 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 65:
#line 915 "cf-parse.y" /* yacc.c:1646  */
    { cmd_reconfig((yyvsp[-2].t), RECONFIG_HARD, (yyvsp[-1].i)); }
#line 4106 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 66:
#line 918 "cf-parse.y" /* yacc.c:1646  */
    { cmd_reconfig((yyvsp[-2].t), RECONFIG_SOFT, (yyvsp[-1].i)); }
#line 4112 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 67:
#line 925 "cf-parse.y" /* yacc.c:1646  */
    { cmd_reconfig_confirm(); }
#line 4118 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 68:
#line 928 "cf-parse.y" /* yacc.c:1646  */
    { cmd_reconfig_undo(); }
#line 4124 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 69:
#line 931 "cf-parse.y" /* yacc.c:1646  */
    { cmd_check_config((yyvsp[-1].t)); }
#line 4130 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 70:
#line 934 "cf-parse.y" /* yacc.c:1646  */
    { cmd_shutdown(); }
#line 4136 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 71:
#line 937 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = NULL; }
#line 4142 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 73:
#line 942 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 4148 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 74:
#line 943 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = UNIX_DEFAULT_CONFIGURE_TIMEOUT; }
#line 4154 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 75:
#line 944 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i); }
#line 4160 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 76:
#line 952 "cf-parse.y" /* yacc.c:1646  */
    { this_proto = krt_init_config((yyvsp[-1].i)); }
#line 4166 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 77:
#line 957 "cf-parse.y" /* yacc.c:1646  */
    { THIS_KRT->persist = (yyvsp[0].i); }
#line 4172 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 78:
#line 958 "cf-parse.y" /* yacc.c:1646  */
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KRT->scan_time = (yyvsp[0].i);
   }
#line 4181 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 79:
#line 962 "cf-parse.y" /* yacc.c:1646  */
    {
      THIS_KRT->learn = (yyvsp[0].i);
#ifndef KRT_ALLOW_LEARN
      if ((yyvsp[0].i))
	cf_error("Learning of kernel routes not supported in this configuration");
#endif
   }
#line 4193 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 80:
#line 969 "cf-parse.y" /* yacc.c:1646  */
    { THIS_KRT->devroutes = (yyvsp[0].i); }
#line 4199 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 81:
#line 970 "cf-parse.y" /* yacc.c:1646  */
    { THIS_KRT->graceful_restart = (yyvsp[0].i); }
#line 4205 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 82:
#line 976 "cf-parse.y" /* yacc.c:1646  */
    { this_proto = kif_init_config((yyvsp[-1].i)); }
#line 4211 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 83:
#line 981 "cf-parse.y" /* yacc.c:1646  */
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KIF->scan_time = (yyvsp[0].i);
   }
#line 4220 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 84:
#line 985 "cf-parse.y" /* yacc.c:1646  */
    {
     struct kif_primary_item *kpi = cfg_alloc(sizeof (struct kif_primary_item));
     kpi->pattern = (yyvsp[-1].t);
     kpi->prefix = (yyvsp[0].px).addr;
     kpi->pxlen = (yyvsp[0].px).len;
     add_tail(&THIS_KIF->primary, &kpi->n);
   }
#line 4232 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 85:
#line 999 "cf-parse.y" /* yacc.c:1646  */
    {
	if ((yyvsp[0].i) <= 0 || (yyvsp[0].i) >= NL_NUM_TABLES)
	  cf_error("Kernel routing table number out of range");
	THIS_KRT->sys.table_id = (yyvsp[0].i);
   }
#line 4242 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 86:
#line 1013 "cf-parse.y" /* yacc.c:1646  */
    { new_config->router_id = (yyvsp[-1].i32); }
#line 4248 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 87:
#line 1014 "cf-parse.y" /* yacc.c:1646  */
    { new_config->router_id_from = this_ipatt; }
#line 4254 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 88:
#line 1018 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = (yyvsp[0].i); }
#line 4260 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 90:
#line 1020 "cf-parse.y" /* yacc.c:1646  */
    {
#ifndef IPV6
     (yyval.i32) = ipa_to_u32((yyvsp[0].a));
#else
     cf_error("Router IDs must be entered as hexadecimal numbers or IPv4 addresses in IPv6 version");
#endif
   }
#line 4272 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 94:
#line 1039 "cf-parse.y" /* yacc.c:1646  */
    { new_config->listen_bgp_addr = (yyvsp[0].a); }
#line 4278 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 95:
#line 1040 "cf-parse.y" /* yacc.c:1646  */
    { new_config->listen_bgp_port = (yyvsp[0].i); }
#line 4284 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 96:
#line 1041 "cf-parse.y" /* yacc.c:1646  */
    { new_config->listen_bgp_flags = 0; }
#line 4290 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 97:
#line 1042 "cf-parse.y" /* yacc.c:1646  */
    { new_config->listen_bgp_flags = 1; }
#line 4296 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 98:
#line 1047 "cf-parse.y" /* yacc.c:1646  */
    { new_config->gr_wait = (yyvsp[-1].i); }
#line 4302 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 99:
#line 1053 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 4308 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 100:
#line 1054 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 4314 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 101:
#line 1058 "cf-parse.y" /* yacc.c:1646  */
    {
   struct rtable_config *cf;
   cf = rt_new_table((yyvsp[-1].s));
   cf->sorted = (yyvsp[0].i);
   }
#line 4324 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 102:
#line 1066 "cf-parse.y" /* yacc.c:1646  */
    {
  this_roa_table = roa_new_table_config((yyvsp[0].s));
}
#line 4332 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 104:
#line 1072 "cf-parse.y" /* yacc.c:1646  */
    {
     roa_add_item_config(this_roa_table, (yyvsp[-5].px).addr, (yyvsp[-5].px).len, (yyvsp[-3].i), (yyvsp[-1].i));
   }
#line 4340 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 107:
#line 1086 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = SYM_PROTO; }
#line 4346 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 108:
#line 1087 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = SYM_TEMPLATE; }
#line 4352 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 109:
#line 1091 "cf-parse.y" /* yacc.c:1646  */
    {
     struct symbol *s = cf_default_name(this_proto->protocol->template, &this_proto->protocol->name_counter);
     s->class = this_proto->class;
     s->def = this_proto;
     this_proto->name = s->name;
     }
#line 4363 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 110:
#line 1097 "cf-parse.y" /* yacc.c:1646  */
    {
     cf_define_symbol((yyvsp[0].s), this_proto->class, this_proto);
     this_proto->name = (yyvsp[0].s)->name;
   }
#line 4372 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 111:
#line 1101 "cf-parse.y" /* yacc.c:1646  */
    {
     if (((yyvsp[0].s)->class != SYM_TEMPLATE) && ((yyvsp[0].s)->class != SYM_PROTO)) cf_error("Template or protocol name expected");

     cf_define_symbol((yyvsp[-2].s), this_proto->class, this_proto);
     this_proto->name = (yyvsp[-2].s)->name;

     proto_copy_config(this_proto, (yyvsp[0].s)->def);
   }
#line 4385 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 113:
#line 1113 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].i) < 0 || (yyvsp[0].i) > 0xFFFF) cf_error("Invalid preference");
     this_proto->preference = (yyvsp[0].i);
   }
#line 4394 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 114:
#line 1117 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->disabled = (yyvsp[0].i); }
#line 4400 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 115:
#line 1118 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->debug = (yyvsp[0].i); }
#line 4406 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 116:
#line 1119 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->mrtdump = (yyvsp[0].i); }
#line 4412 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 117:
#line 1120 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->in_filter = (yyvsp[0].f); }
#line 4418 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 118:
#line 1121 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->out_filter = (yyvsp[0].f); }
#line 4424 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 119:
#line 1122 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->rx_limit = (yyvsp[0].g); }
#line 4430 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 120:
#line 1123 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->in_limit = (yyvsp[0].g); }
#line 4436 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 121:
#line 1124 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->out_limit = (yyvsp[0].g); }
#line 4442 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 122:
#line 1125 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->in_keep_filtered = (yyvsp[0].i); }
#line 4448 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 123:
#line 1126 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->table = (yyvsp[0].r); }
#line 4454 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 124:
#line 1127 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->router_id = (yyvsp[0].i32); }
#line 4460 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 125:
#line 1128 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->dsc = (yyvsp[0].t); }
#line 4466 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 126:
#line 1132 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.f) = (yyvsp[0].f); }
#line 4472 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 128:
#line 1134 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.f) = FILTER_ACCEPT; }
#line 4478 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 129:
#line 1135 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.f) = FILTER_REJECT; }
#line 4484 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 130:
#line 1139 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = PLA_DISABLE; }
#line 4490 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 131:
#line 1140 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = PLA_WARN; }
#line 4496 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 132:
#line 1141 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = PLA_BLOCK; }
#line 4502 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 133:
#line 1142 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = PLA_RESTART; }
#line 4508 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 134:
#line 1143 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = PLA_DISABLE; }
#line 4514 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 135:
#line 1147 "cf-parse.y" /* yacc.c:1646  */
    {
     struct proto_limit *l = cfg_allocz(sizeof(struct proto_limit));
     l->limit = (yyvsp[-1].i);
     l->action = (yyvsp[0].i);
     (yyval.g) = l;
   }
#line 4525 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 136:
#line 1153 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.g) = NULL; }
#line 4531 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 137:
#line 1157 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != SYM_TABLE) cf_error("Table name expected");
     (yyval.r) = (yyvsp[0].s)->def;
   }
#line 4540 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 138:
#line 1165 "cf-parse.y" /* yacc.c:1646  */
    { new_config->proto_default_debug = (yyvsp[0].i); }
#line 4546 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 139:
#line 1166 "cf-parse.y" /* yacc.c:1646  */
    { new_config->cli_debug = (yyvsp[0].i); }
#line 4552 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 140:
#line 1174 "cf-parse.y" /* yacc.c:1646  */
    {
     struct iface_patt_node *ipn = cfg_allocz(sizeof(struct iface_patt_node));
     add_tail(&this_ipatt->ipn_list, NODE ipn);
     this_ipn = ipn;
   }
#line 4562 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 141:
#line 1182 "cf-parse.y" /* yacc.c:1646  */
    { this_ipn->pattern = (yyvsp[0].t); this_ipn->prefix = IPA_NONE; this_ipn->pxlen = 0; }
#line 4568 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 142:
#line 1183 "cf-parse.y" /* yacc.c:1646  */
    { this_ipn->pattern = NULL; this_ipn->prefix = (yyvsp[0].px).addr; this_ipn->pxlen = (yyvsp[0].px).len; }
#line 4574 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 143:
#line 1184 "cf-parse.y" /* yacc.c:1646  */
    { this_ipn->pattern = (yyvsp[-1].t); this_ipn->prefix = (yyvsp[0].px).addr; this_ipn->pxlen = (yyvsp[0].px).len; }
#line 4580 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 144:
#line 1188 "cf-parse.y" /* yacc.c:1646  */
    { this_ipn->positive = 1; }
#line 4586 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 145:
#line 1189 "cf-parse.y" /* yacc.c:1646  */
    { this_ipn->positive = 0; }
#line 4592 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 149:
#line 1203 "cf-parse.y" /* yacc.c:1646  */
    { iface_patt_check(); }
#line 4598 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 150:
#line 1205 "cf-parse.y" /* yacc.c:1646  */
    {
   /* Generic this_ipatt init */
   this_ipatt = cfg_allocz(sizeof(struct iface_patt));
   init_list(&this_ipatt->ipn_list);
 }
#line 4608 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 152:
#line 1217 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i) & 0xfc;        if (((yyvsp[0].i) < 0) || ((yyvsp[0].i) > 255)) cf_error("TX class must be in range 0-255"); }
#line 4614 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 153:
#line 1218 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ((yyvsp[0].i) & 0x3f) << 2; if (((yyvsp[0].i) < 0) || ((yyvsp[0].i) > 63))  cf_error("TX DSCP must be in range 0-63"); }
#line 4620 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 154:
#line 1224 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto = proto_config_new(&proto_device, sizeof(struct rt_dev_config), (yyvsp[-1].i));
     init_list(&DIRECT_CFG->iface_list);
   }
#line 4629 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 158:
#line 1237 "cf-parse.y" /* yacc.c:1646  */
    {
     this_ipatt = cfg_allocz(sizeof(struct iface_patt));
     add_tail(&DIRECT_CFG->iface_list, NODE this_ipatt);
     init_list(&this_ipatt->ipn_list);
   }
#line 4639 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 160:
#line 1251 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ~0; }
#line 4645 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 161:
#line 1252 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 4651 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 162:
#line 1253 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-1].i); }
#line 4657 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 164:
#line 1258 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-2].i) | (yyvsp[0].i); }
#line 4663 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 165:
#line 1262 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_STATES; }
#line 4669 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 166:
#line 1263 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_ROUTES; }
#line 4675 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 167:
#line 1264 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_FILTERS; }
#line 4681 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 168:
#line 1265 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_IFACES; }
#line 4687 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 169:
#line 1266 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_EVENTS; }
#line 4693 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 170:
#line 1267 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_PACKETS; }
#line 4699 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 171:
#line 1273 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ~0; }
#line 4705 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 172:
#line 1274 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 4711 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 173:
#line 1275 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-1].i); }
#line 4717 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 175:
#line 1280 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-2].i) | (yyvsp[0].i); }
#line 4723 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 176:
#line 1284 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = MD_STATES; }
#line 4729 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 177:
#line 1285 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = MD_MESSAGES; }
#line 4735 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 184:
#line 1306 "cf-parse.y" /* yacc.c:1646  */
    {
     if (!this_p_list) {
     	this_p_list = cfg_alloc(sizeof(list));
     	init_list(this_p_list);
        password_id = 1;
     }
     this_p_item = cfg_alloc(sizeof (struct password_item));
     this_p_item->password = (yyvsp[0].t);
     this_p_item->genfrom = 0;
     this_p_item->gento = TIME_INFINITY;
     this_p_item->accfrom = 0;
     this_p_item->accto = TIME_INFINITY;
     this_p_item->id = password_id++;
     add_tail(this_p_list, &this_p_item->n);
   }
#line 4755 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 185:
#line 1324 "cf-parse.y" /* yacc.c:1646  */
    { }
#line 4761 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 186:
#line 1325 "cf-parse.y" /* yacc.c:1646  */
    { this_p_item->genfrom = (yyvsp[-2].time); }
#line 4767 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 187:
#line 1326 "cf-parse.y" /* yacc.c:1646  */
    { this_p_item->gento = (yyvsp[-2].time); }
#line 4773 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 188:
#line 1327 "cf-parse.y" /* yacc.c:1646  */
    { this_p_item->accfrom = (yyvsp[-2].time); }
#line 4779 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 189:
#line 1328 "cf-parse.y" /* yacc.c:1646  */
    { this_p_item->accto = (yyvsp[-2].time); }
#line 4785 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 190:
#line 1329 "cf-parse.y" /* yacc.c:1646  */
    { this_p_item->id = (yyvsp[-2].i); if ((yyvsp[-2].i) <= 0) cf_error("Password ID has to be greated than zero."); }
#line 4791 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 191:
#line 1338 "cf-parse.y" /* yacc.c:1646  */
    { cmd_show_status(); }
#line 4797 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 192:
#line 1341 "cf-parse.y" /* yacc.c:1646  */
    { cmd_show_memory(); }
#line 4803 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 193:
#line 1344 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_show, 0, 0); }
#line 4809 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 194:
#line 1347 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_show, 0, 1); }
#line 4815 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 196:
#line 1351 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.s) = NULL; }
#line 4821 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 197:
#line 1355 "cf-parse.y" /* yacc.c:1646  */
    { if_show(); }
#line 4827 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 198:
#line 1358 "cf-parse.y" /* yacc.c:1646  */
    { if_show_summary(); }
#line 4833 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 199:
#line 1362 "cf-parse.y" /* yacc.c:1646  */
    { rt_show((yyvsp[-1].ra)); }
#line 4839 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 200:
#line 1365 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = cfg_allocz(sizeof(struct rt_show_data));
     (yyval.ra)->pxlen = 256;
     (yyval.ra)->filter = FILTER_ACCEPT;
   }
#line 4849 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 201:
#line 1370 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     if ((yyval.ra)->pxlen != 256) cf_error("Only one prefix expected");
     (yyval.ra)->prefix = (yyvsp[0].px).addr;
     (yyval.ra)->pxlen = (yyvsp[0].px).len;
   }
#line 4860 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 202:
#line 1376 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->pxlen != 256) cf_error("Only one prefix expected");
     (yyval.ra)->prefix = (yyvsp[0].px).addr;
     (yyval.ra)->pxlen = (yyvsp[0].px).len;
     (yyval.ra)->show_for = 1;
   }
#line 4872 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 203:
#line 1383 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyvsp[0].s)->class != SYM_TABLE) cf_error("%s is not a table", (yyvsp[0].s)->name);
     (yyval.ra)->table = ((struct rtable_config *)(yyvsp[0].s)->def)->table;
   }
#line 4882 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 204:
#line 1388 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[0].f);
   }
#line 4892 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 205:
#line 1393 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[0].f);
   }
#line 4902 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 206:
#line 1398 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->verbose = 1;
   }
#line 4911 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 207:
#line 1402 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->primary_only = 1;
   }
#line 4920 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 208:
#line 1406 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->filtered = 1;
   }
#line 4929 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 209:
#line 1410 "cf-parse.y" /* yacc.c:1646  */
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[0].s)->def;
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->export_mode) cf_error("Protocol specified twice");
     if ((yyvsp[0].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[0].s)->name);
     (yyval.ra)->export_mode = (yyvsp[-1].i);
     (yyval.ra)->export_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
   }
#line 4943 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 210:
#line 1419 "cf-parse.y" /* yacc.c:1646  */
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[0].s)->def;
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->show_protocol) cf_error("Protocol specified twice");
     if ((yyvsp[0].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[0].s)->name);
     (yyval.ra)->show_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
   }
#line 4956 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 211:
#line 1427 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->stats = 1;
   }
#line 4965 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 212:
#line 1431 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->stats = 2;
   }
#line 4974 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 213:
#line 1438 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 4980 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 214:
#line 1439 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 2; }
#line 4986 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 215:
#line 1445 "cf-parse.y" /* yacc.c:1646  */
    { roa_show((yyvsp[-1].ro)); }
#line 4992 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 216:
#line 1448 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ro) = cfg_allocz(sizeof(struct roa_show_data));
     (yyval.ro)->mode = ROA_SHOW_ALL;
     (yyval.ro)->table = roa_table_default;
     if (roa_table_default == NULL)
       cf_error("No ROA table defined");
   }
#line 5004 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 217:
#line 1455 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ro) = (yyvsp[-2].ro);
     if ((yyval.ro)->mode != ROA_SHOW_ALL) cf_error("Only one prefix expected");
     (yyval.ro)->prefix = (yyvsp[0].px).addr;
     (yyval.ro)->pxlen = (yyvsp[0].px).len;
     (yyval.ro)->mode = (yyvsp[-1].i);
   }
#line 5016 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 218:
#line 1462 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ro) = (yyvsp[-2].ro);
     (yyval.ro)->asn = (yyvsp[0].i);
   }
#line 5025 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 219:
#line 1466 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ro) = (yyvsp[-2].ro);
     if ((yyvsp[0].s)->class != SYM_ROA) cf_error("%s is not a ROA table", (yyvsp[0].s)->name);
     (yyval.ro)->table = ((struct roa_table_config *)(yyvsp[0].s)->def)->table;
   }
#line 5035 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 220:
#line 1474 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ROA_SHOW_PX; }
#line 5041 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 221:
#line 1475 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ROA_SHOW_IN; }
#line 5047 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 222:
#line 1476 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ROA_SHOW_FOR; }
#line 5053 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 223:
#line 1482 "cf-parse.y" /* yacc.c:1646  */
    { cmd_show_symbols((yyvsp[-1].sd)); }
#line 5059 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 224:
#line 1485 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.sd) = cfg_allocz(sizeof(struct sym_show_data));
   }
#line 5067 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 225:
#line 1488 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_TABLE; }
#line 5073 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 226:
#line 1489 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_FUNCTION; }
#line 5079 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 227:
#line 1490 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_FILTER; }
#line 5085 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 228:
#line 1491 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_PROTO; }
#line 5091 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 229:
#line 1492 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_TEMPLATE; }
#line 5097 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 230:
#line 1493 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_ROA; }
#line 5103 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 231:
#line 1494 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->sym = (yyvsp[0].s); }
#line 5109 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 232:
#line 1499 "cf-parse.y" /* yacc.c:1646  */
    { 
     if (roa_table_default == NULL)
       cf_error("No ROA table defined");
     (yyval.rot) = roa_table_default;
   }
#line 5119 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 233:
#line 1504 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != SYM_ROA)
       cf_error("%s is not a ROA table", (yyvsp[0].s)->name);
     (yyval.rot) = ((struct roa_table_config *)(yyvsp[0].s)->def)->table;
   }
#line 5129 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 234:
#line 1513 "cf-parse.y" /* yacc.c:1646  */
    {
  if (! cli_access_restricted())
    { roa_add_item((yyvsp[-1].rot), (yyvsp[-6].px).addr, (yyvsp[-6].px).len, (yyvsp[-4].i), (yyvsp[-2].i), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
#line 5138 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 235:
#line 1520 "cf-parse.y" /* yacc.c:1646  */
    {
  if (! cli_access_restricted())
    { roa_delete_item((yyvsp[-1].rot), (yyvsp[-6].px).addr, (yyvsp[-6].px).len, (yyvsp[-4].i), (yyvsp[-2].i), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
#line 5147 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 236:
#line 1527 "cf-parse.y" /* yacc.c:1646  */
    {
  if (! cli_access_restricted())
    { roa_flush((yyvsp[-1].rot), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
#line 5156 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 237:
#line 1535 "cf-parse.y" /* yacc.c:1646  */
    { rdump(&root_pool); cli_msg(0, ""); }
#line 5162 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 238:
#line 1537 "cf-parse.y" /* yacc.c:1646  */
    { sk_dump_all(); cli_msg(0, ""); }
#line 5168 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 239:
#line 1539 "cf-parse.y" /* yacc.c:1646  */
    { if_dump_all(); cli_msg(0, ""); }
#line 5174 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 240:
#line 1541 "cf-parse.y" /* yacc.c:1646  */
    { neigh_dump_all(); cli_msg(0, ""); }
#line 5180 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 241:
#line 1543 "cf-parse.y" /* yacc.c:1646  */
    { rta_dump_all(); cli_msg(0, ""); }
#line 5186 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 242:
#line 1545 "cf-parse.y" /* yacc.c:1646  */
    { rt_dump_all(); cli_msg(0, ""); }
#line 5192 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 243:
#line 1547 "cf-parse.y" /* yacc.c:1646  */
    { protos_dump_all(); cli_msg(0, ""); }
#line 5198 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 244:
#line 1550 "cf-parse.y" /* yacc.c:1646  */
    { cmd_eval((yyvsp[-1].x)); }
#line 5204 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 245:
#line 1553 "cf-parse.y" /* yacc.c:1646  */
    {
  cli_set_log_echo(this_cli, (yyvsp[-2].i), (yyvsp[-1].i));
  cli_msg(0, "");
}
#line 5213 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 246:
#line 1559 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ~0; }
#line 5219 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 247:
#line 1560 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 5225 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 248:
#line 1561 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-1].i); }
#line 5231 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 249:
#line 1565 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 4096; }
#line 5237 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 250:
#line 1566 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].i) < 256 || (yyvsp[0].i) > 65536) cf_error("Invalid log buffer size");
     (yyval.i) = (yyvsp[0].i);
   }
#line 5246 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 251:
#line 1573 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_disable, 1, 0); }
#line 5252 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 252:
#line 1575 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_enable, 1, 0); }
#line 5258 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 253:
#line 1577 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_restart, 1, 0); }
#line 5264 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 254:
#line 1579 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_reload, 1, CMD_RELOAD); }
#line 5270 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 255:
#line 1581 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_reload, 1, CMD_RELOAD_IN); }
#line 5276 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 256:
#line 1583 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_reload, 1, CMD_RELOAD_OUT); }
#line 5282 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 257:
#line 1587 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-2].ps), proto_cmd_debug, 1, (yyvsp[-1].i)); }
#line 5288 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 258:
#line 1591 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-2].ps), proto_cmd_mrtdump, 1, (yyvsp[-1].i)); }
#line 5294 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 259:
#line 1594 "cf-parse.y" /* yacc.c:1646  */
    { this_cli->restricted = 1; cli_msg(16, "Access restricted"); }
#line 5300 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 260:
#line 1597 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = (yyvsp[0].s); (yyval.ps).patt = 0; }
#line 5306 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 261:
#line 1598 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; }
#line 5312 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 262:
#line 1599 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = (yyvsp[0].t); (yyval.ps).patt = 1; }
#line 5318 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 263:
#line 1603 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = (yyvsp[0].s); (yyval.ps).patt = 0; }
#line 5324 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 264:
#line 1604 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; }
#line 5330 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 265:
#line 1605 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = (yyvsp[0].t); (yyval.ps).patt = 1; }
#line 5336 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 266:
#line 1613 "cf-parse.y" /* yacc.c:1646  */
    { (yyvsp[0].s) = cf_define_symbol((yyvsp[0].s), SYM_FILTER, NULL); cf_push_scope( (yyvsp[0].s) ); }
#line 5342 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 267:
#line 1614 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyvsp[-2].s)->def = (yyvsp[0].f);
     (yyvsp[0].f)->name = (yyvsp[-2].s)->name;
     DBG( "We have new filter defined (%s)\n", (yyvsp[-2].s)->name );
     cf_pop_scope();
   }
#line 5353 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 268:
#line 1623 "cf-parse.y" /* yacc.c:1646  */
    { f_eval_int((yyvsp[0].x)); }
#line 5359 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 269:
#line 1627 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_INT; }
#line 5365 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 270:
#line 1628 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_BOOL; }
#line 5371 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 271:
#line 1629 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_IP; }
#line 5377 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 272:
#line 1630 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_PREFIX; }
#line 5383 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 273:
#line 1631 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_PAIR; }
#line 5389 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 274:
#line 1632 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_QUAD; }
#line 5395 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 275:
#line 1633 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_EC; }
#line 5401 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 276:
#line 1634 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_STRING; }
#line 5407 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 277:
#line 1635 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_PATH_MASK; }
#line 5413 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 278:
#line 1636 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_PATH; }
#line 5419 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 279:
#line 1637 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_CLIST; }
#line 5425 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 280:
#line 1638 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_ECLIST; }
#line 5431 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 281:
#line 1639 "cf-parse.y" /* yacc.c:1646  */
    { 
	switch ((yyvsp[-1].i)) {
	  case T_INT:
	  case T_PAIR:
	  case T_QUAD:
	  case T_EC:
	  case T_IP:
	       (yyval.i) = T_SET;
	       break;

	  case T_PREFIX:
	       (yyval.i) = T_PREFIX_SET;
	    break;

	  default:
		cf_error( "You can't create sets of this type." );
	}
   }
#line 5454 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 282:
#line 1660 "cf-parse.y" /* yacc.c:1646  */
    {
     struct f_val * val = cfg_alloc(sizeof(struct f_val));
     val->type = T_VOID;
     (yyvsp[0].s) = cf_define_symbol((yyvsp[0].s), SYM_VARIABLE | (yyvsp[-1].i), val);
     DBG( "New variable %s type %x\n", (yyvsp[0].s)->name, (yyvsp[-1].i) );
     (yyvsp[0].s)->aux2 = NULL;
     (yyval.s)=(yyvsp[0].s);
   }
#line 5467 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 283:
#line 1671 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.s) = NULL; }
#line 5473 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 284:
#line 1672 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.s) = (yyvsp[-2].s);
     (yyval.s)->aux2 = (yyvsp[0].s);
   }
#line 5482 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 285:
#line 1679 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.s) = (yyvsp[0].s); }
#line 5488 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 286:
#line 1680 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.s) = (yyvsp[-2].s);
     (yyval.s)->aux2 = (yyvsp[0].s);
   }
#line 5497 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 287:
#line 1687 "cf-parse.y" /* yacc.c:1646  */
    {
     struct filter *f = cfg_alloc(sizeof(struct filter));
     f->name = NULL;
     f->root = (yyvsp[0].x);
     (yyval.f) = f;
   }
#line 5508 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 288:
#line 1696 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != SYM_FILTER) cf_error("No such filter.");
     (yyval.f) = (yyvsp[0].s)->def;
   }
#line 5517 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 290:
#line 1704 "cf-parse.y" /* yacc.c:1646  */
    {
     /* Construct 'IF term THEN ACCEPT; REJECT;' */
     struct filter *f = cfg_alloc(sizeof(struct filter));
     struct f_inst *i, *acc, *rej;
     acc = f_new_inst();		/* ACCEPT */
     acc->code = P('p',',');
     acc->a1.p = NULL;
     acc->a2.i = F_ACCEPT;
     rej = f_new_inst();		/* REJECT */
     rej->code = P('p',',');
     rej->a1.p = NULL;
     rej->a2.i = F_REJECT;
     i = f_new_inst();			/* IF */
     i->code = '?';
     i->a1.p = (yyvsp[0].x);
     i->a2.p = acc;
     i->next = rej;
     f->name = NULL;
     f->root = i;
     (yyval.f) = f;
  }
#line 5543 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 291:
#line 1728 "cf-parse.y" /* yacc.c:1646  */
    { DBG( "Have function parameters\n" ); (yyval.s)=(yyvsp[-1].s); }
#line 5549 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 292:
#line 1729 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.s)=NULL; }
#line 5555 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 293:
#line 1733 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[-3].s)) {
       /* Prepend instruction to clear local variables */
       (yyval.x) = f_new_inst();
       (yyval.x)->code = P('c','v');
       (yyval.x)->a1.p = (yyvsp[-3].s);
       (yyval.x)->next = (yyvsp[-1].x);
     } else
       (yyval.x) = (yyvsp[-1].x);
   }
#line 5570 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 294:
#line 1746 "cf-parse.y" /* yacc.c:1646  */
    { DBG( "Beginning of function %s\n", (yyvsp[0].s)->name );
     (yyvsp[0].s) = cf_define_symbol((yyvsp[0].s), SYM_FUNCTION, NULL);
     cf_push_scope((yyvsp[0].s));
   }
#line 5579 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 295:
#line 1749 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyvsp[-3].s)->def = (yyvsp[0].x);
     (yyvsp[-3].s)->aux2 = (yyvsp[-1].s);
     DBG("Hmm, we've got one function here - %s\n", (yyvsp[-3].s)->name); 
     cf_pop_scope();
   }
#line 5590 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 296:
#line 1762 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = NULL; }
#line 5596 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 297:
#line 1763 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x)->next; (yyvsp[0].x)->next = NULL; }
#line 5602 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 298:
#line 1766 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); (yyvsp[0].x)->next = (yyvsp[0].x); }
#line 5608 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 299:
#line 1767 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); (yyvsp[0].x)->next = (yyvsp[-1].x)->next ; (yyvsp[-1].x)->next = (yyvsp[0].x); }
#line 5614 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 300:
#line 1771 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x)=(yyvsp[0].x);
   }
#line 5622 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 301:
#line 1774 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x)=(yyvsp[-1].x);
   }
#line 5630 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 302:
#line 1783 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = T_IP; (yyval.v).val.px.ip = (yyvsp[0].a); }
#line 5636 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 303:
#line 1796 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[0].i); }
#line 5642 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 304:
#line 1797 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = T_QUAD; (yyval.v).val.i = (yyvsp[0].i32); }
#line 5648 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 305:
#line 1798 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v) = (yyvsp[0].v); }
#line 5654 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 306:
#line 1799 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = pair_a((yyvsp[0].i)); (yyval.v).val.i = pair_b((yyvsp[0].i)); }
#line 5660 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 307:
#line 1803 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[0].i); }
#line 5666 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 308:
#line 1804 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = T_INT; (yyval.v).val.i = f_eval_int((yyvsp[-1].x)); }
#line 5672 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 309:
#line 1805 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = T_QUAD; (yyval.v).val.i = (yyvsp[0].i32); }
#line 5678 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 310:
#line 1806 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v) = (yyvsp[0].v); }
#line 5684 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 311:
#line 1807 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = pair_a((yyvsp[0].i)); (yyval.v).val.i = pair_b((yyvsp[0].i)); }
#line 5690 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 312:
#line 1811 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = f_eval_int((yyvsp[0].x)); check_u16((yyval.i)); }
#line 5696 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 313:
#line 1814 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = pair((yyvsp[0].i), (yyvsp[0].i)); }
#line 5702 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 314:
#line 1815 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = pair((yyvsp[-2].i), (yyvsp[0].i)); }
#line 5708 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 315:
#line 1816 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = 0xFFFF; }
#line 5714 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 316:
#line 1820 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.e) = f_new_pair_set(pair_a((yyvsp[-3].i32)), pair_b((yyvsp[-3].i32)), pair_a((yyvsp[-1].i32)), pair_b((yyvsp[-1].i32)));
   }
#line 5722 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 317:
#line 1823 "cf-parse.y" /* yacc.c:1646  */
    {
     /* Hack: $2 and $4 should be pair_expr, but that would cause shift/reduce conflict */
     if ((pair_a((yyvsp[-9].i32)) != pair_b((yyvsp[-9].i32))) || (pair_a((yyvsp[-7].i32)) != pair_b((yyvsp[-7].i32))))
       cf_error("syntax error");
     (yyval.e) = f_new_pair_item(pair_b((yyvsp[-9].i32)), (yyvsp[-3].i), pair_b((yyvsp[-7].i32)), (yyvsp[-1].i)); 
   }
#line 5733 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 318:
#line 1832 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = f_eval_int((yyvsp[0].x)); }
#line 5739 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 319:
#line 1835 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = EC_RT; }
#line 5745 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 320:
#line 1836 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = EC_RO; }
#line 5751 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 321:
#line 1837 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i); }
#line 5757 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 322:
#line 1838 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = EC_GENERIC; }
#line 5763 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 323:
#line 1842 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_ec_item((yyvsp[-5].i), 0, (yyvsp[-3].i32), (yyvsp[-1].i32), (yyvsp[-1].i32)); }
#line 5769 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 324:
#line 1843 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_ec_item((yyvsp[-7].i), 0, (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-1].i32)); }
#line 5775 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 325:
#line 1844 "cf-parse.y" /* yacc.c:1646  */
    {  (yyval.e) = f_new_ec_item((yyvsp[-5].i), 0, (yyvsp[-3].i32), 0, EC_ALL); }
#line 5781 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 328:
#line 1850 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_item((yyvsp[0].v), (yyvsp[0].v)); }
#line 5787 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 329:
#line 1851 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_item((yyvsp[-2].v), (yyvsp[0].v)); }
#line 5793 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 332:
#line 1857 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_item((yyvsp[0].v), (yyvsp[0].v)); }
#line 5799 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 333:
#line 1858 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_item((yyvsp[-2].v), (yyvsp[0].v)); }
#line 5805 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 335:
#line 1863 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_merge_items((yyvsp[-2].e), (yyvsp[0].e)); }
#line 5811 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 337:
#line 1868 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_merge_items((yyvsp[-2].e), (yyvsp[0].e)); }
#line 5817 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 338:
#line 1872 "cf-parse.y" /* yacc.c:1646  */
    {
     if (((yyvsp[0].i) < 0) || ((yyvsp[0].i) > MAX_PREFIX_LENGTH) || !ip_is_prefix((yyvsp[-2].a), (yyvsp[0].i))) cf_error("Invalid network prefix: %I/%d.", (yyvsp[-2].a), (yyvsp[0].i));
     (yyval.v).type = T_PREFIX; (yyval.v).val.px.ip = (yyvsp[-2].a); (yyval.v).val.px.len = (yyvsp[0].i);
   }
#line 5826 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 339:
#line 1879 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v) = (yyvsp[0].v); }
#line 5832 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 340:
#line 1880 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v) = (yyvsp[-1].v); (yyval.v).val.px.len |= LEN_PLUS; }
#line 5838 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 341:
#line 1881 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v) = (yyvsp[-1].v); (yyval.v).val.px.len |= LEN_MINUS; }
#line 5844 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 342:
#line 1882 "cf-parse.y" /* yacc.c:1646  */
    { 
     if (! ((0 <= (yyvsp[-3].i)) && ((yyvsp[-3].i) <= (yyvsp[-1].i)) && ((yyvsp[-1].i) <= MAX_PREFIX_LENGTH))) cf_error("Invalid prefix pattern range: {%d, %d}.", (yyvsp[-3].i), (yyvsp[-1].i));
     (yyval.v) = (yyvsp[-5].v); (yyval.v).val.px.len |= LEN_RANGE | ((yyvsp[-3].i) << 16) | ((yyvsp[-1].i) << 8);
   }
#line 5853 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 343:
#line 1889 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.trie) = f_new_trie(cfg_mem); trie_add_fprefix((yyval.trie), &((yyvsp[0].v).val.px)); }
#line 5859 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 344:
#line 1890 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.trie) = (yyvsp[-2].trie); trie_add_fprefix((yyval.trie), &((yyvsp[0].v).val.px)); }
#line 5865 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 345:
#line 1893 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = NULL; }
#line 5871 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 346:
#line 1894 "cf-parse.y" /* yacc.c:1646  */
    {
     /* Fill data fields */
     struct f_tree *t;
     for (t = (yyvsp[-2].e); t; t = t->left)
       t->data = (yyvsp[0].x);
     (yyval.e) = f_merge_items((yyvsp[-3].e), (yyvsp[-2].e));
   }
#line 5883 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 347:
#line 1901 "cf-parse.y" /* yacc.c:1646  */
    { 
     struct f_tree *t = f_new_tree();
     t->from.type = t->to.type = T_VOID;
     t->right = t;
     t->data = (yyvsp[0].x);
     (yyval.e) = f_merge_items((yyvsp[-2].e), t);
 }
#line 5895 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 348:
#line 1913 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 5901 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 349:
#line 1914 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[-1].x); }
#line 5907 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 350:
#line 1918 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = (yyvsp[-1].h); }
#line 5913 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 351:
#line 1919 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = (yyvsp[-1].h); }
#line 5919 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 352:
#line 1923 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASN;      (yyval.h)->val = (yyvsp[-1].i); }
#line 5925 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 353:
#line 1924 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASTERISK; (yyval.h)->val  = 0; }
#line 5931 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 354:
#line 1925 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_QUESTION; (yyval.h)->val  = 0; }
#line 5937 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 355:
#line 1926 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASN_EXPR; (yyval.h)->val = (uintptr_t) (yyvsp[-1].x); }
#line 5943 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 356:
#line 1927 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = NULL; }
#line 5949 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 357:
#line 1931 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASN;      (yyval.h)->val = (yyvsp[-1].i); }
#line 5955 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 358:
#line 1932 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASTERISK; (yyval.h)->val  = 0; }
#line 5961 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 359:
#line 1933 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = NULL; }
#line 5967 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 360:
#line 1937 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_INT;  (yyval.x)->a2.i = (yyvsp[0].i); }
#line 5973 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 361:
#line 1938 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 1;  }
#line 5979 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 362:
#line 1939 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 0;  }
#line 5985 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 363:
#line 1940 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_STRING; (yyval.x)->a2.p = (yyvsp[0].t); }
#line 5991 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 364:
#line 1941 "cf-parse.y" /* yacc.c:1646  */
    { NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; (yyval.x)->a1.p = val; *val = (yyvsp[0].v); }
#line 5997 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 365:
#line 1942 "cf-parse.y" /* yacc.c:1646  */
    {NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; (yyval.x)->a1.p = val; *val = (yyvsp[0].v); }
#line 6003 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 366:
#line 1943 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_QUAD;  (yyval.x)->a2.i = (yyvsp[0].i32); }
#line 6009 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 367:
#line 1944 "cf-parse.y" /* yacc.c:1646  */
    { DBG( "We've got a set here..." ); (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_SET; (yyval.x)->a2.p = build_tree((yyvsp[-1].e)); DBG( "ook\n" ); }
#line 6015 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 368:
#line 1945 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_PREFIX_SET;  (yyval.x)->a2.p = (yyvsp[-1].trie); }
#line 6021 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 369:
#line 1946 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = (yyvsp[0].i) >> 16; (yyval.x)->a2.i = (yyvsp[0].i) & 0xffff; }
#line 6027 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 370:
#line 1947 "cf-parse.y" /* yacc.c:1646  */
    { NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; val->type = T_PATH_MASK; val->val.path_mask = (yyvsp[0].h); (yyval.x)->a1.p = val; }
#line 6033 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 371:
#line 1951 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_dpair((yyvsp[-3].x), (yyvsp[-1].x)); }
#line 6039 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 372:
#line 1952 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_ec((yyvsp[-5].i), (yyvsp[-3].x), (yyvsp[-1].x)); }
#line 6045 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 374:
#line 1966 "cf-parse.y" /* yacc.c:1646  */
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[-1].x);
     if ((yyvsp[-3].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[-3].s)->name);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('c','a');
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[-3].s)->def;
     sym = (yyvsp[-3].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[-3].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   }
#line 6070 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 375:
#line 1989 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst();

     switch ((yyvsp[0].s)->class & 0xff00) {
       case SYM_CONSTANT: (yyval.x)->code = 'C'; break;
       case SYM_VARIABLE: (yyval.x)->code = 'V'; break;
       default: cf_error("%s: variable expected.", (yyvsp[0].s)->name);
     }

     (yyval.x)->a1.p = (yyvsp[0].s)->def;
     (yyval.x)->a2.p = (yyvsp[0].s)->name;
   }
#line 6087 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 376:
#line 2003 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_IP;         (yyval.x)->a2.i = SA_FROM;	(yyval.x)->a1.i = 1; }
#line 6093 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 377:
#line 2004 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_IP;         (yyval.x)->a2.i = SA_GW;	(yyval.x)->a1.i = 1; }
#line 6099 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 378:
#line 2005 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_PREFIX;     (yyval.x)->a2.i = SA_NET; }
#line 6105 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 379:
#line 2006 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_STRING;     (yyval.x)->a2.i = SA_PROTO; }
#line 6111 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 380:
#line 2007 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTS;   (yyval.x)->a2.i = SA_SOURCE; }
#line 6117 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 381:
#line 2008 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_SCOPE; (yyval.x)->a2.i = SA_SCOPE;	(yyval.x)->a1.i = 1; }
#line 6123 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 382:
#line 2009 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTC;   (yyval.x)->a2.i = SA_CAST; }
#line 6129 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 383:
#line 2010 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTD;   (yyval.x)->a2.i = SA_DEST;	(yyval.x)->a1.i = 1; }
#line 6135 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 384:
#line 2011 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_STRING;     (yyval.x)->a2.i = SA_IFNAME; }
#line 6141 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 385:
#line 2012 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_INT;        (yyval.x)->a2.i = SA_IFINDEX; }
#line 6147 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 386:
#line 2016 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[-1].x); }
#line 6153 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 387:
#line 2017 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '+';        (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6159 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 388:
#line 2018 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '-';        (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6165 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 389:
#line 2019 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '*';        (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6171 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 390:
#line 2020 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '/';        (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6177 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 391:
#line 2021 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '&';        (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6183 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 392:
#line 2022 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '|';        (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6189 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 393:
#line 2023 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('=','='); (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6195 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 394:
#line 2024 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('!','=');     (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6201 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 395:
#line 2025 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '<';        (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6207 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 396:
#line 2026 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('<','=');     (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6213 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 397:
#line 2027 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '<';        (yyval.x)->a1.p = (yyvsp[0].x); (yyval.x)->a2.p = (yyvsp[-2].x); }
#line 6219 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 398:
#line 2028 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('<','=');     (yyval.x)->a1.p = (yyvsp[0].x); (yyval.x)->a2.p = (yyvsp[-2].x); }
#line 6225 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 399:
#line 2029 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '~';        (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6231 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 400:
#line 2030 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '!'; (yyval.x)->a1.p = (yyvsp[0].x); }
#line 6237 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 401:
#line 2031 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('d','e');  (yyval.x)->a1.p = (yyvsp[-1].x); }
#line 6243 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 402:
#line 2033 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 6249 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 403:
#line 2034 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 6255 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 404:
#line 2035 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 6261 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 405:
#line 2037 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'P'; }
#line 6267 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 406:
#line 2039 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); (yyval.x)->code = 'a'; }
#line 6273 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 407:
#line 2041 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); (yyval.x)->code = P('e','a'); }
#line 6279 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 408:
#line 2043 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('c','p'); (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->aux = T_IP; }
#line 6285 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 409:
#line 2044 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'L'; (yyval.x)->a1.p = (yyvsp[-2].x); }
#line 6291 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 410:
#line 2045 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('i','M'); (yyval.x)->a1.p = (yyvsp[-5].x); (yyval.x)->a2.p = (yyvsp[-1].x); }
#line 6297 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 411:
#line 2046 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('a','f'); (yyval.x)->a1.p = (yyvsp[-2].x); }
#line 6303 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 412:
#line 2047 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('a','l'); (yyval.x)->a1.p = (yyvsp[-2].x); }
#line 6309 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 413:
#line 2057 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_PATH; }
#line 6315 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 414:
#line 2058 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_CLIST; }
#line 6321 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 415:
#line 2059 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_ECLIST; }
#line 6327 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 416:
#line 2060 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('A','p'); (yyval.x)->a1.p = (yyvsp[-3].x); (yyval.x)->a2.p = (yyvsp[-1].x); }
#line 6333 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 417:
#line 2061 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[-3].x); (yyval.x)->a2.p = (yyvsp[-1].x); (yyval.x)->aux = 'a'; }
#line 6339 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 418:
#line 2062 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[-3].x); (yyval.x)->a2.p = (yyvsp[-1].x); (yyval.x)->aux = 'd'; }
#line 6345 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 419:
#line 2063 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[-3].x); (yyval.x)->a2.p = (yyvsp[-1].x); (yyval.x)->aux = 'f'; }
#line 6351 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 420:
#line 2065 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_roa_check((yyvsp[-1].s), NULL, NULL); }
#line 6357 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 421:
#line 2066 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_roa_check((yyvsp[-5].s), (yyvsp[-3].x), (yyvsp[-1].x)); }
#line 6363 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 422:
#line 2071 "cf-parse.y" /* yacc.c:1646  */
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[-1].x);
     if ((yyvsp[-3].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[-3].s)->name);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('c','a');
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[-3].s)->def;
     sym = (yyvsp[-3].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[-3].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   }
#line 6388 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 423:
#line 2094 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_QUITBIRD; }
#line 6394 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 424:
#line 2095 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_ACCEPT; }
#line 6400 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 425:
#line 2096 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_REJECT; }
#line 6406 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 426:
#line 2097 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_ERROR; }
#line 6412 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 427:
#line 2098 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_NOP; }
#line 6418 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 428:
#line 2099 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_NONL; }
#line 6424 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 429:
#line 2103 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'p'; (yyval.x)->a1.p = (yyvsp[0].x); (yyval.x)->a2.p = NULL; }
#line 6430 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 430:
#line 2106 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = NULL; }
#line 6436 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 431:
#line 2107 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 6442 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 432:
#line 2108 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[-2].x)) {
       (yyvsp[-2].x)->next = (yyvsp[0].x);
       (yyval.x) = (yyvsp[-2].x);
     } else (yyval.x) = (yyvsp[0].x);
   }
#line 6453 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 433:
#line 2116 "cf-parse.y" /* yacc.c:1646  */
    { 
     (yyval.x) = f_new_inst();
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[0].x);
     (yyval.x)->next = NULL;
   }
#line 6465 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 434:
#line 2123 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[-2].x);
     (yyval.x)->next = (yyvsp[0].x);
   }
#line 6477 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 435:
#line 2132 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = NULL; }
#line 6483 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 436:
#line 2133 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 6489 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 437:
#line 2137 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = '?';
     (yyval.x)->a1.p = (yyvsp[-2].x);
     (yyval.x)->a2.p = (yyvsp[0].x);
   }
#line 6500 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 438:
#line 2143 "cf-parse.y" /* yacc.c:1646  */
    {
     struct f_inst *i = f_new_inst();
     i->code = '?';
     i->a1.p = (yyvsp[-4].x);
     i->a2.p = (yyvsp[-2].x);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = '?';
     (yyval.x)->a1.p = i;
     (yyval.x)->a2.p = (yyvsp[0].x);
   }
#line 6515 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 439:
#line 2153 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst();
     DBG( "Ook, we'll set value\n" );
     if (((yyvsp[-3].s)->class & ~T_MASK) != SYM_VARIABLE)
       cf_error( "You may set only variables." );
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = (yyvsp[-3].s);
     (yyval.x)->a2.p = (yyvsp[-1].x);
   }
#line 6529 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 440:
#line 2162 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst();
     DBG( "Ook, we'll return the value\n" );
     (yyval.x)->code = 'r';
     (yyval.x)->a1.p = (yyvsp[-1].x);
   }
#line 6540 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 441:
#line 2168 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = (yyvsp[-3].x);
     (yyval.x)->code = P('e','S');
     (yyval.x)->a1.p = (yyvsp[-1].x);
   }
#line 6550 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 442:
#line 2173 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = (yyvsp[-3].x);
     if (!(yyval.x)->a1.i)
       cf_error( "This static attribute is read-only.");
     (yyval.x)->code = P('a','S');
     (yyval.x)->a1.p = (yyvsp[-1].x);
   }
#line 6562 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 443:
#line 2180 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('P','S');
     (yyval.x)->a1.p = (yyvsp[-1].x);
   }
#line 6572 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 444:
#line 2185 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = (yyvsp[-2].x);
     (yyval.x)->aux = EAF_TYPE_UNDEF | EAF_TEMP;
     (yyval.x)->code = P('e','S');
     (yyval.x)->a1.p = NULL;
   }
#line 6583 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 445:
#line 2191 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('p',','); (yyval.x)->a1.p = (yyvsp[-1].x); (yyval.x)->a2.i = (yyvsp[-2].i); }
#line 6589 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 446:
#line 2192 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[-1].x); }
#line 6595 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 447:
#line 2193 "cf-parse.y" /* yacc.c:1646  */
    {
      (yyval.x) = f_new_inst();
      (yyval.x)->code = P('S','W');
      (yyval.x)->a1.p = (yyvsp[-3].x);
      (yyval.x)->a2.p = build_tree( (yyvsp[-1].e) );
   }
#line 6606 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 448:
#line 2201 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_empty((yyvsp[-3].x)); }
#line 6612 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 449:
#line 2202 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_complex( P('A','p'), 'x', (yyvsp[-6].x), (yyvsp[-2].x) ); }
#line 6618 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 450:
#line 2203 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_complex( P('C','a'), 'a', (yyvsp[-6].x), (yyvsp[-2].x) ); }
#line 6624 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 451:
#line 2204 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_complex( P('C','a'), 'd', (yyvsp[-6].x), (yyvsp[-2].x) ); }
#line 6630 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 452:
#line 2205 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_complex( P('C','a'), 'f', (yyvsp[-6].x), (yyvsp[-2].x) ); }
#line 6636 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 453:
#line 2212 "cf-parse.y" /* yacc.c:1646  */
    {
  this_proto = proto_config_new(&proto_bfd, sizeof(struct bfd_config), (yyvsp[-1].i));
  init_list(&BFD_CFG->patt_list);
  init_list(&BFD_CFG->neigh_list);

  if (bfd_cf)
    cf_error("Only one BFD instance allowed");
  bfd_cf = BFD_CFG;
}
#line 6650 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 461:
#line 2239 "cf-parse.y" /* yacc.c:1646  */
    {
  this_ipatt = cfg_allocz(sizeof(struct bfd_iface_config));
  init_list(&this_ipatt->ipn_list);

  BFD_IFACE->min_rx_int = BFD_DEFAULT_MIN_RX_INT;
  BFD_IFACE->min_tx_int = BFD_DEFAULT_MIN_TX_INT;
  BFD_IFACE->idle_tx_int = BFD_DEFAULT_IDLE_TX_INT;
  BFD_IFACE->multiplier = BFD_DEFAULT_MULTIPLIER;
}
#line 6664 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 462:
#line 2250 "cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->min_rx_int = BFD_IFACE->min_tx_int = (yyvsp[0].i32); }
#line 6670 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 463:
#line 2251 "cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->min_rx_int = (yyvsp[0].i32); }
#line 6676 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 464:
#line 2252 "cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->min_tx_int = (yyvsp[0].i32); }
#line 6682 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 465:
#line 2253 "cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->idle_tx_int = (yyvsp[0].i32); }
#line 6688 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 466:
#line 2254 "cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->multiplier = (yyvsp[0].i); }
#line 6694 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 467:
#line 2255 "cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->passive = (yyvsp[0].i); }
#line 6700 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 472:
#line 2269 "cf-parse.y" /* yacc.c:1646  */
    { add_tail(&BFD_CFG->patt_list, NODE this_ipatt); }
#line 6706 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 473:
#line 2272 "cf-parse.y" /* yacc.c:1646  */
    { BFD_CFG->multihop = BFD_IFACE; }
#line 6712 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 474:
#line 2276 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.iface) = NULL; }
#line 6718 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 475:
#line 2277 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.iface) = if_get_by_name((yyvsp[0].s)->name); }
#line 6724 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 476:
#line 2278 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.iface) = if_get_by_name((yyvsp[0].t)); }
#line 6730 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 477:
#line 2282 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.a) = IPA_NONE; }
#line 6736 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 478:
#line 2283 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.a) = (yyvsp[0].a); }
#line 6742 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 479:
#line 2287 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 6748 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 480:
#line 2288 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i); }
#line 6754 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 481:
#line 2292 "cf-parse.y" /* yacc.c:1646  */
    {
  this_bfd_neighbor = cfg_allocz(sizeof(struct bfd_neighbor));
  add_tail(&BFD_CFG->neigh_list, NODE this_bfd_neighbor);

  BFD_NEIGHBOR->addr = (yyvsp[-3].a);
  BFD_NEIGHBOR->local = (yyvsp[-1].a);
  BFD_NEIGHBOR->iface = (yyvsp[-2].iface);
  BFD_NEIGHBOR->multihop = (yyvsp[0].i);

  if ((yyvsp[0].i) && (yyvsp[-2].iface))
    cf_error("Neighbor cannot set both interface and multihop");

  if ((yyvsp[0].i) && ipa_zero((yyvsp[-1].a)))
    cf_error("Multihop neighbor requires specified local address");
}
#line 6774 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 482:
#line 2311 "cf-parse.y" /* yacc.c:1646  */
    { bfd_show_sessions(proto_get_named((yyvsp[-1].s), &proto_bfd)); }
#line 6780 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 483:
#line 2316 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto = proto_config_new(&proto_bgp, sizeof(struct bgp_config), (yyvsp[-1].i));
     BGP_CFG->multihop = -1;	/* undefined */
     BGP_CFG->hold_time = 240;
     BGP_CFG->connect_retry_time = 120;
     BGP_CFG->initial_hold_time = 240;
     BGP_CFG->compare_path_lengths = 1;
     BGP_CFG->igp_metric = 1;
     BGP_CFG->start_delay_time = 5;
     BGP_CFG->error_amnesia_time = 300;
     BGP_CFG->error_delay_time_min = 60;
     BGP_CFG->error_delay_time_max = 300;
     BGP_CFG->enable_refresh = 1;
     BGP_CFG->enable_as4 = 1;
     BGP_CFG->capabilities = 2;
     BGP_CFG->advertise_ipv4 = 1;
     BGP_CFG->interpret_communities = 1;
     BGP_CFG->default_local_pref = 100;
     BGP_CFG->gr_mode = BGP_GR_AWARE;
     BGP_CFG->gr_time = 120;
 }
#line 6806 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 486:
#line 2342 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->local_as = (yyvsp[-1].i); }
#line 6812 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 487:
#line 2343 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->source_addr = (yyvsp[-3].a); BGP_CFG->local_as = (yyvsp[-1].i); }
#line 6818 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 488:
#line 2344 "cf-parse.y" /* yacc.c:1646  */
    {
     if (ipa_nonzero(BGP_CFG->remote_ip))
       cf_error("Only one neighbor per BGP instance is allowed");
     if (!ipa_has_link_scope((yyvsp[-4].a)) != !(yyvsp[-3].iface))
       cf_error("Link-local address and interface scope must be used together");

     BGP_CFG->remote_ip = (yyvsp[-4].a);
     BGP_CFG->iface = (yyvsp[-3].iface);
     BGP_CFG->remote_as = (yyvsp[-1].i);
   }
#line 6833 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 489:
#line 2354 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->rr_cluster_id = (yyvsp[-1].i32); }
#line 6839 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 490:
#line 2355 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->rr_client = 1; }
#line 6845 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 491:
#line 2356 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->rs_client = 1; }
#line 6851 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 492:
#line 2357 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->hold_time = (yyvsp[-1].i); }
#line 6857 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 493:
#line 2358 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->initial_hold_time = (yyvsp[-1].i); }
#line 6863 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 494:
#line 2359 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->connect_retry_time = (yyvsp[-1].i); }
#line 6869 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 495:
#line 2360 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->keepalive_time = (yyvsp[-1].i); }
#line 6875 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 496:
#line 2361 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->multihop = 0; }
#line 6881 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 497:
#line 2362 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->multihop = 64; }
#line 6887 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 498:
#line 2363 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->multihop = (yyvsp[-1].i); if (((yyvsp[-1].i)<1) || ((yyvsp[-1].i)>255)) cf_error("Multihop must be in range 1-255"); }
#line 6893 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 499:
#line 2364 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->next_hop_self = 1; BGP_CFG->next_hop_keep = 0; }
#line 6899 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 500:
#line 2365 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->next_hop_keep = 1; BGP_CFG->next_hop_self = 0; }
#line 6905 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 501:
#line 2366 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->missing_lladdr = MLL_SELF; }
#line 6911 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 502:
#line 2367 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->missing_lladdr = MLL_DROP; }
#line 6917 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 503:
#line 2368 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->missing_lladdr = MLL_IGNORE; }
#line 6923 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 504:
#line 2369 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->gw_mode = GW_DIRECT; }
#line 6929 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 505:
#line 2370 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->gw_mode = GW_RECURSIVE; }
#line 6935 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 506:
#line 2371 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->compare_path_lengths = (yyvsp[-1].i); }
#line 6941 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 507:
#line 2372 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->med_metric = (yyvsp[-1].i); }
#line 6947 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 508:
#line 2373 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->igp_metric = (yyvsp[-1].i); }
#line 6953 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 509:
#line 2374 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->prefer_older = (yyvsp[-1].i); }
#line 6959 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 510:
#line 2375 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->deterministic_med = (yyvsp[-1].i); }
#line 6965 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 511:
#line 2376 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->default_med = (yyvsp[-1].i); }
#line 6971 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 512:
#line 2377 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->default_local_pref = (yyvsp[-1].i); }
#line 6977 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 513:
#line 2378 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->source_addr = (yyvsp[-1].a); }
#line 6983 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 514:
#line 2379 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->start_delay_time = (yyvsp[-1].i); }
#line 6989 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 515:
#line 2380 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->error_amnesia_time = (yyvsp[-1].i); }
#line 6995 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 516:
#line 2381 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->error_delay_time_min = (yyvsp[-3].i); BGP_CFG->error_delay_time_max = (yyvsp[-1].i); }
#line 7001 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 517:
#line 2382 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->disable_after_error = (yyvsp[-1].i); }
#line 7007 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 518:
#line 2383 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->enable_refresh = (yyvsp[-1].i); }
#line 7013 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 519:
#line 2384 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->enable_as4 = (yyvsp[-1].i); }
#line 7019 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 520:
#line 2385 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->capabilities = (yyvsp[-1].i); }
#line 7025 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 521:
#line 2386 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->advertise_ipv4 = (yyvsp[-1].i); }
#line 7031 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 522:
#line 2387 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->password = (yyvsp[-1].t); }
#line 7037 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 523:
#line 2388 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto->in_limit = cfg_allocz(sizeof(struct proto_limit));
     this_proto->in_limit->limit = (yyvsp[-1].i);
     this_proto->in_limit->action = PLA_RESTART;
   }
#line 7047 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 524:
#line 2393 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->passive = (yyvsp[-1].i); }
#line 7053 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 525:
#line 2394 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->interpret_communities = (yyvsp[-1].i); }
#line 7059 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 526:
#line 2395 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->secondary = (yyvsp[-1].i); }
#line 7065 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 527:
#line 2396 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->add_path = ADD_PATH_RX; }
#line 7071 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 528:
#line 2397 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->add_path = ADD_PATH_TX; }
#line 7077 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 529:
#line 2398 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->add_path = (yyvsp[-1].i) ? ADD_PATH_FULL : 0; }
#line 7083 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 530:
#line 2399 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->allow_local_as = -1; }
#line 7089 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 531:
#line 2400 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->allow_local_as = (yyvsp[-1].i); }
#line 7095 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 532:
#line 2401 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->gr_mode = (yyvsp[-1].i); }
#line 7101 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 533:
#line 2402 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->gr_mode = BGP_GR_AWARE; }
#line 7107 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 534:
#line 2403 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->gr_time = (yyvsp[-1].i); }
#line 7113 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 535:
#line 2404 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->igp_table = (yyvsp[-1].r); }
#line 7119 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 536:
#line 2405 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->ttl_security = (yyvsp[-1].i); }
#line 7125 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 537:
#line 2406 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->bfd = (yyvsp[-1].i); cf_check_bfd((yyvsp[-1].i)); }
#line 7131 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 538:
#line 2417 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto = proto_config_new(&proto_ospf, sizeof(struct ospf_config), (yyvsp[-1].i));
     init_list(&OSPF_CFG->area_list);
     init_list(&OSPF_CFG->vlink_list);
     OSPF_CFG->rfc1583 = DEFAULT_RFC1583;
     OSPF_CFG->tick = DEFAULT_OSPFTICK;
  }
#line 7143 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 542:
#line 2433 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->rfc1583 = (yyvsp[0].i); }
#line 7149 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 543:
#line 2434 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->stub_router = (yyvsp[0].i); }
#line 7155 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 544:
#line 2435 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->ecmp = (yyvsp[0].i) ? DEFAULT_ECMP_LIMIT : 0; }
#line 7161 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 545:
#line 2436 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->ecmp = (yyvsp[-2].i) ? (yyvsp[0].i) : 0; if ((yyvsp[0].i) < 0) cf_error("ECMP limit cannot be negative"); }
#line 7167 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 546:
#line 2437 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->merge_external = (yyvsp[0].i); }
#line 7173 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 547:
#line 2438 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->tick = (yyvsp[0].i); if((yyvsp[0].i)<=0) cf_error("Tick must be greater than zero"); }
#line 7179 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 549:
#line 2442 "cf-parse.y" /* yacc.c:1646  */
    {
  this_area = cfg_allocz(sizeof(struct ospf_area_config));
  add_tail(&OSPF_CFG->area_list, NODE this_area);
  this_area->areaid = (yyvsp[0].i32);
  this_area->default_cost = DEFAULT_STUB_COST;
  this_area->type = OPT_E;
  this_area->transint = DEFAULT_TRANSINT;

  init_list(&this_area->patt_list);
  init_list(&this_area->net_list);
  init_list(&this_area->enet_list);
  init_list(&this_area->stubnet_list);
 }
#line 7197 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 550:
#line 2457 "cf-parse.y" /* yacc.c:1646  */
    { ospf_area_finish(); }
#line 7203 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 553:
#line 2466 "cf-parse.y" /* yacc.c:1646  */
    { this_area->type = (yyvsp[0].i) ? 0 : OPT_E; /* We should remove the option */ }
#line 7209 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 554:
#line 2467 "cf-parse.y" /* yacc.c:1646  */
    { this_area->type = OPT_N; }
#line 7215 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 555:
#line 2468 "cf-parse.y" /* yacc.c:1646  */
    { this_area->summary = (yyvsp[0].i); }
#line 7221 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 556:
#line 2469 "cf-parse.y" /* yacc.c:1646  */
    { this_area->default_nssa = (yyvsp[0].i); }
#line 7227 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 557:
#line 2470 "cf-parse.y" /* yacc.c:1646  */
    { this_area->default_cost = (yyvsp[0].i); check_defcost((yyvsp[0].i)); }
#line 7233 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 558:
#line 2471 "cf-parse.y" /* yacc.c:1646  */
    { this_area->default_cost = (yyvsp[0].i) | LSA_EXT_EBIT; check_defcost((yyvsp[0].i)); }
#line 7239 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 559:
#line 2472 "cf-parse.y" /* yacc.c:1646  */
    { this_area->default_cost = (yyvsp[0].i);  check_defcost((yyvsp[0].i)); }
#line 7245 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 560:
#line 2473 "cf-parse.y" /* yacc.c:1646  */
    { this_area->translator = (yyvsp[0].i); }
#line 7251 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 561:
#line 2474 "cf-parse.y" /* yacc.c:1646  */
    { this_area->transint = (yyvsp[0].i); }
#line 7257 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 562:
#line 2475 "cf-parse.y" /* yacc.c:1646  */
    { this_nets = &this_area->net_list; }
#line 7263 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 564:
#line 2476 "cf-parse.y" /* yacc.c:1646  */
    { this_nets = &this_area->enet_list; }
#line 7269 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 571:
#line 2488 "cf-parse.y" /* yacc.c:1646  */
    {
     this_stubnet = cfg_allocz(sizeof(struct ospf_stubnet_config));
     add_tail(&this_area->stubnet_list, NODE this_stubnet);
     this_stubnet->px = (yyvsp[0].px);
     this_stubnet->cost = COST_D;
   }
#line 7280 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 574:
#line 2502 "cf-parse.y" /* yacc.c:1646  */
    { this_stubnet->hidden = (yyvsp[0].i); }
#line 7286 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 575:
#line 2503 "cf-parse.y" /* yacc.c:1646  */
    { this_stubnet->summary = (yyvsp[0].i); }
#line 7292 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 576:
#line 2504 "cf-parse.y" /* yacc.c:1646  */
    { this_stubnet->cost = (yyvsp[0].i); }
#line 7298 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 577:
#line 2508 "cf-parse.y" /* yacc.c:1646  */
    { ospf_iface_finish(); }
#line 7304 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 578:
#line 2509 "cf-parse.y" /* yacc.c:1646  */
    { ospf_iface_finish(); }
#line 7310 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 582:
#line 2518 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->helloint = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Hello interval must be in range 1-65535"); }
#line 7316 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 583:
#line 2519 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->rxmtint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=0) cf_error("Retransmit int must be greater than zero"); }
#line 7322 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 584:
#line 2520 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->inftransdelay = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); }
#line 7328 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 585:
#line 2521 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->waitint = (yyvsp[0].i) ; }
#line 7334 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 586:
#line 2522 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->deadint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead interval must be greater than one"); }
#line 7340 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 587:
#line 2523 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->deadc = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead count must be greater than one"); }
#line 7346 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 588:
#line 2524 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_NONE ; }
#line 7352 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 589:
#line 2525 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE ; }
#line 7358 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 590:
#line 2526 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT ; }
#line 7364 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 592:
#line 2531 "cf-parse.y" /* yacc.c:1646  */
    {
  if (this_area->areaid == 0) cf_error("Virtual link cannot be in backbone");
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&OSPF_CFG->vlink_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->voa = this_area->areaid;
  OSPF_PATT->vid = (yyvsp[0].i32);
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->waitint = WAIT_DMH*HELLOINT_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->deadint = 0;
  OSPF_PATT->type = OSPF_IT_VLINK;
  init_list(&OSPF_PATT->nbma_list);
  OSPF_PATT->autype = OSPF_AUTH_NONE;
  reset_passwords();
 }
#line 7387 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 593:
#line 2552 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->cost = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Cost must be in range 1-65535"); }
#line 7393 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 594:
#line 2553 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->helloint = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Hello interval must be in range 1-65535"); }
#line 7399 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 595:
#line 2554 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->pollint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=0) cf_error("Poll int must be greater than zero"); }
#line 7405 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 596:
#line 2555 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->rxmtint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=0) cf_error("Retransmit int must be greater than zero"); }
#line 7411 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 597:
#line 2556 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->waitint = (yyvsp[0].i) ; }
#line 7417 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 598:
#line 2557 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->deadint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead interval must be greater than one"); }
#line 7423 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 599:
#line 2558 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->deadc = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead count must be greater than one"); }
#line 7429 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 600:
#line 2559 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_BCAST ; }
#line 7435 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 601:
#line 2560 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_BCAST ; }
#line 7441 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 602:
#line 2561 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_NBMA ; }
#line 7447 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 603:
#line 2562 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_NBMA ; }
#line 7453 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 604:
#line 2563 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_PTP ; }
#line 7459 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 605:
#line 2564 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_PTP ; }
#line 7465 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 606:
#line 2565 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_PTMP ; }
#line 7471 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 607:
#line 2566 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_PTMP ; }
#line 7477 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 608:
#line 2567 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->real_bcast = (yyvsp[0].i); if (OSPF_VERSION != 2) cf_error("Real broadcast option requires OSPFv2"); }
#line 7483 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 609:
#line 2568 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->ptp_netmask = (yyvsp[0].i); if (OSPF_VERSION != 2) cf_error("Real netmask option requires OSPFv2"); }
#line 7489 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 610:
#line 2569 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->inftransdelay = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); }
#line 7495 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 611:
#line 2570 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->priority = (yyvsp[0].i) ; if (((yyvsp[0].i)<0) || ((yyvsp[0].i)>255)) cf_error("Priority must be in range 0-255"); }
#line 7501 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 612:
#line 2571 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->strictnbma = (yyvsp[0].i) ; }
#line 7507 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 613:
#line 2572 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->stub = (yyvsp[0].i) ; }
#line 7513 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 614:
#line 2573 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->check_link = (yyvsp[0].i); }
#line 7519 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 615:
#line 2574 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->ecmp_weight = (yyvsp[0].i) - 1; if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>256)) cf_error("ECMP weight must be in range 1-256"); }
#line 7525 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 617:
#line 2576 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_NONE ; }
#line 7531 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 618:
#line 2577 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE ; }
#line 7537 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 619:
#line 2578 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT ; }
#line 7543 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 620:
#line 2579 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->rx_buffer = 0; }
#line 7549 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 621:
#line 2580 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->rx_buffer = OSPF_MAX_PKT_SIZE; }
#line 7555 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 622:
#line 2581 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->rx_buffer = (yyvsp[0].i); if (((yyvsp[0].i) < OSPF_MIN_PKT_SIZE) || ((yyvsp[0].i) > OSPF_MAX_PKT_SIZE)) cf_error("Buffer size must be in range 256-65535"); }
#line 7561 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 623:
#line 2582 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->tx_tos = (yyvsp[0].i); }
#line 7567 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 624:
#line 2583 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->tx_priority = (yyvsp[0].i); }
#line 7573 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 625:
#line 2584 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->tx_length = (yyvsp[0].i); if (((yyvsp[0].i) < OSPF_MIN_PKT_SIZE) || ((yyvsp[0].i) > OSPF_MAX_PKT_SIZE)) cf_error("TX length must be in range 256-65535"); }
#line 7579 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 626:
#line 2585 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->ttl_security = (yyvsp[0].i); }
#line 7585 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 627:
#line 2586 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->ttl_security = 2; }
#line 7591 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 628:
#line 2587 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->bfd = (yyvsp[0].i); cf_check_bfd((yyvsp[0].i)); }
#line 7597 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 629:
#line 2588 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->bsd_secondary = (yyvsp[0].i); }
#line 7603 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 634:
#line 2600 "cf-parse.y" /* yacc.c:1646  */
    {
   this_pref = cfg_allocz(sizeof(struct area_net_config));
   add_tail(this_nets, NODE this_pref);
   this_pref->px.addr = (yyvsp[0].px).addr;
   this_pref->px.len = (yyvsp[0].px).len;
 }
#line 7614 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 636:
#line 2610 "cf-parse.y" /* yacc.c:1646  */
    { this_pref->hidden = 1; }
#line 7620 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 637:
#line 2611 "cf-parse.y" /* yacc.c:1646  */
    { this_pref->tag = (yyvsp[0].i); }
#line 7626 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 640:
#line 2620 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 7632 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 641:
#line 2621 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 7638 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 642:
#line 2625 "cf-parse.y" /* yacc.c:1646  */
    {
   this_nbma = cfg_allocz(sizeof(struct nbma_node));
   add_tail(&OSPF_PATT->nbma_list, NODE this_nbma);
   this_nbma->ip=(yyvsp[-2].a);
   this_nbma->eligible=(yyvsp[-1].i);
 }
#line 7649 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 643:
#line 2634 "cf-parse.y" /* yacc.c:1646  */
    {
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&this_area->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->cost = COST_D;
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->pollint = POLLINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->priority = PRIORITY_D;
  OSPF_PATT->waitint = WAIT_DMH*HELLOINT_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->deadint = 0;
  OSPF_PATT->type = OSPF_IT_UNDEF;
  init_list(&OSPF_PATT->nbma_list);
  OSPF_PATT->autype = OSPF_AUTH_NONE;
  OSPF_PATT->ptp_netmask = 2; /* not specified */
  OSPF_PATT->tx_tos = IP_PREC_INTERNET_CONTROL;
  OSPF_PATT->tx_priority = sk_priority_control;
  reset_passwords();
 }
#line 7675 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 645:
#line 2659 "cf-parse.y" /* yacc.c:1646  */
    { set_instance_id((yyvsp[0].i)); }
#line 7681 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 646:
#line 2663 "cf-parse.y" /* yacc.c:1646  */
    { if (OSPF_VERSION == 3) iface_patt_check(); }
#line 7687 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 652:
#line 2677 "cf-parse.y" /* yacc.c:1646  */
    { ospf_iface_finish(); }
#line 7693 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 654:
#line 2682 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = NULL; }
#line 7699 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 655:
#line 2688 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh(proto_get_named((yyvsp[-1].s), &proto_ospf)); }
#line 7705 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 656:
#line 2691 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_neigh(proto_get_named((yyvsp[-2].s), &proto_ospf), (yyvsp[-1].t)); }
#line 7711 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 657:
#line 2694 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_iface(proto_get_named((yyvsp[-2].s), &proto_ospf), (yyvsp[-1].t)); }
#line 7717 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 658:
#line 2699 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 0, 1); }
#line 7723 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 659:
#line 2702 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 0, 0); }
#line 7729 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 660:
#line 2707 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 1, 1); }
#line 7735 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 661:
#line 2710 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 1, 0); }
#line 7741 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 662:
#line 2714 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_lsadb((yyvsp[-1].ld)); }
#line 7747 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 663:
#line 2717 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ld) = cfg_allocz(sizeof(struct lsadb_show_data));
   }
#line 7755 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 664:
#line 2720 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->scope = LSA_SCOPE_AS; }
#line 7761 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 665:
#line 2721 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->scope = LSA_SCOPE_AREA; (yyval.ld)->area = (yyvsp[0].i32); }
#line 7767 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 666:
#line 2722 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->scope = 1; /* hack, 0 is no filter */ }
#line 7773 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 667:
#line 2723 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->type = (yyvsp[0].i); }
#line 7779 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 668:
#line 2724 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->lsid = (yyvsp[0].i32); }
#line 7785 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 669:
#line 2725 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->router = SH_ROUTER_SELF; }
#line 7791 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 670:
#line 2726 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->router = (yyvsp[0].i32); }
#line 7797 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 671:
#line 2727 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->name = (yyvsp[0].s); }
#line 7803 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 672:
#line 2733 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto = proto_config_new(&proto_pipe, sizeof(struct pipe_config), (yyvsp[-1].i));
     PIPE_CFG->mode = PIPE_TRANSPARENT;
  }
#line 7812 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 675:
#line 2742 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[-1].s)->class != SYM_TABLE)
       cf_error("Routing table name expected");
     PIPE_CFG->peer = (yyvsp[-1].s)->def;
   }
#line 7822 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 676:
#line 2747 "cf-parse.y" /* yacc.c:1646  */
    { PIPE_CFG->mode = PIPE_OPAQUE; }
#line 7828 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 677:
#line 2748 "cf-parse.y" /* yacc.c:1646  */
    { PIPE_CFG->mode = PIPE_TRANSPARENT; }
#line 7834 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 678:
#line 2755 "cf-parse.y" /* yacc.c:1646  */
    {
  this_proto = proto_config_new(&proto_radv, sizeof(struct radv_config), (yyvsp[-1].i));
  init_list(&RADV_CFG->patt_list);
  init_list(&RADV_CFG->pref_list);
  init_list(&RADV_CFG->rdnss_list);
  init_list(&RADV_CFG->dnssl_list);
}
#line 7846 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 681:
#line 2766 "cf-parse.y" /* yacc.c:1646  */
    { add_tail(&RADV_CFG->pref_list, NODE this_radv_prefix); }
#line 7852 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 682:
#line 2767 "cf-parse.y" /* yacc.c:1646  */
    { init_list(&radv_dns_list); }
#line 7858 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 683:
#line 2767 "cf-parse.y" /* yacc.c:1646  */
    { add_tail_list(&RADV_CFG->rdnss_list, &radv_dns_list); }
#line 7864 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 684:
#line 2768 "cf-parse.y" /* yacc.c:1646  */
    { init_list(&radv_dns_list); }
#line 7870 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 685:
#line 2768 "cf-parse.y" /* yacc.c:1646  */
    { add_tail_list(&RADV_CFG->dnssl_list, &radv_dns_list); }
#line 7876 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 686:
#line 2769 "cf-parse.y" /* yacc.c:1646  */
    {
     RADV_CFG->trigger_prefix = (yyvsp[0].px).addr;
     RADV_CFG->trigger_pxlen = (yyvsp[0].px).len;
     RADV_CFG->trigger_valid = 1;
   }
#line 7886 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 690:
#line 2786 "cf-parse.y" /* yacc.c:1646  */
    {
  this_ipatt = cfg_allocz(sizeof(struct radv_iface_config));
  add_tail(&RADV_CFG->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  init_list(&RADV_IFACE->pref_list);
  init_list(&RADV_IFACE->rdnss_list);
  init_list(&RADV_IFACE->dnssl_list);

  RADV_IFACE->min_ra_int = -1; /* undefined */
  RADV_IFACE->max_ra_int = DEFAULT_MAX_RA_INT;
  RADV_IFACE->min_delay = DEFAULT_MIN_DELAY;
  RADV_IFACE->current_hop_limit = DEFAULT_CURRENT_HOP_LIMIT;
  RADV_IFACE->default_lifetime = -1;
  RADV_IFACE->default_lifetime_sensitive = 1;
  RADV_IFACE->default_preference = RA_PREF_MEDIUM;
}
#line 7907 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 691:
#line 2804 "cf-parse.y" /* yacc.c:1646  */
    { RADV_IFACE->min_ra_int = (yyvsp[0].i); if ((yyvsp[0].i) < 3) cf_error("Min RA interval must be at least 3"); }
#line 7913 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 692:
#line 2805 "cf-parse.y" /* yacc.c:1646  */
    { RADV_IFACE->max_ra_int = (yyvsp[0].i); if (((yyvsp[0].i) < 4) || ((yyvsp[0].i) > 1800)) cf_error("Max RA interval must be in range 4-1800"); }
#line 7919 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 693:
#line 2806 "cf-parse.y" /* yacc.c:1646  */
    { RADV_IFACE->min_delay = (yyvsp[0].i); if ((yyvsp[0].i) <= 0) cf_error("Min delay must be positive"); }
#line 7925 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 694:
#line 2807 "cf-parse.y" /* yacc.c:1646  */
    { RADV_IFACE->managed = (yyvsp[0].i); }
#line 7931 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 695:
#line 2808 "cf-parse.y" /* yacc.c:1646  */
    { RADV_IFACE->other_config = (yyvsp[0].i); }
#line 7937 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 696:
#line 2809 "cf-parse.y" /* yacc.c:1646  */
    { RADV_IFACE->link_mtu = (yyvsp[0].i); if ((yyvsp[0].i) < 0) cf_error("Link MTU must be 0 or positive"); }
#line 7943 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 697:
#line 2810 "cf-parse.y" /* yacc.c:1646  */
    { RADV_IFACE->reachable_time = (yyvsp[0].i); if (((yyvsp[0].i) < 0) || ((yyvsp[0].i) > 3600000)) cf_error("Reachable time must be in range 0-3600000"); }
#line 7949 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 698:
#line 2811 "cf-parse.y" /* yacc.c:1646  */
    { RADV_IFACE->retrans_timer = (yyvsp[0].i); if ((yyvsp[0].i) < 0) cf_error("Retrans timer must be 0 or positive"); }
#line 7955 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 699:
#line 2812 "cf-parse.y" /* yacc.c:1646  */
    { RADV_IFACE->current_hop_limit = (yyvsp[0].i); if (((yyvsp[0].i) < 0) || ((yyvsp[0].i) > 255))  cf_error("Current hop limit must be in range 0-255"); }
#line 7961 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 700:
#line 2813 "cf-parse.y" /* yacc.c:1646  */
    {
     RADV_IFACE->default_lifetime = (yyvsp[-1].i);
     if (((yyvsp[-1].i) < 0) || ((yyvsp[-1].i) > 9000))  cf_error("Default lifetime must be in range 0-9000");
     if ((yyvsp[0].i) != -1) RADV_IFACE->default_lifetime_sensitive = (yyvsp[0].i);
   }
#line 7971 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 701:
#line 2818 "cf-parse.y" /* yacc.c:1646  */
    { RADV_IFACE->default_preference = (yyvsp[0].i); }
#line 7977 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 702:
#line 2819 "cf-parse.y" /* yacc.c:1646  */
    { add_tail(&RADV_IFACE->pref_list, NODE this_radv_prefix); }
#line 7983 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 703:
#line 2820 "cf-parse.y" /* yacc.c:1646  */
    { init_list(&radv_dns_list); }
#line 7989 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 704:
#line 2820 "cf-parse.y" /* yacc.c:1646  */
    { add_tail_list(&RADV_IFACE->rdnss_list, &radv_dns_list); }
#line 7995 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 705:
#line 2821 "cf-parse.y" /* yacc.c:1646  */
    { init_list(&radv_dns_list); }
#line 8001 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 706:
#line 2821 "cf-parse.y" /* yacc.c:1646  */
    { add_tail_list(&RADV_IFACE->dnssl_list, &radv_dns_list); }
#line 8007 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 707:
#line 2822 "cf-parse.y" /* yacc.c:1646  */
    { RADV_IFACE->rdnss_local = (yyvsp[0].i); }
#line 8013 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 708:
#line 2823 "cf-parse.y" /* yacc.c:1646  */
    { RADV_IFACE->dnssl_local = (yyvsp[0].i); }
#line 8019 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 709:
#line 2827 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = RA_PREF_LOW; }
#line 8025 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 710:
#line 2828 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = RA_PREF_MEDIUM; }
#line 8031 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 711:
#line 2829 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = RA_PREF_HIGH; }
#line 8037 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 712:
#line 2832 "cf-parse.y" /* yacc.c:1646  */
    {
  struct radv_iface_config *ic = RADV_IFACE;

  if (ic->min_ra_int == (u32) -1)
    ic->min_ra_int = MAX_(ic->max_ra_int / 3, 3);

  if (ic->default_lifetime == (u32) -1)
    ic->default_lifetime = 3 * ic->max_ra_int;

  if ((ic->min_ra_int > 3) &&
      (ic->min_ra_int > (ic->max_ra_int * 3 / 4)))
    cf_error("Min RA interval must be at most 3/4 * Max RA interval %d %d", ic->min_ra_int, ic->max_ra_int);

  if ((ic->default_lifetime > 0) && (ic->default_lifetime < ic->max_ra_int))
    cf_error("Default lifetime must be either 0 or at least Max RA interval");
}
#line 8058 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 718:
#line 2865 "cf-parse.y" /* yacc.c:1646  */
    {
  this_radv_prefix = cfg_allocz(sizeof(struct radv_prefix_config));
  RADV_PREFIX->prefix = (yyvsp[0].px).addr;
  RADV_PREFIX->pxlen = (yyvsp[0].px).len;

  RADV_PREFIX->onlink = 1;
  RADV_PREFIX->autonomous = 1;
  RADV_PREFIX->valid_lifetime = DEFAULT_VALID_LIFETIME;
  RADV_PREFIX->preferred_lifetime = DEFAULT_PREFERRED_LIFETIME;
}
#line 8073 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 719:
#line 2877 "cf-parse.y" /* yacc.c:1646  */
    { RADV_PREFIX->skip = (yyvsp[0].i); }
#line 8079 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 720:
#line 2878 "cf-parse.y" /* yacc.c:1646  */
    { RADV_PREFIX->onlink = (yyvsp[0].i); }
#line 8085 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 721:
#line 2879 "cf-parse.y" /* yacc.c:1646  */
    { RADV_PREFIX->autonomous = (yyvsp[0].i); }
#line 8091 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 722:
#line 2880 "cf-parse.y" /* yacc.c:1646  */
    {
     RADV_PREFIX->valid_lifetime = (yyvsp[-1].i);
     if ((yyvsp[-1].i) < 0) cf_error("Valid lifetime must be 0 or positive");
     if ((yyvsp[0].i) != -1) RADV_PREFIX->valid_lifetime_sensitive = (yyvsp[0].i);
   }
#line 8101 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 723:
#line 2885 "cf-parse.y" /* yacc.c:1646  */
    {
     RADV_PREFIX->preferred_lifetime = (yyvsp[-1].i);
     if ((yyvsp[-1].i) < 0) cf_error("Preferred lifetime must be 0 or positive");
     if ((yyvsp[0].i) != -1) RADV_PREFIX->preferred_lifetime_sensitive = (yyvsp[0].i);
   }
#line 8111 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 724:
#line 2893 "cf-parse.y" /* yacc.c:1646  */
    {
  if (RADV_PREFIX->preferred_lifetime > RADV_PREFIX->valid_lifetime)
    cf_error("Preferred lifetime must be at most Valid lifetime");

  if (RADV_PREFIX->valid_lifetime_sensitive > RADV_PREFIX->preferred_lifetime_sensitive)
    cf_error("Valid lifetime sensitive requires that Preferred lifetime is sensitive too");
}
#line 8123 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 730:
#line 2917 "cf-parse.y" /* yacc.c:1646  */
    {
  struct radv_rdnss_config *cf = cfg_allocz(sizeof(struct radv_rdnss_config));
  add_tail(&radv_dns_list, NODE cf);

  cf->server = (yyvsp[0].a);
  cf->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;
}
#line 8135 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 731:
#line 2926 "cf-parse.y" /* yacc.c:1646  */
    {
  RADV_RDNSS->lifetime = 0;
  RADV_RDNSS->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;
}
#line 8144 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 734:
#line 2933 "cf-parse.y" /* yacc.c:1646  */
    { RADV_RDNSS->lifetime = (yyvsp[0].i); RADV_RDNSS->lifetime_mult = radv_mult_val; }
#line 8150 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 735:
#line 2937 "cf-parse.y" /* yacc.c:1646  */
    {
  if (EMPTY_LIST(radv_dns_list))
    cf_error("No nameserver in RDNSS section");

  struct radv_rdnss_config *cf;
  WALK_LIST(cf, radv_dns_list)
  {
    cf->lifetime = RADV_RDNSS->lifetime;
    cf->lifetime_mult = RADV_RDNSS->lifetime_mult;
  }
}
#line 8166 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 740:
#line 2961 "cf-parse.y" /* yacc.c:1646  */
    {
  struct radv_dnssl_config *cf = cfg_allocz(sizeof(struct radv_dnssl_config));
  add_tail(&radv_dns_list, NODE cf);

  cf->domain = (yyvsp[0].t);
  cf->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;

  if (radv_process_domain(cf) < 0)
    cf_error("Invalid domain dame");
}
#line 8181 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 741:
#line 2973 "cf-parse.y" /* yacc.c:1646  */
    {
  RADV_DNSSL->lifetime = 0;
  RADV_DNSSL->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;
}
#line 8190 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 744:
#line 2980 "cf-parse.y" /* yacc.c:1646  */
    { RADV_DNSSL->lifetime = (yyvsp[0].i); RADV_DNSSL->lifetime_mult = radv_mult_val; }
#line 8196 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 745:
#line 2984 "cf-parse.y" /* yacc.c:1646  */
    {
  if (EMPTY_LIST(radv_dns_list))
    cf_error("No domain in DNSSL section");

  struct radv_dnssl_config *cf;
  WALK_LIST(cf, radv_dns_list)
  {
    cf->lifetime = RADV_DNSSL->lifetime;
    cf->lifetime_mult = RADV_DNSSL->lifetime_mult;
  }
}
#line 8212 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 750:
#line 3008 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i); radv_mult_val = 0; }
#line 8218 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 751:
#line 3009 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; radv_mult_val = (yyvsp[0].i); if (((yyvsp[0].i) < 1) || ((yyvsp[0].i) > 254)) cf_error("Multiplier must be in range 1-254"); }
#line 8224 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 752:
#line 3013 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = -1; }
#line 8230 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 753:
#line 3014 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i); }
#line 8236 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 754:
#line 3020 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto = proto_config_new(&proto_rip, sizeof(struct rip_proto_config), (yyvsp[-1].i));
     rip_init_config(RIP_CFG);
   }
#line 8245 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 757:
#line 3029 "cf-parse.y" /* yacc.c:1646  */
    { RIP_CFG->infinity = (yyvsp[-1].i); }
#line 8251 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 758:
#line 3030 "cf-parse.y" /* yacc.c:1646  */
    { RIP_CFG->port = (yyvsp[-1].i); }
#line 8257 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 759:
#line 3031 "cf-parse.y" /* yacc.c:1646  */
    { RIP_CFG->period = (yyvsp[-1].i); }
#line 8263 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 760:
#line 3032 "cf-parse.y" /* yacc.c:1646  */
    { RIP_CFG->garbage_time = (yyvsp[-1].i); }
#line 8269 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 761:
#line 3033 "cf-parse.y" /* yacc.c:1646  */
    { RIP_CFG->timeout_time = (yyvsp[-1].i); }
#line 8275 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 762:
#line 3034 "cf-parse.y" /* yacc.c:1646  */
    {RIP_CFG->authtype = (yyvsp[-1].i); }
#line 8281 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 764:
#line 3036 "cf-parse.y" /* yacc.c:1646  */
    { RIP_CFG->honor = HO_ALWAYS; }
#line 8287 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 765:
#line 3037 "cf-parse.y" /* yacc.c:1646  */
    { RIP_CFG->honor = HO_NEIGHBOR; }
#line 8293 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 766:
#line 3038 "cf-parse.y" /* yacc.c:1646  */
    { RIP_CFG->honor = HO_NEVER; }
#line 8299 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 768:
#line 3043 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i)=AT_PLAINTEXT; }
#line 8305 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 769:
#line 3044 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i)=AT_MD5; }
#line 8311 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 770:
#line 3045 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i)=AT_NONE; }
#line 8317 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 771:
#line 3050 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i)=IM_BROADCAST; }
#line 8323 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 772:
#line 3051 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i)=0; }
#line 8329 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 773:
#line 3052 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i)=IM_QUIET; }
#line 8335 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 774:
#line 3053 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i)=IM_NOLISTEN; }
#line 8341 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 775:
#line 3054 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i)=IM_VERSION1 | IM_BROADCAST; }
#line 8347 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 777:
#line 3058 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IPATT->metric = (yyvsp[0].i); }
#line 8353 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 778:
#line 3059 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IPATT->mode |= (yyvsp[0].i); }
#line 8359 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 779:
#line 3060 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IPATT->tx_tos = (yyvsp[0].i); }
#line 8365 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 780:
#line 3061 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IPATT->tx_priority = (yyvsp[0].i); }
#line 8371 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 781:
#line 3062 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IPATT->ttl_security = (yyvsp[0].i); }
#line 8377 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 782:
#line 3063 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IPATT->ttl_security = 2; }
#line 8383 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 787:
#line 3077 "cf-parse.y" /* yacc.c:1646  */
    {
     this_ipatt = cfg_allocz(sizeof(struct rip_patt));
     add_tail(&RIP_CFG->iface_list, NODE this_ipatt);
     init_list(&this_ipatt->ipn_list);
     RIP_IPATT->metric = 1;
     RIP_IPATT->tx_tos = IP_PREC_INTERNET_CONTROL;
     RIP_IPATT->tx_priority = sk_priority_control;
     RIP_IPATT->ttl_security = RIP_DEFAULT_TTL_SECURITY;
   }
#line 8397 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 789:
#line 3096 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto = proto_config_new(&proto_static, sizeof(struct static_config), (yyvsp[-1].i));
     static_init_config((struct static_config *) this_proto);
  }
#line 8406 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 792:
#line 3105 "cf-parse.y" /* yacc.c:1646  */
    { STATIC_CFG->check_link = (yyvsp[-1].i); }
#line 8412 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 793:
#line 3106 "cf-parse.y" /* yacc.c:1646  */
    { STATIC_CFG->igp_table = (yyvsp[-1].r); }
#line 8418 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 795:
#line 3110 "cf-parse.y" /* yacc.c:1646  */
    {
     this_srt = cfg_allocz(sizeof(struct static_route));
     add_tail(&STATIC_CFG->other_routes, &this_srt->n);
     this_srt->net = (yyvsp[0].px).addr;
     this_srt->masklen = (yyvsp[0].px).len;
  }
#line 8429 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 796:
#line 3119 "cf-parse.y" /* yacc.c:1646  */
    {
     last_srt_nh = this_srt_nh;
     this_srt_nh = cfg_allocz(sizeof(struct static_route));
     this_srt_nh->dest = RTD_NONE;
     this_srt_nh->via = (yyvsp[-1].a);
     this_srt_nh->via_if = (yyvsp[0].iface);
     this_srt_nh->if_name = (void *) this_srt; /* really */
   }
#line 8442 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 797:
#line 3127 "cf-parse.y" /* yacc.c:1646  */
    {
     this_srt_nh->masklen = (yyvsp[0].i) - 1; /* really */
     if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>256)) cf_error("Weight must be in range 1-256"); 
   }
#line 8451 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 798:
#line 3134 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->mp_next = this_srt_nh; }
#line 8457 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 799:
#line 3135 "cf-parse.y" /* yacc.c:1646  */
    { last_srt_nh->mp_next = this_srt_nh; }
#line 8463 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 800:
#line 3139 "cf-parse.y" /* yacc.c:1646  */
    {
      this_srt->dest = RTD_ROUTER;
      this_srt->via = (yyvsp[-1].a);
      this_srt->via_if = (yyvsp[0].iface);
   }
#line 8473 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 801:
#line 3144 "cf-parse.y" /* yacc.c:1646  */
    {
      this_srt->dest = RTD_DEVICE;
      this_srt->if_name = (yyvsp[0].t);
      rem_node(&this_srt->n);
      add_tail(&STATIC_CFG->iface_routes, &this_srt->n);
   }
#line 8484 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 802:
#line 3150 "cf-parse.y" /* yacc.c:1646  */
    {
      this_srt->dest = RTD_MULTIPATH;
   }
#line 8492 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 803:
#line 3153 "cf-parse.y" /* yacc.c:1646  */
    {
      this_srt->dest = RTDX_RECURSIVE;
      this_srt->via = (yyvsp[0].a);
   }
#line 8501 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 804:
#line 3158 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->dest = RTD_BLACKHOLE; }
#line 8507 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 805:
#line 3159 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->dest = RTD_UNREACHABLE; }
#line 8513 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 806:
#line 3160 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->dest = RTD_BLACKHOLE; }
#line 8519 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 807:
#line 3161 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->dest = RTD_UNREACHABLE; }
#line 8525 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 808:
#line 3162 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->dest = RTD_PROHIBIT; }
#line 8531 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 809:
#line 3166 "cf-parse.y" /* yacc.c:1646  */
    { static_show(proto_get_named((yyvsp[-1].s), &proto_static)); }
#line 8537 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 875:
#line 3174 "cf-parse.y" /* yacc.c:1646  */
    { bgp_check_config(BGP_CFG); }
#line 8543 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 876:
#line 3174 "cf-parse.y" /* yacc.c:1646  */
    { ospf_proto_finish(); }
#line 8549 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 879:
#line 3174 "cf-parse.y" /* yacc.c:1646  */
    { RIP_CFG->passwords = get_passwords(); }
#line 8555 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 888:
#line 3177 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_KRT_SOURCE); }
#line 8561 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 889:
#line 3177 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_KRT_METRIC); }
#line 8567 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 890:
#line 3177 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_KRT_PREFSRC); }
#line 8573 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 891:
#line 3177 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_REALM); }
#line 8579 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 892:
#line 3178 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_GEN_IGP_METRIC); }
#line 8585 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 893:
#line 3178 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = NULL; }
#line 8591 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 894:
#line 3179 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_ENUM_BGP_ORIGIN, EA_CODE(EAP_BGP, BA_ORIGIN)); }
#line 8597 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 895:
#line 3180 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_AS_PATH, T_PATH, EA_CODE(EAP_BGP, BA_AS_PATH)); }
#line 8603 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 896:
#line 3181 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_CODE(EAP_BGP, BA_NEXT_HOP)); }
#line 8609 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 897:
#line 3182 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_MULTI_EXIT_DISC)); }
#line 8615 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 898:
#line 3183 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_LOCAL_PREF)); }
#line 8621 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 899:
#line 3184 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_OPAQUE, T_ENUM_EMPTY, EA_CODE(EAP_BGP, BA_ATOMIC_AGGR)); }
#line 8627 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 900:
#line 3185 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_AGGREGATOR)); }
#line 8633 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 901:
#line 3186 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(EAP_BGP, BA_COMMUNITY)); }
#line 8639 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 902:
#line 3187 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID, T_QUAD, EA_CODE(EAP_BGP, BA_ORIGINATOR_ID)); }
#line 8645 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 903:
#line 3188 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(EAP_BGP, BA_CLUSTER_LIST)); }
#line 8651 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 904:
#line 3189 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_EC_SET, T_ECLIST, EA_CODE(EAP_BGP, BA_EXT_COMMUNITY)); }
#line 8657 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 905:
#line 3189 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC1); }
#line 8663 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 906:
#line 3189 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC2); }
#line 8669 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 907:
#line 3189 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_TAG); }
#line 8675 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 908:
#line 3189 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID | EAF_TEMP, T_QUAD, EA_OSPF_ROUTER_ID); }
#line 8681 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 909:
#line 3189 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_METRIC); }
#line 8687 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 910:
#line 3189 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_TAG); }
#line 8693 "cf-parse.tab.c" /* yacc.c:1646  */
    break;


#line 8697 "cf-parse.tab.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 3191 "cf-parse.y" /* yacc.c:1906  */

/* C Code from ../../conf/confbase.Y */

/* C Code from ../../sysdep/unix/config.Y */

/* C Code from ../../sysdep/unix/krt.Y */

/* C Code from ../../sysdep/linux/netlink.Y */

/* C Code from ../../nest/config.Y */

/* C Code from ../../proto/bfd/config.Y */

/* C Code from ../../proto/bgp/config.Y */

/* C Code from ../../proto/ospf/config.Y */

/* C Code from ../../proto/pipe/config.Y */

/* C Code from ../../proto/radv/config.Y */

/* C Code from ../../proto/rip/config.Y */

/* C Code from ../../proto/static/config.Y */

