/* A Bison parser, made by GNU Bison 3.0.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2013 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         cf_parse
#define yylex           cf_lex
#define yyerror         cf_error
#define yydebug         cf_debug
#define yynerrs         cf_nerrs

#define yylval          cf_lval
#define yychar          cf_char

/* Copy the first part of user declarations.  */
#line 1 "cf-parse.y" /* yacc.c:339  */

/* Headers from ../../conf/confbase.Y */

#define PARSER 1

#include "nest/bird.h"
#include "conf/conf.h"
#include "lib/resource.h"
#include "lib/socket.h"
#include "lib/timer.h"
#include "lib/string.h"
#include "nest/protocol.h"
#include "nest/iface.h"
#include "nest/route.h"
#include "nest/cli.h"
#include "filter/filter.h"

/* FIXME: Turn on YYERROR_VERBOSE and work around lots of bison bugs? */

/* Defines from ../../conf/confbase.Y */

static void
check_u16(unsigned val)
{
  if (val > 0xFFFF)
    cf_error("Value %d out of range (0-65535)", val);
}

/* Headers from ../../sysdep/unix/config.Y */

#include "lib/unix.h"
#include <stdio.h>

/* Headers from ../../sysdep/unix/krt.Y */

#include "lib/krt.h"

/* Defines from ../../sysdep/unix/krt.Y */

#define THIS_KRT ((struct krt_config *) this_proto)
#define THIS_KIF ((struct kif_config *) this_proto)

/* Headers from ../../sysdep/linux/netlink.Y */

/* Headers from ../../nest/config.Y */

#include "nest/rt-dev.h"
#include "nest/password.h"
#include "nest/cmds.h"
#include "lib/lists.h"

/* Defines from ../../nest/config.Y */

static struct proto_config *this_proto;
static struct iface_patt *this_ipatt;
static struct iface_patt_node *this_ipn;
static struct roa_table_config *this_roa_table;
static list *this_p_list;
static struct password_item *this_p_item;
static int password_id;

static void
iface_patt_check(void)
{
  struct iface_patt_node *pn;

  WALK_LIST(pn, this_ipatt->ipn_list)
    if (!pn->pattern || pn->pxlen)
      cf_error("Interface name/mask expected, not IP prefix");
}


static inline void
reset_passwords(void)
{
  this_p_list = NULL;
}

static inline list *
get_passwords(void)
{
  list *rv = this_p_list;
  this_p_list = NULL;
  return rv;
}

#define DIRECT_CFG ((struct rt_dev_config *) this_proto)

/* Headers from ../../filter/config.Y */

/* Defines from ../../filter/config.Y */

#define P(a,b) ((a << 8) | b)

static inline u32 pair(u32 a, u32 b) { return (a << 16) | b; }
static inline u32 pair_a(u32 p) { return p >> 16; }
static inline u32 pair_b(u32 p) { return p & 0xFFFF; }


/*
 * Sets and their items are during parsing handled as lists, linked
 * through left ptr. The first item in a list also contains a pointer
 * to the last item in a list (right ptr). For convenience, even items
 * are handled as one-item lists. Lists are merged by f_merge_items().
 */

static inline struct f_tree *
f_new_item(struct f_val from, struct f_val to)
{
  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from = from;
  t->to = to;
  return t;
}

static inline struct f_tree *
f_merge_items(struct f_tree *a, struct f_tree *b)
{
  if (!a) return b;
  a->right->left = b;
  a->right = b->right;
  b->right = NULL;
  return a;
}

static inline struct f_tree *
f_new_pair_item(int fa, int ta, int fb, int tb)
{
  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_PAIR;
  t->from.val.i = pair(fa, fb);
  t->to.val.i = pair(ta, tb);
  return t;
}

static inline struct f_tree *
f_new_pair_set(int fa, int ta, int fb, int tb)
{
  struct f_tree *lst = NULL;
  int i;

  if ((fa == ta) || ((fb == 0) && (tb == 0xFFFF)))
    return f_new_pair_item(fa, ta, fb, tb);
  
  if ((ta < fa) || (tb < fb))
    cf_error( "From value cannot be higher that To value in pair sets");

  for (i = fa; i <= ta; i++)
    lst = f_merge_items(lst, f_new_pair_item(i, i, fb, tb));

  return lst;
}

#define EC_ALL 0xFFFFFFFF

static struct f_tree *
f_new_ec_item(u32 kind, u32 ipv4_used, u32 key, u32 vf, u32 vt)
{
  u64 fm, to;

  if (ipv4_used || (key >= 0x10000)) {
    check_u16(vf);
    if (vt == EC_ALL)
      vt = 0xFFFF;
    else
      check_u16(vt);
  }

  if (kind == EC_GENERIC) {
    fm = ec_generic(key, vf);
    to = ec_generic(key, vt);
  }
  else if (ipv4_used) {
    fm = ec_ip4(kind, key, vf);
    to = ec_ip4(kind, key, vt);
  }
  else if (key < 0x10000) {
    fm = ec_as2(kind, key, vf);
    to = ec_as2(kind, key, vt);
  }
  else {
    fm = ec_as4(kind, key, vf);
    to = ec_as4(kind, key, vt);
  }

  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_EC;
  t->from.val.ec = fm;
  t->to.val.ec = to;
  return t;
}

static inline struct f_inst *
f_generate_empty(struct f_inst *dyn)
{ 
  struct f_inst *e = f_new_inst();
  e->code = 'E';

  switch (dyn->aux & EAF_TYPE_MASK) {
    case EAF_TYPE_AS_PATH:
      e->aux = T_PATH;
      break;
    case EAF_TYPE_INT_SET:
      e->aux = T_CLIST;
      break;
    case EAF_TYPE_EC_SET:
      e->aux = T_ECLIST;
      break;
    default:
      cf_error("Can't empty that attribute");
  }

  dyn->code = P('e','S');
  dyn->a1.p = e;
  return dyn;
}


static inline struct f_inst *
f_generate_dpair(struct f_inst *t1, struct f_inst *t2)
{
  struct f_inst *rv;

  if ((t1->code == 'c') && (t2->code == 'c')) {
    if ((t1->aux != T_INT) || (t2->aux != T_INT))
      cf_error( "Can't operate with value of non-integer type in pair constructor");

    check_u16(t1->a2.i);
    check_u16(t2->a2.i);

    rv = f_new_inst();
    rv->code = 'c';
    rv->aux = T_PAIR;
    rv->a2.i = pair(t1->a2.i, t2->a2.i);
  }
  else {
    rv = f_new_inst();
    rv->code = P('m', 'p');
    rv->a1.p = t1;
    rv->a2.p = t2;
  }

  return rv;
}

static inline struct f_inst *
f_generate_ec(u16 kind, struct f_inst *tk, struct f_inst *tv)
{
  struct f_inst *rv;
  int c1 = 0, c2 = 0, ipv4_used = 0;
  u32 key = 0, val2 = 0;

  if (tk->code == 'c') {
    c1 = 1;

    if (tk->aux == T_INT) {
      ipv4_used = 0; key = tk->a2.i;
    }
    else if (tk->aux == T_QUAD) {
      ipv4_used = 1; key = tk->a2.i;
    }
    else
      cf_error("Can't operate with key of non-integer/IPv4 type in EC constructor");
  }

#ifndef IPV6
  /* IP->Quad implicit conversion */
  else if (tk->code == 'C') {
    c1 = 1;
    struct f_val *val = tk->a1.p;

    if (val->type == T_INT) {
      ipv4_used = 0; key = val->val.i;
    }
    else if (val->type == T_QUAD) {
      ipv4_used = 1; key = val->val.i;
    }
    else if (val->type == T_IP) {
      ipv4_used = 1; key = ipa_to_u32(val->val.px.ip);
    }
    else
      cf_error("Can't operate with key of non-integer/IPv4 type in EC constructor");
  }
#endif

  if (tv->code == 'c') {
    if (tv->aux != T_INT)
      cf_error("Can't operate with value of non-integer type in EC constructor");
    c2 = 1;
    val2 = tv->a2.i;
  }

  if (c1 && c2) {
    u64 ec;
  
    if (kind == EC_GENERIC) {
      ec = ec_generic(key, val2);
    }
    else if (ipv4_used) {
      check_u16(val2);
      ec = ec_ip4(kind, key, val2);
    }
    else if (key < 0x10000) {
      ec = ec_as2(kind, key, val2);
    }
    else {
      check_u16(val2);
      ec = ec_as4(kind, key, val2);
    }

    NEW_F_VAL;
    rv = f_new_inst();
    rv->code = 'C';
    rv->a1.p = val;    
    val->type = T_EC;
    val->val.ec = ec;
  }
  else {
    rv = f_new_inst();
    rv->code = P('m','c');
    rv->aux = kind;
    rv->a1.p = tk;
    rv->a2.p = tv;
  }

  return rv;
}



/* Headers from ../../proto/bfd/config.Y */

#include "proto/bfd/bfd.h"

/* Defines from ../../proto/bfd/config.Y */

#define BFD_CFG ((struct bfd_config *) this_proto)
#define BFD_IFACE ((struct bfd_iface_config *) this_ipatt)
#define BFD_NEIGHBOR this_bfd_neighbor

static struct bfd_neighbor *this_bfd_neighbor;

extern struct bfd_config *bfd_cf;

/* Headers from ../../proto/bgp/config.Y */

#include "proto/bgp/bgp.h"

/* Defines from ../../proto/bgp/config.Y */

#define BGP_CFG ((struct bgp_config *) this_proto)

/* Headers from ../../proto/ospf/config.Y */

#include "proto/ospf/ospf.h"

/* Defines from ../../proto/ospf/config.Y */

#define OSPF_CFG ((struct ospf_config *) this_proto)
#define OSPF_PATT ((struct ospf_iface_patt *) this_ipatt)

static struct ospf_area_config *this_area;
static struct nbma_node *this_nbma;
static list *this_nets;
static struct area_net_config *this_pref;
static struct ospf_stubnet_config *this_stubnet; 

#ifdef OSPFv2
static void
ospf_iface_finish(void)
{
  struct ospf_iface_patt *ip = OSPF_PATT;

  if (ip->deadint == 0)
    ip->deadint = ip->deadc * ip->helloint;

  ip->passwords = get_passwords();

  if ((ip->autype == OSPF_AUTH_CRYPT) && (ip->helloint < 5))
    log(L_WARN "Hello or poll interval less that 5 makes cryptographic authenication prone to replay attacks");

  if ((ip->autype == OSPF_AUTH_NONE) && (ip->passwords != NULL))
    log(L_WARN "Password option without authentication option does not make sense");
}
#endif

#ifdef OSPFv3
static void
ospf_iface_finish(void)
{
  struct ospf_iface_patt *ip = OSPF_PATT;

  if (ip->deadint == 0)
    ip->deadint = ip->deadc * ip->helloint;

  if ((ip->autype != OSPF_AUTH_NONE) || (get_passwords() != NULL))
    cf_error("Authentication not supported in OSPFv3");
}
#endif

static void
ospf_area_finish(void)
{
  if ((this_area->areaid == 0) && (this_area->type != OPT_E))
    cf_error("Backbone area cannot be stub/NSSA");

  if (this_area->summary && (this_area->type == OPT_E))
    cf_error("Only Stub/NSSA areas can use summary propagation");

  if (this_area->default_nssa && ((this_area->type != OPT_N) || ! this_area->summary))
    cf_error("Only NSSA areas with summary propagation can use NSSA default route");

  if ((this_area->default_cost & LSA_EXT_EBIT) && ! this_area->default_nssa)
    cf_error("Only NSSA default route can use type 2 metric");
}

static void
ospf_proto_finish(void)
{
  struct ospf_config *cf = OSPF_CFG;

  if (EMPTY_LIST(cf->area_list))
    cf_error( "No configured areas in OSPF");

  int areano = 0;
  int backbone = 0;
  struct ospf_area_config *ac;
  WALK_LIST(ac, cf->area_list)
  {
    areano++;
    if (ac->areaid == 0)
     backbone = 1;
  }
  cf->abr = areano > 1;

  if (cf->abr && !backbone)
  {
    struct ospf_area_config *ac = cfg_allocz(sizeof(struct ospf_area_config));
    ac->type = OPT_E; /* Backbone is non-stub */
    add_head(&cf->area_list, NODE ac);
    init_list(&ac->patt_list);
    init_list(&ac->net_list);
    init_list(&ac->enet_list);
    init_list(&ac->stubnet_list);
  }

  if (!cf->abr && !EMPTY_LIST(cf->vlink_list))
    cf_error( "Vlinks cannot be used on single area router");
}

static inline void
check_defcost(int cost)
{
  if ((cost <= 0) || (cost >= LSINFINITY))
   cf_error("Default cost must be in range 1-%d", LSINFINITY-1);
}

static inline void
set_instance_id(unsigned id)
{
#ifdef OSPFv3
  OSPF_PATT->instance_id = id;
#else
  cf_error("Instance ID requires OSPFv3");
#endif
}

/* Headers from ../../proto/pipe/config.Y */

#include "proto/pipe/pipe.h"

/* Defines from ../../proto/pipe/config.Y */

#define PIPE_CFG ((struct pipe_config *) this_proto)

/* Headers from ../../proto/rip/config.Y */

#include "proto/rip/rip.h"
#include "nest/iface.h"

/* Defines from ../../proto/rip/config.Y */

#define RIP_CFG ((struct rip_proto_config *) this_proto)
#define RIP_IPATT ((struct rip_patt *) this_ipatt)

#ifdef IPV6
#define RIP_DEFAULT_TTL_SECURITY 2
#else
#define RIP_DEFAULT_TTL_SECURITY 0
#endif

/* Headers from ../../proto/static/config.Y */

#include "proto/static/static.h"

/* Defines from ../../proto/static/config.Y */

#define STATIC_CFG ((struct static_config *) this_proto)
static struct static_route *this_srt, *this_srt_nh, *last_srt_nh;


#line 579 "cf-parse.tab.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "cf-parse.tab.h".  */
#ifndef YY_CF_CF_PARSE_TAB_H_INCLUDED
# define YY_CF_CF_PARSE_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int cf_debug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    END = 258,
    CLI_MARKER = 259,
    INVALID_TOKEN = 260,
    ELSECOL = 261,
    DDOT = 262,
    GEQ = 263,
    LEQ = 264,
    NEQ = 265,
    AND = 266,
    OR = 267,
    PO = 268,
    PC = 269,
    NUM = 270,
    ENUM = 271,
    RTRID = 272,
    IPA = 273,
    SYM = 274,
    TEXT = 275,
    PREFIX_DUMMY = 276,
    DEFINE = 277,
    ON = 278,
    OFF = 279,
    YES = 280,
    NO = 281,
    S = 282,
    MS = 283,
    US = 284,
    LOG = 285,
    SYSLOG = 286,
    ALL = 287,
    DEBUG = 288,
    TRACE = 289,
    INFO = 290,
    REMOTE = 291,
    WARNING = 292,
    ERROR = 293,
    AUTH = 294,
    FATAL = 295,
    BUG = 296,
    STDERR = 297,
    SOFT = 298,
    TIMEFORMAT = 299,
    ISO = 300,
    OLD = 301,
    SHORT = 302,
    LONG = 303,
    BASE = 304,
    NAME = 305,
    CONFIRM = 306,
    UNDO = 307,
    CHECK = 308,
    TIMEOUT = 309,
    CONFIGURE = 310,
    DOWN = 311,
    KERNEL = 312,
    PERSIST = 313,
    SCAN = 314,
    TIME = 315,
    LEARN = 316,
    DEVICE = 317,
    ROUTES = 318,
    GRACEFUL = 319,
    RESTART = 320,
    KRT_SOURCE = 321,
    KRT_METRIC = 322,
    TABLE = 323,
    KRT_PREFSRC = 324,
    KRT_REALM = 325,
    ROUTER = 326,
    ID = 327,
    PROTOCOL = 328,
    TEMPLATE = 329,
    PREFERENCE = 330,
    DISABLED = 331,
    DIRECT = 332,
    INTERFACE = 333,
    IMPORT = 334,
    EXPORT = 335,
    FILTER = 336,
    NONE = 337,
    STATES = 338,
    FILTERS = 339,
    RECEIVE = 340,
    LIMIT = 341,
    ACTION = 342,
    WARN = 343,
    BLOCK = 344,
    DISABLE = 345,
    KEEP = 346,
    FILTERED = 347,
    PASSWORD = 348,
    FROM = 349,
    PASSIVE = 350,
    TO = 351,
    EVENTS = 352,
    PACKETS = 353,
    PROTOCOLS = 354,
    INTERFACES = 355,
    PRIMARY = 356,
    STATS = 357,
    COUNT = 358,
    FOR = 359,
    COMMANDS = 360,
    PREEXPORT = 361,
    GENERATE = 362,
    ROA = 363,
    MAX = 364,
    FLUSH = 365,
    AS = 366,
    LISTEN = 367,
    BGP = 368,
    V6ONLY = 369,
    DUAL = 370,
    ADDRESS = 371,
    PORT = 372,
    PASSWORDS = 373,
    DESCRIPTION = 374,
    SORTED = 375,
    RELOAD = 376,
    IN = 377,
    OUT = 378,
    MRTDUMP = 379,
    MESSAGES = 380,
    RESTRICT = 381,
    MEMORY = 382,
    IGP_METRIC = 383,
    CLASS = 384,
    DSCP = 385,
    WAIT = 386,
    SHOW = 387,
    STATUS = 388,
    SUMMARY = 389,
    ROUTE = 390,
    SYMBOLS = 391,
    ADD = 392,
    DELETE = 393,
    DUMP = 394,
    RESOURCES = 395,
    SOCKETS = 396,
    NEIGHBORS = 397,
    ATTRIBUTES = 398,
    EVAL = 399,
    ECHO = 400,
    ENABLE = 401,
    FUNCTION = 402,
    PRINT = 403,
    PRINTN = 404,
    UNSET = 405,
    RETURN = 406,
    ACCEPT = 407,
    REJECT = 408,
    QUITBIRD = 409,
    INT = 410,
    BOOL = 411,
    IP = 412,
    PREFIX = 413,
    PAIR = 414,
    QUAD = 415,
    EC = 416,
    SET = 417,
    STRING = 418,
    BGPMASK = 419,
    BGPPATH = 420,
    CLIST = 421,
    ECLIST = 422,
    IF = 423,
    THEN = 424,
    ELSE = 425,
    CASE = 426,
    TRUE = 427,
    FALSE = 428,
    RT = 429,
    RO = 430,
    UNKNOWN = 431,
    GENERIC = 432,
    GW = 433,
    NET = 434,
    MASK = 435,
    PROTO = 436,
    SOURCE = 437,
    SCOPE = 438,
    CAST = 439,
    DEST = 440,
    IFNAME = 441,
    IFINDEX = 442,
    LEN = 443,
    DEFINED = 444,
    CONTAINS = 445,
    RESET = 446,
    PREPEND = 447,
    FIRST = 448,
    LAST = 449,
    MATCH = 450,
    ROA_CHECK = 451,
    EMPTY = 452,
    WHERE = 453,
    BFD = 454,
    MIN = 455,
    IDLE = 456,
    RX = 457,
    TX = 458,
    INTERVAL = 459,
    MULTIPLIER = 460,
    MULTIHOP = 461,
    NEIGHBOR = 462,
    DEV = 463,
    LOCAL = 464,
    SESSIONS = 465,
    HOLD = 466,
    CONNECT = 467,
    RETRY = 468,
    KEEPALIVE = 469,
    STARTUP = 470,
    VIA = 471,
    NEXT = 472,
    HOP = 473,
    SELF = 474,
    DEFAULT = 475,
    PATH = 476,
    METRIC = 477,
    START = 478,
    DELAY = 479,
    FORGET = 480,
    AFTER = 481,
    BGP_PATH = 482,
    BGP_LOCAL_PREF = 483,
    BGP_MED = 484,
    BGP_ORIGIN = 485,
    BGP_NEXT_HOP = 486,
    BGP_ATOMIC_AGGR = 487,
    BGP_AGGREGATOR = 488,
    BGP_COMMUNITY = 489,
    BGP_EXT_COMMUNITY = 490,
    RR = 491,
    RS = 492,
    CLIENT = 493,
    CLUSTER = 494,
    AS4 = 495,
    ADVERTISE = 496,
    IPV4 = 497,
    CAPABILITIES = 498,
    PREFER = 499,
    OLDER = 500,
    MISSING = 501,
    LLADDR = 502,
    DROP = 503,
    IGNORE = 504,
    REFRESH = 505,
    INTERPRET = 506,
    COMMUNITIES = 507,
    BGP_ORIGINATOR_ID = 508,
    BGP_CLUSTER_LIST = 509,
    IGP = 510,
    GATEWAY = 511,
    RECURSIVE = 512,
    MED = 513,
    TTL = 514,
    SECURITY = 515,
    DETERMINISTIC = 516,
    SECONDARY = 517,
    ALLOW = 518,
    PATHS = 519,
    AWARE = 520,
    OSPF = 521,
    AREA = 522,
    OSPF_METRIC1 = 523,
    OSPF_METRIC2 = 524,
    OSPF_TAG = 525,
    OSPF_ROUTER_ID = 526,
    RFC1583COMPAT = 527,
    STUB = 528,
    TICK = 529,
    COST = 530,
    COST2 = 531,
    RETRANSMIT = 532,
    HELLO = 533,
    TRANSMIT = 534,
    PRIORITY = 535,
    DEAD = 536,
    TYPE = 537,
    BROADCAST = 538,
    BCAST = 539,
    NONBROADCAST = 540,
    NBMA = 541,
    POINTOPOINT = 542,
    PTP = 543,
    POINTOMULTIPOINT = 544,
    PTMP = 545,
    SIMPLE = 546,
    AUTHENTICATION = 547,
    STRICT = 548,
    CRYPTOGRAPHIC = 549,
    ELIGIBLE = 550,
    POLL = 551,
    NETWORKS = 552,
    HIDDEN = 553,
    VIRTUAL = 554,
    LINK = 555,
    ONLY = 556,
    BUFFER = 557,
    LARGE = 558,
    NORMAL = 559,
    STUBNET = 560,
    TAG = 561,
    EXTERNAL = 562,
    LSADB = 563,
    ECMP = 564,
    WEIGHT = 565,
    NSSA = 566,
    TRANSLATOR = 567,
    STABILITY = 568,
    GLOBAL = 569,
    LSID = 570,
    INSTANCE = 571,
    REAL = 572,
    NETMASK = 573,
    LENGTH = 574,
    MERGE = 575,
    TOPOLOGY = 576,
    STATE = 577,
    PIPE = 578,
    PEER = 579,
    MODE = 580,
    OPAQUE = 581,
    TRANSPARENT = 582,
    RIP = 583,
    INFINITY = 584,
    PERIOD = 585,
    GARBAGE = 586,
    MULTICAST = 587,
    QUIET = 588,
    NOLISTEN = 589,
    VERSION1 = 590,
    PLAINTEXT = 591,
    MD5 = 592,
    HONOR = 593,
    NEVER = 594,
    ALWAYS = 595,
    RIP_METRIC = 596,
    RIP_TAG = 597,
    STATIC = 598,
    PROHIBIT = 599,
    MULTIPATH = 600,
    BLACKHOLE = 601,
    UNREACHABLE = 602
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE YYSTYPE;
union YYSTYPE
{
#line 508 "cf-parse.y" /* yacc.c:355  */

  int i;
  u32 i32;
  ip_addr a;
  struct symbol *s;
  char *t;
  struct rtable_config *r;
  struct f_inst *x;
  struct filter *f;
  struct f_tree *e;
  struct f_trie *trie;
  struct f_val v;
  struct f_path_mask *h;
  struct password_item *p;
  struct rt_show_data *ra;
  struct roa_show_data *ro;
  struct sym_show_data *sd;
  struct lsadb_show_data *ld;
  struct iface *iface;
  struct roa_table *rot;
  void *g;
  bird_clock_t time;
  struct prefix px;
  struct proto_spec ps;
  struct timeformat *tf;

#line 994 "cf-parse.tab.c" /* yacc.c:355  */
};
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE cf_lval;

int cf_parse (void);

#endif /* !YY_CF_CF_PARSE_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 1009 "cf-parse.tab.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  67
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   2733

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  369
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  256
/* YYNRULES -- Number of rules.  */
#define YYNRULES  833
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  1574

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   602

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    31,     2,     2,     2,    30,     2,     2,
     360,   361,    28,    26,   365,    27,    32,    29,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   362,   359,
      23,    22,    24,   366,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   367,     2,   368,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   363,     2,   364,    25,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   697,   697,   698,   701,   703,   711,   720,   721,   722,
     729,   730,   731,   739,   740,   741,   742,   743,   744,   750,
     751,   758,   759,   763,   770,   771,   775,   779,   786,   794,
     795,   802,   803,   809,   818,   819,   823,   828,   829,   833,
     834,   838,   839,   843,   844,   845,   846,   847,   848,   849,
     850,   851,   857,   858,   867,   868,   869,   870,   873,   874,
     875,   876,   877,   878,   882,   889,   892,   899,   902,   905,
     908,   912,   913,   917,   918,   919,   927,   932,   933,   937,
     944,   945,   951,   956,   960,   974,   988,   989,   993,   994,
     995,  1006,  1008,  1010,  1014,  1015,  1016,  1017,  1022,  1028,
    1029,  1033,  1041,  1045,  1047,  1053,  1054,  1061,  1062,  1066,
    1072,  1076,  1086,  1088,  1092,  1093,  1094,  1095,  1096,  1097,
    1098,  1099,  1100,  1101,  1102,  1103,  1107,  1108,  1109,  1110,
    1114,  1115,  1116,  1117,  1118,  1122,  1128,  1132,  1140,  1141,
    1149,  1157,  1158,  1159,  1163,  1164,  1168,  1173,  1174,  1178,
    1180,  1188,  1192,  1193,  1199,  1206,  1207,  1208,  1212,  1220,
    1226,  1227,  1228,  1232,  1233,  1237,  1238,  1239,  1240,  1241,
    1242,  1248,  1249,  1250,  1254,  1255,  1259,  1260,  1266,  1267,
    1270,  1272,  1276,  1277,  1281,  1299,  1300,  1301,  1302,  1303,
    1304,  1312,  1315,  1318,  1321,  1325,  1326,  1329,  1332,  1336,
    1340,  1345,  1351,  1358,  1363,  1368,  1373,  1377,  1381,  1385,
    1394,  1402,  1406,  1413,  1414,  1419,  1423,  1430,  1437,  1441,
    1449,  1450,  1451,  1456,  1460,  1463,  1464,  1465,  1466,  1467,
    1468,  1469,  1474,  1479,  1487,  1494,  1501,  1509,  1511,  1513,
    1515,  1517,  1519,  1521,  1524,  1528,  1534,  1535,  1536,  1540,
    1541,  1547,  1549,  1551,  1553,  1555,  1557,  1561,  1565,  1568,
    1572,  1573,  1574,  1578,  1579,  1580,  1588,  1588,  1598,  1602,
    1603,  1604,  1605,  1606,  1607,  1608,  1609,  1610,  1611,  1612,
    1613,  1614,  1635,  1646,  1647,  1654,  1655,  1662,  1671,  1675,
    1679,  1703,  1704,  1708,  1721,  1721,  1737,  1738,  1741,  1742,
    1746,  1749,  1758,  1771,  1772,  1773,  1774,  1778,  1779,  1780,
    1781,  1782,  1786,  1789,  1790,  1791,  1795,  1798,  1807,  1810,
    1811,  1812,  1813,  1817,  1818,  1819,  1823,  1824,  1825,  1826,
    1830,  1831,  1832,  1833,  1837,  1838,  1842,  1843,  1847,  1854,
    1855,  1856,  1857,  1864,  1865,  1868,  1869,  1876,  1888,  1889,
    1893,  1894,  1898,  1899,  1900,  1901,  1902,  1906,  1907,  1908,
    1912,  1913,  1914,  1915,  1916,  1917,  1918,  1919,  1920,  1921,
    1922,  1926,  1927,  1937,  1941,  1964,  1978,  1979,  1980,  1981,
    1982,  1983,  1984,  1985,  1986,  1987,  1991,  1992,  1993,  1994,
    1995,  1996,  1997,  1998,  1999,  2000,  2001,  2002,  2003,  2004,
    2005,  2006,  2008,  2009,  2010,  2012,  2014,  2016,  2018,  2019,
    2020,  2021,  2022,  2032,  2033,  2034,  2035,  2036,  2037,  2038,
    2040,  2041,  2046,  2069,  2070,  2071,  2072,  2073,  2074,  2078,
    2081,  2082,  2083,  2091,  2098,  2107,  2108,  2112,  2118,  2128,
    2137,  2143,  2148,  2155,  2160,  2166,  2167,  2168,  2176,  2177,
    2178,  2179,  2180,  2186,  2198,  2199,  2200,  2201,  2204,  2206,
    2210,  2214,  2225,  2226,  2227,  2228,  2229,  2230,  2233,  2235,
    2238,  2240,  2243,  2246,  2251,  2252,  2253,  2257,  2258,  2262,
    2263,  2266,  2285,  2291,  2315,  2316,  2317,  2318,  2319,  2329,
    2330,  2331,  2332,  2333,  2334,  2335,  2336,  2337,  2338,  2339,
    2340,  2341,  2342,  2343,  2344,  2345,  2346,  2347,  2348,  2349,
    2350,  2351,  2352,  2353,  2354,  2355,  2356,  2357,  2358,  2359,
    2360,  2361,  2362,  2363,  2368,  2369,  2370,  2371,  2372,  2373,
    2374,  2375,  2376,  2377,  2378,  2379,  2380,  2381,  2392,  2402,
    2403,  2407,  2408,  2409,  2410,  2411,  2412,  2413,  2414,  2417,
    2432,  2435,  2437,  2441,  2442,  2443,  2444,  2445,  2446,  2447,
    2448,  2449,  2450,  2450,  2451,  2451,  2452,  2453,  2454,  2458,
    2459,  2463,  2471,  2473,  2477,  2478,  2479,  2483,  2484,  2487,
    2489,  2492,  2493,  2494,  2495,  2496,  2497,  2498,  2499,  2500,
    2501,  2502,  2505,  2527,  2528,  2529,  2530,  2531,  2532,  2533,
    2534,  2535,  2536,  2537,  2538,  2539,  2540,  2541,  2542,  2543,
    2544,  2545,  2546,  2547,  2548,  2549,  2550,  2551,  2552,  2553,
    2554,  2555,  2556,  2557,  2558,  2559,  2560,  2561,  2562,  2563,
    2564,  2567,  2569,  2572,  2574,  2583,  2585,  2586,  2589,  2591,
    2595,  2596,  2599,  2609,  2632,  2634,  2638,  2638,  2641,  2643,
    2646,  2648,  2652,  2656,  2657,  2662,  2665,  2668,  2673,  2676,
    2681,  2684,  2688,  2692,  2695,  2696,  2697,  2698,  2699,  2700,
    2701,  2702,  2708,  2715,  2716,  2717,  2722,  2723,  2729,  2736,
    2737,  2738,  2739,  2740,  2741,  2742,  2743,  2744,  2745,  2746,
    2747,  2748,  2752,  2753,  2754,  2759,  2760,  2761,  2762,  2763,
    2766,  2767,  2768,  2769,  2770,  2771,  2772,  2775,  2777,  2780,
    2782,  2786,  2798,  2805,  2812,  2813,  2814,  2815,  2816,  2819,
    2828,  2836,  2843,  2844,  2848,  2853,  2859,  2862,  2867,  2868,
    2869,  2870,  2871,  2874,  2881,  2881,  2881,  2881,  2881,  2881,
    2881,  2881,  2881,  2881,  2881,  2881,  2881,  2881,  2881,  2882,
    2882,  2882,  2882,  2882,  2882,  2882,  2882,  2882,  2882,  2882,
    2882,  2882,  2882,  2882,  2882,  2882,  2882,  2882,  2882,  2882,
    2882,  2882,  2882,  2882,  2882,  2882,  2882,  2882,  2882,  2882,
    2882,  2882,  2882,  2882,  2882,  2882,  2882,  2882,  2882,  2882,
    2882,  2882,  2882,  2882,  2882,  2883,  2883,  2883,  2883,  2883,
    2883,  2883,  2883,  2883,  2884,  2884,  2884,  2884,  2885,  2885,
    2885,  2886,  2886,  2886,  2886,  2886,  2887,  2887,  2888,  2889,
    2890,  2891,  2892,  2893,  2894,  2895,  2896,  2897,  2898,  2898,
    2898,  2898,  2898,  2898
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "END", "CLI_MARKER", "INVALID_TOKEN",
  "ELSECOL", "DDOT", "GEQ", "LEQ", "NEQ", "AND", "OR", "PO", "PC", "NUM",
  "ENUM", "RTRID", "IPA", "SYM", "TEXT", "PREFIX_DUMMY", "'='", "'<'",
  "'>'", "'~'", "'+'", "'-'", "'*'", "'/'", "'%'", "'!'", "'.'", "DEFINE",
  "ON", "OFF", "YES", "NO", "S", "MS", "US", "LOG", "SYSLOG", "ALL",
  "DEBUG", "TRACE", "INFO", "REMOTE", "WARNING", "ERROR", "AUTH", "FATAL",
  "BUG", "STDERR", "SOFT", "TIMEFORMAT", "ISO", "OLD", "SHORT", "LONG",
  "BASE", "NAME", "CONFIRM", "UNDO", "CHECK", "TIMEOUT", "CONFIGURE",
  "DOWN", "KERNEL", "PERSIST", "SCAN", "TIME", "LEARN", "DEVICE", "ROUTES",
  "GRACEFUL", "RESTART", "KRT_SOURCE", "KRT_METRIC", "TABLE",
  "KRT_PREFSRC", "KRT_REALM", "ROUTER", "ID", "PROTOCOL", "TEMPLATE",
  "PREFERENCE", "DISABLED", "DIRECT", "INTERFACE", "IMPORT", "EXPORT",
  "FILTER", "NONE", "STATES", "FILTERS", "RECEIVE", "LIMIT", "ACTION",
  "WARN", "BLOCK", "DISABLE", "KEEP", "FILTERED", "PASSWORD", "FROM",
  "PASSIVE", "TO", "EVENTS", "PACKETS", "PROTOCOLS", "INTERFACES",
  "PRIMARY", "STATS", "COUNT", "FOR", "COMMANDS", "PREEXPORT", "GENERATE",
  "ROA", "MAX", "FLUSH", "AS", "LISTEN", "BGP", "V6ONLY", "DUAL",
  "ADDRESS", "PORT", "PASSWORDS", "DESCRIPTION", "SORTED", "RELOAD", "IN",
  "OUT", "MRTDUMP", "MESSAGES", "RESTRICT", "MEMORY", "IGP_METRIC",
  "CLASS", "DSCP", "WAIT", "SHOW", "STATUS", "SUMMARY", "ROUTE", "SYMBOLS",
  "ADD", "DELETE", "DUMP", "RESOURCES", "SOCKETS", "NEIGHBORS",
  "ATTRIBUTES", "EVAL", "ECHO", "ENABLE", "FUNCTION", "PRINT", "PRINTN",
  "UNSET", "RETURN", "ACCEPT", "REJECT", "QUITBIRD", "INT", "BOOL", "IP",
  "PREFIX", "PAIR", "QUAD", "EC", "SET", "STRING", "BGPMASK", "BGPPATH",
  "CLIST", "ECLIST", "IF", "THEN", "ELSE", "CASE", "TRUE", "FALSE", "RT",
  "RO", "UNKNOWN", "GENERIC", "GW", "NET", "MASK", "PROTO", "SOURCE",
  "SCOPE", "CAST", "DEST", "IFNAME", "IFINDEX", "LEN", "DEFINED",
  "CONTAINS", "RESET", "PREPEND", "FIRST", "LAST", "MATCH", "ROA_CHECK",
  "EMPTY", "WHERE", "BFD", "MIN", "IDLE", "RX", "TX", "INTERVAL",
  "MULTIPLIER", "MULTIHOP", "NEIGHBOR", "DEV", "LOCAL", "SESSIONS", "HOLD",
  "CONNECT", "RETRY", "KEEPALIVE", "STARTUP", "VIA", "NEXT", "HOP", "SELF",
  "DEFAULT", "PATH", "METRIC", "START", "DELAY", "FORGET", "AFTER",
  "BGP_PATH", "BGP_LOCAL_PREF", "BGP_MED", "BGP_ORIGIN", "BGP_NEXT_HOP",
  "BGP_ATOMIC_AGGR", "BGP_AGGREGATOR", "BGP_COMMUNITY",
  "BGP_EXT_COMMUNITY", "RR", "RS", "CLIENT", "CLUSTER", "AS4", "ADVERTISE",
  "IPV4", "CAPABILITIES", "PREFER", "OLDER", "MISSING", "LLADDR", "DROP",
  "IGNORE", "REFRESH", "INTERPRET", "COMMUNITIES", "BGP_ORIGINATOR_ID",
  "BGP_CLUSTER_LIST", "IGP", "GATEWAY", "RECURSIVE", "MED", "TTL",
  "SECURITY", "DETERMINISTIC", "SECONDARY", "ALLOW", "PATHS", "AWARE",
  "OSPF", "AREA", "OSPF_METRIC1", "OSPF_METRIC2", "OSPF_TAG",
  "OSPF_ROUTER_ID", "RFC1583COMPAT", "STUB", "TICK", "COST", "COST2",
  "RETRANSMIT", "HELLO", "TRANSMIT", "PRIORITY", "DEAD", "TYPE",
  "BROADCAST", "BCAST", "NONBROADCAST", "NBMA", "POINTOPOINT", "PTP",
  "POINTOMULTIPOINT", "PTMP", "SIMPLE", "AUTHENTICATION", "STRICT",
  "CRYPTOGRAPHIC", "ELIGIBLE", "POLL", "NETWORKS", "HIDDEN", "VIRTUAL",
  "LINK", "ONLY", "BUFFER", "LARGE", "NORMAL", "STUBNET", "TAG",
  "EXTERNAL", "LSADB", "ECMP", "WEIGHT", "NSSA", "TRANSLATOR", "STABILITY",
  "GLOBAL", "LSID", "INSTANCE", "REAL", "NETMASK", "LENGTH", "MERGE",
  "TOPOLOGY", "STATE", "PIPE", "PEER", "MODE", "OPAQUE", "TRANSPARENT",
  "RIP", "INFINITY", "PERIOD", "GARBAGE", "MULTICAST", "QUIET", "NOLISTEN",
  "VERSION1", "PLAINTEXT", "MD5", "HONOR", "NEVER", "ALWAYS", "RIP_METRIC",
  "RIP_TAG", "STATIC", "PROHIBIT", "MULTIPATH", "BLACKHOLE", "UNREACHABLE",
  "';'", "'('", "')'", "':'", "'{'", "'}'", "','", "'?'", "'['", "']'",
  "$accept", "config", "conf_entries", "definition", "expr", "expr_us",
  "bool", "ipa", "ipa_scope", "prefix", "prefix_or_ipa", "pxlen",
  "datetime", "text", "text_or_none", "log_config", "syslog_name",
  "log_file", "log_mask", "log_mask_list", "log_cat", "mrtdump_base",
  "timeformat_which", "timeformat_spec", "timeformat_base",
  "cmd_CONFIGURE", "cmd_CONFIGURE_SOFT", "cmd_CONFIGURE_CONFIRM",
  "cmd_CONFIGURE_UNDO", "cmd_CONFIGURE_CHECK", "cmd_DOWN", "cfg_name",
  "cfg_timeout", "kern_proto_start", "kern_item", "kif_proto_start",
  "kif_item", "kern_sys_item", "rtrid", "idval", "listen", "listen_opts",
  "listen_opt", "gr_opts", "tab_sorted", "newtab", "roa_table_start",
  "roa_table_opts", "roa_table", "proto_start", "proto_name", "proto_item",
  "imexport", "limit_action", "limit_spec", "rtable", "debug_default",
  "iface_patt_node_init", "iface_patt_node_body", "iface_negate",
  "iface_patt_node", "iface_patt_list", "iface_patt_list_nopx",
  "iface_patt_init", "iface_patt", "tos", "dev_proto_start", "dev_proto",
  "dev_iface_init", "dev_iface_patt", "debug_mask", "debug_list",
  "debug_flag", "mrtdump_mask", "mrtdump_list", "mrtdump_flag",
  "password_list", "password_items", "password_item",
  "password_item_begin", "password_item_params", "cmd_SHOW_STATUS",
  "cmd_SHOW_MEMORY", "cmd_SHOW_PROTOCOLS", "cmd_SHOW_PROTOCOLS_ALL",
  "optsym", "cmd_SHOW_INTERFACES", "cmd_SHOW_INTERFACES_SUMMARY",
  "cmd_SHOW_ROUTE", "r_args", "export_or_preexport", "cmd_SHOW_ROA",
  "roa_args", "roa_mode", "cmd_SHOW_SYMBOLS", "sym_args", "roa_table_arg",
  "cmd_ADD_ROA", "cmd_DELETE_ROA", "cmd_FLUSH_ROA", "cmd_DUMP_RESOURCES",
  "cmd_DUMP_SOCKETS", "cmd_DUMP_INTERFACES", "cmd_DUMP_NEIGHBORS",
  "cmd_DUMP_ATTRIBUTES", "cmd_DUMP_ROUTES", "cmd_DUMP_PROTOCOLS",
  "cmd_EVAL", "cmd_ECHO", "echo_mask", "echo_size", "cmd_DISABLE",
  "cmd_ENABLE", "cmd_RESTART", "cmd_RELOAD", "cmd_RELOAD_IN",
  "cmd_RELOAD_OUT", "cmd_DEBUG", "cmd_MRTDUMP", "cmd_RESTRICT",
  "proto_patt", "proto_patt2", "filter_def", "$@1", "filter_eval", "type",
  "one_decl", "decls", "declsn", "filter_body", "filter", "where_filter",
  "function_params", "function_body", "function_def", "$@2", "cmds",
  "cmds_int", "block", "fipa", "set_atom", "switch_atom", "pair_expr",
  "pair_atom", "pair_item", "ec_expr", "ec_kind", "ec_item", "set_item",
  "switch_item", "set_items", "switch_items", "fprefix_s", "fprefix",
  "fprefix_set", "switch_body", "bgp_path_expr", "bgp_path",
  "bgp_path_tail1", "bgp_path_tail2", "constant", "constructor", "rtadot",
  "function_call", "symbol", "static_attr", "term", "break_command",
  "print_one", "print_list", "var_listn", "var_list", "cmd",
  "bfd_proto_start", "bfd_proto_item", "bfd_proto_opts", "bfd_proto",
  "bfd_iface_start", "bfd_iface_item", "bfd_iface_opts",
  "bfd_iface_opt_list", "bfd_iface", "bfd_multihop", "bfd_neigh_iface",
  "bfd_neigh_local", "bfd_neigh_multihop", "bfd_neighbor",
  "cmd_SHOW_BFD_SESSIONS", "bgp_proto_start", "bgp_proto",
  "ospf_proto_start", "ospf_proto", "ospf_proto_item", "ospf_area_start",
  "ospf_area", "ospf_area_opts", "ospf_area_item", "$@3", "$@4",
  "ospf_stubnet", "ospf_stubnet_start", "ospf_stubnet_opts",
  "ospf_stubnet_item", "ospf_vlink", "ospf_vlink_opts", "ospf_vlink_item",
  "ospf_vlink_start", "ospf_iface_item", "pref_list", "pref_item",
  "pref_base", "pref_opt", "nbma_list", "nbma_eligible", "nbma_item",
  "ospf_iface_start", "ospf_instance_id", "ospf_iface_patt_list", "$@5",
  "ospf_iface_opts", "ospf_iface_opt_list", "ospf_iface", "opttext",
  "cmd_SHOW_OSPF", "cmd_SHOW_OSPF_NEIGHBORS", "cmd_SHOW_OSPF_INTERFACE",
  "cmd_SHOW_OSPF_TOPOLOGY", "cmd_SHOW_OSPF_TOPOLOGY_ALL",
  "cmd_SHOW_OSPF_STATE", "cmd_SHOW_OSPF_STATE_ALL", "cmd_SHOW_OSPF_LSADB",
  "lsadb_args", "pipe_proto_start", "pipe_proto", "rip_cfg_start",
  "rip_cfg", "rip_auth", "rip_mode", "rip_iface_item", "rip_iface_opts",
  "rip_iface_opt_list", "rip_iface_init", "rip_iface",
  "static_proto_start", "static_proto", "stat_route0", "stat_multipath1",
  "stat_multipath", "stat_route", "cmd_SHOW_STATIC", "conf", "cli_cmd",
  "proto", "kern_proto", "kif_proto", "dynamic_attr", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,    61,    60,    62,   126,    43,    45,    42,    47,
      37,    33,    46,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,    59,
      40,    41,    58,   123,   125,    44,    63,    91,    93
};
# endif

#define YYPACT_NINF -1214

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-1214)))

#define YYTABLE_NINF -436

#define yytable_value_is_error(Yytable_value) \
  (!!((Yytable_value) == (-436)))

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
      72,  2494,   137,   636,   584,   519,   143,   584,   584,    41,
     761,   584,   183,  1114,    92,   101,   710,  1493,    56,   584,
   -1214, -1214, -1214, -1214, -1214, -1214, -1214, -1214, -1214, -1214,
   -1214, -1214, -1214, -1214, -1214, -1214, -1214, -1214, -1214, -1214,
   -1214, -1214, -1214, -1214, -1214, -1214, -1214, -1214, -1214, -1214,
   -1214, -1214, -1214, -1214, -1214, -1214, -1214, -1214, -1214, -1214,
   -1214, -1214, -1214, -1214, -1214, -1214, -1214, -1214, -1214,   186,
     454,   233,   438,   156,   228,   223, -1214, -1214,   350,   301,
     354,   104,  1493,   478, -1214, -1214, -1214, -1214, -1214,   485,
     485, -1214, -1214, -1214, -1214,   168, -1214,   823, -1214,   485,
    1601, -1214, -1214, -1214,   485, -1214,   485,  2213,   485,  2057,
     485,  2128,   485,  2243,   485,  2087, -1214, -1214,  1973,  2313,
   -1214, -1214, -1214,    77, -1214,   518,   574,   626,   518,   522,
   -1214,   632,   672,   512,   584,   584,   675,    78, -1214,   674,
     171, -1214,   678,   692, -1214, -1214,   400,   456,   619,   405,
     405,   701,   713,   716,   723,   726,   730,   737,    34, -1214,
   -1214, -1214,   718,   385, -1214,   546,    21,    11,  1493, -1214,
     402,   414,   433, -1214, -1214,   443,   497,   500,   902,   125,
   -1214, -1214, -1214, -1214, -1214,  1917, -1214,  2540, -1214, -1214,
    1293,   767,   874,   857, -1214, -1214,   820, -1214, -1214,    23,
      77,   194, -1214, -1214, -1214, -1214,   798,   542,   750,   783,
     140, -1214,   906, -1214,    78,   568,  2663, -1214,   825,   577,
     580, -1214, -1214, -1214, -1214, -1214, -1214, -1214, -1214, -1214,
   -1214,   597,    77,   918,   862,   194,   664, -1214,   639,   203,
     868,   424,    78, -1214,   610,   614,   612,   624,   -14,   914,
     623,   754,   424,   664,   895,   721,    66,   880,   664,    12,
     405,   306,   926,   784,   938,   788,   792,   216,   793,   801,
     319,   779,   776,   664,   781,   780,   786,    47,   -13,   812,
     789,   802,   664,   833, -1214,   696,   694,   607,   664,   976,
     194,   664,   749, -1214, -1214,   703,   712, -1214,   714,   994,
     312, -1214,   732,   717,  1011, -1214,   424,   194,   729,    59,
     194,   194,  1022,   -91, -1214,   735,   739, -1214,   733,   734,
     790,   405,  1020, -1214,   747,   549,   758,  1024,   664,  1036,
     664,  1044,  1043, -1214,   764,   766,   768,  1049,  1108, -1214,
     770,   771, -1214, -1214,   416,  1130,   522, -1214, -1214,  1131,
     194,  1132, -1214, -1214,  1121,  1138,  1141,  1142, -1214, -1214,
   -1214,   309,  1143, -1214, -1214,   738,  1148, -1214,  1152,   932,
   -1214, -1214,  2302,   867,   619, -1214,   619,   619, -1214,   322,
     399,  1155,  1156, -1214, -1214,     0,  1040,  1041, -1214, -1214,
   -1214, -1214, -1214, -1214, -1214,    34, -1214,    34,  1493,    34,
      34,  1149, -1214,  1154,  1095,  1144,   956,  1153,    11,    11,
    1176,  1139,  1493,  1493,  1493,  1493,  1493,  1188, -1214, -1214,
    1195, -1214,   847,    61, -1214, -1214, -1214, -1214,   856, -1214,
   -1214,  1206, -1214, -1214, -1214,   123,    30, -1214,   141, -1214,
   -1214, -1214, -1214, -1214, -1214, -1214, -1214, -1214, -1214, -1214,
   -1214, -1214, -1214, -1214, -1214, -1214, -1214, -1214, -1214, -1214,
   -1214, -1214, -1214, -1214, -1214, -1214, -1214, -1214, -1214, -1214,
   -1214, -1214, -1214, -1214, -1214,  1493,  1493,  1493,  1493,  1493,
    1493,  1493,  1493,  1493,  1493,  1493,  1493,  1493,   745, -1214,
   -1214, -1214, -1214, -1214, -1214, -1214, -1214, -1214,   422, -1214,
   -1214,  1212, -1214,  1493,   424, -1214, -1214,  1293,   861, -1214,
    1493, -1214,   194,   748,   769, -1214,   194, -1214, -1214, -1214,
   -1214, -1214, -1214,   863,  2555, -1214,   -19,   871, -1214,   866,
    1202, -1214, -1214,   -65, -1214, -1214, -1214, -1214,   607, -1214,
   -1214, -1214, -1214, -1214, -1214, -1214, -1214, -1214,  1950, -1214,
     184,  1124,  1493, -1214, -1214,   184, -1214,   184, -1214, -1214,
   -1214, -1214, -1214, -1214,  1158,  1160,   617, -1214,  1183,   875,
     877,   194,    44,   984,   664,   405,   888, -1214,   896,  1224,
     194,  1134,   194,  1186,   194,  1192,   -28,   194,   194,   664,
    1194,   900,  1184,   907,   664,   909,   664,   388,   664,   918,
     664,   916,   917,   664,   664,   664,   921,  1159, -1214, -1214,
   -1214, -1214,   664, -1214,  1180,   664, -1214, -1214, -1214,  1266,
     928,   929, -1214, -1214,   194, -1214,   930, -1214,   937,  1196,
   -1214, -1214, -1214,   940,   942,   945,   194,   947,   948,   950,
   -1214, -1214,   200, -1214,   664, -1214,   918, -1214, -1214,   782,
   -1214,   405, -1214,  1083, -1214, -1214, -1214,   194, -1214,   194,
   -1214,   664,   664, -1214, -1214, -1214,   194, -1214,   405, -1214,
   -1214, -1214, -1214, -1214, -1214, -1214, -1214,   480, -1214, -1214,
    1308, -1214, -1214, -1214, -1214, -1214, -1214, -1214, -1214, -1214,
     503, -1214, -1214,  1309, -1214, -1214, -1214,  1302, -1214,  1307,
   -1214,   405, -1214, -1214,  1304,  1311, -1214,  1950, -1214, -1214,
   -1214, -1214,   405, -1214, -1214,  1313, -1214, -1214, -1214, -1214,
   -1214, -1214, -1214, -1214, -1214,  1325,  1314,  1314,   753,   619,
    1314,   619,  1314, -1214, -1214,   194,   405, -1214,  1318,  1331,
   -1214, -1214,   265, -1214, -1214, -1214, -1214,   107, -1214,   986,
   -1214,  1321, -1214, -1214, -1214, -1214,   240,   425,   491,   787,
     538,   119, -1214,  1493, -1214,  1493, -1214,  1343,   988,   992,
     814,   225,   286, -1214, -1214, -1214,  1336,  1341, -1214,  2637,
    2637,  2637,  2688,  2688,  2637,  2637,  2637,  2637,   508,   508,
    1139,  1139, -1214,  1001, -1214, -1214, -1214, -1214,  1293, -1214,
    1847, -1214,   533, -1214,   814,  1348, -1214, -1214, -1214, -1214,
    1010, -1214,  1013, -1214, -1214, -1214, -1214, -1214, -1214, -1214,
   -1214, -1214, -1214, -1214, -1214, -1214,   166,  1018,  1016, -1214,
   -1214, -1214, -1214,   405,   194, -1214, -1214, -1214,  1919,  2555,
   -1214,   405, -1214, -1214,  1353, -1214,  1017, -1214, -1214, -1214,
   -1214,  1283, -1214,   664,  2663, -1214, -1214,   648,   194,   194,
     194,  1025,  1026,   664, -1214, -1214,  1028,  1029,  1031,  1034,
     664,  1035,  1037, -1214, -1214,  1364,  1273,  1045,   194,  1048,
     194,  1050,   194,  1051,  1055,  1058,  1059,  1060,   194, -1214,
     607, -1214,  1061, -1214,  1064,  1065,  1067,  1068,  1071,  1072,
    1073, -1214, -1214,  1075,  1076,  1077, -1214,   304, -1214,   194,
   -1214,   616,  1081, -1214, -1214,  1082,    -5, -1214, -1214,  1078,
    1084, -1214, -1214, -1214,  1085, -1214, -1214, -1214,   194,   561,
     582,  1086,  1087,  1088, -1214,  1224, -1214,   405,  1133,  1083,
   -1214, -1214, -1214, -1214, -1214,     0, -1214, -1214, -1214,   416,
   -1214, -1214,   309, -1214, -1214, -1214, -1214, -1214, -1214, -1214,
   -1214, -1214, -1214, -1214,  1405,  1442, -1214, -1214,   607, -1214,
     607,  1436, -1214, -1214,   607,  1314,  1449,  1314,  1450, -1214,
   -1214,  1335,  1342, -1214,  1493, -1214,  1431,  1493,  1493,  1493,
   -1214,  1493, -1214,  1493,   588,   991,  1493,  1222,  1493, -1214,
   -1214, -1214, -1214,  1098,   718, -1214,  1493, -1214, -1214, -1214,
   -1214, -1214,  1017, -1214, -1214, -1214,  2555,    28, -1214, -1214,
   -1214,  1106,  1105, -1214,  1352, -1214,   870, -1214,   609, -1214,
   -1214, -1214, -1214,   405, -1214, -1214,  1115,  1102,  1116,  1117,
   -1214, -1214,  1118, -1214, -1214, -1214, -1214,  1119, -1214, -1214,
   -1214,   194, -1214,  1123, -1214,  1126, -1214,  1127, -1214, -1214,
   -1214, -1214, -1214,  1128,  1129, -1214, -1214, -1214, -1214, -1214,
   -1214, -1214, -1214, -1214, -1214, -1214, -1214,  1135, -1214, -1214,
     664,    -2,   134, -1214,  1162,   405, -1214, -1214,   181, -1214,
    1140, -1214,  1163, -1214, -1214, -1214, -1214, -1214,  1196, -1214,
    1145,  1460,  1460,  1460,  1460, -1214, -1214, -1214, -1214,  1224,
     194,  1133, -1214, -1214, -1214, -1214, -1214, -1214, -1214, -1214,
    1486, -1214,  1488, -1214,  1477,  1478, -1214, -1214,  1174,  1517,
    1548,  1582,   633,  1493, -1214, -1214,  2663,  1137,  1136,  2663,
    1487,  1607, -1214,    29, -1214,  1483, -1214, -1214,  1157,  1493,
   -1214, -1214, -1214,  1493,  1493,  1150,    19,  1917,  1164,  1300,
   -1214,  2555, -1214,  1500,   405, -1214, -1214, -1214, -1214, -1214,
   -1214, -1214, -1214, -1214,  1169, -1214,    95, -1214, -1214,   194,
   -1214, -1214, -1214, -1214,  1175, -1214, -1214, -1214, -1214, -1214,
   -1214, -1214, -1214, -1214,   194,   194,   664,   194, -1214,  1170,
     607, -1214, -1214,  1173,  1185,   194, -1214, -1214,   194,  1189,
     338, -1214,   200, -1214,  1178,  1179,  1203,  1204, -1214, -1214,
   -1214, -1214,   512,   512, -1214, -1214, -1214, -1214,  1493,  1646,
    1509,  1347,  1187, -1214,  1493,  1095,  1493, -1214,  1872,  2490,
     741, -1214, -1214,  1499,   511, -1214,  2663,  1190,  1205, -1214,
    1439, -1214,  1017,  1169, -1214, -1214,  1534,   424,  1345,  1207,
   -1214,  1017,  1215, -1214, -1214, -1214, -1214, -1214, -1214, -1214,
   -1214, -1214, -1214, -1214,    85,   194,  1296,   618, -1214,  1209,
   -1214,   200,   200,   200,   200,  1566,  1578,  1693, -1214,  1223,
    1225,     6, -1214,  1902,  1226,  1927,  2003, -1214,  1871, -1214,
    1493,  1493,   935,  1300, -1214,  1569, -1214,   117, -1214, -1214,
     405,  1371, -1214,  1163, -1214, -1214,    14,   -78,    26,   864,
     194,   194,   194, -1214, -1214,   316, -1214, -1214, -1214, -1214,
   -1214, -1214, -1214, -1214, -1214, -1214, -1214, -1214, -1214, -1214,
    1493, -1214,  1493, -1214, -1214, -1214, -1214,  1234,    28,  1415,
   -1214,    24,  1952,  1977,  1237,  1238,  1239,  1240,  1242, -1214,
    1243,   664,   744,  1389,   194,   194, -1214,  1253, -1214,   664,
   -1214, -1214,  2320, -1214, -1214, -1214,   100,   664,   194,   664,
   -1214,  1254, -1214,   194,   194,   194,  1385,    45,    52, -1214,
   -1214,  1262, -1214, -1214, -1214,  1310, -1214,  1258,  1264,  1265,
    1274,  1871,   148, -1214, -1214, -1214,   856, -1214, -1214,  1619,
   -1214, -1214, -1214,   224, -1214, -1214,  1493,  1493,  1493,  1493,
   -1214, -1214, -1214,  1412,  1413,  1422,   794, -1214, -1214, -1214,
   -1214,  1329,   194,  1280,   664,  1333,   289,  1373,   664,   664,
     194,   194,   194,  1414,   194,   307,   894,  1319,   111,  1351,
     194,  1330,  1356, -1214, -1214,  1294, -1214,   194,  1303, -1214,
   -1214, -1214, -1214, -1214, -1214, -1214,   194,   194, -1214, -1214,
   -1214, -1214, -1214, -1214,  1493, -1214, -1214, -1214, -1214, -1214,
    1718,    79,   148,    86,  1743,  1768,  1793,  1818,   194,   194,
     194, -1214, -1214, -1214,   664, -1214, -1214, -1214,    31,   194,
     194, -1214,   688, -1214, -1214, -1214, -1214, -1214,   194, -1214,
     194, -1214, -1214, -1214, -1214, -1214, -1214, -1214, -1214, -1214,
     664, -1214, -1214, -1214,   664, -1214,   194,   664, -1214, -1214,
   -1214, -1214, -1214,  1291, -1214,  1493, -1214, -1214, -1214,  1305,
    1306,  1320,  1322, -1214, -1214, -1214, -1214,    -3, -1214, -1214,
   -1214, -1214, -1214,  1349, -1214, -1214, -1214, -1214, -1214, -1214,
   -1214, -1214,  1718, -1214, -1214, -1214, -1214,  1357, -1214, -1214,
   -1214, -1214,  1323, -1214
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       4,     0,     0,     0,     0,    71,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   373,     0,     0,
     749,   750,   751,   752,   753,   754,   755,   756,   757,   758,
     759,   760,   761,   762,   763,   764,   765,   766,   767,   768,
     769,   770,   771,   772,   773,   774,   775,   776,   777,   778,
     779,   780,   781,   782,   783,   784,   785,   786,   787,   788,
     789,   790,   791,   792,   793,   794,     3,     1,     2,     0,
       0,     0,     0,     0,     0,     0,   107,   108,     0,     0,
       0,     0,   373,     0,   734,   735,   736,   737,   738,   109,
     109,   739,   740,   741,   742,   105,   743,     0,   745,   109,
     112,   746,   747,   748,   109,   798,   109,   112,   109,   112,
     109,   112,   109,   112,   109,   112,     5,   744,   112,   112,
     260,   262,   261,     0,    72,    71,     0,     0,    71,    73,
      70,     0,     0,   232,     0,     0,     0,     0,   259,   264,
       0,   216,     0,     0,   200,   224,     0,   196,   196,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   356,   360,
     369,   366,   302,   375,   363,     0,     0,   359,   373,   405,
       0,     0,     0,   361,   362,     0,     0,     0,   373,     0,
     364,   365,   370,   403,   404,     0,   402,     0,   247,   246,
       0,   249,     0,     0,    30,    29,    35,    38,    36,     0,
       0,     0,    57,    56,    55,    54,     0,     0,     0,    99,
       0,   266,     0,    92,     0,     0,   268,   294,   110,     0,
       0,   103,    76,    82,   154,   483,   453,   538,   672,   678,
     713,     0,     0,     0,     0,     0,    18,   158,     0,     0,
       0,     0,     0,   797,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    18,     0,     0,     0,     0,    18,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    18,     0,     0,     0,     0,     0,     0,
       0,     0,    18,     0,   799,     0,     0,     0,    18,     0,
       0,    18,     0,   800,   541,     0,     0,   548,     0,     0,
       0,   801,     0,     0,     0,   711,     0,     0,     0,     0,
       0,     0,     0,     0,   802,     0,     0,   179,   183,     0,
       0,     0,     0,   803,     0,     0,     0,     0,    18,     0,
      18,     0,     0,   795,     0,     0,     0,     0,    32,   796,
       0,     0,   161,   160,     0,     0,    73,    67,    68,     0,
      74,     0,   253,   251,     0,     0,     0,     0,   254,   172,
     171,     0,     0,   263,   265,   264,     0,   197,     0,   220,
     192,   191,     0,     0,   196,   195,   196,   196,   663,   196,
     196,     0,     0,    19,    20,     0,     0,     0,   242,   243,
     239,   237,   238,   240,   241,   356,   375,   356,   373,   356,
     356,     0,   348,     0,   373,     0,     0,     0,   359,   359,
       0,   400,   373,   373,   373,   373,   373,     0,   319,   320,
       0,   322,     0,     0,     7,   306,   304,     9,   373,   303,
     305,   328,   326,   327,   334,     0,   339,   343,     0,   816,
     811,   812,   813,   814,   376,   815,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   818,   821,   820,   817,   819,
     822,   823,   824,   827,   825,   826,   828,   829,   830,   831,
     832,   833,   406,   407,   244,   373,   373,   373,   373,   373,
     373,   373,   373,   373,   373,   373,   373,   373,     0,    43,
      44,    45,    46,    47,    48,    49,    50,    51,     0,    41,
     250,     0,   252,   373,     0,    37,    39,     0,     0,   138,
     373,   139,    58,     0,     0,    64,     0,   100,   101,    88,
      89,    90,   150,     0,   283,   102,     0,     0,    53,     0,
       0,   804,   808,     0,   155,   115,   137,   123,     0,   113,
      14,    16,    15,    17,    13,   114,   140,   128,   283,   129,
       0,     0,   373,   117,   127,     0,   118,     0,   125,   116,
     156,   157,   458,   484,     0,     0,    18,   496,     0,     0,
       0,     0,    18,     0,    18,     0,     0,   497,     0,    21,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    18,
       0,     0,     0,     0,    18,     0,    18,     0,    18,     0,
      18,     0,     0,    18,    18,    18,     0,     0,   485,   539,
     549,   542,    18,   547,   544,    18,   540,   551,   673,     0,
       0,     0,   674,   679,     0,   140,     0,   184,     0,   180,
     694,   692,   693,     0,     0,     0,     0,     0,     0,     0,
     680,   687,   185,   714,    18,   719,     0,   715,   729,     0,
     728,     0,   732,     0,   730,   731,   718,     0,    77,     0,
      79,    18,    18,   806,   807,   805,     0,    31,     0,   810,
     809,   166,   165,   167,   169,   170,   168,     0,   163,   257,
       0,    69,    75,    65,   233,   236,   255,   256,   176,   177,
       0,   174,   258,     0,   193,   198,   215,     0,   222,     0,
     221,     0,   199,   206,     0,     0,   214,   283,   208,   207,
     211,   212,     0,   213,   201,     0,   205,   223,   231,   225,
     228,   229,   227,   230,   226,     0,   654,   654,     0,   196,
     654,   196,   654,   655,   733,     0,     0,    23,     0,     0,
     352,   353,     0,   354,   355,   350,   338,   433,   436,     0,
     413,     0,   414,   357,   358,   351,     0,     0,     0,     0,
       0,     0,   321,   373,   386,   373,   315,   313,     0,     0,
     312,     0,     0,   367,   340,   341,     0,     0,   368,   398,
     396,   394,   391,   392,   393,   395,   397,   399,   387,   388,
     389,   390,   408,     0,   409,   411,   412,   248,     0,   245,
       0,    34,     0,    33,     0,     0,    60,    61,    62,    63,
       0,   140,     0,    86,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,     0,     0,     0,   267,
     287,    96,    97,     0,     0,    91,    93,    52,     0,   283,
     111,     0,   106,   124,   144,   147,   159,   288,   289,   126,
     136,   130,   120,    18,   290,   121,   119,   112,     0,     0,
       0,     0,     0,    18,   522,   524,     0,     0,     0,     0,
      18,     0,     0,   537,   498,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   490,
       0,   491,     0,   520,     0,     0,     0,     0,     0,     0,
       0,   504,   505,     0,     0,     0,   526,     0,   543,     0,
     546,     0,     0,   676,   677,     0,   709,   691,   682,     0,
       0,   686,   681,   683,     0,   689,   690,   688,     0,     0,
       0,     0,     0,     0,   725,    21,   727,     0,   722,   726,
      85,    78,    80,    81,    83,    25,    24,    84,   162,     0,
      66,   173,     0,   194,   219,   218,   217,   203,   210,   204,
     202,   209,   482,   653,     0,     0,   662,   671,     0,   669,
       0,     0,   666,   664,     0,   654,     0,   654,     0,    26,
      27,     0,     0,   349,   373,   422,     0,   373,   373,   373,
     401,   373,   420,   373,     0,     0,   373,   373,   373,     8,
     302,   329,   335,     0,     0,   344,   373,    42,     6,    40,
      59,    98,   151,    87,   282,   281,   283,   373,    94,    95,
     292,   285,     0,   295,     0,   145,     0,   140,     0,   135,
     122,   461,   461,     0,   460,   454,     0,     0,     0,     0,
     533,   532,     0,   523,   527,   528,   529,     0,   519,   513,
      22,     0,   486,     0,   492,     0,   495,     0,   500,   499,
     512,   511,   506,     0,     0,   521,   509,   501,   502,   503,
     525,   535,   508,   507,   536,   510,   530,     0,   545,   643,
      18,     0,    18,   562,     0,     0,   564,   554,    18,   550,
       0,   568,   644,   675,   685,   707,   712,   178,   180,   684,
       0,     0,     0,     0,     0,   182,   716,   717,   724,    21,
       0,   723,   164,   175,   657,   656,   670,   665,   667,   668,
       0,   658,     0,   660,     0,     0,   434,   415,     0,     0,
       0,     0,     0,   373,   371,   314,   312,     0,     0,   318,
       0,     0,   284,     0,   426,     0,   427,   428,     0,   373,
     424,   425,   423,   373,   373,     0,   373,     0,     0,   373,
     298,     0,   291,     0,   141,   142,   146,   148,   133,   131,
     132,   134,   140,   455,   470,   456,   474,   457,   459,     0,
     515,   534,   517,   518,     0,   487,   494,   493,   514,   489,
     531,   140,   567,   555,     0,     0,    18,     0,   553,     0,
       0,   571,   566,   570,     0,     0,   560,   552,     0,   578,
     700,   181,   185,    28,     0,     0,     0,     0,   720,   721,
     659,   661,   232,   232,   419,   417,   418,   416,   373,     0,
     316,   373,     0,   410,   373,   373,   373,   373,     0,     0,
       0,   293,   299,     0,     0,   446,   429,   431,     0,   286,
       0,   143,   149,   470,   468,   473,     0,     0,   477,     0,
     488,   646,   650,   557,   558,   556,   559,   631,   592,   572,
     631,   561,   645,   579,     0,     0,     0,     0,   710,     0,
     190,   185,   185,   185,   185,     0,     0,     0,   372,     0,
       0,     0,   342,     0,     0,     0,     0,   440,   373,   345,
     373,   373,     0,   373,   445,     0,   472,     0,   475,   476,
       0,   479,   516,   644,   648,   652,     0,     0,     0,   581,
       0,     0,     0,   703,   701,    18,   695,   696,   697,   698,
     699,   702,   708,   186,   187,   188,   189,   234,   235,   421,
     373,   325,   373,   323,   439,   374,   443,     0,   373,   437,
     300,     0,     0,     0,     0,     0,     0,     0,     0,   432,
       0,    18,     0,     0,     0,     0,   471,     0,   478,    18,
     481,   647,     0,   563,   634,   632,   635,    18,     0,    18,
     569,     0,   565,     0,     0,     0,     0,     0,     0,   577,
     591,     0,   152,   153,   704,     0,   705,     0,     0,     0,
       0,   373,   373,   307,   311,   309,   373,   447,   310,   332,
     330,   331,   336,     0,   442,   441,   373,   373,   373,   373,
     448,   104,   467,     0,     0,     0,     0,   462,   466,   469,
     480,     0,     0,     0,    18,     0,     0,     0,    18,    18,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   651,   630,     0,   636,     0,     0,   575,
     576,   574,   573,   585,   583,   582,     0,     0,   586,   588,
     589,   590,   580,   706,   373,   324,   444,   301,   438,   347,
     312,     0,   373,     0,     0,     0,     0,     0,     0,     0,
       0,    10,    11,    12,    18,   597,   638,   628,     0,     0,
       0,   623,    18,   629,   613,   593,   596,   594,     0,   611,
       0,   598,   600,   601,   602,   603,   604,   605,   606,   607,
      18,   617,   618,   619,    18,   595,     0,    18,   649,   637,
     633,   584,   587,     0,   308,   373,   333,   346,   337,     0,
       0,     0,     0,   463,   464,   465,   614,     0,   621,   620,
     622,   624,   625,     0,   626,   610,   599,   609,   612,   615,
     608,   317,     0,   452,   450,   451,   449,   640,   616,   639,
     627,   641,     0,   642
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1214, -1214, -1214, -1214,   -29,  -580,  -230,  -241,  -853,  -144,
    -688, -1214,  -148,   -79, -1214, -1214, -1214, -1214, -1214,  1177,
     887, -1214, -1214, -1214, -1214, -1214, -1214, -1214, -1214, -1214,
   -1214,   506,  1340, -1214, -1214, -1214, -1214, -1214, -1214,  -284,
   -1214, -1214, -1214, -1214, -1214, -1214, -1214, -1214, -1214, -1214,
     962,   -97,  1427, -1214,   157,  -375, -1214, -1214, -1214, -1214,
     662,  -616, -1214, -1214, -1214,   258, -1214, -1214, -1214, -1214,
     115, -1214,   746,   -66, -1214,   756, -1197,   600,  -621, -1214,
    -611, -1214, -1214, -1214, -1214,  -141, -1214, -1214, -1214, -1214,
   -1214, -1214, -1214, -1214, -1214, -1214,  -244, -1214, -1214, -1214,
   -1214, -1214, -1214, -1214, -1214, -1214, -1214, -1214, -1214, -1214,
   -1214, -1214, -1214, -1214, -1214, -1214, -1214, -1214, -1214, -1214,
    1263,  1334, -1214, -1214, -1214, -1214,  -746,   690,   548,  1199,
    1003,  1339, -1214,   873, -1214, -1214,  -910, -1214,   323,  -178,
     961,   232,  -985,   736, -1213, -1121,  1556, -1204,   963,   254,
   -1214, -1214,  -175,   971, -1214, -1214, -1214, -1214,   635,   576,
   -1214, -1214, -1000, -1214,   179,   581,   -17, -1214, -1214,   436,
     765,   521, -1045, -1214, -1214, -1214, -1214,   725, -1214, -1214,
     505, -1214, -1214, -1214, -1214, -1214, -1214, -1214, -1214, -1214,
   -1214, -1214, -1214, -1214, -1214, -1214, -1214, -1214, -1214, -1214,
   -1214, -1214, -1214, -1214, -1214, -1214, -1214, -1214,   489, -1214,
   -1214, -1214, -1214, -1214, -1214, -1214,   447, -1214, -1214, -1214,
   -1214, -1214,  -198, -1214, -1214, -1214, -1214, -1214, -1214, -1214,
   -1214, -1214, -1214, -1214, -1214, -1214, -1214, -1214, -1214, -1214,
   -1214, -1214, -1214, -1214, -1214, -1214,   822, -1214, -1214, -1214,
   -1214, -1214, -1214, -1214, -1214, -1102
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,     3,    85,   544,  1427,   545,   385,   876,   946,
     947,   737,  1214,   198,   668,    86,   505,   199,   508,   498,
     499,    87,   206,   207,    88,    20,    21,    22,    23,    24,
      25,   129,   351,    89,   334,    90,   340,   335,    91,   523,
      92,   526,   836,    93,   518,    94,    95,   533,    96,    97,
     219,   244,   553,  1029,   852,   537,    98,   844,  1166,  1026,
     845,   846,  1253,   811,   812,  1323,    99,   100,   546,   245,
     345,   677,   678,   362,   690,   691,   316,   919,   317,   318,
     931,    26,    27,    28,    29,   381,    30,    31,    32,   372,
     715,    33,   369,   701,    34,   373,   355,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,   191,
     501,    47,    48,    49,    50,    51,    52,    53,    54,    55,
     123,   366,   101,   524,   102,   826,   827,   828,  1022,   848,
     849,   554,   839,   830,   103,   529,  1155,  1156,  1349,   180,
     431,  1409,   767,   768,   432,  1138,   769,   433,   434,  1412,
     435,  1413,   181,   437,   438,  1351,   400,   182,   401,   410,
     183,   184,   185,  1158,   186,   472,  1136,  1159,  1247,  1248,
     748,   749,  1160,   104,  1036,   857,   105,  1172,  1367,  1307,
    1255,  1173,  1175,  1258,  1311,  1370,  1177,    56,   106,   107,
     108,   109,   295,   296,   297,   911,  1090,  1199,  1204,  1202,
    1203,  1317,  1381,  1091,  1319,  1391,  1092,  1455,  1316,  1375,
    1376,  1458,  1547,  1572,  1569,  1191,  1209,  1262,  1313,  1372,
    1315,  1192,   964,    57,    58,    59,    60,    61,    62,    63,
      64,   728,   110,   111,   112,   113,   633,  1331,  1279,  1210,
    1096,   625,   626,   114,   115,   325,   938,   939,   326,    65,
     116,    66,   117,   118,   119,   473
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     187,   430,   215,   610,   436,   386,   387,   382,   920,   916,
     285,  1135,   294,  1342,   302,  1567,   315,  1157,   324,   579,
     581,   336,   341,   570,   960,  -297,   408,   424,   576,   735,
    1402,   427,   383,   384,  -297,  -297,  -297,  -297,  1143,  1403,
    1404,  1405,  1000,   595,   383,   384,   424,  1143,   406,   395,
     427,  1234,   606,   396,   841,  1244,   774,   775,   611,   424,
     424,   614,   397,   427,   427,   216,   506,  1377,  1144,   475,
     476,   477,   478,   479,   883,   601,     1,  1144,   540,   541,
     542,   543,  1108,   480,   481,   482,   483,   484,   485,   486,
     487,   188,  1021,   488,  1403,  1404,  1405,  1000,   658,   189,
     660,  1403,  1404,  1405,  1000,  1145,   831,   832,   833,   834,
    1291,  1242,   342,   359,  1145,   475,   476,   477,   478,   479,
     343,   360,  1390,   194,   195,  1256,   599,   637,   564,   480,
     481,   482,   483,   484,   485,   486,   487,    67,  1410,   488,
     424,   425,   426,   162,   427,  1469,   130,  1411,   527,   424,
     429,   411,   630,   427,  -296,   519,  1157,   520,   521,  1467,
     133,   423,   558,  -296,  -296,  -296,  -296,  1143,   540,   541,
     542,   543,   511,   569,   367,  1454,   559,   645,  1146,  1147,
    1148,  1149,  1150,  1151,  1152,  1014,   138,  1146,  1147,  1148,
    1149,  1150,  1151,  1152,  1347,  1012,   424,  1144,  1153,   424,
     427,  1154,   884,   427,  1521,   193,   539,  1153,  1378,   424,
    1154,   149,   573,   427,   214,   540,   541,   542,   543,   850,
     150,  1398,   565,  1361,   899,  1320,  1321,   627,   714,   407,
     578,  1379,   208,   725,  1145,   726,   727,  1296,   730,   732,
     424,   425,   426,  1000,   427,   522,   547,   209,   475,   476,
     477,   478,   479,  1350,   843,   602,  1218,   867,   868,   638,
     639,   613,   480,   481,   482,   483,   484,   485,   486,   487,
    1410,   933,   488,   475,   476,   477,   478,   479,   628,  1411,
     600,   634,   635,   928,  1194,  1195,  1380,   480,   481,   482,
     483,   484,   485,   486,   487,   548,   549,   488,  1157,   842,
     555,   424,   425,   426,  1000,   427,   210,  1146,  1147,  1148,
    1149,  1150,  1151,  1152,  1257,   509,   368,   574,   929,   424,
    1196,   682,   424,   427,   383,   384,   427,  1153,  1362,  1363,
    1154,   424,  1364,  1365,   872,   427,   862,   402,  1165,  1015,
     835,   375,   869,   200,   871,  1548,  1549,   535,  1157,   201,
     540,   541,   542,   543,  1470,  1397,  1350,  1471,  1095,   887,
    1027,  1568,   736,   930,   892,   729,   894,  1343,   898,   211,
     900,   577,   510,   903,   904,   905,  1322,   409,  1373,  -297,
     212,   742,   908,  -297,  1406,   910,   507,   747,  1407,  1235,
    1382,   510,  -296,   776,   398,   756,   757,   758,   759,   760,
     399,  1157,  1157,   688,   510,   510,   631,   632,   935,  1456,
     936,   770,   552,  1522,   932,  1021,  1523,  1457,   375,   190,
    1197,  1510,   764,   383,   384,   801,   765,   945,   580,  1320,
    1321,   942,   943,   475,   476,   477,   478,   479,  1400,  1535,
     344,   361,   731,   194,   195,   689,  1406,   480,   481,   482,
     483,   484,   485,   486,   487,   587,   588,   488,   779,   780,
     781,   782,   783,   784,   785,   786,   787,   788,   789,   790,
     791,   945,   984,   194,   195,   375,  1251,   920,   213,   202,
     992,  1366,  1157,   805,   993,   428,   800,   810,   772,  1533,
     671,   773,  1479,   804,   510,   980,   196,   217,   203,   475,
     476,   477,   478,   479,   218,  1205,   777,   197,  -296,   778,
     672,   673,  -296,   480,   481,   482,   483,   484,   485,   486,
     487,   851,   204,   488,   674,   675,   851,   676,   851,   965,
    1395,   221,   976,  1301,   978,   854,   486,   487,   124,   124,
     488,   510,   866,  1302,   510,   376,   475,   476,   477,   478,
     479,   877,  1274,   879,   510,   881,  1252,   956,   885,   886,
     480,   481,   482,   483,   484,   485,   486,   487,   591,   592,
     488,  1275,  1537,   125,   402,  1261,   402,   347,   402,   402,
    1499,   126,   127,   128,   205,   510,  1482,   350,   975,  1483,
     977,   354,  1018,   430,   430,   915,   475,   476,   477,   478,
     479,  1280,   436,   120,   121,   987,  1064,   924,  1276,   377,
     480,   481,   482,   483,   484,   485,   486,   487,   895,  1500,
     488,   374,   519,  1030,   520,   521,   983,   122,   940,   348,
     941,   346,   424,  1042,   349,   352,   427,   944,   375,    68,
    1047,   475,   476,   477,   478,   479,   428,   896,   897,   620,
     621,   540,   541,   542,   543,   480,   481,   482,   483,   484,
     485,   486,   487,  1076,   510,   488,  1101,   510,  1102,    69,
    1333,  1334,  1335,  1336,  1277,   353,   510,    70,   358,   424,
      71,   370,   547,   427,  1116,  1168,  1117,  1103,   860,  1104,
    1119,    72,   232,   363,   364,   371,  1109,  1024,   540,   541,
     542,   543,  1278,   424,   388,  1079,   979,   427,  1169,  1170,
    1171,    73,   855,   648,   856,    74,   389,   365,    75,   390,
      76,    77,   540,   541,   542,   543,   391,   233,    78,   392,
     234,   548,   549,   393,   235,   236,   550,  1031,   238,   239,
     394,   551,   429,   429,   240,   404,   994,   403,   995,   475,
     476,   477,   478,   479,   405,    79,   966,   363,   364,    80,
    1035,  1080,   412,   480,   481,   482,   483,   484,   485,   486,
     487,    81,   967,   488,   413,   378,   649,  1120,   241,  1122,
     120,   121,   500,   242,   151,   945,   797,   798,   379,   380,
     988,    82,  1176,   414,    83,   475,   476,   477,   478,   479,
     383,   384,   934,   415,   122,  1019,   806,   807,   650,   480,
     481,   482,   483,   484,   485,   486,   487,   651,   512,   488,
     152,   153,   475,   476,   477,   478,   479,   808,   809,  1037,
    1038,  1039,  1491,  1492,  1493,   968,   480,   481,   482,   483,
     484,   485,   486,   487,   948,   949,   488,  1081,   552,  1053,
    1193,  1055,  1198,  1057,   513,   514,   989,   416,  1206,  1063,
     417,   154,   155,   156,   157,  1032,  1033,   951,   952,   158,
     717,   159,   160,   161,   162,   163,   164,   502,  1077,   503,
    1078,   504,   165,   166,   766,   167,   718,   168,   383,   384,
    1164,   222,   516,   861,   134,   135,   223,  1009,   798,  1100,
    1082,   515,  1553,   991,   652,   653,   654,   655,  1543,  1544,
    1545,   224,  1326,   792,   517,   158,  1268,   159,   160,   161,
     162,   163,   164,   945,  1083,   525,  1084,   528,   165,   166,
     530,   167,  1085,   168,  1086,   696,   793,   536,  1087,  1088,
     531,  1201,   169,   532,   794,   538,   719,   225,   170,   795,
     796,   720,   721,  1133,  1215,  1216,  1217,  1423,  1424,   722,
     534,  1327,  1328,  1329,  1330,   557,  1265,   747,   306,   560,
    1128,  1129,  1130,   561,  1131,   562,  1132,   510,  1285,  1286,
    1089,  1139,   567,   969,   753,   754,   723,   563,   169,  1141,
     566,   568,   571,   308,   170,    84,   572,   582,  1228,   475,
     476,   477,   478,   479,   171,   172,  1383,   575,   583,   584,
     585,   697,  1034,   480,   481,   482,   483,   484,   485,   486,
     487,   586,  1184,   488,   510,   724,   589,  1354,   593,   594,
     740,   970,   741,   226,   743,   744,   590,   596,   597,   173,
     174,   418,   419,   420,   421,   603,   971,   698,   510,   598,
     171,   172,   220,   607,   699,   608,   175,   609,   612,   176,
     604,   231,   616,   177,   972,   700,   246,   615,   247,  1368,
     286,   605,   298,   619,   303,   617,   319,   618,   973,   974,
     623,  1219,   624,  1355,  1356,   173,   174,   418,   419,   420,
     421,   622,   629,   636,   640,  1396,   642,   643,   641,   646,
     227,   644,   175,   657,  1299,   176,   647,   659,   158,   177,
     159,   160,   161,   162,   163,   164,  1229,   656,   661,   662,
     666,   165,   166,   663,   167,   664,   168,   665,   667,   669,
     670,  1422,  1238,   679,   681,   683,  1239,  1240,  1357,  1430,
     684,   685,  1246,  1358,   686,   687,   692,  1459,   990,  1461,
    1259,   694,  1384,  1385,  1386,   695,  1387,   228,   733,   734,
     738,   739,   229,   745,   751,  1263,  1264,  1388,  1266,   746,
     750,   488,  1374,  1408,  1374,   999,  1271,   230,  1309,  1272,
     752,   169,   475,   476,   477,   478,   479,   170,  1512,  1513,
    1514,  1515,  1516,  1517,  1518,  1519,   480,   481,   482,   483,
     484,   485,   486,   487,  1497,   755,   488,   761,  1503,  1504,
     762,  1287,   763,   771,  1139,   799,   178,  1293,   747,  1295,
     803,   840,   813,   179,   139,   140,   838,   853,  1389,   858,
     837,   859,   863,   141,   864,   158,   865,   159,   160,   161,
     162,   163,   164,   171,   172,   870,  1324,   873,   165,   166,
     766,   167,   142,   168,   875,   874,   878,   880,   143,   889,
     144,   145,   178,   882,  1546,   888,   891,   890,   893,   179,
     131,   132,  1554,   136,   137,   901,   902,   909,   173,   174,
     906,   907,   192,  1352,  1353,   912,  1246,   913,   914,   917,
    1557,  1392,  1393,  1394,  1558,   175,   918,  1560,   176,   921,
     306,   922,   177,  1408,   923,  1408,   925,   926,   169,   927,
     937,   950,   953,   158,   170,   159,   160,   161,   162,   163,
     164,   954,   955,   957,   146,  1139,   165,   166,   962,   167,
     958,   168,   961,   981,   963,  1426,  1428,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   982,   985,   986,  1460,
     996,  1003,  1134,   997,  1463,  1464,  1465,   998,  1468,  1004,
     158,  1006,   159,   160,   161,   162,   163,   164,  1010,  1011,
     171,   172,  1013,   165,   166,  1290,   167,  1016,   168,  1017,
    1025,  1028,  1027,  1050,  1040,  1041,   169,  1043,  1044,  1480,
    1045,   147,   170,  1046,  1048,  1051,  1049,   356,   357,  1484,
    1485,  1486,  1487,  1495,  1052,   173,   174,  1054,  1114,  1056,
    1058,  1505,  1506,  1507,  1059,  1509,  1511,  1060,  1061,  1062,
    1065,  1525,   175,  1066,  1067,   176,  1068,  1069,  1529,   177,
    1070,  1071,  1072,   169,  1073,  1074,  1075,  1531,  1532,   170,
    1093,  1094,  1097,  1098,  1099,  1115,  1106,  1107,   171,   172,
    1105,  1118,  1121,  1123,  1110,   178,  -435,  1124,  1127,  1426,
    1426,  1426,   179,  1140,  1125,  1161,  1162,  1179,   148,  1550,
    1551,  1552,  1163,  1200,  1178,  1180,  1181,  1182,  1183,  1555,
    1213,  1556,  1185,   173,   174,  1186,  1187,  1188,  1189,  1220,
    1208,  1221,  1222,  1223,  1190,   171,   172,  1559,  1230,  1207,
     175,  1231,  1232,   176,  1212,  1236,   158,   177,   159,   160,
     161,   162,   163,   164,  1241,  1250,  1289,  1237,  1562,   165,
     166,  1300,   167,  1245,   168,   475,   476,   477,   478,   479,
     173,   174,  1254,  1267,  1260,  1224,  1269,  1281,  1282,   480,
     481,   482,   483,   484,   485,   486,   487,   175,  1270,   488,
     176,  1292,  1273,  1308,   177,  1303,   475,   476,   477,   478,
     479,  1305,  1283,  1284,  1304,  1310,  1312,  1325,  1332,  1337,
     480,   481,   482,   483,   484,   485,   486,   487,  1314,   169,
     488,  1338,   178,  1340,  1360,   170,  1341,  1345,  1369,   179,
     475,   476,   477,   478,   479,  1399,  1401,  1416,  1417,  1418,
    1419,  1420,  1421,  1425,   480,   481,   482,   483,   484,   485,
     486,   487,  1429,  1462,   488,   475,   476,   477,   478,   479,
    1466,  1472,  1473,  1474,  1476,  1475,  1481,  1488,  1489,   480,
     481,   482,   483,   484,   485,   486,   487,  1490,  1477,   488,
    1494,   171,   172,  1496,  1502,   232,  1498,  1524,  1520,  1508,
    1527,  1526,  1561,  1528,   475,   476,   477,   478,   479,  -430,
     178,  1570,  1530,  1571,  1563,  1564,   556,   179,   480,   481,
     482,   483,   484,   485,   486,   487,   173,   174,   488,  1565,
     233,  1566,  1573,   234,   802,  1007,   680,   235,   236,  1167,
     237,   238,   239,   175,  1501,  1112,   176,   240,  1211,   693,
     177,   475,   476,   477,   478,   479,  1142,   178,  1113,  1249,
     959,   716,  1023,  1536,   179,   480,   481,   482,   483,   484,
     485,   486,   487,   829,  1478,   488,   475,   476,   477,   478,
     479,   241,  1001,  1137,   422,  1002,   242,  1538,  1243,  1359,
     480,   481,   482,   483,   484,   485,   486,   487,  1005,  1126,
     488,   475,   476,   477,   478,   479,  1294,  1174,  1306,  1318,
    1371,  1111,     0,     0,     0,   480,   481,   482,   483,   484,
     485,   486,   487,     0,     0,   488,   475,   476,   477,   478,
     479,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     480,   481,   482,   483,   484,   485,   486,   487,     0,     0,
     488,   475,   476,   477,   478,   479,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   480,   481,   482,   483,   484,
     485,   486,   487,     0,     0,   488,   475,   476,   477,   478,
     479,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     480,   481,   482,   483,   484,   485,   486,   487,     0,     0,
     488,     0,     0,   178,     0,   475,   476,   477,   478,   479,
     179,     0,     0,     0,     0,     0,     0,     0,     0,   480,
     481,   482,   483,   484,   485,   486,   487,     0,  1225,   488,
     475,   476,   477,   478,   479,     0,     0,     0,     0,     0,
    1143,     0,     0,     0,   480,   481,   482,   483,   484,   485,
     486,   487,     0,     0,   488,     0,     0,     0,     0,  1226,
     475,   476,   477,   478,   479,     0,     0,     0,     0,     0,
    1144,     0,   439,     0,   480,   481,   482,   483,   484,   485,
     486,   487,     0,     0,   488,   475,   476,   477,   478,   479,
       0,     0,     0,  1227,     0,     0,     0,     0,     0,   480,
     481,   482,   483,   484,   485,   486,   487,  1145,     0,   488,
     475,   476,   477,   478,   479,   243,     0,     0,  1233,   847,
       0,     0,     0,     0,   480,   481,   482,   483,   484,   485,
     486,   487,     0,     0,   488,   475,   476,   477,   478,   479,
       0,     0,     0,     0,   440,   441,     0,   442,   443,   480,
     481,   482,   483,   484,   485,   486,   487,  1288,   439,   488,
       0,     0,     0,     0,     0,     0,     0,   232,     0,     0,
       0,     0,   444,     0,     0,     0,     0,     0,     0,     0,
    1146,  1147,  1148,  1149,  1150,  1151,  1152,     0,     0,     0,
       0,   327,   328,   329,     0,   330,   331,     0,   332,     0,
    1153,     0,   233,  1154,  1339,   234,   445,     0,     0,   235,
     236,     0,     0,   238,   239,     0,     0,     0,     0,   240,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1534,
     440,   441,     0,   442,   443,   814,   815,   816,   817,   818,
     819,   820,     0,   821,   822,   823,   824,   825,     0,     0,
       0,   232,     0,   241,  1539,     0,   446,   447,   242,   448,
     449,   450,   451,   452,   453,   454,   814,   815,   816,   817,
     818,   819,   820,     0,   821,   822,   823,   824,   825,  1540,
       0,   232,     0,     0,     0,     0,   233,     0,     0,   234,
       0,     0,   445,   235,   236,     0,     0,   238,   239,     0,
       0,   320,     0,   240,  1541,   455,   456,   457,   458,   459,
     460,   461,   462,   463,     0,     0,   233,     0,     0,   234,
       0,     0,   232,   235,   236,     0,     0,   238,   239,  1542,
       0,   464,   465,   240,     0,     0,     0,   241,     0,     0,
       0,     0,   242,     0,     0,     0,   466,   467,   468,   469,
       0,     0,     0,     0,     0,     0,  1008,   233,     0,     0,
     234,     0,     0,     0,   235,   236,     0,   241,   238,   239,
       0,     0,   242,     0,   240,     0,     0,     0,     0,     0,
       0,  1297,     0,   321,  1348,     0,     0,     0,     0,     0,
       0,   455,   456,   457,   458,   459,   460,   461,   462,   463,
       0,     0,     0,     0,     0,     0,     0,   232,   241,     0,
       0,  1344,   248,   242,     0,     0,     0,   464,   465,   470,
     471,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1020,     0,   466,   467,   468,   469,  1346,   232,   249,     0,
       0,     0,   233,     0,     0,   234,     0,     0,     0,   235,
     236,   250,     0,   238,   239,   702,     0,     0,   304,   240,
       0,  1414,     0,     0,   251,     0,     0,   252,     0,   253,
     383,   384,   233,     0,     0,   234,     0,     0,     0,   235,
     236,     0,   305,   238,   239,   287,  1415,   333,     0,   240,
     288,   289,   290,   241,     0,   703,     0,   306,   242,     0,
       0,     0,     0,   322,     0,   470,   471,   232,     0,   254,
       0,   255,     0,     0,     0,     0,     0,     0,     0,     0,
     256,   307,   308,   241,     0,     0,     0,   291,   242,     0,
       0,   704,     0,   337,  1431,     0,   705,     0,   292,     0,
       0,     0,   233,   706,   707,   234,     0,     0,     0,   235,
     236,     0,     0,   238,   239,   708,   257,     0,     0,   240,
       0,     0,     0,     0,   709,   710,   711,   712,     0,   713,
       0,   293,     0,   258,   306,   338,     0,     0,     0,     0,
     259,   260,     0,   261,     0,   262,   263,     0,   264,   265,
       0,   266,     0,   241,   267,   268,     0,   269,   242,   308,
       0,   323,     0,     0,     0,     0,     0,     0,     0,     0,
     270,   271,  1432,   299,   300,   272,     0,   273,   274,     0,
     275,     0,     0,  1433,     0,   276,     0,     0,     0,   277,
     278,     0,   279,   280,     0,   281,   282,   283,     0,     0,
       0,     0,   301,     0,     0,     0,     0,     0,   475,   476,
     477,   478,   479,     0,     0,     0,     0,     0,     0,     0,
       0,   552,   480,   481,   482,   483,   484,   485,   486,   487,
       0,     0,   488,     0,     0,     0,     0,     0,     0,     0,
    1434,     0,     0,  1435,  1436,     0,     0,     0,     4,     0,
       0,     0,     0,   474,     0,     0,   309,     0,   475,   476,
     477,   478,   479,     0,     0,     0,     0,     0,     0,     0,
       5,     6,   480,   481,   482,   483,   484,   485,   486,   487,
       7,     0,   488,     0,     0,     0,     0,   284,     0,     0,
       0,     0,     0,   310,   311,   312,     0,     0,     0,     0,
    1437,     0,   313,  1438,     0,     8,     0,     0,     0,     0,
       0,     0,     0,     0,  1439,     0,  1440,   314,  1441,  1442,
    1443,  1444,  1445,  1446,     0,     9,     0,     0,     0,  1447,
       0,     0,     0,  1448,  1449,     0,    10,  1450,     0,    11,
       0,    12,     0,     0,     0,     0,     0,    13,     0,     0,
    1451,     0,    14,    15,    16,  -436,  -436,  -436,  1452,    17,
      18,    19,     0,     0,     0,     0,     0,     0,     0,  -436,
    -436,  -436,  -436,   484,   485,   486,   487,     0,     0,   488,
    1298,   475,   476,   477,   478,   479,     0,   339,     0,     0,
       0,     0,     0,     0,  1453,   480,   481,   482,   483,   484,
     485,   486,   487,     0,     0,   488,   475,   476,   477,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     480,   481,   482,   483,   484,   485,   486,   487,     0,     0,
     488,   814,   815,   816,   817,   818,   819,   820,     0,   821,
     822,   823,   824,   825
};

static const yytype_int16 yycheck[] =
{
      17,   179,    81,   287,   179,   149,   150,   148,   629,   625,
     107,   996,   109,     7,   111,    18,   113,  1017,   115,   260,
     261,   118,   119,   253,   712,     6,    15,    15,   258,    29,
       6,    19,    18,    19,    15,    16,    17,    18,    19,    15,
      16,    17,    18,   273,    18,    19,    15,    19,    27,    15,
      19,    22,   282,    19,   119,  1157,    26,    27,   288,    15,
      15,   291,    28,    19,    19,    82,    43,   145,    49,     8,
       9,    10,    11,    12,   102,    88,     4,    49,    34,    35,
      36,    37,   935,    22,    23,    24,    25,    26,    27,    28,
      29,    35,   838,    32,    15,    16,    17,    18,   328,    43,
     330,    15,    16,    17,    18,    86,   125,   126,   127,   128,
    1231,  1156,    35,    35,    86,     8,     9,    10,    11,    12,
      43,    43,  1319,    19,    20,    30,    79,   218,   142,    22,
      23,    24,    25,    26,    27,    28,    29,     0,  1351,    32,
      15,    16,    17,    18,    19,    93,     3,  1351,   214,    15,
     179,   168,    93,    19,     6,    15,  1156,    17,    18,   114,
     119,   178,   241,    15,    16,    17,    18,    19,    34,    35,
      36,    37,   201,   252,     3,  1372,   242,   321,   159,   160,
     161,   162,   163,   164,   165,    19,     3,   159,   160,   161,
     162,   163,   164,   165,  1296,   811,    15,    49,   179,    15,
      19,   182,   230,    19,    93,    19,   235,   179,   286,    15,
     182,   119,   146,    19,   110,    34,    35,    36,    37,    35,
     119,  1342,   236,   106,   599,   140,   141,   306,   372,   208,
     259,   309,    76,   374,    86,   376,   377,  1237,   379,   380,
      15,    16,    17,    18,    19,   105,    43,    19,     8,     9,
      10,    11,    12,  1298,   538,   268,  1109,   213,   214,   350,
     351,   290,    22,    23,    24,    25,    26,    27,    28,    29,
    1483,   646,    32,     8,     9,    10,    11,    12,   307,  1483,
     233,   310,   311,    83,   286,   287,   364,    22,    23,    24,
      25,    26,    27,    28,    29,    92,    93,    32,  1298,   364,
      97,    15,    16,    17,    18,    19,    83,   159,   160,   161,
     162,   163,   164,   165,   219,   200,   145,   251,   118,    15,
     322,   350,    15,    19,    18,    19,    19,   179,   211,   212,
     182,    15,   215,   216,   575,    19,   566,   158,  1026,   173,
     359,    19,   572,   110,   574,   314,   315,   232,  1348,   116,
      34,    35,    36,    37,   302,  1340,  1401,   305,   363,   589,
     365,   364,   362,   163,   594,    43,   596,   361,   598,    19,
     600,   359,   360,   603,   604,   605,   291,   366,   364,   360,
      79,   398,   612,   364,   360,   615,   363,   404,   364,   360,
     364,   360,   364,   363,   360,   412,   413,   414,   415,   416,
     366,  1401,  1402,    94,   360,   360,   347,   348,   649,   309,
     651,   428,   209,   302,   644,  1161,   305,   317,    19,   363,
     286,   114,   361,    18,    19,   504,   365,   668,   122,   140,
     141,   661,   662,     8,     9,    10,    11,    12,  1348,   360,
     363,   363,    43,    19,    20,   136,   360,    22,    23,    24,
      25,    26,    27,    28,    29,   239,   240,    32,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   712,   365,    19,    20,    19,  1164,  1098,   124,    41,
     361,   364,  1482,   512,   365,   360,   503,   516,   365,  1474,
      74,   368,  1402,   510,   360,   736,    42,    19,    60,     8,
       9,    10,    11,    12,    19,   324,   365,    53,   360,   368,
      94,    95,   364,    22,    23,    24,    25,    26,    27,    28,
      29,   550,    84,    32,   108,   109,   555,   111,   557,   727,
     214,   363,   730,    22,   732,   552,    28,    29,    20,    20,
      32,   360,   571,    32,   360,    89,     8,     9,    10,    11,
      12,   580,   214,   582,   360,   584,  1172,   701,   587,   588,
      22,    23,    24,    25,    26,    27,    28,    29,   249,   250,
      32,   233,  1482,    54,   395,  1191,   397,     3,   399,   400,
     291,    62,    63,    64,   146,   360,   362,    65,   729,   365,
     731,    79,   833,   771,   772,   624,     8,     9,    10,    11,
      12,  1212,   777,    19,    20,   365,   890,   636,   270,   153,
      22,    23,    24,    25,    26,    27,    28,    29,   230,   330,
      32,   221,    15,   853,    17,    18,   361,    43,   657,     3,
     659,   125,    15,   863,   128,     3,    19,   666,    19,     3,
     870,     8,     9,    10,    11,    12,   360,   259,   260,   337,
     338,    34,    35,    36,    37,    22,    23,    24,    25,    26,
      27,    28,    29,   359,   360,    32,   105,   360,   107,    33,
    1281,  1282,  1283,  1284,   336,     3,   360,    41,     3,    15,
      44,     3,    43,    19,   968,    76,   970,   105,    71,   107,
     974,    55,    44,    19,    20,     3,   937,   841,    34,    35,
      36,    37,   364,    15,     3,    89,   735,    19,    99,   100,
     101,    75,   555,   164,   557,    79,     3,    43,    82,     3,
      84,    85,    34,    35,    36,    37,     3,    79,    92,     3,
      82,    92,    93,     3,    86,    87,    97,    89,    90,    91,
       3,   102,   771,   772,    96,   360,   763,    29,   765,     8,
       9,    10,    11,    12,   208,   119,     3,    19,    20,   123,
     857,   145,   360,    22,    23,    24,    25,    26,    27,    28,
      29,   135,    19,    32,   360,   319,   227,   975,   130,   977,
      19,    20,    15,   135,    74,  1026,   364,   365,   332,   333,
     365,   155,  1033,   360,   158,     8,     9,    10,    11,    12,
      18,    19,    20,   360,    43,   834,    58,    59,   259,    22,
      23,    24,    25,    26,    27,    28,    29,   268,    20,    32,
     110,   111,     8,     9,    10,    11,    12,    58,    59,   858,
     859,   860,    38,    39,    40,    82,    22,    23,    24,    25,
      26,    27,    28,    29,   364,   365,    32,   231,   209,   878,
    1080,   880,  1082,   882,    56,    57,   365,   360,  1088,   888,
     360,   151,   152,   153,   154,   217,   218,   364,   365,    13,
       3,    15,    16,    17,    18,    19,    20,     3,   907,    22,
     909,    61,    26,    27,    28,    29,    19,    31,    18,    19,
      20,    68,   142,   276,   133,   134,    73,   364,   365,   928,
     284,   359,   214,   365,   355,   356,   357,   358,  1488,  1489,
    1490,    88,   294,   168,   131,    13,  1200,    15,    16,    17,
      18,    19,    20,  1164,   308,    19,   310,   359,    26,    27,
     105,    29,   316,    31,   318,     3,   191,    19,   322,   323,
     363,  1085,    86,   363,   199,    83,    79,   124,    92,   204,
     205,    84,    85,   365,  1102,  1103,  1104,   213,   214,    92,
     363,   343,   344,   345,   346,    97,  1196,   984,   104,   359,
     987,   988,   989,   359,   991,   363,   993,   360,  1222,  1223,
     364,   998,   359,   230,   408,   409,   119,   363,    86,  1006,
      76,   237,    97,   129,    92,   359,   275,    71,   365,     8,
       9,    10,    11,    12,   148,   149,   142,   127,   224,    71,
     222,    79,   364,    22,    23,    24,    25,    26,    27,    28,
      29,   229,  1051,    32,   360,   158,   233,    92,   249,   253,
     395,   278,   397,   210,   399,   400,   235,   256,   258,   183,
     184,   185,   186,   187,   188,   233,   293,   115,   360,   263,
     148,   149,    90,   220,   122,   359,   200,   363,    82,   203,
     271,    99,   359,   207,   311,   133,   104,   318,   106,  1310,
     108,   269,   110,    79,   112,   363,   114,   363,   325,   326,
     363,  1110,    71,   148,   149,   183,   184,   185,   186,   187,
     188,   359,   363,    71,   359,  1325,   363,   363,   359,    79,
     277,   311,   200,    79,   363,   203,   359,    71,    13,   207,
      15,    16,    17,    18,    19,    20,  1133,   359,    74,    76,
      71,    26,    27,   359,    29,   359,    31,   359,    20,   359,
     359,  1361,  1149,     3,     3,     3,  1153,  1154,   203,  1369,
      19,     3,  1159,   208,     3,     3,     3,  1377,   361,  1379,
    1179,     3,   288,   289,   290,     3,   292,   334,     3,     3,
     120,   120,   339,    14,   208,  1194,  1195,   303,  1197,    15,
      26,    32,  1316,  1351,  1318,   361,  1205,   354,  1257,  1208,
      27,    86,     8,     9,    10,    11,    12,    92,   294,   295,
     296,   297,   298,   299,   300,   301,    22,    23,    24,    25,
      26,    27,    28,    29,  1434,    29,    32,    19,  1438,  1439,
      15,  1228,   365,     7,  1231,     3,   360,  1234,  1235,  1236,
     359,    19,   359,   367,   110,   111,   360,   103,   364,    71,
     359,    71,    49,   119,   359,    13,   359,    15,    16,    17,
      18,    19,    20,   148,   149,   261,  1275,   359,    26,    27,
      28,    29,   138,    31,    30,   359,   122,    71,   144,   359,
     146,   147,   360,    71,  1494,    71,   359,    83,   359,   367,
       7,     8,  1502,    10,    11,   359,   359,    97,   183,   184,
     359,   122,    19,  1300,  1301,    19,  1303,   359,   359,   359,
    1520,  1320,  1321,  1322,  1524,   200,   359,  1527,   203,   359,
     104,   359,   207,  1481,   359,  1483,   359,   359,    86,   359,
     227,     3,     3,    13,    92,    15,    16,    17,    18,    19,
      20,    19,    15,    19,   210,  1342,    26,    27,     3,    29,
      19,    31,    19,    15,    20,  1364,  1365,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    15,   361,    27,  1378,
       7,    15,   361,   365,  1383,  1384,  1385,   365,  1387,    18,
      13,   360,    15,    16,    17,    18,    19,    20,    20,   359,
     148,   149,   359,    26,    27,    28,    29,   359,    31,   363,
      27,    98,   365,    19,   359,   359,    86,   359,   359,  1406,
     359,   277,    92,   359,   359,   122,   359,   134,   135,  1416,
    1417,  1418,  1419,  1432,   359,   183,   184,   359,     3,   359,
     359,  1440,  1441,  1442,   359,  1444,  1445,   359,   359,   359,
     359,  1450,   200,   359,   359,   203,   359,   359,  1457,   207,
     359,   359,   359,    86,   359,   359,   359,  1466,  1467,    92,
     359,   359,   364,   359,   359,     3,   359,   359,   148,   149,
     364,    15,     3,     3,   321,   360,   361,   122,    27,  1488,
    1489,  1490,   367,   365,   122,   359,   361,   365,   354,  1498,
    1499,  1500,   120,   311,   359,   359,   359,   359,   359,  1508,
      20,  1510,   359,   183,   184,   359,   359,   359,   359,     3,
     327,     3,    15,    15,   359,   148,   149,  1526,   361,   359,
     200,   365,    15,   203,   359,    22,    13,   207,    15,    16,
      17,    18,    19,    20,   364,    15,     7,   360,  1535,    26,
      27,    22,    29,   359,    31,     8,     9,    10,    11,    12,
     183,   184,   363,   363,   359,   361,   363,   359,   359,    22,
      23,    24,    25,    26,    27,    28,    29,   200,   363,    32,
     203,   364,   363,    19,   207,   365,     8,     9,    10,    11,
      12,   122,   359,   359,   359,   220,   359,   271,   359,     3,
      22,    23,    24,    25,    26,    27,    28,    29,   363,    86,
      32,     3,   360,   360,    15,    92,   361,   361,   217,   367,
       8,     9,    10,    11,    12,   361,   181,   360,   360,   360,
     360,   359,   359,   214,    22,    23,    24,    25,    26,    27,
      28,    29,   359,   359,    32,     8,     9,    10,    11,    12,
     235,   359,   312,   365,   359,   361,     7,   215,   215,    22,
      23,    24,    25,    26,    27,    28,    29,   215,   364,    32,
     311,   148,   149,   363,   271,    44,   313,   296,   329,   235,
     294,   321,   361,   359,     8,     9,    10,    11,    12,   359,
     360,   312,   359,   306,   359,   359,   239,   367,    22,    23,
      24,    25,    26,    27,    28,    29,   183,   184,    32,   359,
      79,   359,   359,    82,   507,   798,   346,    86,    87,  1027,
      89,    90,    91,   200,  1436,   949,   203,    96,  1098,   365,
     207,     8,     9,    10,    11,    12,  1016,   360,   952,  1161,
     707,   372,   839,  1481,   367,    22,    23,    24,    25,    26,
      27,    28,    29,   524,  1401,    32,     8,     9,    10,    11,
      12,   130,   771,   997,   178,   772,   135,  1483,  1157,  1303,
      22,    23,    24,    25,    26,    27,    28,    29,   777,   984,
      32,     8,     9,    10,    11,    12,  1235,  1032,  1253,  1270,
    1313,   939,    -1,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    -1,    32,     8,     9,    10,    11,
      12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    -1,
      32,     8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    -1,    32,     8,     9,    10,    11,
      12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    -1,
      32,    -1,    -1,   360,    -1,     8,     9,    10,    11,    12,
     367,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,   361,    32,
       8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,
      19,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    -1,    32,    -1,    -1,    -1,    -1,   361,
       8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,
      49,    -1,     5,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    -1,    32,     8,     9,    10,    11,    12,
      -1,    -1,    -1,   361,    -1,    -1,    -1,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    86,    -1,    32,
       8,     9,    10,    11,    12,   364,    -1,    -1,   361,    19,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    -1,    32,     8,     9,    10,    11,    12,
      -1,    -1,    -1,    -1,    77,    78,    -1,    80,    81,    22,
      23,    24,    25,    26,    27,    28,    29,   361,     5,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    44,    -1,    -1,
      -1,    -1,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     159,   160,   161,   162,   163,   164,   165,    -1,    -1,    -1,
      -1,    68,    69,    70,    -1,    72,    73,    -1,    75,    -1,
     179,    -1,    79,   182,   361,    82,   139,    -1,    -1,    86,
      87,    -1,    -1,    90,    91,    -1,    -1,    -1,    -1,    96,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   361,
      77,    78,    -1,    80,    81,   166,   167,   168,   169,   170,
     171,   172,    -1,   174,   175,   176,   177,   178,    -1,    -1,
      -1,    44,    -1,   130,   361,    -1,   189,   190,   135,   192,
     193,   194,   195,   196,   197,   198,   166,   167,   168,   169,
     170,   171,   172,    -1,   174,   175,   176,   177,   178,   361,
      -1,    44,    -1,    -1,    -1,    -1,    79,    -1,    -1,    82,
      -1,    -1,   139,    86,    87,    -1,    -1,    90,    91,    -1,
      -1,    64,    -1,    96,   361,   238,   239,   240,   241,   242,
     243,   244,   245,   246,    -1,    -1,    79,    -1,    -1,    82,
      -1,    -1,    44,    86,    87,    -1,    -1,    90,    91,   361,
      -1,   264,   265,    96,    -1,    -1,    -1,   130,    -1,    -1,
      -1,    -1,   135,    -1,    -1,    -1,   279,   280,   281,   282,
      -1,    -1,    -1,    -1,    -1,    -1,   359,    79,    -1,    -1,
      82,    -1,    -1,    -1,    86,    87,    -1,   130,    90,    91,
      -1,    -1,   135,    -1,    96,    -1,    -1,    -1,    -1,    -1,
      -1,   359,    -1,   146,   363,    -1,    -1,    -1,    -1,    -1,
      -1,   238,   239,   240,   241,   242,   243,   244,   245,   246,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    44,   130,    -1,
      -1,   359,    49,   135,    -1,    -1,    -1,   264,   265,   352,
     353,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     361,    -1,   279,   280,   281,   282,   359,    44,    75,    -1,
      -1,    -1,    79,    -1,    -1,    82,    -1,    -1,    -1,    86,
      87,    88,    -1,    90,    91,     3,    -1,    -1,    65,    96,
      -1,   359,    -1,    -1,   101,    -1,    -1,   104,    -1,   106,
      18,    19,    79,    -1,    -1,    82,    -1,    -1,    -1,    86,
      87,    -1,    89,    90,    91,   278,   359,   364,    -1,    96,
     283,   284,   285,   130,    -1,    43,    -1,   104,   135,    -1,
      -1,    -1,    -1,   266,    -1,   352,   353,    44,    -1,   146,
      -1,   148,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     157,   128,   129,   130,    -1,    -1,    -1,   320,   135,    -1,
      -1,    79,    -1,    70,    64,    -1,    84,    -1,   331,    -1,
      -1,    -1,    79,    91,    92,    82,    -1,    -1,    -1,    86,
      87,    -1,    -1,    90,    91,   103,   193,    -1,    -1,    96,
      -1,    -1,    -1,    -1,   112,   113,   114,   115,    -1,   117,
      -1,   364,    -1,   210,   104,   112,    -1,    -1,    -1,    -1,
     217,   218,    -1,   220,    -1,   222,   223,    -1,   225,   226,
      -1,   228,    -1,   130,   231,   232,    -1,   234,   135,   129,
      -1,   364,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     247,   248,   142,   335,   336,   252,    -1,   254,   255,    -1,
     257,    -1,    -1,   153,    -1,   262,    -1,    -1,    -1,   266,
     267,    -1,   269,   270,    -1,   272,   273,   274,    -1,    -1,
      -1,    -1,   364,    -1,    -1,    -1,    -1,    -1,     8,     9,
      10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   209,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    -1,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     210,    -1,    -1,   213,   214,    -1,    -1,    -1,    44,    -1,
      -1,    -1,    -1,     3,    -1,    -1,   303,    -1,     8,     9,
      10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      66,    67,    22,    23,    24,    25,    26,    27,    28,    29,
      76,    -1,    32,    -1,    -1,    -1,    -1,   364,    -1,    -1,
      -1,    -1,    -1,   340,   341,   342,    -1,    -1,    -1,    -1,
     270,    -1,   349,   273,    -1,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   284,    -1,   286,   364,   288,   289,
     290,   291,   292,   293,    -1,   121,    -1,    -1,    -1,   299,
      -1,    -1,    -1,   303,   304,    -1,   132,   307,    -1,   135,
      -1,   137,    -1,    -1,    -1,    -1,    -1,   143,    -1,    -1,
     320,    -1,   148,   149,   150,     8,     9,    10,   328,   155,
     156,   157,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    -1,    32,
     180,     8,     9,    10,    11,    12,    -1,   364,    -1,    -1,
      -1,    -1,    -1,    -1,   364,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    -1,    32,     8,     9,    10,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    -1,
      32,   166,   167,   168,   169,   170,   171,   172,    -1,   174,
     175,   176,   177,   178
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,     4,   370,   371,    44,    66,    67,    76,   101,   121,
     132,   135,   137,   143,   148,   149,   150,   155,   156,   157,
     394,   395,   396,   397,   398,   399,   450,   451,   452,   453,
     455,   456,   457,   460,   463,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   556,   592,   593,   594,
     595,   596,   597,   598,   599,   618,   620,     0,     3,    33,
      41,    44,    55,    75,    79,    82,    84,    85,    92,   119,
     123,   135,   155,   158,   359,   372,   384,   390,   393,   402,
     404,   407,   409,   412,   414,   415,   417,   418,   425,   435,
     436,   491,   493,   503,   542,   545,   557,   558,   559,   560,
     601,   602,   603,   604,   612,   613,   619,   621,   622,   623,
      19,    20,    43,   489,    20,    54,    62,    63,    64,   400,
       3,   489,   489,   119,   133,   134,   489,   489,     3,   110,
     111,   119,   138,   144,   146,   147,   210,   277,   354,   119,
     119,    74,   110,   111,   151,   152,   153,   154,    13,    15,
      16,    17,    18,    19,    20,    26,    27,    29,    31,    86,
      92,   148,   149,   183,   184,   200,   203,   207,   360,   367,
     508,   521,   526,   529,   530,   531,   533,   535,    35,    43,
     363,   478,   489,    19,    19,    20,    42,    53,   382,   386,
     110,   116,    41,    60,    84,   146,   391,   392,    76,    19,
      83,    19,    79,   124,   110,   382,   535,    19,    19,   419,
     419,   363,    68,    73,    88,   124,   210,   277,   334,   339,
     354,   419,    44,    79,    82,    86,    87,    89,    90,    91,
      96,   130,   135,   364,   420,   438,   419,   419,    49,    75,
      88,   101,   104,   106,   146,   148,   157,   193,   210,   217,
     218,   220,   222,   223,   225,   226,   228,   231,   232,   234,
     247,   248,   252,   254,   255,   257,   262,   266,   267,   269,
     270,   272,   273,   274,   364,   420,   419,   278,   283,   284,
     285,   320,   331,   364,   420,   561,   562,   563,   419,   335,
     336,   364,   420,   419,    65,    89,   104,   128,   129,   303,
     340,   341,   342,   349,   364,   420,   445,   447,   448,   419,
      64,   146,   266,   364,   420,   614,   617,    68,    69,    70,
      72,    73,    75,   364,   403,   406,   420,    70,   112,   364,
     405,   420,    35,    43,   363,   439,   400,     3,     3,   400,
      65,   401,     3,     3,    79,   465,   489,   489,     3,    35,
      43,   363,   442,    19,    20,    43,   490,     3,   145,   461,
       3,     3,   458,   464,   221,    19,    89,   153,   319,   332,
     333,   454,   454,    18,    19,   376,   378,   378,     3,     3,
       3,     3,     3,     3,     3,    15,    19,    28,   360,   366,
     525,   527,   533,    29,   360,   208,    27,   208,    15,   366,
     528,   535,   360,   360,   360,   360,   360,   360,   185,   186,
     187,   188,   515,   535,    15,    16,    17,    19,   360,   373,
     508,   509,   513,   516,   517,   519,   521,   522,   523,     5,
      77,    78,    80,    81,   105,   139,   189,   190,   192,   193,
     194,   195,   196,   197,   198,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   264,   265,   279,   280,   281,   282,
     352,   353,   534,   624,     3,     8,     9,    10,    11,    12,
      22,    23,    24,    25,    26,    27,    28,    29,    32,    44,
      45,    46,    47,    48,    49,    50,    51,    52,   388,   389,
      15,   479,     3,    22,    61,   385,    43,   363,   387,   439,
     360,   373,    20,    56,    57,   359,   142,   131,   413,    15,
      17,    18,   105,   408,   492,    19,   410,   442,   359,   504,
     105,   363,   363,   416,   363,   439,    19,   424,    83,   373,
      34,    35,    36,    37,   373,   375,   437,    43,    92,    93,
      97,   102,   209,   421,   500,    97,   421,    97,   382,   442,
     359,   359,   363,   363,   142,   236,    76,   359,   237,   382,
     375,    97,   275,   146,   251,   127,   375,   359,   373,   376,
     122,   376,    71,   224,    71,   222,   229,   239,   240,   233,
     235,   249,   250,   249,   253,   375,   256,   258,   263,    79,
     233,    88,   268,   233,   271,   269,   375,   220,   359,   363,
     408,   375,    82,   373,   375,   318,   359,   363,   363,    79,
     337,   338,   359,   363,    71,   610,   611,   382,   373,   363,
      93,   347,   348,   605,   373,   373,    71,   218,   350,   351,
     359,   359,   363,   363,   311,   378,    79,   359,   164,   227,
     259,   268,   355,   356,   357,   358,   359,    79,   375,    71,
     375,    74,    76,   359,   359,   359,    71,    20,   383,   359,
     359,    74,    94,    95,   108,   109,   111,   440,   441,     3,
     401,     3,   373,     3,    19,     3,     3,     3,    94,   136,
     443,   444,     3,   490,     3,     3,     3,    79,   115,   122,
     133,   462,     3,    43,    79,    84,    91,    92,   103,   112,
     113,   114,   115,   117,   378,   459,   500,     3,    19,    79,
      84,    85,    92,   119,   158,   454,   454,   454,   600,    43,
     454,    43,   454,     3,     3,    29,   362,   380,   120,   120,
     527,   527,   535,   527,   527,    14,    15,   535,   539,   540,
      26,   208,    27,   528,   528,    29,   535,   535,   535,   535,
     535,    19,    15,   365,   361,   365,    28,   511,   512,   515,
     535,     7,   365,   368,    26,    27,   363,   365,   368,   535,
     535,   535,   535,   535,   535,   535,   535,   535,   535,   535,
     535,   535,   168,   191,   199,   204,   205,   364,   365,     3,
     535,   382,   388,   359,   535,   373,    58,    59,    58,    59,
     373,   432,   433,   359,   166,   167,   168,   169,   170,   171,
     172,   174,   175,   176,   177,   178,   494,   495,   496,   498,
     502,   125,   126,   127,   128,   359,   411,   359,   360,   501,
      19,   119,   364,   408,   426,   429,   430,    19,   498,   499,
      35,   373,   423,   103,   535,   423,   423,   544,    71,    71,
      71,   276,   375,    49,   359,   359,   373,   213,   214,   375,
     261,   375,   376,   359,   359,    30,   377,   373,   122,   373,
      71,   373,    71,   102,   230,   373,   373,   375,    71,   359,
      83,   359,   375,   359,   375,   230,   259,   260,   375,   424,
     375,   359,   359,   375,   375,   375,   359,   122,   375,    97,
     375,   564,    19,   359,   359,   373,   430,   359,   359,   446,
     447,   359,   359,   359,   373,   359,   359,   359,    83,   118,
     163,   449,   375,   424,    20,   376,   376,   227,   615,   616,
     373,   373,   375,   375,   373,   376,   378,   379,   364,   365,
       3,   364,   365,     3,    19,    15,   378,    19,    19,   499,
     379,    19,     3,    20,   591,   591,     3,    19,    82,   230,
     278,   293,   311,   325,   326,   454,   591,   454,   591,   373,
     376,    15,    15,   361,   365,   361,    27,   365,   365,   365,
     361,   365,   361,   365,   535,   535,     7,   365,   365,   361,
      18,   509,   517,    15,    18,   522,   360,   389,   359,   364,
      20,   359,   430,   359,    19,   173,   359,   363,   376,   373,
     361,   495,   497,   502,   378,    27,   428,   365,    98,   422,
     375,    89,   217,   218,   364,   420,   543,   373,   373,   373,
     359,   359,   375,   359,   359,   359,   359,   375,   359,   359,
      19,   122,   359,   373,   359,   373,   359,   373,   359,   359,
     359,   359,   359,   373,   408,   359,   359,   359,   359,   359,
     359,   359,   359,   359,   359,   359,   359,   373,   373,    89,
     145,   231,   284,   308,   310,   316,   318,   322,   323,   364,
     565,   572,   575,   359,   359,   363,   609,   364,   359,   359,
     373,   105,   107,   105,   107,   364,   359,   359,   377,   376,
     321,   615,   441,   444,     3,     3,   408,   408,    15,   408,
     591,     3,   591,     3,   122,   122,   539,    27,   535,   535,
     535,   535,   535,   365,   361,   511,   535,   512,   514,   535,
     365,   535,   496,    19,    49,    86,   159,   160,   161,   162,
     163,   164,   165,   179,   182,   505,   506,   531,   532,   536,
     541,   359,   361,   120,    20,   379,   427,   429,    76,    99,
     100,   101,   546,   550,   546,   551,   376,   555,   359,   365,
     359,   359,   359,   359,   373,   359,   359,   359,   359,   359,
     359,   584,   590,   375,   286,   287,   322,   286,   375,   566,
     311,   378,   568,   569,   567,   324,   375,   359,   327,   585,
     608,   446,   359,    20,   381,   381,   381,   381,   377,   373,
       3,     3,    15,    15,   361,   361,   361,   361,   365,   535,
     361,   365,    15,   361,    22,   360,    22,   360,   535,   535,
     535,   364,   541,   534,   624,   359,   535,   537,   538,   497,
      15,   379,   430,   431,   363,   549,    30,   219,   552,   373,
     359,   430,   586,   373,   373,   375,   373,   363,   408,   363,
     363,   373,   373,   363,   214,   233,   270,   336,   364,   607,
     449,   359,   359,   359,   359,   465,   465,   535,   361,     7,
      28,   514,   364,   535,   540,   535,   531,   359,   180,   363,
      22,    22,    32,   365,   359,   122,   549,   548,    19,   382,
     220,   553,   359,   587,   363,   589,   577,   570,   577,   573,
     140,   141,   291,   434,   373,   271,   294,   343,   344,   345,
     346,   606,   359,   449,   449,   449,   449,     3,     3,   361,
     360,   361,     7,   361,   359,   361,   359,   624,   363,   507,
     541,   524,   535,   535,    92,   148,   149,   203,   208,   538,
      15,   106,   211,   212,   215,   216,   364,   547,   376,   217,
     554,   585,   588,   364,   378,   578,   579,   145,   286,   309,
     364,   571,   364,   142,   288,   289,   290,   292,   303,   364,
     445,   574,   373,   373,   373,   214,   375,   511,   514,   361,
     505,   181,     6,    15,    16,    17,   360,   364,   508,   510,
     513,   516,   518,   520,   359,   359,   360,   360,   360,   360,
     359,   359,   375,   213,   214,   214,   373,   374,   373,   359,
     375,    64,   142,   153,   210,   213,   214,   270,   273,   284,
     286,   288,   289,   290,   291,   292,   293,   299,   303,   304,
     307,   320,   328,   364,   445,   576,   309,   317,   580,   375,
     373,   375,   359,   373,   373,   373,   235,   114,   373,    93,
     302,   305,   359,   312,   365,   361,   359,   364,   507,   505,
     535,     7,   362,   365,   535,   535,   535,   535,   215,   215,
     215,    38,    39,    40,   311,   373,   363,   375,   313,   291,
     330,   434,   271,   375,   375,   373,   373,   373,   235,   373,
     114,   373,   294,   295,   296,   297,   298,   299,   300,   301,
     329,    93,   302,   305,   296,   373,   321,   294,   359,   373,
     359,   373,   373,   511,   361,   360,   510,   505,   518,   361,
     361,   361,   361,   374,   374,   374,   375,   581,   314,   315,
     373,   373,   373,   214,   375,   373,   373,   375,   375,   373,
     375,   361,   535,   359,   359,   359,   359,    18,   364,   583,
     312,   306,   582,   359
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   369,   370,   370,   371,   371,   372,   373,   373,   373,
     374,   374,   374,   375,   375,   375,   375,   375,   375,   376,
     376,   377,   377,   378,   379,   379,   380,   380,   381,   382,
     382,   383,   383,   384,   385,   385,   386,   386,   386,   387,
     387,   388,   388,   389,   389,   389,   389,   389,   389,   389,
     389,   389,   390,   390,   391,   391,   391,   391,   392,   392,
     392,   392,   392,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   400,   401,   401,   401,   402,   403,   403,   403,
     403,   403,   404,   405,   405,   406,   407,   407,   408,   408,
     408,   409,   410,   410,   411,   411,   411,   411,   412,   413,
     413,   414,   415,   416,   416,   417,   417,   418,   418,   419,
     419,   419,   420,   420,   420,   420,   420,   420,   420,   420,
     420,   420,   420,   420,   420,   420,   421,   421,   421,   421,
     422,   422,   422,   422,   422,   423,   423,   424,   425,   425,
     426,   427,   427,   427,   428,   428,   429,   430,   430,   431,
     432,   433,   434,   434,   435,   436,   436,   436,   437,   438,
     439,   439,   439,   440,   440,   441,   441,   441,   441,   441,
     441,   442,   442,   442,   443,   443,   444,   444,   445,   445,
     446,   446,   447,   447,   448,   449,   449,   449,   449,   449,
     449,   450,   451,   452,   453,   454,   454,   455,   456,   457,
     458,   458,   458,   458,   458,   458,   458,   458,   458,   458,
     458,   458,   458,   459,   459,   460,   461,   461,   461,   461,
     462,   462,   462,   463,   464,   464,   464,   464,   464,   464,
     464,   464,   465,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   478,   478,   479,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   489,   489,   490,   490,   490,   492,   491,   493,   494,
     494,   494,   494,   494,   494,   494,   494,   494,   494,   494,
     494,   494,   495,   496,   496,   497,   497,   498,   499,   499,
     500,   501,   501,   502,   504,   503,   505,   505,   506,   506,
     507,   507,   508,   509,   509,   509,   509,   510,   510,   510,
     510,   510,   511,   512,   512,   512,   513,   513,   514,   515,
     515,   515,   515,   516,   516,   516,   517,   517,   517,   517,
     518,   518,   518,   518,   519,   519,   520,   520,   521,   522,
     522,   522,   522,   523,   523,   524,   524,   524,   525,   525,
     526,   526,   527,   527,   527,   527,   527,   528,   528,   528,
     529,   529,   529,   529,   529,   529,   529,   529,   529,   529,
     529,   530,   530,   531,   532,   533,   534,   534,   534,   534,
     534,   534,   534,   534,   534,   534,   535,   535,   535,   535,
     535,   535,   535,   535,   535,   535,   535,   535,   535,   535,
     535,   535,   535,   535,   535,   535,   535,   535,   535,   535,
     535,   535,   535,   535,   535,   535,   535,   535,   535,   535,
     535,   535,   535,   536,   536,   536,   536,   536,   536,   537,
     538,   538,   538,   539,   539,   540,   540,   541,   541,   541,
     541,   541,   541,   541,   541,   541,   541,   541,   541,   541,
     541,   541,   541,   542,   543,   543,   543,   543,   544,   544,
     545,   546,   547,   547,   547,   547,   547,   547,   548,   548,
     549,   549,   550,   551,   552,   552,   552,   553,   553,   554,
     554,   555,   556,   557,   558,   558,   558,   558,   558,   558,
     558,   558,   558,   558,   558,   558,   558,   558,   558,   558,
     558,   558,   558,   558,   558,   558,   558,   558,   558,   558,
     558,   558,   558,   558,   558,   558,   558,   558,   558,   558,
     558,   558,   558,   558,   558,   558,   558,   558,   558,   558,
     558,   558,   558,   558,   558,   558,   558,   558,   559,   560,
     560,   561,   561,   561,   561,   561,   561,   561,   561,   562,
     563,   564,   564,   565,   565,   565,   565,   565,   565,   565,
     565,   565,   566,   565,   567,   565,   565,   565,   565,   568,
     568,   569,   570,   570,   571,   571,   571,   572,   572,   573,
     573,   574,   574,   574,   574,   574,   574,   574,   574,   574,
     574,   574,   575,   576,   576,   576,   576,   576,   576,   576,
     576,   576,   576,   576,   576,   576,   576,   576,   576,   576,
     576,   576,   576,   576,   576,   576,   576,   576,   576,   576,
     576,   576,   576,   576,   576,   576,   576,   576,   576,   576,
     576,   577,   577,   578,   579,   580,   580,   580,   581,   581,
     582,   582,   583,   584,   585,   585,   587,   586,   588,   588,
     589,   589,   590,   591,   591,   592,   593,   594,   595,   596,
     597,   598,   599,   600,   600,   600,   600,   600,   600,   600,
     600,   600,   601,   602,   602,   602,   602,   602,   603,   604,
     604,   604,   604,   604,   604,   604,   604,   604,   604,   604,
     604,   604,   605,   605,   605,   606,   606,   606,   606,   606,
     607,   607,   607,   607,   607,   607,   607,   608,   608,   609,
     609,   610,   611,   612,   613,   613,   613,   613,   613,   614,
     615,   615,   616,   616,   617,   617,   617,   617,   617,   617,
     617,   617,   617,   618,   619,   619,   619,   619,   619,   619,
     619,   619,   619,   619,   619,   619,   619,   619,   619,   620,
     620,   620,   620,   620,   620,   620,   620,   620,   620,   620,
     620,   620,   620,   620,   620,   620,   620,   620,   620,   620,
     620,   620,   620,   620,   620,   620,   620,   620,   620,   620,
     620,   620,   620,   620,   620,   620,   620,   620,   620,   620,
     620,   620,   620,   620,   620,   621,   621,   621,   621,   621,
     621,   621,   621,   621,   622,   622,   622,   622,   623,   623,
     623,   624,   624,   624,   624,   624,   624,   624,   624,   624,
     624,   624,   624,   624,   624,   624,   624,   624,   624,   624,
     624,   624,   624,   624
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     2,     2,     0,     2,     5,     1,     3,     1,
       2,     2,     2,     1,     1,     1,     1,     1,     0,     1,
       1,     0,     2,     2,     1,     1,     2,     2,     1,     1,
       1,     1,     0,     4,     2,     0,     1,     2,     1,     1,
       3,     1,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     4,     3,     1,     1,     1,     1,     2,     4,
       3,     3,     3,     3,     3,     4,     5,     3,     3,     4,
       2,     0,     1,     0,     1,     2,     2,     2,     3,     2,
       3,     3,     2,     3,     3,     3,     4,     5,     1,     1,
       1,     4,     0,     2,     2,     2,     1,     1,     5,     0,
       1,     3,     3,     0,     8,     1,     4,     1,     1,     0,
       1,     3,     0,     2,     2,     2,     2,     2,     2,     3,
       3,     3,     4,     2,     3,     2,     2,     1,     1,     1,
       0,     2,     2,     2,     2,     2,     1,     1,     3,     3,
       0,     1,     1,     2,     0,     1,     3,     1,     3,     1,
       0,     2,     2,     2,     2,     3,     3,     3,     0,     3,
       1,     1,     3,     1,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     3,     1,     3,     1,     1,     4,     1,
       0,     3,     4,     1,     2,     0,     5,     5,     5,     5,
       4,     3,     3,     4,     5,     1,     0,     3,     4,     4,
       0,     2,     3,     3,     3,     2,     2,     2,     2,     3,
       3,     2,     2,     1,     1,     4,     0,     3,     3,     3,
       0,     1,     1,     4,     0,     2,     2,     2,     2,     2,
       2,     2,     0,     2,     9,     9,     4,     3,     3,     3,
       3,     3,     3,     3,     3,     4,     1,     1,     3,     0,
       1,     3,     3,     3,     3,     4,     4,     4,     4,     2,
       1,     1,     1,     1,     0,     1,     0,     4,     2,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     2,     0,     3,     1,     3,     1,     1,     1,
       2,     3,     2,     4,     0,     5,     0,     1,     1,     2,
       1,     3,     1,     1,     1,     1,     1,     1,     3,     1,
       1,     1,     1,     1,     3,     1,     5,    11,     1,     1,
       1,     2,     1,     7,     9,     7,     1,     1,     1,     3,
       1,     1,     1,     3,     1,     3,     1,     3,     3,     1,
       2,     2,     6,     1,     3,     0,     4,     3,     1,     3,
       3,     3,     2,     2,     2,     2,     0,     2,     2,     0,
       1,     1,     1,     1,     1,     1,     1,     3,     3,     1,
       1,     5,     7,     0,     4,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       2,     4,     1,     1,     1,     1,     2,     2,     3,     3,
       6,     3,     3,     3,     3,     5,     6,     6,     6,     6,
       4,     8,     4,     1,     1,     1,     1,     1,     1,     1,
       0,     1,     3,     1,     3,     0,     1,     4,     6,     4,
       3,     5,     5,     4,     6,     3,     2,     5,     5,     8,
       8,     8,     8,     2,     1,     2,     2,     2,     0,     3,
       5,     0,     2,     4,     4,     4,     2,     2,     0,     3,
       0,     3,     3,     2,     0,     2,     2,     0,     2,     0,
       2,     4,     5,     2,     3,     3,     5,     6,     7,     6,
       4,     4,     5,     6,     6,     5,     3,     3,     4,     5,
       5,     5,     5,     5,     4,     4,     5,     5,     5,     5,
       5,     5,     5,     5,     6,     6,     8,     6,     6,     5,
       4,     5,     4,     5,     4,     5,     4,     5,     5,     5,
       5,     6,     5,     5,     6,     5,     5,     4,     2,     3,
       3,     1,     2,     3,     2,     4,     3,     2,     1,     2,
       4,     0,     3,     2,     1,     2,     3,     3,     3,     3,
       2,     3,     0,     5,     0,     5,     2,     2,     1,     4,
       1,     1,     0,     3,     2,     2,     2,     5,     2,     0,
       3,     0,     2,     2,     3,     2,     2,     3,     2,     2,
       2,     1,     3,     2,     2,     2,     2,     2,     2,     3,
       2,     2,     2,     2,     2,     2,     2,     2,     3,     3,
       3,     2,     3,     2,     3,     3,     4,     2,     2,     2,
       3,     3,     3,     2,     3,     3,     3,     4,     2,     2,
       1,     0,     2,     3,     1,     0,     1,     2,     0,     2,
       0,     1,     3,     0,     0,     2,     0,     3,     0,     3,
       0,     3,     3,     1,     0,     4,     6,     6,     6,     7,
       6,     7,     5,     0,     2,     3,     2,     3,     3,     2,
       3,     2,     2,     3,     3,     5,     4,     4,     2,     3,
       3,     4,     4,     4,     5,     5,     4,     3,     4,     4,
       4,     4,     1,     1,     1,     1,     1,     1,     1,     1,
       0,     2,     2,     2,     3,     3,     4,     0,     3,     0,
       3,     0,     3,     2,     3,     3,     5,     5,     3,     2,
       3,     3,     1,     2,     4,     3,     3,     3,     2,     2,
       2,     2,     2,     4,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     2,     2,     2,     1,     2,
       2,     2,     2,     2,     3,     3,     3,     3,     3,     3,
       3,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 697 "cf-parse.y" /* yacc.c:1646  */
    { return 0; }
#line 3573 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 3:
#line 698 "cf-parse.y" /* yacc.c:1646  */
    { return 0; }
#line 3579 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 6:
#line 711 "cf-parse.y" /* yacc.c:1646  */
    {
     struct f_val *val = cfg_alloc(sizeof(struct f_val));
     *val = f_eval((yyvsp[-1].x), cfg_mem);
     if (val->type == T_RETURN) cf_error("Runtime error");
     cf_define_symbol((yyvsp[-3].s), SYM_CONSTANT | val->type, val);
   }
#line 3590 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 8:
#line 721 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = f_eval_int((yyvsp[-1].x)); }
#line 3596 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 9:
#line 722 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != (SYM_CONSTANT | T_INT)) cf_error("Number expected");
     (yyval.i) = SYM_VAL((yyvsp[0].s)).i; }
#line 3604 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 10:
#line 729 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = (u32) (yyvsp[-1].i) * 1000000; }
#line 3610 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 11:
#line 730 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = (u32) (yyvsp[-1].i) * 1000; }
#line 3616 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 12:
#line 731 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = (u32) (yyvsp[-1].i) * 1; }
#line 3622 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 13:
#line 739 "cf-parse.y" /* yacc.c:1646  */
    {(yyval.i) = !!(yyvsp[0].i); }
#line 3628 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 14:
#line 740 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 3634 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 15:
#line 741 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 3640 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 16:
#line 742 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 3646 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 17:
#line 743 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 3652 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 18:
#line 744 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 3658 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 20:
#line 751 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != (SYM_CONSTANT | T_IP)) cf_error("IP address expected");
     (yyval.a) = SYM_VAL((yyvsp[0].s)).px.ip;
   }
#line 3667 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 21:
#line 758 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.iface) = NULL; }
#line 3673 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 22:
#line 759 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.iface) = if_get_by_name((yyvsp[0].s)->name); }
#line 3679 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 23:
#line 763 "cf-parse.y" /* yacc.c:1646  */
    {
     if (!ip_is_prefix((yyvsp[-1].a), (yyvsp[0].i))) cf_error("Invalid prefix");
     (yyval.px).addr = (yyvsp[-1].a); (yyval.px).len = (yyvsp[0].i);
   }
#line 3688 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 25:
#line 771 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.px).addr = (yyvsp[0].a); (yyval.px).len = BITS_PER_IP_ADDRESS; }
#line 3694 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 26:
#line 775 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].i) < 0 || (yyvsp[0].i) > BITS_PER_IP_ADDRESS) cf_error("Invalid prefix length %d", (yyvsp[0].i));
     (yyval.i) = (yyvsp[0].i);
   }
#line 3703 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 27:
#line 779 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.i) = ipa_mklen((yyvsp[0].a));
     if ((yyval.i) < 0) cf_error("Invalid netmask %I", (yyvsp[0].a));
   }
#line 3712 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 28:
#line 786 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.time) = tm_parse_datetime((yyvsp[0].t));
     if (!(yyval.time))
       cf_error("Invalid date and time");
   }
#line 3722 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 30:
#line 795 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != (SYM_CONSTANT | T_STRING)) cf_error("String expected");
     (yyval.t) = SYM_VAL((yyvsp[0].s)).s;
   }
#line 3731 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 31:
#line 802 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = (yyvsp[0].t); }
#line 3737 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 32:
#line 803 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = NULL; }
#line 3743 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 33:
#line 809 "cf-parse.y" /* yacc.c:1646  */
    {
    struct log_config *c = cfg_allocz(sizeof(struct log_config));
    c->fh = (yyvsp[-2].g);
    c->mask = (yyvsp[-1].i);
    add_tail(&new_config->logfiles, &c->n);
  }
#line 3754 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 34:
#line 818 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = (yyvsp[0].t); }
#line 3760 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 35:
#line 819 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = bird_name; }
#line 3766 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 36:
#line 823 "cf-parse.y" /* yacc.c:1646  */
    {
     FILE *f = tracked_fopen(new_config->pool, (yyvsp[0].t), "a");
     if (!f) cf_error("Unable to open log file `%s': %m", (yyvsp[0].t));
     (yyval.g) = f;
   }
#line 3776 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 37:
#line 828 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.g) = NULL; new_config->syslog_name = (yyvsp[0].t); }
#line 3782 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 38:
#line 829 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.g) = stderr; }
#line 3788 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 39:
#line 833 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ~0; }
#line 3794 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 40:
#line 834 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-1].i); }
#line 3800 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 41:
#line 838 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1 << (yyvsp[0].i); }
#line 3806 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 42:
#line 839 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-2].i) | (1 << (yyvsp[0].i)); }
#line 3812 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 43:
#line 843 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_DEBUG[0]; }
#line 3818 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 44:
#line 844 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_TRACE[0]; }
#line 3824 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 45:
#line 845 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_INFO[0]; }
#line 3830 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 46:
#line 846 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_REMOTE[0]; }
#line 3836 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 47:
#line 847 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_WARN[0]; }
#line 3842 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 48:
#line 848 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_ERR[0]; }
#line 3848 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 49:
#line 849 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_AUTH[0]; }
#line 3854 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 50:
#line 850 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_FATAL[0]; }
#line 3860 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 51:
#line 851 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_BUG[0]; }
#line 3866 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 52:
#line 857 "cf-parse.y" /* yacc.c:1646  */
    { new_config->proto_default_mrtdump = (yyvsp[-1].i); }
#line 3872 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 53:
#line 858 "cf-parse.y" /* yacc.c:1646  */
    {
     FILE *f = tracked_fopen(new_config->pool, (yyvsp[-1].t), "a");
     if (!f) cf_error("Unable to open MRTDump file '%s': %m", (yyvsp[-1].t));
     new_config->mrtdump_file = fileno(f);
   }
#line 3882 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 54:
#line 867 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.tf) = &new_config->tf_route; }
#line 3888 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 55:
#line 868 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.tf) = &new_config->tf_proto; }
#line 3894 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 56:
#line 869 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.tf) = &new_config->tf_base; }
#line 3900 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 57:
#line 870 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.tf) = &new_config->tf_log; }
#line 3906 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 58:
#line 873 "cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-1].tf) = (struct timeformat){(yyvsp[0].t), NULL, 0}; }
#line 3912 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 59:
#line 874 "cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-3].tf) = (struct timeformat){(yyvsp[-2].t), (yyvsp[0].t), (yyvsp[-1].i)}; }
#line 3918 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 60:
#line 875 "cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-2].tf) = (struct timeformat){"%T", "%F", 20*3600}; }
#line 3924 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 61:
#line 876 "cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-2].tf) = (struct timeformat){"%F %T", NULL, 0}; }
#line 3930 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 62:
#line 877 "cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-2].tf) = (struct timeformat){NULL, NULL, 0}; }
#line 3936 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 63:
#line 878 "cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-2].tf) = (struct timeformat){"%d-%m-%Y %T", NULL, 0}; }
#line 3942 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 65:
#line 890 "cf-parse.y" /* yacc.c:1646  */
    { cmd_reconfig((yyvsp[-2].t), RECONFIG_HARD, (yyvsp[-1].i)); }
#line 3948 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 66:
#line 893 "cf-parse.y" /* yacc.c:1646  */
    { cmd_reconfig((yyvsp[-2].t), RECONFIG_SOFT, (yyvsp[-1].i)); }
#line 3954 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 67:
#line 900 "cf-parse.y" /* yacc.c:1646  */
    { cmd_reconfig_confirm(); }
#line 3960 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 68:
#line 903 "cf-parse.y" /* yacc.c:1646  */
    { cmd_reconfig_undo(); }
#line 3966 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 69:
#line 906 "cf-parse.y" /* yacc.c:1646  */
    { cmd_check_config((yyvsp[-1].t)); }
#line 3972 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 70:
#line 909 "cf-parse.y" /* yacc.c:1646  */
    { cmd_shutdown(); }
#line 3978 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 71:
#line 912 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = NULL; }
#line 3984 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 73:
#line 917 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 3990 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 74:
#line 918 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = UNIX_DEFAULT_CONFIGURE_TIMEOUT; }
#line 3996 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 75:
#line 919 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i); }
#line 4002 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 76:
#line 927 "cf-parse.y" /* yacc.c:1646  */
    { this_proto = krt_init_config((yyvsp[-1].i)); }
#line 4008 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 77:
#line 932 "cf-parse.y" /* yacc.c:1646  */
    { THIS_KRT->persist = (yyvsp[0].i); }
#line 4014 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 78:
#line 933 "cf-parse.y" /* yacc.c:1646  */
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KRT->scan_time = (yyvsp[0].i);
   }
#line 4023 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 79:
#line 937 "cf-parse.y" /* yacc.c:1646  */
    {
      THIS_KRT->learn = (yyvsp[0].i);
#ifndef KRT_ALLOW_LEARN
      if ((yyvsp[0].i))
	cf_error("Learning of kernel routes not supported in this configuration");
#endif
   }
#line 4035 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 80:
#line 944 "cf-parse.y" /* yacc.c:1646  */
    { THIS_KRT->devroutes = (yyvsp[0].i); }
#line 4041 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 81:
#line 945 "cf-parse.y" /* yacc.c:1646  */
    { THIS_KRT->graceful_restart = (yyvsp[0].i); }
#line 4047 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 82:
#line 951 "cf-parse.y" /* yacc.c:1646  */
    { this_proto = kif_init_config((yyvsp[-1].i)); }
#line 4053 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 83:
#line 956 "cf-parse.y" /* yacc.c:1646  */
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KIF->scan_time = (yyvsp[0].i);
   }
#line 4062 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 84:
#line 960 "cf-parse.y" /* yacc.c:1646  */
    {
     struct kif_primary_item *kpi = cfg_alloc(sizeof (struct kif_primary_item));
     kpi->pattern = (yyvsp[-1].t);
     kpi->prefix = (yyvsp[0].px).addr;
     kpi->pxlen = (yyvsp[0].px).len;
     add_tail(&THIS_KIF->primary, &kpi->n);
   }
#line 4074 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 85:
#line 974 "cf-parse.y" /* yacc.c:1646  */
    {
	if ((yyvsp[0].i) <= 0 || (yyvsp[0].i) >= NL_NUM_TABLES)
	  cf_error("Kernel routing table number out of range");
	THIS_KRT->sys.table_id = (yyvsp[0].i);
   }
#line 4084 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 86:
#line 988 "cf-parse.y" /* yacc.c:1646  */
    { new_config->router_id = (yyvsp[-1].i32); }
#line 4090 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 87:
#line 989 "cf-parse.y" /* yacc.c:1646  */
    { new_config->router_id_from = this_ipatt; }
#line 4096 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 88:
#line 993 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = (yyvsp[0].i); }
#line 4102 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 90:
#line 995 "cf-parse.y" /* yacc.c:1646  */
    {
#ifndef IPV6
     (yyval.i32) = ipa_to_u32((yyvsp[0].a));
#else
     cf_error("Router IDs must be entered as hexadecimal numbers or IPv4 addresses in IPv6 version");
#endif
   }
#line 4114 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 94:
#line 1014 "cf-parse.y" /* yacc.c:1646  */
    { new_config->listen_bgp_addr = (yyvsp[0].a); }
#line 4120 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 95:
#line 1015 "cf-parse.y" /* yacc.c:1646  */
    { new_config->listen_bgp_port = (yyvsp[0].i); }
#line 4126 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 96:
#line 1016 "cf-parse.y" /* yacc.c:1646  */
    { new_config->listen_bgp_flags = 0; }
#line 4132 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 97:
#line 1017 "cf-parse.y" /* yacc.c:1646  */
    { new_config->listen_bgp_flags = 1; }
#line 4138 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 98:
#line 1022 "cf-parse.y" /* yacc.c:1646  */
    { new_config->gr_wait = (yyvsp[-1].i); }
#line 4144 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 99:
#line 1028 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 4150 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 100:
#line 1029 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 4156 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 101:
#line 1033 "cf-parse.y" /* yacc.c:1646  */
    {
   struct rtable_config *cf;
   cf = rt_new_table((yyvsp[-1].s));
   cf->sorted = (yyvsp[0].i);
   }
#line 4166 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 102:
#line 1041 "cf-parse.y" /* yacc.c:1646  */
    {
  this_roa_table = roa_new_table_config((yyvsp[0].s));
}
#line 4174 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 104:
#line 1047 "cf-parse.y" /* yacc.c:1646  */
    {
     roa_add_item_config(this_roa_table, (yyvsp[-5].px).addr, (yyvsp[-5].px).len, (yyvsp[-3].i), (yyvsp[-1].i));
   }
#line 4182 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 107:
#line 1061 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = SYM_PROTO; }
#line 4188 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 108:
#line 1062 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = SYM_TEMPLATE; }
#line 4194 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 109:
#line 1066 "cf-parse.y" /* yacc.c:1646  */
    {
     struct symbol *s = cf_default_name(this_proto->protocol->template, &this_proto->protocol->name_counter);
     s->class = this_proto->class;
     s->def = this_proto;
     this_proto->name = s->name;
     }
#line 4205 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 110:
#line 1072 "cf-parse.y" /* yacc.c:1646  */
    {
     cf_define_symbol((yyvsp[0].s), this_proto->class, this_proto);
     this_proto->name = (yyvsp[0].s)->name;
   }
#line 4214 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 111:
#line 1076 "cf-parse.y" /* yacc.c:1646  */
    {
     if (((yyvsp[0].s)->class != SYM_TEMPLATE) && ((yyvsp[0].s)->class != SYM_PROTO)) cf_error("Template or protocol name expected");

     cf_define_symbol((yyvsp[-2].s), this_proto->class, this_proto);
     this_proto->name = (yyvsp[-2].s)->name;

     proto_copy_config(this_proto, (yyvsp[0].s)->def);
   }
#line 4227 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 113:
#line 1088 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].i) < 0 || (yyvsp[0].i) > 0xFFFF) cf_error("Invalid preference");
     this_proto->preference = (yyvsp[0].i);
   }
#line 4236 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 114:
#line 1092 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->disabled = (yyvsp[0].i); }
#line 4242 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 115:
#line 1093 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->debug = (yyvsp[0].i); }
#line 4248 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 116:
#line 1094 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->mrtdump = (yyvsp[0].i); }
#line 4254 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 117:
#line 1095 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->in_filter = (yyvsp[0].f); }
#line 4260 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 118:
#line 1096 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->out_filter = (yyvsp[0].f); }
#line 4266 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 119:
#line 1097 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->rx_limit = (yyvsp[0].g); }
#line 4272 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 120:
#line 1098 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->in_limit = (yyvsp[0].g); }
#line 4278 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 121:
#line 1099 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->out_limit = (yyvsp[0].g); }
#line 4284 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 122:
#line 1100 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->in_keep_filtered = (yyvsp[0].i); }
#line 4290 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 123:
#line 1101 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->table = (yyvsp[0].r); }
#line 4296 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 124:
#line 1102 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->router_id = (yyvsp[0].i32); }
#line 4302 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 125:
#line 1103 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->dsc = (yyvsp[0].t); }
#line 4308 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 126:
#line 1107 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.f) = (yyvsp[0].f); }
#line 4314 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 128:
#line 1109 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.f) = FILTER_ACCEPT; }
#line 4320 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 129:
#line 1110 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.f) = FILTER_REJECT; }
#line 4326 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 130:
#line 1114 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = PLA_DISABLE; }
#line 4332 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 131:
#line 1115 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = PLA_WARN; }
#line 4338 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 132:
#line 1116 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = PLA_BLOCK; }
#line 4344 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 133:
#line 1117 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = PLA_RESTART; }
#line 4350 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 134:
#line 1118 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = PLA_DISABLE; }
#line 4356 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 135:
#line 1122 "cf-parse.y" /* yacc.c:1646  */
    {
     struct proto_limit *l = cfg_allocz(sizeof(struct proto_limit));
     l->limit = (yyvsp[-1].i);
     l->action = (yyvsp[0].i);
     (yyval.g) = l;
   }
#line 4367 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 136:
#line 1128 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.g) = NULL; }
#line 4373 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 137:
#line 1132 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != SYM_TABLE) cf_error("Table name expected");
     (yyval.r) = (yyvsp[0].s)->def;
   }
#line 4382 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 138:
#line 1140 "cf-parse.y" /* yacc.c:1646  */
    { new_config->proto_default_debug = (yyvsp[0].i); }
#line 4388 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 139:
#line 1141 "cf-parse.y" /* yacc.c:1646  */
    { new_config->cli_debug = (yyvsp[0].i); }
#line 4394 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 140:
#line 1149 "cf-parse.y" /* yacc.c:1646  */
    {
     struct iface_patt_node *ipn = cfg_allocz(sizeof(struct iface_patt_node));
     add_tail(&this_ipatt->ipn_list, NODE ipn);
     this_ipn = ipn;
   }
#line 4404 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 141:
#line 1157 "cf-parse.y" /* yacc.c:1646  */
    { this_ipn->pattern = (yyvsp[0].t); this_ipn->prefix = IPA_NONE; this_ipn->pxlen = 0; }
#line 4410 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 142:
#line 1158 "cf-parse.y" /* yacc.c:1646  */
    { this_ipn->pattern = NULL; this_ipn->prefix = (yyvsp[0].px).addr; this_ipn->pxlen = (yyvsp[0].px).len; }
#line 4416 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 143:
#line 1159 "cf-parse.y" /* yacc.c:1646  */
    { this_ipn->pattern = (yyvsp[-1].t); this_ipn->prefix = (yyvsp[0].px).addr; this_ipn->pxlen = (yyvsp[0].px).len; }
#line 4422 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 144:
#line 1163 "cf-parse.y" /* yacc.c:1646  */
    { this_ipn->positive = 1; }
#line 4428 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 145:
#line 1164 "cf-parse.y" /* yacc.c:1646  */
    { this_ipn->positive = 0; }
#line 4434 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 149:
#line 1178 "cf-parse.y" /* yacc.c:1646  */
    { iface_patt_check(); }
#line 4440 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 150:
#line 1180 "cf-parse.y" /* yacc.c:1646  */
    {
   /* Generic this_ipatt init */
   this_ipatt = cfg_allocz(sizeof(struct iface_patt));
   init_list(&this_ipatt->ipn_list);
 }
#line 4450 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 152:
#line 1192 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i) & 0xfc;        if (((yyvsp[0].i) < 0) || ((yyvsp[0].i) > 255)) cf_error("TX class must be in range 0-255"); }
#line 4456 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 153:
#line 1193 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ((yyvsp[0].i) & 0x3f) << 2; if (((yyvsp[0].i) < 0) || ((yyvsp[0].i) > 63))  cf_error("TX DSCP must be in range 0-63"); }
#line 4462 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 154:
#line 1199 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto = proto_config_new(&proto_device, sizeof(struct rt_dev_config), (yyvsp[-1].i));
     init_list(&DIRECT_CFG->iface_list);
   }
#line 4471 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 158:
#line 1212 "cf-parse.y" /* yacc.c:1646  */
    {
     this_ipatt = cfg_allocz(sizeof(struct iface_patt));
     add_tail(&DIRECT_CFG->iface_list, NODE this_ipatt);
     init_list(&this_ipatt->ipn_list);
   }
#line 4481 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 160:
#line 1226 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ~0; }
#line 4487 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 161:
#line 1227 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 4493 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 162:
#line 1228 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-1].i); }
#line 4499 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 164:
#line 1233 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-2].i) | (yyvsp[0].i); }
#line 4505 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 165:
#line 1237 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_STATES; }
#line 4511 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 166:
#line 1238 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_ROUTES; }
#line 4517 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 167:
#line 1239 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_FILTERS; }
#line 4523 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 168:
#line 1240 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_IFACES; }
#line 4529 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 169:
#line 1241 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_EVENTS; }
#line 4535 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 170:
#line 1242 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_PACKETS; }
#line 4541 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 171:
#line 1248 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ~0; }
#line 4547 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 172:
#line 1249 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 4553 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 173:
#line 1250 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-1].i); }
#line 4559 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 175:
#line 1255 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-2].i) | (yyvsp[0].i); }
#line 4565 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 176:
#line 1259 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = MD_STATES; }
#line 4571 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 177:
#line 1260 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = MD_MESSAGES; }
#line 4577 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 184:
#line 1281 "cf-parse.y" /* yacc.c:1646  */
    {
     if (!this_p_list) {
     	this_p_list = cfg_alloc(sizeof(list));
     	init_list(this_p_list);
        password_id = 1;
     }
     this_p_item = cfg_alloc(sizeof (struct password_item));
     this_p_item->password = (yyvsp[0].t);
     this_p_item->genfrom = 0;
     this_p_item->gento = TIME_INFINITY;
     this_p_item->accfrom = 0;
     this_p_item->accto = TIME_INFINITY;
     this_p_item->id = password_id++;
     add_tail(this_p_list, &this_p_item->n);
   }
#line 4597 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 185:
#line 1299 "cf-parse.y" /* yacc.c:1646  */
    { }
#line 4603 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 186:
#line 1300 "cf-parse.y" /* yacc.c:1646  */
    { this_p_item->genfrom = (yyvsp[-2].time); }
#line 4609 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 187:
#line 1301 "cf-parse.y" /* yacc.c:1646  */
    { this_p_item->gento = (yyvsp[-2].time); }
#line 4615 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 188:
#line 1302 "cf-parse.y" /* yacc.c:1646  */
    { this_p_item->accfrom = (yyvsp[-2].time); }
#line 4621 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 189:
#line 1303 "cf-parse.y" /* yacc.c:1646  */
    { this_p_item->accto = (yyvsp[-2].time); }
#line 4627 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 190:
#line 1304 "cf-parse.y" /* yacc.c:1646  */
    { this_p_item->id = (yyvsp[-2].i); if ((yyvsp[-2].i) <= 0) cf_error("Password ID has to be greated than zero."); }
#line 4633 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 191:
#line 1313 "cf-parse.y" /* yacc.c:1646  */
    { cmd_show_status(); }
#line 4639 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 192:
#line 1316 "cf-parse.y" /* yacc.c:1646  */
    { cmd_show_memory(); }
#line 4645 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 193:
#line 1319 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_show, 0, 0); }
#line 4651 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 194:
#line 1322 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_show, 0, 1); }
#line 4657 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 196:
#line 1326 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.s) = NULL; }
#line 4663 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 197:
#line 1330 "cf-parse.y" /* yacc.c:1646  */
    { if_show(); }
#line 4669 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 198:
#line 1333 "cf-parse.y" /* yacc.c:1646  */
    { if_show_summary(); }
#line 4675 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 199:
#line 1337 "cf-parse.y" /* yacc.c:1646  */
    { rt_show((yyvsp[-1].ra)); }
#line 4681 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 200:
#line 1340 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = cfg_allocz(sizeof(struct rt_show_data));
     (yyval.ra)->pxlen = 256;
     (yyval.ra)->filter = FILTER_ACCEPT;
   }
#line 4691 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 201:
#line 1345 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     if ((yyval.ra)->pxlen != 256) cf_error("Only one prefix expected");
     (yyval.ra)->prefix = (yyvsp[0].px).addr;
     (yyval.ra)->pxlen = (yyvsp[0].px).len;
   }
#line 4702 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 202:
#line 1351 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->pxlen != 256) cf_error("Only one prefix expected");
     (yyval.ra)->prefix = (yyvsp[0].px).addr;
     (yyval.ra)->pxlen = (yyvsp[0].px).len;
     (yyval.ra)->show_for = 1;
   }
#line 4714 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 203:
#line 1358 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyvsp[0].s)->class != SYM_TABLE) cf_error("%s is not a table", (yyvsp[0].s)->name);
     (yyval.ra)->table = ((struct rtable_config *)(yyvsp[0].s)->def)->table;
   }
#line 4724 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 204:
#line 1363 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[0].f);
   }
#line 4734 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 205:
#line 1368 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[0].f);
   }
#line 4744 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 206:
#line 1373 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->verbose = 1;
   }
#line 4753 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 207:
#line 1377 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->primary_only = 1;
   }
#line 4762 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 208:
#line 1381 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->filtered = 1;
   }
#line 4771 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 209:
#line 1385 "cf-parse.y" /* yacc.c:1646  */
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[0].s)->def;
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->export_mode) cf_error("Protocol specified twice");
     if ((yyvsp[0].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[0].s)->name);
     (yyval.ra)->export_mode = (yyvsp[-1].i);
     (yyval.ra)->export_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
   }
#line 4785 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 210:
#line 1394 "cf-parse.y" /* yacc.c:1646  */
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[0].s)->def;
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->show_protocol) cf_error("Protocol specified twice");
     if ((yyvsp[0].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[0].s)->name);
     (yyval.ra)->show_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
   }
#line 4798 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 211:
#line 1402 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->stats = 1;
   }
#line 4807 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 212:
#line 1406 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->stats = 2;
   }
#line 4816 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 213:
#line 1413 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 4822 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 214:
#line 1414 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 2; }
#line 4828 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 215:
#line 1420 "cf-parse.y" /* yacc.c:1646  */
    { roa_show((yyvsp[-1].ro)); }
#line 4834 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 216:
#line 1423 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ro) = cfg_allocz(sizeof(struct roa_show_data));
     (yyval.ro)->mode = ROA_SHOW_ALL;
     (yyval.ro)->table = roa_table_default;
     if (roa_table_default == NULL)
       cf_error("No ROA table defined");
   }
#line 4846 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 217:
#line 1430 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ro) = (yyvsp[-2].ro);
     if ((yyval.ro)->mode != ROA_SHOW_ALL) cf_error("Only one prefix expected");
     (yyval.ro)->prefix = (yyvsp[0].px).addr;
     (yyval.ro)->pxlen = (yyvsp[0].px).len;
     (yyval.ro)->mode = (yyvsp[-1].i);
   }
#line 4858 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 218:
#line 1437 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ro) = (yyvsp[-2].ro);
     (yyval.ro)->asn = (yyvsp[0].i);
   }
#line 4867 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 219:
#line 1441 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ro) = (yyvsp[-2].ro);
     if ((yyvsp[0].s)->class != SYM_ROA) cf_error("%s is not a ROA table", (yyvsp[0].s)->name);
     (yyval.ro)->table = ((struct roa_table_config *)(yyvsp[0].s)->def)->table;
   }
#line 4877 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 220:
#line 1449 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ROA_SHOW_PX; }
#line 4883 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 221:
#line 1450 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ROA_SHOW_IN; }
#line 4889 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 222:
#line 1451 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ROA_SHOW_FOR; }
#line 4895 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 223:
#line 1457 "cf-parse.y" /* yacc.c:1646  */
    { cmd_show_symbols((yyvsp[-1].sd)); }
#line 4901 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 224:
#line 1460 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.sd) = cfg_allocz(sizeof(struct sym_show_data));
   }
#line 4909 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 225:
#line 1463 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_TABLE; }
#line 4915 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 226:
#line 1464 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_FUNCTION; }
#line 4921 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 227:
#line 1465 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_FILTER; }
#line 4927 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 228:
#line 1466 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_PROTO; }
#line 4933 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 229:
#line 1467 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_TEMPLATE; }
#line 4939 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 230:
#line 1468 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_ROA; }
#line 4945 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 231:
#line 1469 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->sym = (yyvsp[0].s); }
#line 4951 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 232:
#line 1474 "cf-parse.y" /* yacc.c:1646  */
    { 
     if (roa_table_default == NULL)
       cf_error("No ROA table defined");
     (yyval.rot) = roa_table_default;
   }
#line 4961 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 233:
#line 1479 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != SYM_ROA)
       cf_error("%s is not a ROA table", (yyvsp[0].s)->name);
     (yyval.rot) = ((struct roa_table_config *)(yyvsp[0].s)->def)->table;
   }
#line 4971 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 234:
#line 1488 "cf-parse.y" /* yacc.c:1646  */
    {
  if (! cli_access_restricted())
    { roa_add_item((yyvsp[-1].rot), (yyvsp[-6].px).addr, (yyvsp[-6].px).len, (yyvsp[-4].i), (yyvsp[-2].i), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
#line 4980 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 235:
#line 1495 "cf-parse.y" /* yacc.c:1646  */
    {
  if (! cli_access_restricted())
    { roa_delete_item((yyvsp[-1].rot), (yyvsp[-6].px).addr, (yyvsp[-6].px).len, (yyvsp[-4].i), (yyvsp[-2].i), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
#line 4989 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 236:
#line 1502 "cf-parse.y" /* yacc.c:1646  */
    {
  if (! cli_access_restricted())
    { roa_flush((yyvsp[-1].rot), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
#line 4998 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 237:
#line 1510 "cf-parse.y" /* yacc.c:1646  */
    { rdump(&root_pool); cli_msg(0, ""); }
#line 5004 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 238:
#line 1512 "cf-parse.y" /* yacc.c:1646  */
    { sk_dump_all(); cli_msg(0, ""); }
#line 5010 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 239:
#line 1514 "cf-parse.y" /* yacc.c:1646  */
    { if_dump_all(); cli_msg(0, ""); }
#line 5016 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 240:
#line 1516 "cf-parse.y" /* yacc.c:1646  */
    { neigh_dump_all(); cli_msg(0, ""); }
#line 5022 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 241:
#line 1518 "cf-parse.y" /* yacc.c:1646  */
    { rta_dump_all(); cli_msg(0, ""); }
#line 5028 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 242:
#line 1520 "cf-parse.y" /* yacc.c:1646  */
    { rt_dump_all(); cli_msg(0, ""); }
#line 5034 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 243:
#line 1522 "cf-parse.y" /* yacc.c:1646  */
    { protos_dump_all(); cli_msg(0, ""); }
#line 5040 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 244:
#line 1525 "cf-parse.y" /* yacc.c:1646  */
    { cmd_eval((yyvsp[-1].x)); }
#line 5046 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 245:
#line 1528 "cf-parse.y" /* yacc.c:1646  */
    {
  cli_set_log_echo(this_cli, (yyvsp[-2].i), (yyvsp[-1].i));
  cli_msg(0, "");
}
#line 5055 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 246:
#line 1534 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ~0; }
#line 5061 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 247:
#line 1535 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 5067 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 248:
#line 1536 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-1].i); }
#line 5073 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 249:
#line 1540 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 4096; }
#line 5079 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 250:
#line 1541 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].i) < 256 || (yyvsp[0].i) > 65536) cf_error("Invalid log buffer size");
     (yyval.i) = (yyvsp[0].i);
   }
#line 5088 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 251:
#line 1548 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_disable, 1, 0); }
#line 5094 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 252:
#line 1550 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_enable, 1, 0); }
#line 5100 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 253:
#line 1552 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_restart, 1, 0); }
#line 5106 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 254:
#line 1554 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_reload, 1, CMD_RELOAD); }
#line 5112 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 255:
#line 1556 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_reload, 1, CMD_RELOAD_IN); }
#line 5118 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 256:
#line 1558 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_reload, 1, CMD_RELOAD_OUT); }
#line 5124 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 257:
#line 1562 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-2].ps), proto_cmd_debug, 1, (yyvsp[-1].i)); }
#line 5130 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 258:
#line 1566 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-2].ps), proto_cmd_mrtdump, 1, (yyvsp[-1].i)); }
#line 5136 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 259:
#line 1569 "cf-parse.y" /* yacc.c:1646  */
    { this_cli->restricted = 1; cli_msg(16, "Access restricted"); }
#line 5142 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 260:
#line 1572 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = (yyvsp[0].s); (yyval.ps).patt = 0; }
#line 5148 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 261:
#line 1573 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; }
#line 5154 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 262:
#line 1574 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = (yyvsp[0].t); (yyval.ps).patt = 1; }
#line 5160 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 263:
#line 1578 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = (yyvsp[0].s); (yyval.ps).patt = 0; }
#line 5166 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 264:
#line 1579 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; }
#line 5172 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 265:
#line 1580 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = (yyvsp[0].t); (yyval.ps).patt = 1; }
#line 5178 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 266:
#line 1588 "cf-parse.y" /* yacc.c:1646  */
    { (yyvsp[0].s) = cf_define_symbol((yyvsp[0].s), SYM_FILTER, NULL); cf_push_scope( (yyvsp[0].s) ); }
#line 5184 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 267:
#line 1589 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyvsp[-2].s)->def = (yyvsp[0].f);
     (yyvsp[0].f)->name = (yyvsp[-2].s)->name;
     DBG( "We have new filter defined (%s)\n", (yyvsp[-2].s)->name );
     cf_pop_scope();
   }
#line 5195 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 268:
#line 1598 "cf-parse.y" /* yacc.c:1646  */
    { f_eval_int((yyvsp[0].x)); }
#line 5201 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 269:
#line 1602 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_INT; }
#line 5207 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 270:
#line 1603 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_BOOL; }
#line 5213 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 271:
#line 1604 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_IP; }
#line 5219 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 272:
#line 1605 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_PREFIX; }
#line 5225 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 273:
#line 1606 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_PAIR; }
#line 5231 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 274:
#line 1607 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_QUAD; }
#line 5237 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 275:
#line 1608 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_EC; }
#line 5243 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 276:
#line 1609 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_STRING; }
#line 5249 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 277:
#line 1610 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_PATH_MASK; }
#line 5255 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 278:
#line 1611 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_PATH; }
#line 5261 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 279:
#line 1612 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_CLIST; }
#line 5267 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 280:
#line 1613 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_ECLIST; }
#line 5273 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 281:
#line 1614 "cf-parse.y" /* yacc.c:1646  */
    { 
	switch ((yyvsp[-1].i)) {
	  case T_INT:
	  case T_PAIR:
	  case T_QUAD:
	  case T_EC:
	  case T_IP:
	       (yyval.i) = T_SET;
	       break;

	  case T_PREFIX:
	       (yyval.i) = T_PREFIX_SET;
	    break;

	  default:
		cf_error( "You can't create sets of this type." );
	}
   }
#line 5296 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 282:
#line 1635 "cf-parse.y" /* yacc.c:1646  */
    {
     struct f_val * val = cfg_alloc(sizeof(struct f_val));
     val->type = T_VOID;
     (yyvsp[0].s) = cf_define_symbol((yyvsp[0].s), SYM_VARIABLE | (yyvsp[-1].i), val);
     DBG( "New variable %s type %x\n", (yyvsp[0].s)->name, (yyvsp[-1].i) );
     (yyvsp[0].s)->aux2 = NULL;
     (yyval.s)=(yyvsp[0].s);
   }
#line 5309 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 283:
#line 1646 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.s) = NULL; }
#line 5315 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 284:
#line 1647 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.s) = (yyvsp[-2].s);
     (yyval.s)->aux2 = (yyvsp[0].s);
   }
#line 5324 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 285:
#line 1654 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.s) = (yyvsp[0].s); }
#line 5330 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 286:
#line 1655 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.s) = (yyvsp[-2].s);
     (yyval.s)->aux2 = (yyvsp[0].s);
   }
#line 5339 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 287:
#line 1662 "cf-parse.y" /* yacc.c:1646  */
    {
     struct filter *f = cfg_alloc(sizeof(struct filter));
     f->name = NULL;
     f->root = (yyvsp[0].x);
     (yyval.f) = f;
   }
#line 5350 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 288:
#line 1671 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != SYM_FILTER) cf_error("No such filter.");
     (yyval.f) = (yyvsp[0].s)->def;
   }
#line 5359 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 290:
#line 1679 "cf-parse.y" /* yacc.c:1646  */
    {
     /* Construct 'IF term THEN ACCEPT; REJECT;' */
     struct filter *f = cfg_alloc(sizeof(struct filter));
     struct f_inst *i, *acc, *rej;
     acc = f_new_inst();		/* ACCEPT */
     acc->code = P('p',',');
     acc->a1.p = NULL;
     acc->a2.i = F_ACCEPT;
     rej = f_new_inst();		/* REJECT */
     rej->code = P('p',',');
     rej->a1.p = NULL;
     rej->a2.i = F_REJECT;
     i = f_new_inst();			/* IF */
     i->code = '?';
     i->a1.p = (yyvsp[0].x);
     i->a2.p = acc;
     i->next = rej;
     f->name = NULL;
     f->root = i;
     (yyval.f) = f;
  }
#line 5385 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 291:
#line 1703 "cf-parse.y" /* yacc.c:1646  */
    { DBG( "Have function parameters\n" ); (yyval.s)=(yyvsp[-1].s); }
#line 5391 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 292:
#line 1704 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.s)=NULL; }
#line 5397 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 293:
#line 1708 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[-3].s)) {
       /* Prepend instruction to clear local variables */
       (yyval.x) = f_new_inst();
       (yyval.x)->code = P('c','v');
       (yyval.x)->a1.p = (yyvsp[-3].s);
       (yyval.x)->next = (yyvsp[-1].x);
     } else
       (yyval.x) = (yyvsp[-1].x);
   }
#line 5412 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 294:
#line 1721 "cf-parse.y" /* yacc.c:1646  */
    { DBG( "Beginning of function %s\n", (yyvsp[0].s)->name );
     (yyvsp[0].s) = cf_define_symbol((yyvsp[0].s), SYM_FUNCTION, NULL);
     cf_push_scope((yyvsp[0].s));
   }
#line 5421 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 295:
#line 1724 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyvsp[-3].s)->def = (yyvsp[0].x);
     (yyvsp[-3].s)->aux2 = (yyvsp[-1].s);
     DBG("Hmm, we've got one function here - %s\n", (yyvsp[-3].s)->name); 
     cf_pop_scope();
   }
#line 5432 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 296:
#line 1737 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = NULL; }
#line 5438 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 297:
#line 1738 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x)->next; (yyvsp[0].x)->next = NULL; }
#line 5444 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 298:
#line 1741 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); (yyvsp[0].x)->next = (yyvsp[0].x); }
#line 5450 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 299:
#line 1742 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); (yyvsp[0].x)->next = (yyvsp[-1].x)->next ; (yyvsp[-1].x)->next = (yyvsp[0].x); }
#line 5456 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 300:
#line 1746 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x)=(yyvsp[0].x);
   }
#line 5464 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 301:
#line 1749 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x)=(yyvsp[-1].x);
   }
#line 5472 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 302:
#line 1758 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = T_IP; (yyval.v).val.px.ip = (yyvsp[0].a); }
#line 5478 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 303:
#line 1771 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[0].i); }
#line 5484 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 304:
#line 1772 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = T_QUAD; (yyval.v).val.i = (yyvsp[0].i32); }
#line 5490 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 305:
#line 1773 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v) = (yyvsp[0].v); }
#line 5496 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 306:
#line 1774 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = pair_a((yyvsp[0].i)); (yyval.v).val.i = pair_b((yyvsp[0].i)); }
#line 5502 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 307:
#line 1778 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[0].i); }
#line 5508 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 308:
#line 1779 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = T_INT; (yyval.v).val.i = f_eval_int((yyvsp[-1].x)); }
#line 5514 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 309:
#line 1780 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = T_QUAD; (yyval.v).val.i = (yyvsp[0].i32); }
#line 5520 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 310:
#line 1781 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v) = (yyvsp[0].v); }
#line 5526 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 311:
#line 1782 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = pair_a((yyvsp[0].i)); (yyval.v).val.i = pair_b((yyvsp[0].i)); }
#line 5532 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 312:
#line 1786 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = f_eval_int((yyvsp[0].x)); check_u16((yyval.i)); }
#line 5538 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 313:
#line 1789 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = pair((yyvsp[0].i), (yyvsp[0].i)); }
#line 5544 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 314:
#line 1790 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = pair((yyvsp[-2].i), (yyvsp[0].i)); }
#line 5550 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 315:
#line 1791 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = 0xFFFF; }
#line 5556 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 316:
#line 1795 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.e) = f_new_pair_set(pair_a((yyvsp[-3].i32)), pair_b((yyvsp[-3].i32)), pair_a((yyvsp[-1].i32)), pair_b((yyvsp[-1].i32)));
   }
#line 5564 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 317:
#line 1798 "cf-parse.y" /* yacc.c:1646  */
    {
     /* Hack: $2 and $4 should be pair_expr, but that would cause shift/reduce conflict */
     if ((pair_a((yyvsp[-9].i32)) != pair_b((yyvsp[-9].i32))) || (pair_a((yyvsp[-7].i32)) != pair_b((yyvsp[-7].i32))))
       cf_error("syntax error");
     (yyval.e) = f_new_pair_item(pair_b((yyvsp[-9].i32)), (yyvsp[-3].i), pair_b((yyvsp[-7].i32)), (yyvsp[-1].i)); 
   }
#line 5575 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 318:
#line 1807 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = f_eval_int((yyvsp[0].x)); }
#line 5581 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 319:
#line 1810 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = EC_RT; }
#line 5587 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 320:
#line 1811 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = EC_RO; }
#line 5593 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 321:
#line 1812 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i); }
#line 5599 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 322:
#line 1813 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = EC_GENERIC; }
#line 5605 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 323:
#line 1817 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_ec_item((yyvsp[-5].i), 0, (yyvsp[-3].i32), (yyvsp[-1].i32), (yyvsp[-1].i32)); }
#line 5611 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 324:
#line 1818 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_ec_item((yyvsp[-7].i), 0, (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-1].i32)); }
#line 5617 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 325:
#line 1819 "cf-parse.y" /* yacc.c:1646  */
    {  (yyval.e) = f_new_ec_item((yyvsp[-5].i), 0, (yyvsp[-3].i32), 0, EC_ALL); }
#line 5623 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 328:
#line 1825 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_item((yyvsp[0].v), (yyvsp[0].v)); }
#line 5629 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 329:
#line 1826 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_item((yyvsp[-2].v), (yyvsp[0].v)); }
#line 5635 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 332:
#line 1832 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_item((yyvsp[0].v), (yyvsp[0].v)); }
#line 5641 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 333:
#line 1833 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_item((yyvsp[-2].v), (yyvsp[0].v)); }
#line 5647 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 335:
#line 1838 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_merge_items((yyvsp[-2].e), (yyvsp[0].e)); }
#line 5653 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 337:
#line 1843 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_merge_items((yyvsp[-2].e), (yyvsp[0].e)); }
#line 5659 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 338:
#line 1847 "cf-parse.y" /* yacc.c:1646  */
    {
     if (((yyvsp[0].i) < 0) || ((yyvsp[0].i) > MAX_PREFIX_LENGTH) || !ip_is_prefix((yyvsp[-2].a), (yyvsp[0].i))) cf_error("Invalid network prefix: %I/%d.", (yyvsp[-2].a), (yyvsp[0].i));
     (yyval.v).type = T_PREFIX; (yyval.v).val.px.ip = (yyvsp[-2].a); (yyval.v).val.px.len = (yyvsp[0].i);
   }
#line 5668 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 339:
#line 1854 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v) = (yyvsp[0].v); }
#line 5674 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 340:
#line 1855 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v) = (yyvsp[-1].v); (yyval.v).val.px.len |= LEN_PLUS; }
#line 5680 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 341:
#line 1856 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v) = (yyvsp[-1].v); (yyval.v).val.px.len |= LEN_MINUS; }
#line 5686 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 342:
#line 1857 "cf-parse.y" /* yacc.c:1646  */
    { 
     if (! ((0 <= (yyvsp[-3].i)) && ((yyvsp[-3].i) <= (yyvsp[-1].i)) && ((yyvsp[-1].i) <= MAX_PREFIX_LENGTH))) cf_error("Invalid prefix pattern range: {%d, %d}.", (yyvsp[-3].i), (yyvsp[-1].i));
     (yyval.v) = (yyvsp[-5].v); (yyval.v).val.px.len |= LEN_RANGE | ((yyvsp[-3].i) << 16) | ((yyvsp[-1].i) << 8);
   }
#line 5695 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 343:
#line 1864 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.trie) = f_new_trie(cfg_mem); trie_add_fprefix((yyval.trie), &((yyvsp[0].v).val.px)); }
#line 5701 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 344:
#line 1865 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.trie) = (yyvsp[-2].trie); trie_add_fprefix((yyval.trie), &((yyvsp[0].v).val.px)); }
#line 5707 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 345:
#line 1868 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = NULL; }
#line 5713 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 346:
#line 1869 "cf-parse.y" /* yacc.c:1646  */
    {
     /* Fill data fields */
     struct f_tree *t;
     for (t = (yyvsp[-2].e); t; t = t->left)
       t->data = (yyvsp[0].x);
     (yyval.e) = f_merge_items((yyvsp[-3].e), (yyvsp[-2].e));
   }
#line 5725 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 347:
#line 1876 "cf-parse.y" /* yacc.c:1646  */
    { 
     struct f_tree *t = f_new_tree();
     t->from.type = t->to.type = T_VOID;
     t->right = t;
     t->data = (yyvsp[0].x);
     (yyval.e) = f_merge_items((yyvsp[-2].e), t);
 }
#line 5737 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 348:
#line 1888 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 5743 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 349:
#line 1889 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[-1].x); }
#line 5749 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 350:
#line 1893 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = (yyvsp[-1].h); }
#line 5755 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 351:
#line 1894 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = (yyvsp[-1].h); }
#line 5761 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 352:
#line 1898 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASN;      (yyval.h)->val = (yyvsp[-1].i); }
#line 5767 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 353:
#line 1899 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASTERISK; (yyval.h)->val  = 0; }
#line 5773 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 354:
#line 1900 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_QUESTION; (yyval.h)->val  = 0; }
#line 5779 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 355:
#line 1901 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASN_EXPR; (yyval.h)->val = (uintptr_t) (yyvsp[-1].x); }
#line 5785 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 356:
#line 1902 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = NULL; }
#line 5791 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 357:
#line 1906 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASN;      (yyval.h)->val = (yyvsp[-1].i); }
#line 5797 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 358:
#line 1907 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASTERISK; (yyval.h)->val  = 0; }
#line 5803 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 359:
#line 1908 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = NULL; }
#line 5809 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 360:
#line 1912 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_INT;  (yyval.x)->a2.i = (yyvsp[0].i); }
#line 5815 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 361:
#line 1913 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 1;  }
#line 5821 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 362:
#line 1914 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 0;  }
#line 5827 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 363:
#line 1915 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_STRING; (yyval.x)->a2.p = (yyvsp[0].t); }
#line 5833 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 364:
#line 1916 "cf-parse.y" /* yacc.c:1646  */
    { NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; (yyval.x)->a1.p = val; *val = (yyvsp[0].v); }
#line 5839 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 365:
#line 1917 "cf-parse.y" /* yacc.c:1646  */
    {NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; (yyval.x)->a1.p = val; *val = (yyvsp[0].v); }
#line 5845 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 366:
#line 1918 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_QUAD;  (yyval.x)->a2.i = (yyvsp[0].i32); }
#line 5851 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 367:
#line 1919 "cf-parse.y" /* yacc.c:1646  */
    { DBG( "We've got a set here..." ); (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_SET; (yyval.x)->a2.p = build_tree((yyvsp[-1].e)); DBG( "ook\n" ); }
#line 5857 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 368:
#line 1920 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_PREFIX_SET;  (yyval.x)->a2.p = (yyvsp[-1].trie); }
#line 5863 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 369:
#line 1921 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = (yyvsp[0].i) >> 16; (yyval.x)->a2.i = (yyvsp[0].i) & 0xffff; }
#line 5869 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 370:
#line 1922 "cf-parse.y" /* yacc.c:1646  */
    { NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; val->type = T_PATH_MASK; val->val.path_mask = (yyvsp[0].h); (yyval.x)->a1.p = val; }
#line 5875 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 371:
#line 1926 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_dpair((yyvsp[-3].x), (yyvsp[-1].x)); }
#line 5881 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 372:
#line 1927 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_ec((yyvsp[-5].i), (yyvsp[-3].x), (yyvsp[-1].x)); }
#line 5887 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 374:
#line 1941 "cf-parse.y" /* yacc.c:1646  */
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[-1].x);
     if ((yyvsp[-3].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[-3].s)->name);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('c','a');
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[-3].s)->def;
     sym = (yyvsp[-3].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[-3].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   }
#line 5912 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 375:
#line 1964 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst();

     switch ((yyvsp[0].s)->class & 0xff00) {
       case SYM_CONSTANT: (yyval.x)->code = 'C'; break;
       case SYM_VARIABLE: (yyval.x)->code = 'V'; break;
       default: cf_error("%s: variable expected.", (yyvsp[0].s)->name);
     }

     (yyval.x)->a1.p = (yyvsp[0].s)->def;
     (yyval.x)->a2.p = (yyvsp[0].s)->name;
   }
#line 5929 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 376:
#line 1978 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_IP;         (yyval.x)->a2.i = SA_FROM;	(yyval.x)->a1.i = 1; }
#line 5935 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 377:
#line 1979 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_IP;         (yyval.x)->a2.i = SA_GW;	(yyval.x)->a1.i = 1; }
#line 5941 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 378:
#line 1980 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_PREFIX;     (yyval.x)->a2.i = SA_NET; }
#line 5947 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 379:
#line 1981 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_STRING;     (yyval.x)->a2.i = SA_PROTO; }
#line 5953 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 380:
#line 1982 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTS;   (yyval.x)->a2.i = SA_SOURCE; }
#line 5959 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 381:
#line 1983 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_SCOPE; (yyval.x)->a2.i = SA_SCOPE;	(yyval.x)->a1.i = 1; }
#line 5965 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 382:
#line 1984 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTC;   (yyval.x)->a2.i = SA_CAST; }
#line 5971 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 383:
#line 1985 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTD;   (yyval.x)->a2.i = SA_DEST;	(yyval.x)->a1.i = 1; }
#line 5977 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 384:
#line 1986 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_STRING;     (yyval.x)->a2.i = SA_IFNAME; }
#line 5983 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 385:
#line 1987 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_INT;        (yyval.x)->a2.i = SA_IFINDEX; }
#line 5989 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 386:
#line 1991 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[-1].x); }
#line 5995 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 387:
#line 1992 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '+';        (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6001 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 388:
#line 1993 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '-';        (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6007 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 389:
#line 1994 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '*';        (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6013 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 390:
#line 1995 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '/';        (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6019 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 391:
#line 1996 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '&';        (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6025 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 392:
#line 1997 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '|';        (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6031 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 393:
#line 1998 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('=','='); (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6037 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 394:
#line 1999 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('!','=');     (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6043 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 395:
#line 2000 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '<';        (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6049 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 396:
#line 2001 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('<','=');     (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6055 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 397:
#line 2002 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '<';        (yyval.x)->a1.p = (yyvsp[0].x); (yyval.x)->a2.p = (yyvsp[-2].x); }
#line 6061 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 398:
#line 2003 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('<','=');     (yyval.x)->a1.p = (yyvsp[0].x); (yyval.x)->a2.p = (yyvsp[-2].x); }
#line 6067 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 399:
#line 2004 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '~';        (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6073 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 400:
#line 2005 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '!'; (yyval.x)->a1.p = (yyvsp[0].x); }
#line 6079 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 401:
#line 2006 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('d','e');  (yyval.x)->a1.p = (yyvsp[-1].x); }
#line 6085 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 402:
#line 2008 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 6091 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 403:
#line 2009 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 6097 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 404:
#line 2010 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 6103 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 405:
#line 2012 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'P'; }
#line 6109 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 406:
#line 2014 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); (yyval.x)->code = 'a'; }
#line 6115 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 407:
#line 2016 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); (yyval.x)->code = P('e','a'); }
#line 6121 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 408:
#line 2018 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('c','p'); (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->aux = T_IP; }
#line 6127 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 409:
#line 2019 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'L'; (yyval.x)->a1.p = (yyvsp[-2].x); }
#line 6133 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 410:
#line 2020 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('i','M'); (yyval.x)->a1.p = (yyvsp[-5].x); (yyval.x)->a2.p = (yyvsp[-1].x); }
#line 6139 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 411:
#line 2021 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('a','f'); (yyval.x)->a1.p = (yyvsp[-2].x); }
#line 6145 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 412:
#line 2022 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('a','l'); (yyval.x)->a1.p = (yyvsp[-2].x); }
#line 6151 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 413:
#line 2032 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_PATH; }
#line 6157 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 414:
#line 2033 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_CLIST; }
#line 6163 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 415:
#line 2034 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_ECLIST; }
#line 6169 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 416:
#line 2035 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('A','p'); (yyval.x)->a1.p = (yyvsp[-3].x); (yyval.x)->a2.p = (yyvsp[-1].x); }
#line 6175 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 417:
#line 2036 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[-3].x); (yyval.x)->a2.p = (yyvsp[-1].x); (yyval.x)->aux = 'a'; }
#line 6181 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 418:
#line 2037 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[-3].x); (yyval.x)->a2.p = (yyvsp[-1].x); (yyval.x)->aux = 'd'; }
#line 6187 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 419:
#line 2038 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[-3].x); (yyval.x)->a2.p = (yyvsp[-1].x); (yyval.x)->aux = 'f'; }
#line 6193 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 420:
#line 2040 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_roa_check((yyvsp[-1].s), NULL, NULL); }
#line 6199 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 421:
#line 2041 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_roa_check((yyvsp[-5].s), (yyvsp[-3].x), (yyvsp[-1].x)); }
#line 6205 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 422:
#line 2046 "cf-parse.y" /* yacc.c:1646  */
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[-1].x);
     if ((yyvsp[-3].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[-3].s)->name);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('c','a');
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[-3].s)->def;
     sym = (yyvsp[-3].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[-3].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   }
#line 6230 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 423:
#line 2069 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_QUITBIRD; }
#line 6236 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 424:
#line 2070 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_ACCEPT; }
#line 6242 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 425:
#line 2071 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_REJECT; }
#line 6248 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 426:
#line 2072 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_ERROR; }
#line 6254 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 427:
#line 2073 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_NOP; }
#line 6260 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 428:
#line 2074 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_NONL; }
#line 6266 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 429:
#line 2078 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'p'; (yyval.x)->a1.p = (yyvsp[0].x); (yyval.x)->a2.p = NULL; }
#line 6272 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 430:
#line 2081 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = NULL; }
#line 6278 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 431:
#line 2082 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 6284 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 432:
#line 2083 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[-2].x)) {
       (yyvsp[-2].x)->next = (yyvsp[0].x);
       (yyval.x) = (yyvsp[-2].x);
     } else (yyval.x) = (yyvsp[0].x);
   }
#line 6295 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 433:
#line 2091 "cf-parse.y" /* yacc.c:1646  */
    { 
     (yyval.x) = f_new_inst();
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[0].x);
     (yyval.x)->next = NULL;
   }
#line 6307 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 434:
#line 2098 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[-2].x);
     (yyval.x)->next = (yyvsp[0].x);
   }
#line 6319 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 435:
#line 2107 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = NULL; }
#line 6325 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 436:
#line 2108 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 6331 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 437:
#line 2112 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = '?';
     (yyval.x)->a1.p = (yyvsp[-2].x);
     (yyval.x)->a2.p = (yyvsp[0].x);
   }
#line 6342 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 438:
#line 2118 "cf-parse.y" /* yacc.c:1646  */
    {
     struct f_inst *i = f_new_inst();
     i->code = '?';
     i->a1.p = (yyvsp[-4].x);
     i->a2.p = (yyvsp[-2].x);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = '?';
     (yyval.x)->a1.p = i;
     (yyval.x)->a2.p = (yyvsp[0].x);
   }
#line 6357 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 439:
#line 2128 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst();
     DBG( "Ook, we'll set value\n" );
     if (((yyvsp[-3].s)->class & ~T_MASK) != SYM_VARIABLE)
       cf_error( "You may set only variables." );
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = (yyvsp[-3].s);
     (yyval.x)->a2.p = (yyvsp[-1].x);
   }
#line 6371 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 440:
#line 2137 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst();
     DBG( "Ook, we'll return the value\n" );
     (yyval.x)->code = 'r';
     (yyval.x)->a1.p = (yyvsp[-1].x);
   }
#line 6382 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 441:
#line 2143 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = (yyvsp[-3].x);
     (yyval.x)->code = P('e','S');
     (yyval.x)->a1.p = (yyvsp[-1].x);
   }
#line 6392 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 442:
#line 2148 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = (yyvsp[-3].x);
     if (!(yyval.x)->a1.i)
       cf_error( "This static attribute is read-only.");
     (yyval.x)->code = P('a','S');
     (yyval.x)->a1.p = (yyvsp[-1].x);
   }
#line 6404 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 443:
#line 2155 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('P','S');
     (yyval.x)->a1.p = (yyvsp[-1].x);
   }
#line 6414 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 444:
#line 2160 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = (yyvsp[-2].x);
     (yyval.x)->aux = EAF_TYPE_UNDEF | EAF_TEMP;
     (yyval.x)->code = P('e','S');
     (yyval.x)->a1.p = NULL;
   }
#line 6425 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 445:
#line 2166 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('p',','); (yyval.x)->a1.p = (yyvsp[-1].x); (yyval.x)->a2.i = (yyvsp[-2].i); }
#line 6431 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 446:
#line 2167 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[-1].x); }
#line 6437 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 447:
#line 2168 "cf-parse.y" /* yacc.c:1646  */
    {
      (yyval.x) = f_new_inst();
      (yyval.x)->code = P('S','W');
      (yyval.x)->a1.p = (yyvsp[-3].x);
      (yyval.x)->a2.p = build_tree( (yyvsp[-1].e) );
   }
#line 6448 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 448:
#line 2176 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_empty((yyvsp[-3].x)); }
#line 6454 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 449:
#line 2177 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_complex( P('A','p'), 'x', (yyvsp[-6].x), (yyvsp[-2].x) ); }
#line 6460 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 450:
#line 2178 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_complex( P('C','a'), 'a', (yyvsp[-6].x), (yyvsp[-2].x) ); }
#line 6466 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 451:
#line 2179 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_complex( P('C','a'), 'd', (yyvsp[-6].x), (yyvsp[-2].x) ); }
#line 6472 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 452:
#line 2180 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_complex( P('C','a'), 'f', (yyvsp[-6].x), (yyvsp[-2].x) ); }
#line 6478 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 453:
#line 2187 "cf-parse.y" /* yacc.c:1646  */
    {
  this_proto = proto_config_new(&proto_bfd, sizeof(struct bfd_config), (yyvsp[-1].i));
  init_list(&BFD_CFG->patt_list);
  init_list(&BFD_CFG->neigh_list);

  if (bfd_cf)
    cf_error("Only one BFD instance allowed");
  bfd_cf = BFD_CFG;
}
#line 6492 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 461:
#line 2214 "cf-parse.y" /* yacc.c:1646  */
    {
  this_ipatt = cfg_allocz(sizeof(struct bfd_iface_config));
  init_list(&this_ipatt->ipn_list);

  BFD_IFACE->min_rx_int = BFD_DEFAULT_MIN_RX_INT;
  BFD_IFACE->min_tx_int = BFD_DEFAULT_MIN_TX_INT;
  BFD_IFACE->idle_tx_int = BFD_DEFAULT_IDLE_TX_INT;
  BFD_IFACE->multiplier = BFD_DEFAULT_MULTIPLIER;
}
#line 6506 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 462:
#line 2225 "cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->min_rx_int = BFD_IFACE->min_tx_int = (yyvsp[0].i32); }
#line 6512 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 463:
#line 2226 "cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->min_rx_int = (yyvsp[0].i32); }
#line 6518 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 464:
#line 2227 "cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->min_tx_int = (yyvsp[0].i32); }
#line 6524 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 465:
#line 2228 "cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->idle_tx_int = (yyvsp[0].i32); }
#line 6530 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 466:
#line 2229 "cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->multiplier = (yyvsp[0].i); }
#line 6536 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 467:
#line 2230 "cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->passive = (yyvsp[0].i); }
#line 6542 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 472:
#line 2244 "cf-parse.y" /* yacc.c:1646  */
    { add_tail(&BFD_CFG->patt_list, NODE this_ipatt); }
#line 6548 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 473:
#line 2247 "cf-parse.y" /* yacc.c:1646  */
    { BFD_CFG->multihop = BFD_IFACE; }
#line 6554 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 474:
#line 2251 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.iface) = NULL; }
#line 6560 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 475:
#line 2252 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.iface) = if_get_by_name((yyvsp[0].s)->name); }
#line 6566 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 476:
#line 2253 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.iface) = if_get_by_name((yyvsp[0].t)); }
#line 6572 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 477:
#line 2257 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.a) = IPA_NONE; }
#line 6578 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 478:
#line 2258 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.a) = (yyvsp[0].a); }
#line 6584 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 479:
#line 2262 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 6590 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 480:
#line 2263 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i); }
#line 6596 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 481:
#line 2267 "cf-parse.y" /* yacc.c:1646  */
    {
  this_bfd_neighbor = cfg_allocz(sizeof(struct bfd_neighbor));
  add_tail(&BFD_CFG->neigh_list, NODE this_bfd_neighbor);

  BFD_NEIGHBOR->addr = (yyvsp[-3].a);
  BFD_NEIGHBOR->local = (yyvsp[-1].a);
  BFD_NEIGHBOR->iface = (yyvsp[-2].iface);
  BFD_NEIGHBOR->multihop = (yyvsp[0].i);

  if ((yyvsp[0].i) && (yyvsp[-2].iface))
    cf_error("Neighbor cannot set both interface and multihop");

  if ((yyvsp[0].i) && ipa_zero((yyvsp[-1].a)))
    cf_error("Multihop neighbor requires specified local address");
}
#line 6616 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 482:
#line 2286 "cf-parse.y" /* yacc.c:1646  */
    { bfd_show_sessions(proto_get_named((yyvsp[-1].s), &proto_bfd)); }
#line 6622 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 483:
#line 2291 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto = proto_config_new(&proto_bgp, sizeof(struct bgp_config), (yyvsp[-1].i));
     BGP_CFG->multihop = -1;	/* undefined */
     BGP_CFG->hold_time = 240;
     BGP_CFG->connect_retry_time = 120;
     BGP_CFG->initial_hold_time = 240;
     BGP_CFG->compare_path_lengths = 1;
     BGP_CFG->igp_metric = 1;
     BGP_CFG->start_delay_time = 5;
     BGP_CFG->error_amnesia_time = 300;
     BGP_CFG->error_delay_time_min = 60;
     BGP_CFG->error_delay_time_max = 300;
     BGP_CFG->enable_refresh = 1;
     BGP_CFG->enable_as4 = 1;
     BGP_CFG->capabilities = 2;
     BGP_CFG->advertise_ipv4 = 1;
     BGP_CFG->interpret_communities = 1;
     BGP_CFG->default_local_pref = 100;
     BGP_CFG->gr_mode = BGP_GR_AWARE;
     BGP_CFG->gr_time = 120;
 }
#line 6648 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 486:
#line 2317 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->local_as = (yyvsp[-1].i); }
#line 6654 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 487:
#line 2318 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->source_addr = (yyvsp[-3].a); BGP_CFG->local_as = (yyvsp[-1].i); }
#line 6660 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 488:
#line 2319 "cf-parse.y" /* yacc.c:1646  */
    {
     if (ipa_nonzero(BGP_CFG->remote_ip))
       cf_error("Only one neighbor per BGP instance is allowed");
     if (!ipa_has_link_scope((yyvsp[-4].a)) != !(yyvsp[-3].iface))
       cf_error("Link-local address and interface scope must be used together");

     BGP_CFG->remote_ip = (yyvsp[-4].a);
     BGP_CFG->iface = (yyvsp[-3].iface);
     BGP_CFG->remote_as = (yyvsp[-1].i);
   }
#line 6675 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 489:
#line 2329 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->rr_cluster_id = (yyvsp[-1].i32); }
#line 6681 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 490:
#line 2330 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->rr_client = 1; }
#line 6687 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 491:
#line 2331 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->rs_client = 1; }
#line 6693 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 492:
#line 2332 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->hold_time = (yyvsp[-1].i); }
#line 6699 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 493:
#line 2333 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->initial_hold_time = (yyvsp[-1].i); }
#line 6705 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 494:
#line 2334 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->connect_retry_time = (yyvsp[-1].i); }
#line 6711 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 495:
#line 2335 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->keepalive_time = (yyvsp[-1].i); }
#line 6717 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 496:
#line 2336 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->multihop = 0; }
#line 6723 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 497:
#line 2337 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->multihop = 64; }
#line 6729 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 498:
#line 2338 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->multihop = (yyvsp[-1].i); if (((yyvsp[-1].i)<1) || ((yyvsp[-1].i)>255)) cf_error("Multihop must be in range 1-255"); }
#line 6735 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 499:
#line 2339 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->next_hop_self = 1; BGP_CFG->next_hop_keep = 0; }
#line 6741 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 500:
#line 2340 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->next_hop_keep = 1; BGP_CFG->next_hop_self = 0; }
#line 6747 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 501:
#line 2341 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->missing_lladdr = MLL_SELF; }
#line 6753 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 502:
#line 2342 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->missing_lladdr = MLL_DROP; }
#line 6759 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 503:
#line 2343 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->missing_lladdr = MLL_IGNORE; }
#line 6765 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 504:
#line 2344 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->gw_mode = GW_DIRECT; }
#line 6771 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 505:
#line 2345 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->gw_mode = GW_RECURSIVE; }
#line 6777 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 506:
#line 2346 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->compare_path_lengths = (yyvsp[-1].i); }
#line 6783 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 507:
#line 2347 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->med_metric = (yyvsp[-1].i); }
#line 6789 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 508:
#line 2348 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->igp_metric = (yyvsp[-1].i); }
#line 6795 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 509:
#line 2349 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->prefer_older = (yyvsp[-1].i); }
#line 6801 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 510:
#line 2350 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->deterministic_med = (yyvsp[-1].i); }
#line 6807 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 511:
#line 2351 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->default_med = (yyvsp[-1].i); }
#line 6813 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 512:
#line 2352 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->default_local_pref = (yyvsp[-1].i); }
#line 6819 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 513:
#line 2353 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->source_addr = (yyvsp[-1].a); }
#line 6825 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 514:
#line 2354 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->start_delay_time = (yyvsp[-1].i); }
#line 6831 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 515:
#line 2355 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->error_amnesia_time = (yyvsp[-1].i); }
#line 6837 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 516:
#line 2356 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->error_delay_time_min = (yyvsp[-3].i); BGP_CFG->error_delay_time_max = (yyvsp[-1].i); }
#line 6843 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 517:
#line 2357 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->disable_after_error = (yyvsp[-1].i); }
#line 6849 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 518:
#line 2358 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->enable_refresh = (yyvsp[-1].i); }
#line 6855 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 519:
#line 2359 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->enable_as4 = (yyvsp[-1].i); }
#line 6861 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 520:
#line 2360 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->capabilities = (yyvsp[-1].i); }
#line 6867 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 521:
#line 2361 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->advertise_ipv4 = (yyvsp[-1].i); }
#line 6873 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 522:
#line 2362 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->password = (yyvsp[-1].t); }
#line 6879 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 523:
#line 2363 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto->in_limit = cfg_allocz(sizeof(struct proto_limit));
     this_proto->in_limit->limit = (yyvsp[-1].i);
     this_proto->in_limit->action = PLA_RESTART;
   }
#line 6889 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 524:
#line 2368 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->passive = (yyvsp[-1].i); }
#line 6895 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 525:
#line 2369 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->interpret_communities = (yyvsp[-1].i); }
#line 6901 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 526:
#line 2370 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->secondary = (yyvsp[-1].i); }
#line 6907 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 527:
#line 2371 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->add_path = ADD_PATH_RX; }
#line 6913 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 528:
#line 2372 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->add_path = ADD_PATH_TX; }
#line 6919 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 529:
#line 2373 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->add_path = (yyvsp[-1].i) ? ADD_PATH_FULL : 0; }
#line 6925 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 530:
#line 2374 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->allow_local_as = -1; }
#line 6931 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 531:
#line 2375 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->allow_local_as = (yyvsp[-1].i); }
#line 6937 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 532:
#line 2376 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->gr_mode = (yyvsp[-1].i); }
#line 6943 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 533:
#line 2377 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->gr_mode = BGP_GR_AWARE; }
#line 6949 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 534:
#line 2378 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->gr_time = (yyvsp[-1].i); }
#line 6955 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 535:
#line 2379 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->igp_table = (yyvsp[-1].r); }
#line 6961 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 536:
#line 2380 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->ttl_security = (yyvsp[-1].i); }
#line 6967 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 537:
#line 2381 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->bfd = (yyvsp[-1].i); cf_check_bfd((yyvsp[-1].i)); }
#line 6973 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 538:
#line 2392 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto = proto_config_new(&proto_ospf, sizeof(struct ospf_config), (yyvsp[-1].i));
     init_list(&OSPF_CFG->area_list);
     init_list(&OSPF_CFG->vlink_list);
     OSPF_CFG->rfc1583 = DEFAULT_RFC1583;
     OSPF_CFG->tick = DEFAULT_OSPFTICK;
  }
#line 6985 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 542:
#line 2408 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->rfc1583 = (yyvsp[0].i); }
#line 6991 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 543:
#line 2409 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->stub_router = (yyvsp[0].i); }
#line 6997 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 544:
#line 2410 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->ecmp = (yyvsp[0].i) ? DEFAULT_ECMP_LIMIT : 0; }
#line 7003 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 545:
#line 2411 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->ecmp = (yyvsp[-2].i) ? (yyvsp[0].i) : 0; if ((yyvsp[0].i) < 0) cf_error("ECMP limit cannot be negative"); }
#line 7009 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 546:
#line 2412 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->merge_external = (yyvsp[0].i); }
#line 7015 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 547:
#line 2413 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->tick = (yyvsp[0].i); if((yyvsp[0].i)<=0) cf_error("Tick must be greater than zero"); }
#line 7021 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 549:
#line 2417 "cf-parse.y" /* yacc.c:1646  */
    {
  this_area = cfg_allocz(sizeof(struct ospf_area_config));
  add_tail(&OSPF_CFG->area_list, NODE this_area);
  this_area->areaid = (yyvsp[0].i32);
  this_area->default_cost = DEFAULT_STUB_COST;
  this_area->type = OPT_E;
  this_area->transint = DEFAULT_TRANSINT;

  init_list(&this_area->patt_list);
  init_list(&this_area->net_list);
  init_list(&this_area->enet_list);
  init_list(&this_area->stubnet_list);
 }
#line 7039 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 550:
#line 2432 "cf-parse.y" /* yacc.c:1646  */
    { ospf_area_finish(); }
#line 7045 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 553:
#line 2441 "cf-parse.y" /* yacc.c:1646  */
    { this_area->type = (yyvsp[0].i) ? 0 : OPT_E; /* We should remove the option */ }
#line 7051 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 554:
#line 2442 "cf-parse.y" /* yacc.c:1646  */
    { this_area->type = OPT_N; }
#line 7057 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 555:
#line 2443 "cf-parse.y" /* yacc.c:1646  */
    { this_area->summary = (yyvsp[0].i); }
#line 7063 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 556:
#line 2444 "cf-parse.y" /* yacc.c:1646  */
    { this_area->default_nssa = (yyvsp[0].i); }
#line 7069 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 557:
#line 2445 "cf-parse.y" /* yacc.c:1646  */
    { this_area->default_cost = (yyvsp[0].i); check_defcost((yyvsp[0].i)); }
#line 7075 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 558:
#line 2446 "cf-parse.y" /* yacc.c:1646  */
    { this_area->default_cost = (yyvsp[0].i) | LSA_EXT_EBIT; check_defcost((yyvsp[0].i)); }
#line 7081 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 559:
#line 2447 "cf-parse.y" /* yacc.c:1646  */
    { this_area->default_cost = (yyvsp[0].i);  check_defcost((yyvsp[0].i)); }
#line 7087 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 560:
#line 2448 "cf-parse.y" /* yacc.c:1646  */
    { this_area->translator = (yyvsp[0].i); }
#line 7093 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 561:
#line 2449 "cf-parse.y" /* yacc.c:1646  */
    { this_area->transint = (yyvsp[0].i); }
#line 7099 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 562:
#line 2450 "cf-parse.y" /* yacc.c:1646  */
    { this_nets = &this_area->net_list; }
#line 7105 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 564:
#line 2451 "cf-parse.y" /* yacc.c:1646  */
    { this_nets = &this_area->enet_list; }
#line 7111 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 571:
#line 2463 "cf-parse.y" /* yacc.c:1646  */
    {
     this_stubnet = cfg_allocz(sizeof(struct ospf_stubnet_config));
     add_tail(&this_area->stubnet_list, NODE this_stubnet);
     this_stubnet->px = (yyvsp[0].px);
     this_stubnet->cost = COST_D;
   }
#line 7122 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 574:
#line 2477 "cf-parse.y" /* yacc.c:1646  */
    { this_stubnet->hidden = (yyvsp[0].i); }
#line 7128 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 575:
#line 2478 "cf-parse.y" /* yacc.c:1646  */
    { this_stubnet->summary = (yyvsp[0].i); }
#line 7134 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 576:
#line 2479 "cf-parse.y" /* yacc.c:1646  */
    { this_stubnet->cost = (yyvsp[0].i); }
#line 7140 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 577:
#line 2483 "cf-parse.y" /* yacc.c:1646  */
    { ospf_iface_finish(); }
#line 7146 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 578:
#line 2484 "cf-parse.y" /* yacc.c:1646  */
    { ospf_iface_finish(); }
#line 7152 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 582:
#line 2493 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->helloint = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Hello interval must be in range 1-65535"); }
#line 7158 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 583:
#line 2494 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->rxmtint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=0) cf_error("Retransmit int must be greater than zero"); }
#line 7164 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 584:
#line 2495 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->inftransdelay = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); }
#line 7170 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 585:
#line 2496 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->waitint = (yyvsp[0].i) ; }
#line 7176 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 586:
#line 2497 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->deadint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead interval must be greater than one"); }
#line 7182 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 587:
#line 2498 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->deadc = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead count must be greater than one"); }
#line 7188 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 588:
#line 2499 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_NONE ; }
#line 7194 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 589:
#line 2500 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE ; }
#line 7200 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 590:
#line 2501 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT ; }
#line 7206 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 592:
#line 2506 "cf-parse.y" /* yacc.c:1646  */
    {
  if (this_area->areaid == 0) cf_error("Virtual link cannot be in backbone");
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&OSPF_CFG->vlink_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->voa = this_area->areaid;
  OSPF_PATT->vid = (yyvsp[0].i32);
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->waitint = WAIT_DMH*HELLOINT_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->deadint = 0;
  OSPF_PATT->type = OSPF_IT_VLINK;
  init_list(&OSPF_PATT->nbma_list);
  OSPF_PATT->autype = OSPF_AUTH_NONE;
  reset_passwords();
 }
#line 7229 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 593:
#line 2527 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->cost = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Cost must be in range 1-65535"); }
#line 7235 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 594:
#line 2528 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->helloint = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Hello interval must be in range 1-65535"); }
#line 7241 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 595:
#line 2529 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->pollint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=0) cf_error("Poll int must be greater than zero"); }
#line 7247 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 596:
#line 2530 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->rxmtint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=0) cf_error("Retransmit int must be greater than zero"); }
#line 7253 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 597:
#line 2531 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->waitint = (yyvsp[0].i) ; }
#line 7259 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 598:
#line 2532 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->deadint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead interval must be greater than one"); }
#line 7265 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 599:
#line 2533 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->deadc = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead count must be greater than one"); }
#line 7271 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 600:
#line 2534 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_BCAST ; }
#line 7277 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 601:
#line 2535 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_BCAST ; }
#line 7283 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 602:
#line 2536 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_NBMA ; }
#line 7289 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 603:
#line 2537 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_NBMA ; }
#line 7295 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 604:
#line 2538 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_PTP ; }
#line 7301 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 605:
#line 2539 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_PTP ; }
#line 7307 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 606:
#line 2540 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_PTMP ; }
#line 7313 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 607:
#line 2541 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_PTMP ; }
#line 7319 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 608:
#line 2542 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->real_bcast = (yyvsp[0].i); if (OSPF_VERSION != 2) cf_error("Real broadcast option requires OSPFv2"); }
#line 7325 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 609:
#line 2543 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->ptp_netmask = (yyvsp[0].i); if (OSPF_VERSION != 2) cf_error("Real netmask option requires OSPFv2"); }
#line 7331 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 610:
#line 2544 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->inftransdelay = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); }
#line 7337 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 611:
#line 2545 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->priority = (yyvsp[0].i) ; if (((yyvsp[0].i)<0) || ((yyvsp[0].i)>255)) cf_error("Priority must be in range 0-255"); }
#line 7343 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 612:
#line 2546 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->strictnbma = (yyvsp[0].i) ; }
#line 7349 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 613:
#line 2547 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->stub = (yyvsp[0].i) ; }
#line 7355 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 614:
#line 2548 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->check_link = (yyvsp[0].i); }
#line 7361 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 615:
#line 2549 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->ecmp_weight = (yyvsp[0].i) - 1; if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>256)) cf_error("ECMP weight must be in range 1-256"); }
#line 7367 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 617:
#line 2551 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_NONE ; }
#line 7373 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 618:
#line 2552 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE ; }
#line 7379 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 619:
#line 2553 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT ; }
#line 7385 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 620:
#line 2554 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->rx_buffer = 0; }
#line 7391 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 621:
#line 2555 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->rx_buffer = OSPF_MAX_PKT_SIZE; }
#line 7397 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 622:
#line 2556 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->rx_buffer = (yyvsp[0].i); if (((yyvsp[0].i) < OSPF_MIN_PKT_SIZE) || ((yyvsp[0].i) > OSPF_MAX_PKT_SIZE)) cf_error("Buffer size must be in range 256-65535"); }
#line 7403 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 623:
#line 2557 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->tx_tos = (yyvsp[0].i); }
#line 7409 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 624:
#line 2558 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->tx_priority = (yyvsp[0].i); }
#line 7415 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 625:
#line 2559 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->tx_length = (yyvsp[0].i); if (((yyvsp[0].i) < OSPF_MIN_PKT_SIZE) || ((yyvsp[0].i) > OSPF_MAX_PKT_SIZE)) cf_error("TX length must be in range 256-65535"); }
#line 7421 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 626:
#line 2560 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->ttl_security = (yyvsp[0].i); }
#line 7427 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 627:
#line 2561 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->ttl_security = 2; }
#line 7433 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 628:
#line 2562 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->bfd = (yyvsp[0].i); cf_check_bfd((yyvsp[0].i)); }
#line 7439 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 629:
#line 2563 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->bsd_secondary = (yyvsp[0].i); }
#line 7445 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 634:
#line 2575 "cf-parse.y" /* yacc.c:1646  */
    {
   this_pref = cfg_allocz(sizeof(struct area_net_config));
   add_tail(this_nets, NODE this_pref);
   this_pref->px.addr = (yyvsp[0].px).addr;
   this_pref->px.len = (yyvsp[0].px).len;
 }
#line 7456 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 636:
#line 2585 "cf-parse.y" /* yacc.c:1646  */
    { this_pref->hidden = 1; }
#line 7462 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 637:
#line 2586 "cf-parse.y" /* yacc.c:1646  */
    { this_pref->tag = (yyvsp[0].i); }
#line 7468 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 640:
#line 2595 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 7474 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 641:
#line 2596 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 7480 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 642:
#line 2600 "cf-parse.y" /* yacc.c:1646  */
    {
   this_nbma = cfg_allocz(sizeof(struct nbma_node));
   add_tail(&OSPF_PATT->nbma_list, NODE this_nbma);
   this_nbma->ip=(yyvsp[-2].a);
   this_nbma->eligible=(yyvsp[-1].i);
 }
#line 7491 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 643:
#line 2609 "cf-parse.y" /* yacc.c:1646  */
    {
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&this_area->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->cost = COST_D;
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->pollint = POLLINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->priority = PRIORITY_D;
  OSPF_PATT->waitint = WAIT_DMH*HELLOINT_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->deadint = 0;
  OSPF_PATT->type = OSPF_IT_UNDEF;
  init_list(&OSPF_PATT->nbma_list);
  OSPF_PATT->autype = OSPF_AUTH_NONE;
  OSPF_PATT->ptp_netmask = 2; /* not specified */
  OSPF_PATT->tx_tos = IP_PREC_INTERNET_CONTROL;
  OSPF_PATT->tx_priority = sk_priority_control;
  reset_passwords();
 }
#line 7517 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 645:
#line 2634 "cf-parse.y" /* yacc.c:1646  */
    { set_instance_id((yyvsp[0].i)); }
#line 7523 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 646:
#line 2638 "cf-parse.y" /* yacc.c:1646  */
    { if (OSPF_VERSION == 3) iface_patt_check(); }
#line 7529 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 652:
#line 2652 "cf-parse.y" /* yacc.c:1646  */
    { ospf_iface_finish(); }
#line 7535 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 654:
#line 2657 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = NULL; }
#line 7541 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 655:
#line 2663 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh(proto_get_named((yyvsp[-1].s), &proto_ospf)); }
#line 7547 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 656:
#line 2666 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_neigh(proto_get_named((yyvsp[-2].s), &proto_ospf), (yyvsp[-1].t)); }
#line 7553 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 657:
#line 2669 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_iface(proto_get_named((yyvsp[-2].s), &proto_ospf), (yyvsp[-1].t)); }
#line 7559 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 658:
#line 2674 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 0, 1); }
#line 7565 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 659:
#line 2677 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 0, 0); }
#line 7571 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 660:
#line 2682 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 1, 1); }
#line 7577 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 661:
#line 2685 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 1, 0); }
#line 7583 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 662:
#line 2689 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_lsadb((yyvsp[-1].ld)); }
#line 7589 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 663:
#line 2692 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ld) = cfg_allocz(sizeof(struct lsadb_show_data));
   }
#line 7597 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 664:
#line 2695 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->scope = LSA_SCOPE_AS; }
#line 7603 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 665:
#line 2696 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->scope = LSA_SCOPE_AREA; (yyval.ld)->area = (yyvsp[0].i32); }
#line 7609 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 666:
#line 2697 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->scope = 1; /* hack, 0 is no filter */ }
#line 7615 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 667:
#line 2698 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->type = (yyvsp[0].i); }
#line 7621 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 668:
#line 2699 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->lsid = (yyvsp[0].i32); }
#line 7627 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 669:
#line 2700 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->router = SH_ROUTER_SELF; }
#line 7633 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 670:
#line 2701 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->router = (yyvsp[0].i32); }
#line 7639 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 671:
#line 2702 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->name = (yyvsp[0].s); }
#line 7645 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 672:
#line 2708 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto = proto_config_new(&proto_pipe, sizeof(struct pipe_config), (yyvsp[-1].i));
     PIPE_CFG->mode = PIPE_TRANSPARENT;
  }
#line 7654 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 675:
#line 2717 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[-1].s)->class != SYM_TABLE)
       cf_error("Routing table name expected");
     PIPE_CFG->peer = (yyvsp[-1].s)->def;
   }
#line 7664 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 676:
#line 2722 "cf-parse.y" /* yacc.c:1646  */
    { PIPE_CFG->mode = PIPE_OPAQUE; }
#line 7670 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 677:
#line 2723 "cf-parse.y" /* yacc.c:1646  */
    { PIPE_CFG->mode = PIPE_TRANSPARENT; }
#line 7676 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 678:
#line 2729 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto = proto_config_new(&proto_rip, sizeof(struct rip_proto_config), (yyvsp[-1].i));
     rip_init_config(RIP_CFG);
   }
#line 7685 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 681:
#line 2738 "cf-parse.y" /* yacc.c:1646  */
    { RIP_CFG->infinity = (yyvsp[-1].i); }
#line 7691 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 682:
#line 2739 "cf-parse.y" /* yacc.c:1646  */
    { RIP_CFG->port = (yyvsp[-1].i); }
#line 7697 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 683:
#line 2740 "cf-parse.y" /* yacc.c:1646  */
    { RIP_CFG->period = (yyvsp[-1].i); }
#line 7703 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 684:
#line 2741 "cf-parse.y" /* yacc.c:1646  */
    { RIP_CFG->garbage_time = (yyvsp[-1].i); }
#line 7709 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 685:
#line 2742 "cf-parse.y" /* yacc.c:1646  */
    { RIP_CFG->timeout_time = (yyvsp[-1].i); }
#line 7715 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 686:
#line 2743 "cf-parse.y" /* yacc.c:1646  */
    {RIP_CFG->authtype = (yyvsp[-1].i); }
#line 7721 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 688:
#line 2745 "cf-parse.y" /* yacc.c:1646  */
    { RIP_CFG->honor = HO_ALWAYS; }
#line 7727 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 689:
#line 2746 "cf-parse.y" /* yacc.c:1646  */
    { RIP_CFG->honor = HO_NEIGHBOR; }
#line 7733 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 690:
#line 2747 "cf-parse.y" /* yacc.c:1646  */
    { RIP_CFG->honor = HO_NEVER; }
#line 7739 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 692:
#line 2752 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i)=AT_PLAINTEXT; }
#line 7745 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 693:
#line 2753 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i)=AT_MD5; }
#line 7751 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 694:
#line 2754 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i)=AT_NONE; }
#line 7757 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 695:
#line 2759 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i)=IM_BROADCAST; }
#line 7763 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 696:
#line 2760 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i)=0; }
#line 7769 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 697:
#line 2761 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i)=IM_QUIET; }
#line 7775 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 698:
#line 2762 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i)=IM_NOLISTEN; }
#line 7781 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 699:
#line 2763 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i)=IM_VERSION1 | IM_BROADCAST; }
#line 7787 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 701:
#line 2767 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IPATT->metric = (yyvsp[0].i); }
#line 7793 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 702:
#line 2768 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IPATT->mode |= (yyvsp[0].i); }
#line 7799 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 703:
#line 2769 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IPATT->tx_tos = (yyvsp[0].i); }
#line 7805 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 704:
#line 2770 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IPATT->tx_priority = (yyvsp[0].i); }
#line 7811 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 705:
#line 2771 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IPATT->ttl_security = (yyvsp[0].i); }
#line 7817 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 706:
#line 2772 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IPATT->ttl_security = 2; }
#line 7823 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 711:
#line 2786 "cf-parse.y" /* yacc.c:1646  */
    {
     this_ipatt = cfg_allocz(sizeof(struct rip_patt));
     add_tail(&RIP_CFG->iface_list, NODE this_ipatt);
     init_list(&this_ipatt->ipn_list);
     RIP_IPATT->metric = 1;
     RIP_IPATT->tx_tos = IP_PREC_INTERNET_CONTROL;
     RIP_IPATT->tx_priority = sk_priority_control;
     RIP_IPATT->ttl_security = RIP_DEFAULT_TTL_SECURITY;
   }
#line 7837 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 713:
#line 2805 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto = proto_config_new(&proto_static, sizeof(struct static_config), (yyvsp[-1].i));
     static_init_config((struct static_config *) this_proto);
  }
#line 7846 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 716:
#line 2814 "cf-parse.y" /* yacc.c:1646  */
    { STATIC_CFG->check_link = (yyvsp[-1].i); }
#line 7852 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 717:
#line 2815 "cf-parse.y" /* yacc.c:1646  */
    { STATIC_CFG->igp_table = (yyvsp[-1].r); }
#line 7858 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 719:
#line 2819 "cf-parse.y" /* yacc.c:1646  */
    {
     this_srt = cfg_allocz(sizeof(struct static_route));
     add_tail(&STATIC_CFG->other_routes, &this_srt->n);
     this_srt->net = (yyvsp[0].px).addr;
     this_srt->masklen = (yyvsp[0].px).len;
  }
#line 7869 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 720:
#line 2828 "cf-parse.y" /* yacc.c:1646  */
    {
     last_srt_nh = this_srt_nh;
     this_srt_nh = cfg_allocz(sizeof(struct static_route));
     this_srt_nh->dest = RTD_NONE;
     this_srt_nh->via = (yyvsp[-1].a);
     this_srt_nh->via_if = (yyvsp[0].iface);
     this_srt_nh->if_name = (void *) this_srt; /* really */
   }
#line 7882 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 721:
#line 2836 "cf-parse.y" /* yacc.c:1646  */
    {
     this_srt_nh->masklen = (yyvsp[0].i) - 1; /* really */
     if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>256)) cf_error("Weight must be in range 1-256"); 
   }
#line 7891 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 722:
#line 2843 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->mp_next = this_srt_nh; }
#line 7897 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 723:
#line 2844 "cf-parse.y" /* yacc.c:1646  */
    { last_srt_nh->mp_next = this_srt_nh; }
#line 7903 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 724:
#line 2848 "cf-parse.y" /* yacc.c:1646  */
    {
      this_srt->dest = RTD_ROUTER;
      this_srt->via = (yyvsp[-1].a);
      this_srt->via_if = (yyvsp[0].iface);
   }
#line 7913 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 725:
#line 2853 "cf-parse.y" /* yacc.c:1646  */
    {
      this_srt->dest = RTD_DEVICE;
      this_srt->if_name = (yyvsp[0].t);
      rem_node(&this_srt->n);
      add_tail(&STATIC_CFG->iface_routes, &this_srt->n);
   }
#line 7924 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 726:
#line 2859 "cf-parse.y" /* yacc.c:1646  */
    {
      this_srt->dest = RTD_MULTIPATH;
   }
#line 7932 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 727:
#line 2862 "cf-parse.y" /* yacc.c:1646  */
    {
      this_srt->dest = RTDX_RECURSIVE;
      this_srt->via = (yyvsp[0].a);
   }
#line 7941 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 728:
#line 2867 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->dest = RTD_BLACKHOLE; }
#line 7947 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 729:
#line 2868 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->dest = RTD_UNREACHABLE; }
#line 7953 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 730:
#line 2869 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->dest = RTD_BLACKHOLE; }
#line 7959 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 731:
#line 2870 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->dest = RTD_UNREACHABLE; }
#line 7965 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 732:
#line 2871 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->dest = RTD_PROHIBIT; }
#line 7971 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 733:
#line 2875 "cf-parse.y" /* yacc.c:1646  */
    { static_show(proto_get_named((yyvsp[-1].s), &proto_static)); }
#line 7977 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 799:
#line 2883 "cf-parse.y" /* yacc.c:1646  */
    { bgp_check_config(BGP_CFG); }
#line 7983 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 800:
#line 2883 "cf-parse.y" /* yacc.c:1646  */
    { ospf_proto_finish(); }
#line 7989 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 802:
#line 2883 "cf-parse.y" /* yacc.c:1646  */
    { RIP_CFG->passwords = get_passwords(); }
#line 7995 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 811:
#line 2886 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_KRT_SOURCE); }
#line 8001 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 812:
#line 2886 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_KRT_METRIC); }
#line 8007 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 813:
#line 2886 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_KRT_PREFSRC); }
#line 8013 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 814:
#line 2886 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_REALM); }
#line 8019 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 815:
#line 2887 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_GEN_IGP_METRIC); }
#line 8025 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 816:
#line 2887 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = NULL; }
#line 8031 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 817:
#line 2888 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_ENUM_BGP_ORIGIN, EA_CODE(EAP_BGP, BA_ORIGIN)); }
#line 8037 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 818:
#line 2889 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_AS_PATH, T_PATH, EA_CODE(EAP_BGP, BA_AS_PATH)); }
#line 8043 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 819:
#line 2890 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_CODE(EAP_BGP, BA_NEXT_HOP)); }
#line 8049 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 820:
#line 2891 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_MULTI_EXIT_DISC)); }
#line 8055 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 821:
#line 2892 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_LOCAL_PREF)); }
#line 8061 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 822:
#line 2893 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_OPAQUE, T_ENUM_EMPTY, EA_CODE(EAP_BGP, BA_ATOMIC_AGGR)); }
#line 8067 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 823:
#line 2894 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_AGGREGATOR)); }
#line 8073 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 824:
#line 2895 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(EAP_BGP, BA_COMMUNITY)); }
#line 8079 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 825:
#line 2896 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID, T_QUAD, EA_CODE(EAP_BGP, BA_ORIGINATOR_ID)); }
#line 8085 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 826:
#line 2897 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(EAP_BGP, BA_CLUSTER_LIST)); }
#line 8091 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 827:
#line 2898 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_EC_SET, T_ECLIST, EA_CODE(EAP_BGP, BA_EXT_COMMUNITY)); }
#line 8097 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 828:
#line 2898 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC1); }
#line 8103 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 829:
#line 2898 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC2); }
#line 8109 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 830:
#line 2898 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_TAG); }
#line 8115 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 831:
#line 2898 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID | EAF_TEMP, T_QUAD, EA_OSPF_ROUTER_ID); }
#line 8121 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 832:
#line 2898 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_METRIC); }
#line 8127 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 833:
#line 2898 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_TAG); }
#line 8133 "cf-parse.tab.c" /* yacc.c:1646  */
    break;


#line 8137 "cf-parse.tab.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 2900 "cf-parse.y" /* yacc.c:1906  */

/* C Code from ../../conf/confbase.Y */

/* C Code from ../../sysdep/unix/config.Y */

/* C Code from ../../sysdep/unix/krt.Y */

/* C Code from ../../sysdep/linux/netlink.Y */

/* C Code from ../../nest/config.Y */

/* C Code from ../../proto/bfd/config.Y */

/* C Code from ../../proto/bgp/config.Y */

/* C Code from ../../proto/ospf/config.Y */

/* C Code from ../../proto/pipe/config.Y */

/* C Code from ../../proto/rip/config.Y */

/* C Code from ../../proto/static/config.Y */

